#ifndef __DRV_ADC_H__
#define __DRV_ADC_H__

#include "Global.h"


/**************************ADC **************************************/
#define Cc_ADC                              ADC1
#define Cc_ADC_CLK                          RCC_APB2Periph_ADC1
#define Cc_ADC_CLK_INIT                     RCC_APB2PeriphClockCmd

/**************************DMA for ADC********************************/
#define Cc_ADC_DMA                          DMA2
#define Cc_ADC_DMA_CLK                      RCC_AHB1Periph_DMA2
#define Cc_ADC_DMA_CLK_INIT                 RCC_AHB1PeriphClockCmd
#define Cc_ADC_DMA_CHANNEL                  DMA_Channel_0
#define Cc_ADC_DMA_STREAM                   DMA2_Stream0

/**************************ADC Pin ***********************************/
#define Cc00_ADC_CHANNEL                    ADC_Channel_14
#define Cc00_ADC_PIN                        GPIO_Pin_4
#define Cc00_ADC_GPIO_PORT                  GPIOC
#define Cc00_ADC_GPIO_CLK                   RCC_AHB1Periph_GPIOC

#define Cc01_ADC_CHANNEL                    ADC_Channel_15
#define Cc01_ADC_PIN                        GPIO_Pin_5
#define Cc01_ADC_GPIO_PORT                  GPIOC
#define Cc01_ADC_GPIO_CLK                   RCC_AHB1Periph_GPIOC


/**************************ADC **************************************/
#define Temp_ADC                            ADC2
#define Temp_ADC_CLK                        RCC_APB2Periph_ADC2
#define Temp_ADC_CLK_INIT                   RCC_APB2PeriphClockCmd

/**************************DMA for ADC********************************/
#define Temp_ADC_DMA                        DMA2
#define Temp_ADC_DMA_CLK                    RCC_AHB1Periph_DMA2
#define Temp_ADC_DMA_CLK_INIT               RCC_AHB1PeriphClockCmd
#define Temp_ADC_DMA_CHANNEL                DMA_Channel_1
#define Temp_ADC_DMA_STREAM                 DMA2_Stream2

/**************************ADC Pin ***********************************/
#define Temp00_ADC_CHANNEL                    ADC_Channel_10
#define Temp00_ADC_PIN                        GPIO_Pin_0
#define Temp00_ADC_GPIO_PORT                  GPIOC
#define Temp00_ADC_GPIO_CLK                   RCC_AHB1Periph_GPIOC

#define Temp01_ADC_CHANNEL                    ADC_Channel_11
#define Temp01_ADC_PIN                        GPIO_Pin_1
#define Temp01_ADC_GPIO_PORT                  GPIOC
#define Temp01_ADC_GPIO_CLK                   RCC_AHB1Periph_GPIOC

#define Temp02_ADC_CHANNEL                    ADC_Channel_12
#define Temp02_ADC_PIN                        GPIO_Pin_2
#define Temp02_ADC_GPIO_PORT                  GPIOC
#define Temp02_ADC_GPIO_CLK                   RCC_AHB1Periph_GPIOC

#define Temp03_ADC_CHANNEL                    ADC_Channel_13
#define Temp03_ADC_PIN                        GPIO_Pin_3
#define Temp03_ADC_GPIO_PORT                  GPIOC
#define Temp03_ADC_GPIO_CLK                   RCC_AHB1Periph_GPIOC


extern void AdcCheckInit(void);
extern void CcCheckInit(void);

extern EnumSwitchStatus CcStatusRead(void);
extern  EnumSwitchStatus CcStatusRead_B(void);
extern  EnumSwitchStatus CcStatusRead_AB(void);
extern u8 NtcRetToTemp(u32 Rp,u16 Bx);
#if 0
extern u8 NtcRetToTemp(u32 Rp,u16 Bx);
#else
extern u8 PT1000RetToTemp(void);
extern u8 PT1000RetToTempN(void);
extern u8 PT1000RetToTempB_P(void);
extern u8 PT1000RetToTempB_N(void);

#endif

extern s16 Adc_GetNtcTemp(void);

extern s16 Adc_Get_a_PTemp(void);
extern s16 Adc_Get_a_NTemp(void);
extern s16 Adc_Get_B_PTemp(void);
extern s16 Adc_Get_B_NTemp(void);
#endif

