
/******************************************************************************
ļ  : Drv_Buzzer.c
  : 
  :
޸  : 2015-04-02      

******************************************************************************/

#include "Drv_Buzzer.h"

typedef struct
{
  u16 OnMs;
  u16 OffMs;
  u16 CtrlCount;
}StructBuzzerCtrl;

StructBuzzerCtrl BuzzerCtrl;
osTimerId BuzzerTimer;

/******************************************************************************
  : BuzzerInit
  : IOʼ
  : 
  : 
******************************************************************************/
void BuzzerSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    Buzzer_PORT->BSRRH = Buzzer_PIN;
  else
    Buzzer_PORT->BSRRL = Buzzer_PIN;
}

/******************************************************************************
  : BuzzerDelayCtrl
  : ̵ʱõ͵úڶʱ
  : 
  : 
******************************************************************************/
static void BuzzerDelayCtrl(void const *Param)
{
  if(BuzzerCtrl.CtrlCount)
    BuzzerCtrl.CtrlCount--;

  if(BuzzerCtrl.CtrlCount)
  {
    if(BuzzerCtrl.CtrlCount & 0x01)
    {
      BuzzerSet(eSwSta_On);
      osTimerStart(BuzzerTimer, BuzzerCtrl.OnMs);
    }
    else
    {
      BuzzerSet(eSwSta_Off);
      osTimerStart(BuzzerTimer, BuzzerCtrl.OffMs);
    }
  }
  else
  {
    BuzzerSet(eSwSta_Off);
    osTimerStop(BuzzerTimer);
  }
}

/******************************************************************************
  : BuzzerInit
  : IOʼ
  : 
  : 
******************************************************************************/
void BuzzerInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  BuzzerCtrl.OnMs = 0;
  BuzzerCtrl.OffMs = 0;
  BuzzerCtrl.CtrlCount = 0;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Buzzer_PIN;
  RCC_AHB1PeriphClockCmd(Buzzer_RCC, ENABLE);
  GPIO_Init(Buzzer_PORT, &GPIO_InitStructure);
  GPIO_ResetBits(Buzzer_PORT, Buzzer_PIN);

  /* Create Touch screen Timer */
  osTimerDef(BuzzerTimer, BuzzerDelayCtrl);
  BuzzerTimer = osTimerCreate(osTimer(BuzzerTimer), osTimerPeriodic, (void *)0);

  /* Start the TS Timer */
  osTimerStart(BuzzerTimer, 33);
}

/******************************************************************************
  : BuzzerRun
  : ʱ
  : Count -- ٴ
        OnMs -- ೤ʱ䣬
        OffMs -- ೤ʱ䣬
  : 
******************************************************************************/
void BuzzerRun(u16 Count, u16 OnMs, u16 OffMs)
{
  if(Count < 1)
    return;
  if(OnMs < 1)
    return;

  osTimerStop(BuzzerTimer);

  BuzzerCtrl.CtrlCount = 2*Count - 1;
  BuzzerCtrl.OnMs = OnMs;
  BuzzerCtrl.OffMs = OffMs;

  BuzzerSet(eSwSta_On);
  osTimerStart(BuzzerTimer, BuzzerCtrl.OnMs);
}




