
/******************************************************************************
ļ  : Drv_Connect.c
  : CPCPѹ,CCźż
  :
޸  : 2015-03-26      

******************************************************************************/

#include "Drv_Connect.h"

u16 DcAdcValueAlign[Dc_AverageSize][4];

/******************************************************************************
  : DcAdcInit
  : ֱźCP Temp AD ʼʹDMA
  : 
  : 
******************************************************************************/
void DcAdcInit(void)
{
  GPIO_InitTypeDef       GPIO_InitStructure;
  DMA_InitTypeDef        DMA_InitStructure;
  ADC_InitTypeDef        ADC_InitStructure;

  /* Enable peripheral clocks *************************************************/
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Pin = Cp_A_ADC_PIN;
  RCC_APB2PeriphClockCmd(Cp_A_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Cp_A_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Pin = Cp_B_ADC_PIN;
  RCC_APB2PeriphClockCmd(Cp_B_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Cp_B_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Pin = TempA_ADC_PIN;
  RCC_APB2PeriphClockCmd(TempA_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(TempA_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Pin = TempA_ADC_PIN;
  RCC_APB2PeriphClockCmd(TempA_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(TempA_ADC_GPIO_PORT, &GPIO_InitStructure);

  /* DMA1 channel1 configuration ----------------------------------------------*/
  Dc_ADC_DMA_CLK_INIT(Dc_ADC_DMA_CLK, ENABLE);
  DMA_DeInit(Dc_ADC_DMA_CHANNEL);
  DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&Dc_ADC->DR;
  DMA_InitStructure.DMA_MemoryBaseAddr = (u32)&DcAdcValueAlign;
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
  DMA_InitStructure.DMA_BufferSize = sizeof(DcAdcValueAlign)/sizeof(DcAdcValueAlign[0][0]);
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;
  DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
  DMA_Init(Dc_ADC_DMA_CHANNEL, &DMA_InitStructure);
  /* Enable DMA1 channel1 */
  DMA_Cmd(Dc_ADC_DMA_CHANNEL, ENABLE);

  /* ADCCLK = PCLK2/6 */
  RCC_ADCCLKConfig(RCC_PCLK2_Div6);

  Dc_ADC_CLK_INIT(Dc_ADC_CLK, ENABLE);
  /* ADC1 regular channel 12 configuration ************************************/
  ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;
  ADC_InitStructure.ADC_ScanConvMode = ENABLE;
  ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;
  ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
  ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
  ADC_InitStructure.ADC_NbrOfChannel = 4;//3;
  ADC_Init(Dc_ADC, &ADC_InitStructure);
  ADC_RegularChannelConfig(Dc_ADC, Cp_A_ADC_CHANNEL, 1, ADC_SampleTime_28Cycles5);
  ADC_RegularChannelConfig(Dc_ADC, Cp_B_ADC_CHANNEL, 2, ADC_SampleTime_28Cycles5);
  ADC_RegularChannelConfig(Dc_ADC, TempA_ADC_CHANNEL, 3, ADC_SampleTime_28Cycles5);
  ADC_RegularChannelConfig(Dc_ADC, TempB_ADC_CHANNEL, 4, ADC_SampleTime_28Cycles5);

  /* Enable ADC1 DMA */
  ADC_DMACmd(Dc_ADC, ENABLE);

  /* Enable ADC1 **************************************************************/
  ADC_Cmd(Dc_ADC, ENABLE);

  /* Enable ADC1 reset calibration register */
  ADC_ResetCalibration(Dc_ADC);
  /* Check the end of ADC1 reset calibration register */
  while(ADC_GetResetCalibrationStatus(Dc_ADC));
  /* Start ADC1 calibration */
  ADC_StartCalibration(Dc_ADC);
  /* Check the end of ADC1 calibration */
  while(ADC_GetCalibrationStatus(Dc_ADC));

  /* Start ADC1 Software Conversion */
  ADC_SoftwareStartConvCmd(Dc_ADC, ENABLE);
}

/******************************************************************************
  : CpDutySet_A
  : CP A ռձ
  : Duty - ռձ
        (0-1000) 0 ͵ƽ  ڵ1000ߵƽ ռձ
  : 
******************************************************************************/
void CpDutySet_A(u16 Duty)
{
  static u16 LastDuty = 0xFFFF;

  TIM_OCInitTypeDef  TIM_OCInitStructure;

  if(LastDuty == Duty)
    return;

  LastDuty = Duty;

  /* PWM1 Mode configuration: Channel1 */
  TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
  TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  if(Duty > 1000)
    TIM_OCInitStructure.TIM_Pulse = 0;
  else
    TIM_OCInitStructure.TIM_Pulse = 1000 - Duty;
  TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
  CP_A_OCxInit(CP_TIM, &TIM_OCInitStructure);
  CP_A_OCxPreloadConfig(CP_TIM, TIM_OCPreload_Enable);
}

/******************************************************************************
  : CpDutySet_B
  : CP B ռձ
  : Duty - ռձ
        (0-1000) 0 ͵ƽ  ڵ1000ߵƽ ռձ
  : 
******************************************************************************/
void CpDutySet_B(u16 Duty)
{
  static u16 LastDuty = 0xFFFF;

  TIM_OCInitTypeDef  TIM_OCInitStructure;

  if(LastDuty == Duty)
    return;

  LastDuty = Duty;

  /* PWM1 Mode configuration: Channel1 */
  TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
  TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  if(Duty > 1000)
    TIM_OCInitStructure.TIM_Pulse = 0;
  else
    TIM_OCInitStructure.TIM_Pulse = 1000 - Duty;
  TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
  CP_B_OCxInit(CP_TIM, &TIM_OCInitStructure);
  CP_B_OCxPreloadConfig(CP_TIM, TIM_OCPreload_Enable);
}

/******************************************************************************
  : CpPwmInit
  : CPʼ
  : 
  : 
******************************************************************************/
void CpPwmInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
  RCC_ClocksTypeDef RCC_Clocks;

  /* GPIO clock enable */
  RCC_APB2PeriphClockCmd(CP_A_OUT_GPIO_CLK, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);
  GPIO_PinRemapConfig(GPIO_Remap_TIM4, ENABLE);
  /* GPIO Configuration: TIM3 CH1 (PB6)*/
  GPIO_InitStructure.GPIO_Pin = CP_A_OUT_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(CP_A_OUT_GPIO_PORT, &GPIO_InitStructure);


  RCC_APB2PeriphClockCmd(CP_B_OUT_GPIO_CLK, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);
  GPIO_PinRemapConfig(GPIO_Remap_TIM4, ENABLE);
  /* GPIO Configuration: TIM3 CH1 (PB6)*/
  GPIO_InitStructure.GPIO_Pin = CP_B_OUT_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(CP_B_OUT_GPIO_PORT, &GPIO_InitStructure);

  RCC_GetClocksFreq(&RCC_Clocks);
  /* TIM clock enable */
  CP_TIM_CLK_INIT(CP_TIM_CLK, ENABLE);
  /* Time base configuration */
  TIM_TimeBaseStructure.TIM_Period = 1000 - 1;
  if(RCC_Clocks.PCLK1_Frequency < RCC_Clocks.HCLK_Frequency)
    TIM_TimeBaseStructure.TIM_Prescaler = (RCC_Clocks.PCLK1_Frequency*2/1000000) - 1;
  else
    TIM_TimeBaseStructure.TIM_Prescaler = (RCC_Clocks.PCLK1_Frequency/1000000) - 1;
  TIM_TimeBaseStructure.TIM_ClockDivision = 0;
  TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
  TIM_TimeBaseInit(CP_TIM, &TIM_TimeBaseStructure);

  /* PWM1 Mode configuration: Channel1 */
  CpDutySet_A(1000);
  CpDutySet_B(1000);

  TIM_ARRPreloadConfig(CP_TIM, ENABLE);

  /* TIM3 enable counter */
  TIM_Cmd(CP_TIM, ENABLE);
}

/******************************************************************************
  : CcCheckInit
  : Ccźżʼ
  : 
  : 
******************************************************************************/
void CcCheckInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* GPIO clock enable */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Pin = Cc_A_Check_PIN;
  RCC_APB2PeriphClockCmd(Cc_A_Check_GPIO_CLK, ENABLE);
  GPIO_Init(Cc_A_Check_GPIO_PORT, &GPIO_InitStructure);

  /* GPIO clock enable */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Pin = Cc_B_Check_PIN;
  RCC_APB2PeriphClockCmd(Cc_B_Check_GPIO_CLK, ENABLE);
  GPIO_Init(Cc_B_Check_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : StopCheckInit
  : ͣźżʼ
  : 
  : 
******************************************************************************/
void StopCheckInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* GPIO clock enable */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Pin = Stop_Check_PIN;
  RCC_APB2PeriphClockCmd(Stop_Check_GPIO_CLK, ENABLE);
  GPIO_Init(Stop_Check_GPIO_PORT, &GPIO_InitStructure);
}
/******************************************************************************
  : DoorCheckInit
  : źżʼ
  : 
  : 
******************************************************************************/
void DoorCheckInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* GPIO clock enable */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Pin = Door_Check_PIN;
  RCC_APB2PeriphClockCmd(Door_Check_GPIO_CLK, ENABLE);
  GPIO_Init(Door_Check_GPIO_PORT, &GPIO_InitStructure);
}


