
#ifndef __DRV_DHT12_H__
#define __DRV_DHT12_H__

#include "Global.h"

#define Dht12_SCL_GPIO_CLK               RCC_AHB1Periph_GPIOC
#define Dht12_SCL_GPIO_PORT              GPIOC
#define Dht12_SCL_PIN                    GPIO_Pin_15

#define Dht12_SDA_GPIO_CLK               RCC_AHB1Periph_GPIOC
#define Dht12_SDA_GPIO_PORT              GPIOC
#define Dht12_SDA_PIN                    GPIO_Pin_14

#define Dht12_SlaveAddr                  (0xB8)

typedef enum
{
  eDht12_Humity_H_Addr  = 0x00,
  eDht12_Humity_L_Addr  = 0x01,
  eDht12_Temp_H_Addr    = 0x02,
  eDht12_Temp_L_Addr    = 0x03,
  eDht12_ChkSum_Addr    = 0x04,
  eDht12_end            = 0x05,
}EnumDht12DataAddr;

typedef enum
{
  eDht12Err_Sucess = 0, //ɹ
  eDht12Err_DataPiont,  //ָΪ
  eDht12Err_BusErr,     //ߴ
  eDht12Err_WriteCmd,   //豸ӵַдӦ
  eDht12Err_ReadCmd,    //豸ӵַӦ
  eDht12Err_RegAddr,    //ĴߵַӦ
  //eDht12Err_ChkSum,
  eDht12Err_Error,      //
}EnumDht12Error;

typedef enum
{
  eDht12_HumityNum = 0,
  eDht12_TempNum = 1,
  eDht12_Num,
}EnumDht12Num;

typedef struct
{
  u8 ValidFlag;
  u16 Dht12Humity;
  s16 Dht12Temp;
  //u8 ChkSum;
}StructDht12Data;
extern StructDht12Data Dht12Data;
extern u8 Dht12Error;

extern u8 Dht12Init(void);
extern EnumDht12Error Dht12ReadData(u8 *pDh12);
extern u8 Dht12_GetHumiAndTemp(void);
extern u16 Dht12_GetHumi(void);
extern s16 Dht12_GetTemp(void);

#endif

