
#ifndef __DRV_IMDJYC_H__
#define __DRV_IMDJYC_H__

#include "Global.h"


#define Imd_USARTx_BaudRate      (9600)

#define Imd_USARTx                           USART2
#define Imd_USARTx_CLK                       RCC_APB1Periph_USART2
#define Imd_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define Imd_USARTx_IRQn                      USART2_IRQn
#define Imd_USARTx_IRQHandler                USART2_IRQHandler

#define Imd_USARTx_TX_PIN                    GPIO_Pin_5
#define Imd_USARTx_TX_GPIO_PORT              GPIOD
#define Imd_USARTx_TX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define Imd_USARTx_TX_SOURCE                 GPIO_PinSource5
#define Imd_USARTx_TX_AF                     GPIO_AF_USART2

#define Imd_USARTx_RX_PIN                    GPIO_Pin_6
#define Imd_USARTx_RX_GPIO_PORT              GPIOD
#define Imd_USARTx_RX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define Imd_USARTx_RX_SOURCE                 GPIO_PinSource6
#define Imd_USARTx_RX_AF                     GPIO_AF_USART2

#define Imd_RxTxEn_PIN                       GPIO_Pin_7
#define Imd_RxTxEn_GPIO_PORT                 GPIOD
#define Imd_RxTxEn_GPIO_CLK                  RCC_AHB1Periph_GPIOD


#define ImdRtuAddr        (0x01)
#define ImdRtuAddr_B        (0x02)

typedef struct
{
  u8  Vaild;
  u8  PositWarn;
  u8  NegatWarn;
  u16 PositVolt;
  u16 NegatVolt;
  u16 PnVolt;
  u16 PositResist;
  u16 NegatResist;
}StructImdValue;

extern StructImdValue ImdValue;
extern StructImdValue ImdValue_B;


extern u8 ImdInit(void);
extern int ImdRead(StructImdValue *pImdValue);
extern int ImdWrite(u16 Addr, u16 Value);
extern int ImdAddrSet(u8 addr, u8 changeaddr);

extern int ImdRead_B(StructImdValue *pImdValue);
extern int ImdWrite_B(u16 Addr, u16 Value);

#endif

