
/******************************************************************************
ļ  : Drv_Internet.c
  : ̨
  :
޸  : 2014-09-04      

******************************************************************************/

#include "Drv_InternetBsb.h"

#include "Drv_W5500.h"

#include "Drv_DtuG7710.h"

#include "Drv_Meter.h"

#include "Thd_Lcd.h"

#include "Drv_Adc.h"

#define MaxSizeRecvMsgQ  (1024+512)

osMessageQId InternetDataRecvMsg = NULL;

const StructNetDrv NetDrvHandle[] =
{
  {
    W5500_Init,
    CableNetAvail,
    CableNetClose,
    W5500_Send
  }
};

StructNetDrv *pNetDrv = NULL;

void NetInit(osMessageQId AppRecvQ)
{
  if(pNetDrv)
    pNetDrv->pNetInit(AppRecvQ);
}

u8 NetAvail(void)
{
  if(pNetDrv)
    return pNetDrv->pNetAvail();
  return FALSE;
}

void NetClose(void)
{
  if(pNetDrv)
    pNetDrv->pNetClose();
}

static int InternetFrameSend(u8 *pData, u16 Len)
{
  if(0 == UserParam.HadSigned)
    return -1;
  if(pNetDrv)
    return pNetDrv->pNetSend(pData, Len);
  return -2;
}

/******************************************************************************
  : InternetInit
  : ͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 InternetInit(void)
{
  /* Create Storage Message Queue */
  InternetDataRecvMsg = NULL;
  osMessageQDef(InternetDataRecvMsg, MaxSizeRecvMsgQ, u8);
  InternetDataRecvMsg = osMessageCreate(osMessageQ(InternetDataRecvMsg), NULL);

  if(UserParam.NetType < 1)
  {
    pNetDrv = (StructNetDrv*)&NetDrvHandle[UserParam.NetType];
  }
  else
  {
    pNetDrv = (StructNetDrv*)&NetDrvHandle[0];
  }

  NetInit(InternetDataRecvMsg);

  return TRUE;
}

/******************************************************************
*    ƣ InternetFrameRecv
*       ȡڽն(FIFO)һ֡
            һ֡EEͷFF FC FF FF βһ֡
*ڲ 
*ڲ 
********************************************************************/
u8 InternetFrameRecv(u8 *pFrame)
{
  static u8 Buffer[512];
  static u16 BufPos = 0;
  static u32 LastRecvTick = 0;

  osEvent RecvDataMsg;
  u16 FrameLen;
  u16 i;
  u8 ChkSum;

  RecvDataMsg = osMessageGet(InternetDataRecvMsg, 0);
  while((osEventMessage == RecvDataMsg.status) && (BufPos < sizeof(Buffer)))
  {
    LastRecvTick = GetSystemTick();
    Buffer[BufPos] = RecvDataMsg.value.v;
    BufPos++;
    if(BufPos >= sizeof(Buffer))
      break;
    RecvDataMsg = osMessageGet(InternetDataRecvMsg, 0);
  }

  while(BufPos > 9)
  {
    if((0x68 == Buffer[0]) && (0x00 == Buffer[7]) && (0x01 == Buffer[8]))
    {//֡ͷ֡ϣ汾0x80Э
      FrameLen = (Buffer[2] * 256) + Buffer[1] + 27 + 1 + 1;
      if(BufPos >= FrameLen)
      {//֡ѽ꣬У֡
        if(0x16 == Buffer[FrameLen-2])
        {
          ChkSum = 0;
          for(i=0; i<FrameLen; i++)
            ChkSum += Buffer[i];

          if(0xFF == ChkSum)
          {
            memcpy(pFrame, Buffer, FrameLen);
            BufPos -= FrameLen;
            memmove(&Buffer[0], &Buffer[FrameLen], BufPos);
            return TRUE;
          }
        }
      }
      else
        break;
    }
    BufPos--;
    memmove(&Buffer[0], &Buffer[1], BufPos);
  }

  if((GetSystemTick() - LastRecvTick) > 5000)
  {
    LastRecvTick = GetSystemTick();
    BufPos = 0;
  }

  return FALSE;
}

int BuildFrameHead(u8 Cmd, u32 Resp, u8 ChgNum, u8 *pData)
{
  u8 Len = 0;
  StructTime Time;
  u32 Temp;

  Len = 0;

  pData[Len++] = 0x68;//ַ  BIN  1  0x68

  pData[Len++] = 0x00;//*ĳ  BIN  2
  pData[Len++] = 0x00;

  if(UserParam.HadSigned)
    Temp = 1;
  else
    Temp = 0;
  pData[Len++] = Temp;//Ƿע  BIN  1

  pData[Len++] = Resp>>16;////Ӧ  BIN  3
  pData[Len++] = Resp>>8;
  pData[Len++] = Resp;

  pData[Len++] = 0x00;//Ӫ  BCD  2
  pData[Len++] = 0x01;

  pData[Len++] = UserParam.PillarNum[0];//豸ַ  BCD  8
  pData[Len++] = UserParam.PillarNum[1];
  pData[Len++] = UserParam.PillarNum[2];
  pData[Len++] = UserParam.PillarNum[3];
  pData[Len++] = UserParam.PillarNum[4];
  pData[Len++] = UserParam.PillarNum[5];
  pData[Len++] = UserParam.PillarNum[6];
  pData[Len++] = UserParam.PillarNum[7];

  pData[Len++] = Cmd;//֡  BIN  1

  StampToTime(RtcGetTime(), &Time);
  Temp = Time.Year/100;//ˮ  BCD  7
  pData[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Temp = Time.Year%100;
  pData[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  pData[Len++] = (((Time.Mon/10)<<4)&0xF0) | ((Time.Mon%10)&0x0F);
  pData[Len++] = (((Time.Day/10)<<4)&0xF0) | ((Time.Day%10)&0x0F);
  pData[Len++] = (((Time.Hour/10)<<4)&0xF0) | ((Time.Hour%10)&0x0F);
  pData[Len++] = (((Time.Min/10)<<4)&0xF0) | ((Time.Min%10)&0x0F);
  pData[Len++] = (((Time.Sec/10)<<4)&0xF0) | ((Time.Sec%10)&0x0F);
  
 

  pData[Len++] = __PillarType__;//׮  BIN 1    0ǹ  0x00   1˫ǹ  0x01  2. ֱǹ  0x02  3. ֱ˫ǹ  0x03
  pData[Len++] = ChgNum;//ǹ  BIN 1 0. ע  0x00  1. A  0x01  2B  0x02

  return Len;
}

int BuildFrameHeadAck(u8 Cmd, u32 Resp, u8 *pFrame, u8 *pData)
{
  memcpy(pData, pFrame, 27);
  pData[4] = Resp>>16;////Ӧ  BIN  3
  pData[5] = Resp>>8;
  pData[6] = Resp;

  pData[17] = Cmd;

  return 27;
}

int BuildFrameTail(u8 *pData, u16 Len)
{
  u16 i;
  u32 Temp;

  Temp = Len - 27;
  pData[1] = ((u8)Temp>>0);
  pData[2] = ((u8)(Temp>>8));//֡

  pData[Len++] = 0x16;

  Temp = 0;
  for(i=0; i<Len; i++)
    Temp += pData[i];
  Temp = ~Temp;
  pData[Len++] = (u8)Temp;//У

  return Len;
}

//(0x10) ϵͳѯǩϱ
int SendPillarSignIn(u8 ChgNum)
{
  u8 Data[128] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendPillarSignIn, 0, ChgNum, Data);

  Data[Len++] = 0x00;//ע˺  BCD  4
  Data[Len++] = 0x00;
  Data[Len++] = 0x50;
  Data[Len++] = 0x24;

  Data[Len++] = 0x21;//ע  BCD  4
  Data[Len++] = 0x96;
  Data[Len++] = 0x85;
  Data[Len++] = 0x02;

  Data[Len++] = 0x01;//  豸һ  BCD 1   4λ0׮   1ֱ׮    4λ豸߱ĳ  0-n
  Data[Len++] = 0x00;//豸  BCD  1    豸ͺ

  Data[Len++] = 0x00;//SN  BCD  8
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;

  Data[Len++] = 0x00;//*GPS  BIN  4
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;

  Data[Len++] = 0x00;//*GPSγ  BIN  4
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;
  Data[Len++] = 0x00;

  Data[Len++] = (u8)(__SoftVer__>>8);//汾  BCD  2
  Data[Len++] = (u8)(__SoftVer__&0x00FF);

  Data[Len++] = (u8)(__ProtocolVer__ >> 8);//ͨѶЭ汾  BCD  2
  Data[Len++] = (u8)(__ProtocolVer__ & 0x00FF);

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//(0x58) ԶϢϱ
int SendHeartBeat(u8 ChgNum)
{
  StructReserveParam *pReserveParam;
  StructChgRecd *pChgRecd;
  StructMeterValue *pMeterValue;
  EnumSwitchStatus  (*pGetCcStatus)(void);
  UnionPillarError *pChargeError;
  u32 Temp,Temp1;
  s32 sTemp;

  u8 Data[128] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendHeartBeat, 0, ChgNum, Data);

#if 1
//  if((2 == ChgNum) && (0 == UserParam.ChgFun.Value.Num_B))
//    return -3;
  if(2 == ChgNum)
  {
    pChgRecd = &CurChgRecd_B;
    pReserveParam = &ReserveParam_B;
    pMeterValue = &MeterValue_B;
    pGetCcStatus = &CcStatusRead_B;
    pChargeError = &PillarError_B;

    if(pReserveParam->ValidFlag)
      Temp = 1;
    else
      Temp = 0;
    Data[Len++] = (u8)Temp;//ԤԼ״̬  BIN  1

    if(pChgRecd->RecordValid || ((NULL != pCurChgRecd_AB) && (pCurChgRecd_AB->RecordValid)))
      Temp = 1;
    else if(pReserveParam->ValidFlag)
      Temp = 2;
    else
      Temp = 0;
    //Temp += (ChgNum << 4);
    Data[Len++] = (u8)Temp;//  ׮״̬  BIN 1   4λʾ  0-ǹ1-Aڣ2-B  4λʾÿ״̬  0-    1-  2-  ԤԼ

    if(pChgRecd->RecordValid)
      Temp = pChgRecd->ChgEnergy/10;
    else
      Temp = 0;
    Data[Len++] = (u8)(Temp>>0);//*γ()  BIN  4  0.01Kwh/bit
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);
    Data[Len++] = (u8)(Temp>>24);

    if(pChgRecd->RecordValid)
      Temp = pChgRecd->TotalMoney;
    else
      Temp = 0;
    Data[Len++] = (u8)(Temp>>0);//*γ(Ԫ)  BIN  4
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);
    Data[Len++] = (u8)(Temp>>24);


    Data[Len++] = 0x00;//ͣλ״̬  BIN  1
    Data[Len++] = 0x00;//ͣλǷ  BIN  1

    if(0 == pChargeError->Mult)
      Temp = 0x00;
    else if(pChargeError->Value.Emergency)
      Temp = 0x01;
    else if(pChargeError->Value.Meter)
      Temp = 0x02;
    //else if(pChargeError->Value.Meter)
    //  Temp = 0x03;
    else if(pChargeError->Value.Reader)
      Temp = 0x04;
    else if(pChargeError->Value.Insulation)
      Temp = 0x07;
    else if(pChargeError->Value.Door)
      Temp = 0x11;
    else if(pChargeError->Value.SPD)
      Temp = 0x12;
    else if(pChargeError->Value.ACMeter)
      Temp = 0x13;
    else
      Temp = 0x0A;
    Data[Len++] = (u8)Temp;//  ϴ    BIN 1

    Temp = pMeterValue->Voltage*10;
    Data[Len++] = (u8)Temp;//ѹ(V)  BIN  3  ϵΪ0.01
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);

    Temp = pMeterValue->Current/10;
    Data[Len++] = (u8)Temp;//(A)  BIN  3  ϵΪ0.01
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);

    if(pChgRecd->RecordValid)
      Temp = pChgRecd->ChgTime/60;
    else
      Temp = 0;
    Data[Len++] = (u8)Temp;//ʱ()  BIN  3  ϵΪ1
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);

    Temp = ((long long)pMeterValue->Voltage) * ((long long)pMeterValue->Current)/10000;
    Data[Len++] = (u8)Temp;//(W)  BIN  3  ϵΪ1
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);

    if(eSwSta_Off == pGetCcStatus())
      Temp = 0x00;
    //else if(eCnctSta_ConnectError == pGetCcStatus())
      //Temp = 0x02;
    else
      Temp = 0x01;
    Data[Len++] = (u8)Temp;//ӿ״̬  BIN  1

    if(((eChgPro_B_ChgRun == ChargeCtrl_B.CurProcess) ||(eChgPro_B_WaitVoltChgRun == ChargeCtrl_B.CurProcess))
      && (BcsMsg_B.Valid)
      )
    {
      Data[Len++] = BcsMsg_B.CurSoc;//ǰɵ״̬SOC(%)  BIN  1  ϵΪ1
      Data[Len++] = (u8)BcsMsg_B.RemainMin;//ʣʱ  BIN  2  ϵΪ1min
      Data[Len++] = (u8)(BcsMsg_B.RemainMin>>8);
    }
    else
    {
      Data[Len++] = 0xFF;//ǰɵ״̬SOC(%)  BIN  1  ϵΪ1
      Data[Len++] = 0xFF;//ʣʱ  BIN  2  ϵΪ1min
      Data[Len++] = 0xFF;
    }

    if(0 == pChargeError->Mult)
      Temp = 0x000000;
    else if(pChargeError->Value.Emergency)
      Temp = 0x000002;
    else if(pChargeError->Value.Meter)
      Temp = 0x000004;
    else if(pChargeError->Value.Contactor)
      Temp = 0x000008;
    else if(pChargeError->Value.Reader)
      Temp = 0x000010;
    else if(pChargeError->Value.Insulation)
      Temp = 0x000080;
    else if(pChargeError->Value.OutCurrt)
      Temp = 0x000100;
    else if(pChargeError->Value.OutVolt)
      Temp = 0x000200;
    else if(pChargeError->Value.NoDcmod)
      Temp = 0x000400;
    else if(pChargeError->Value.BMS)
      Temp = 0x000800;
    else if(pChargeError->Value.InVolt)
      Temp = 0x002000;
    else if(pChargeError->Value.Door)
      Temp = 0x004000;
    else if(pChargeError->Value.SPD)
      Temp = 0x008000;
    else if(pChargeError->Value.ACMeter)
      Temp = 0x010000;
    else if(pChargeError->Value.ImdDev)
      Temp = 0x020000;
    else if(pChargeError->Value.EleLock)
      Temp = 0x040000;
    else if(pChargeError->Value.UniContactor)
      Temp = 0x080000;
    else
      Temp = 0x000001;
    Data[Len++] = (u8)Temp;//  ϴ    BIN 3//201509044λ
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);
    Data[Len++] = (u8)(Temp>>24);

    /*ȡʣ*/
    Temp = RtcGetTime()%(24*3600);//Сʱ
   Temp1= Temp = Temp/1800;//30
    if((UserParam.EnergyTimeRate[Temp] > 0) && (UserParam.EnergyTimeRate[Temp] < 5))
      Temp = UserParam.EnergyTimeRate[Temp] - 1;
    else
      Temp = 0;
	if((UserParam.ServerTimeRate[Temp1] > 0) && (UserParam.ServerTimeRate[Temp1] < 5))
    Temp1 = UserParam.ServerTimeRate[Temp1] - 1;
  else
    Temp1 = 0;
    Temp = UserParam.EnergyRate[Temp] + UserParam.ServerRate2[Temp1];
    Data[Len++] = (u8)Temp;
    Data[Len++] = (u8)(Temp>>8);

    if(pChgRecd->RecordValid)
      memcpy(&Data[Len], pChgRecd->CardNum, 10);
    else
      memset(&Data[Len], 0x00, 10);//û	BCD	10
    Len += 10;

    sTemp = UserParam.FreeTime;
    Data[Len++] = (u8)sTemp;//׮ռ÷շʱ	BIN	2
    Data[Len++] = (u8)(sTemp>>8);

    sTemp = UserParam.EmployRate;
    Data[Len++] = (u8)sTemp;//ռ÷շѷ	BIN	2
    Data[Len++] = (u8)(sTemp>>8);

    sTemp = pChgRecd->EmployMoney;
    Data[Len++] = (u8)(sTemp>>0);//׮ռ÷	BIN	4
    Data[Len++] = (u8)(sTemp>>8);
    Data[Len++] = (u8)(sTemp>>16);
    Data[Len++] = (u8)(sTemp>>24);

    sTemp = pChgRecd->EnergyMoney;
    Data[Len++] = (u8)(sTemp>>0);//	BIN	4
    Data[Len++] = (u8)(sTemp>>8);
    Data[Len++] = (u8)(sTemp>>16);
    Data[Len++] = (u8)(sTemp>>24);

    sTemp = pChgRecd->ServeMoney;
    Data[Len++] = (u8)(sTemp>>0);//	BIN	4
    Data[Len++] = (u8)(sTemp>>8);
    Data[Len++] = (u8)(sTemp>>16);
    Data[Len++] = (u8)(sTemp>>24);

    Len = BuildFrameTail(Data, Len);
  }
  else
#endif
  {
    pChgRecd = &CurChgRecd;
    pReserveParam = &ReserveParam;
    pMeterValue = &MeterValue;
    pGetCcStatus = CcStatusRead;
    pChargeError = &PillarError;

    if(pReserveParam->ValidFlag)
      Temp = 1;
    else
      Temp = 0;
    Data[Len++] = (u8)Temp;//ԤԼ״̬  BIN  1

    if(pChgRecd->RecordValid)
      Temp = 1;
    else if(pReserveParam->ValidFlag)
      Temp = 2;
    else
      Temp = 0;
    //Temp += (ChgNum << 4);
    Data[Len++] = (u8)Temp;//  ׮״̬  BIN 1   4λʾ  0-ǹ1-Aڣ2-B  4λʾÿ״̬  0-    1-  2-  ԤԼ

    if(pChgRecd->RecordValid)
      Temp = pChgRecd->ChgEnergy/10;
    else
      Temp = 0;
    Data[Len++] = (u8)(Temp>>0);//*γ()  BIN  4  0.01Kwh/bit
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);
    Data[Len++] = (u8)(Temp>>24);

    if(pChgRecd->RecordValid)
      Temp = pChgRecd->TotalMoney;
    else
      Temp = 0;
    Data[Len++] = (u8)(Temp>>0);//*γ(Ԫ)  BIN  4
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);
    Data[Len++] = (u8)(Temp>>24);


    Data[Len++] = 0x00;//ͣλ״̬  BIN  1
    Data[Len++] = 0x00;//ͣλǷ  BIN  1

    if(0 == pChargeError->Mult)
      Temp = 0x00;
    else if(pChargeError->Value.Emergency)
      Temp = 0x01;
    else if(pChargeError->Value.Meter)
      Temp = 0x02;
    //else if(pChargeError->Value.Meter)
    //  Temp = 0x03;
    else if(pChargeError->Value.Reader)
      Temp = 0x04;
    else if(pChargeError->Value.Insulation)
      Temp = 0x07;
    else if(pChargeError->Value.Door)
      Temp = 0x11;
    else if(pChargeError->Value.SPD)
      Temp = 0x12;
    else if(pChargeError->Value.ACMeter)
      Temp = 0x13;
    else
      Temp = 0x0A;
    Data[Len++] = (u8)Temp;//  ϴ    BIN 1

    Temp = pMeterValue->Voltage*10;
    Data[Len++] = (u8)Temp;//ѹ(V)  BIN  3  ϵΪ0.01
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);

    Temp = pMeterValue->Current/10;
    Data[Len++] = (u8)Temp;//(A)  BIN  3  ϵΪ0.01
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);

    if(pChgRecd->RecordValid)
      Temp = pChgRecd->ChgTime/60;
    else
      Temp = 0;
    Data[Len++] = (u8)Temp;//ʱ()  BIN  3  ϵΪ1
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);

    Temp = ((long long)pMeterValue->Voltage) * ((long long)pMeterValue->Current)/10000;
    Data[Len++] = (u8)Temp;//(W)  BIN  3  ϵΪ1
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);

    if(eSwSta_Off == pGetCcStatus())
      Temp = 0x00;
    //else if(eCnctSta_ConnectError == pGetCcStatus())
      //Temp = 0x02;
    else
      Temp = 0x01;
    Data[Len++] = (u8)Temp;//ӿ״̬  BIN  1

    if(((eChgPro_ChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_WaitVoltChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_AB_ChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_AB_WaitVoltChgRun == ChargeCtrl.CurProcess)
        )
      && (BcsMsg.Valid))
    {
      Data[Len++] = BcsMsg.CurSoc;//ǰɵ״̬SOC(%)  BIN  1  ϵΪ1
      Data[Len++] = (u8)BcsMsg.RemainMin;//ʣʱ  BIN  2  ϵΪ1min
      Data[Len++] = (u8)(BcsMsg.RemainMin>>8);
    }
    else
    {
      Data[Len++] = 0xFF;//ǰɵ״̬SOC(%)  BIN  1  ϵΪ1
      Data[Len++] = 0xFF;//ʣʱ  BIN  2  ϵΪ1min
      Data[Len++] = 0xFF;
    }

    if(0 == pChargeError->Mult)
      Temp = 0x000000;
    else if(pChargeError->Value.Emergency)
      Temp = 0x000002;
    else if(pChargeError->Value.Meter)
      Temp = 0x000004;
    else if(pChargeError->Value.Contactor)
      Temp = 0x000008;
    else if(pChargeError->Value.Reader)
      Temp = 0x000010;
    else if(pChargeError->Value.Insulation)
      Temp = 0x000080;
    else if(pChargeError->Value.OutCurrt)
      Temp = 0x000100;
    else if(pChargeError->Value.OutVolt)
      Temp = 0x000200;
    else if(pChargeError->Value.NoDcmod)
      Temp = 0x000400;
    else if(pChargeError->Value.BMS)
      Temp = 0x000800;
    else if(pChargeError->Value.InVolt)
      Temp = 0x002000;
    else if(pChargeError->Value.Door)
      Temp = 0x004000;
    else if(pChargeError->Value.SPD)
      Temp = 0x008000;
    else if(pChargeError->Value.ACMeter)
      Temp = 0x010000;
    else if(pChargeError->Value.ImdDev)
      Temp = 0x020000;
    else if(pChargeError->Value.EleLock)
      Temp = 0x040000;
    else if(pChargeError->Value.UniContactor)
      Temp = 0x080000;
    else
      Temp = 0x000001;
    Data[Len++] = (u8)Temp;//  ϴ    BIN 3//201509044λ
    Data[Len++] = (u8)(Temp>>8);
    Data[Len++] = (u8)(Temp>>16);
    Data[Len++] = (u8)(Temp>>24);

    /*ȡʣ*/
    Temp = RtcGetTime()%(24*3600);//Сʱ
    Temp1=Temp = Temp/1800;//30
    if((UserParam.EnergyTimeRate[Temp] > 0) && (UserParam.EnergyTimeRate[Temp] < 5))
      Temp = UserParam.EnergyTimeRate[Temp] - 1;
    else
      Temp = 0;
	
	 if((UserParam.ServerTimeRate[Temp1] > 0) && (UserParam.ServerTimeRate[Temp1] < 5))
    Temp1 = UserParam.ServerTimeRate[Temp1] - 1;
  else
    Temp1 = 0;
	
    Temp = UserParam.EnergyRate[Temp] + UserParam.ServerRate2[Temp1];
    Data[Len++] = (u8)Temp;
    Data[Len++] = (u8)(Temp>>8);

    if(pChgRecd->RecordValid)
      memcpy(&Data[Len], pChgRecd->CardNum, 10);
    else
      memset(&Data[Len], 0x00, 10);//û	BCD	10
    Len += 10;

    sTemp = UserParam.FreeTime;
    Data[Len++] = (u8)sTemp;//׮ռ÷շʱ	BIN	2
    Data[Len++] = (u8)(sTemp>>8);

    sTemp = UserParam.EmployRate;
    Data[Len++] = (u8)sTemp;//ռ÷շѷ	BIN	2
    Data[Len++] = (u8)(sTemp>>8);

    sTemp = pChgRecd->EmployMoney;
    Data[Len++] = (u8)(sTemp>>0);//׮ռ÷	BIN	4
    Data[Len++] = (u8)(sTemp>>8);
    Data[Len++] = (u8)(sTemp>>16);
    Data[Len++] = (u8)(sTemp>>24);

    sTemp = pChgRecd->EnergyMoney;
    Data[Len++] = (u8)(sTemp>>0);//	BIN	4
    Data[Len++] = (u8)(sTemp>>8);
    Data[Len++] = (u8)(sTemp>>16);
    Data[Len++] = (u8)(sTemp>>24);

    sTemp = pChgRecd->ServeMoney;
    Data[Len++] = (u8)(sTemp>>0);//	BIN	4
    Data[Len++] = (u8)(sTemp>>8);
    Data[Len++] = (u8)(sTemp>>16);
    Data[Len++] = (u8)(sTemp>>24);

    Len = BuildFrameTail(Data, Len);
  }

  return InternetFrameSend(Data, Len);
}

//eCmd_cSendPillarStatus    = 0x40,//׮״̬Ϣϱ
int SendPillarStatus(u8 ChgNum)
{
  EnumSwitchStatus  (*pGetCcStatus)(void);
  UnionPillarError *pChargeError;
  u32 Temp;

  u8 Data[256] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendPillarStatus, 0, ChgNum, Data);
#if 1
//  if((2 == ChgNum) && (0 == UserParam.ChgFun.Value.Num_B))
//    return -3;
  if(2 == ChgNum)
  {
    pGetCcStatus = CcStatusRead_B;
    pChargeError = &PillarError_B;
  }
  else
#endif
  {
    pGetCcStatus = CcStatusRead;

    pChargeError = &PillarError;
  }
  Data[Len++] = ChgNum;

  if(eSwSta_Off == pGetCcStatus())
    Temp = 0;
  else
    Temp = 1;
  Data[Len++] = (u8)Temp;//  ǹ״̬  BIN 1   00  δ  01  

  if(0 == pChargeError->Mult)
    Temp = 0x000000;
  else if(pChargeError->Value.Emergency)
    Temp = 0x000002;
  else if(pChargeError->Value.Meter)
    Temp = 0x000004;
  else if(pChargeError->Value.Contactor)
    Temp = 0x000008;
  else if(pChargeError->Value.Reader)
    Temp = 0x000010;
  else if(pChargeError->Value.Insulation)
    Temp = 0x000080;
  else if(pChargeError->Value.OutCurrt)
    Temp = 0x000100;
  else if(pChargeError->Value.OutVolt)
    Temp = 0x000200;
  else if(pChargeError->Value.NoDcmod)
    Temp = 0x000400;
  else if(pChargeError->Value.BMS)
    Temp = 0x000800;
  else if(pChargeError->Value.InVolt)
    Temp = 0x002000;
  else if(pChargeError->Value.Door)
    Temp = 0x004000;
  else if(pChargeError->Value.SPD)
    Temp = 0x008000;
  else if(pChargeError->Value.ACMeter)
    Temp = 0x010000;
  else if(pChargeError->Value.ImdDev)
    Temp = 0x020000;
  else if(pChargeError->Value.EleLock)
    Temp = 0x040000;
  else if(pChargeError->Value.UniContactor)
    Temp = 0x080000;
  else
    Temp = 0x000001;

  Data[Len++] = (u8)Temp;//  ϴ    BIN 3//201509044λ
  Data[Len++] = (u8)(Temp>>8);
  Data[Len++] = (u8)(Temp>>16);
  Data[Len++] = (u8)(Temp>>24);

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//(0x78)׮նϱ¼
int SendChgRecord(u8 ChgNum)
{
  s32 sTemp;
  u8 i;
  StructChgRecd *pChgRecd;
  StructTime Time;
  u32 Temp;

  u8 Data[256] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendChgRecord, 0, ChgNum, Data);

#if 1
//  if((2 == ChgNum) && (0 == UserParam.ChgFun.Value.Num_B))
//    return -3;
  if(2 == ChgNum)
  {
    pChgRecd = &CurChgRecd_B;
  }
  else
#endif
  {
    pChgRecd = &CurChgRecd;
  }

  StampToTime(pChgRecd->ChgStartTime, &Time);
  Temp = Time.Year/100;
  Data[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Temp = Time.Year%100;
  Data[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Data[Len++] = (((Time.Mon/10)<<4)&0xF0) | ((Time.Mon%10)&0x0F);
  Data[Len++] = (((Time.Day/10)<<4)&0xF0) | ((Time.Day%10)&0x0F);
  Data[Len++] = (((Time.Hour/10)<<4)&0xF0) | ((Time.Hour%10)&0x0F);
  Data[Len++] = (((Time.Min/10)<<4)&0xF0) | ((Time.Min%10)&0x0F);
  Data[Len++] = (((Time.Sec/10)<<4)&0xF0) | ((Time.Sec%10)&0x0F);

  StampToTime(pChgRecd->ChgStopTime, &Time);
  Temp = Time.Year/100;
  Data[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Temp = Time.Year%100;
  Data[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Data[Len++] = (((Time.Mon/10)<<4)&0xF0) | ((Time.Mon%10)&0x0F);
  Data[Len++] = (((Time.Day/10)<<4)&0xF0) | ((Time.Day%10)&0x0F);
  Data[Len++] = (((Time.Hour/10)<<4)&0xF0) | ((Time.Hour%10)&0x0F);
  Data[Len++] = (((Time.Min/10)<<4)&0xF0) | ((Time.Min%10)&0x0F);
  Data[Len++] = (((Time.Sec/10)<<4)&0xF0) | ((Time.Sec%10)&0x0F);

  memcpy(&Data[Len], pChgRecd->CardNum, 10);//û  BCD  10
  Len += 10;

  Temp = pChgRecd->StartMeterEnergy/10;
  Data[Len++] = (u8)(Temp>>0);//*ǰ  BIN  4  ϵΪ0.01
  Data[Len++] = (u8)(Temp>>8);
  Data[Len++] = (u8)(Temp>>16);
  Data[Len++] = (u8)(Temp>>24);

  Temp = pChgRecd->StopMeterEnergy/10;
  Data[Len++] = (u8)(Temp>>0);//*  BIN  4  ϵΪ0.01
  Data[Len++] = (u8)(Temp>>8);
  Data[Len++] = (u8)(Temp>>16);
  Data[Len++] = (u8)(Temp>>24);

  Temp = pChgRecd->ChgEnergy/10;
  Data[Len++] = (u8)(Temp>>0);//*γ  BIN  4  ϵΪ0.01
  Data[Len++] = (u8)(Temp>>8);
  Data[Len++] = (u8)(Temp>>16);
  Data[Len++] = (u8)(Temp>>24);

  Temp = pChgRecd->EnergyMoney;
  Data[Len++] = (u8)(Temp>>0);//γ(Ԫ)  BIN  4
  Data[Len++] = (u8)(Temp>>8);
  Data[Len++] = (u8)(Temp>>16);
  Data[Len++] = (u8)(Temp>>24);

  //if(pChgRecd->CardValidFlag)
    sTemp = pChgRecd->StartCardMoney;
  //else
    //sTemp = 0;
  Data[Len++] = (u8)(sTemp>>0);//*ǰ  BIN  4
  Data[Len++] = (u8)(sTemp>>8);
  Data[Len++] = (u8)(sTemp>>16);
  Data[Len++] = (u8)(sTemp>>24);

  //if(pChgRecd->CardValidFlag)
    sTemp = pChgRecd->StopCardMoney;
  //else
    //sTemp = 0;
  Data[Len++] = (u8)(sTemp>>0);//*  BIN  4
  Data[Len++] = (u8)(sTemp>>8);
  Data[Len++] = (u8)(sTemp>>16);
  Data[Len++] = (u8)(sTemp>>24);

  sTemp = pChgRecd->ServeMoney;
  Data[Len++] = (u8)(sTemp>>0);//*ѽ  BIN  2
  Data[Len++] = (u8)(sTemp>>8);

  //if(pChgRecd->MoneyDecFlag)
  //  Temp = 1;
  //else
  //  Temp = 0;
  Data[Len++] = pChgRecd->MoneyDecFlag;//Ƿ֧  BIN 1

  for(i=0; i<48; i++)
  {
    Temp = pChgRecd->ChgEnergySeg[i];
    Data[Len++] = (u8)(Temp>>0);
    Data[Len++] = (u8)(Temp>>8);//ʱ1 2 [00:00:00~00:30:00]
  }

  if(pChgRecd->CardValidFlag)
    Temp = 0;
  else
    Temp = 1;
  Data[Len++] = (u8)(Temp>>0);//ʽ    0ˢ  1̨  2عԱ

  sTemp = pChgRecd->EmployMoney;
  Data[Len++] = (u8)(sTemp>>0);//׮ռ÷	BIN	4
  Data[Len++] = (u8)(sTemp>>8);
  Data[Len++] = (u8)(sTemp>>16);
  Data[Len++] = (u8)(sTemp>>24);

  Data[Len++] = pChgRecd->ChgStopType;

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//¼
int SendAwaitChgRecd(StructAwaitChgRecdLog *pChgLog)
{
  u32 sTemp;
  u8 i;
  StructTime Time;
  u32 Temp;

  u8 Data[256] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendAwaitChgRecd, 0, pChgLog->ChgNum, Data);

  StampToTime(pChgLog->ChgStartTime, &Time);
  Temp = Time.Year/100;
  Data[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Temp = Time.Year%100;
  Data[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Data[Len++] = (((Time.Mon/10)<<4)&0xF0) | ((Time.Mon%10)&0x0F);
  Data[Len++] = (((Time.Day/10)<<4)&0xF0) | ((Time.Day%10)&0x0F);
  Data[Len++] = (((Time.Hour/10)<<4)&0xF0) | ((Time.Hour%10)&0x0F);
  Data[Len++] = (((Time.Min/10)<<4)&0xF0) | ((Time.Min%10)&0x0F);
  Data[Len++] = (((Time.Sec/10)<<4)&0xF0) | ((Time.Sec%10)&0x0F);

  StampToTime(pChgLog->ChgStopTime, &Time);
  Temp = Time.Year/100;
  Data[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Temp = Time.Year%100;
  Data[Len++] = (((Temp/10)<<4)&0xF0) | ((Temp%10)&0x0F);
  Data[Len++] = (((Time.Mon/10)<<4)&0xF0) | ((Time.Mon%10)&0x0F);
  Data[Len++] = (((Time.Day/10)<<4)&0xF0) | ((Time.Day%10)&0x0F);
  Data[Len++] = (((Time.Hour/10)<<4)&0xF0) | ((Time.Hour%10)&0x0F);
  Data[Len++] = (((Time.Min/10)<<4)&0xF0) | ((Time.Min%10)&0x0F);
  Data[Len++] = (((Time.Sec/10)<<4)&0xF0) | ((Time.Sec%10)&0x0F);

  memcpy(&Data[Len], pChgLog->CardNum, 10);//û  BCD  10
  Len += 10;

  Temp = pChgLog->StartMeterEnergy/10;
  Data[Len++] = (u8)(Temp>>0);//*ǰ  BIN  4  ϵΪ0.01
  Data[Len++] = (u8)(Temp>>8);
  Data[Len++] = (u8)(Temp>>16);
  Data[Len++] = (u8)(Temp>>24);

  Temp = pChgLog->StopMeterEnergy/10;
  Data[Len++] = (u8)(Temp>>0);//*  BIN  4  ϵΪ0.01
  Data[Len++] = (u8)(Temp>>8);
  Data[Len++] = (u8)(Temp>>16);
  Data[Len++] = (u8)(Temp>>24);

  Temp = 0;
  for(i=0; i<48; i++)
  {
    Temp += pChgLog->ChgEnergySeg[i];
  }
  //Temp = (pChgLog->StopMeterEnergy - pChgLog->StartMeterEnergy)/10;
  Data[Len++] = (u8)(Temp>>0);//*γ  BIN  4  ϵΪ0.01
  Data[Len++] = (u8)(Temp>>8);
  Data[Len++] = (u8)(Temp>>16);
  Data[Len++] = (u8)(Temp>>24);

  sTemp = pChgLog->EnergyMoney;
  Data[Len++] = (u8)(sTemp>>0);//*γ(Ԫ)  BIN  4
  Data[Len++] = (u8)(sTemp>>8);
  Data[Len++] = (u8)(sTemp>>16);
  Data[Len++] = (u8)(sTemp>>24);

  sTemp = pChgLog->StartCardMoney;
  Data[Len++] = (u8)(sTemp>>0);//*ǰ  BIN  4
  Data[Len++] = (u8)(sTemp>>8);
  Data[Len++] = (u8)(sTemp>>16);
  Data[Len++] = (u8)(sTemp>>24);

  sTemp = 0;//sTemp = pChgLog->StopCardMoney;
  Data[Len++] = (u8)(sTemp>>0);//*  BIN  4
  Data[Len++] = (u8)(sTemp>>8);
  Data[Len++] = (u8)(sTemp>>16);
  Data[Len++] = (u8)(sTemp>>24);

  sTemp = pChgLog->ServeMoney;
  Data[Len++] = (u8)(sTemp>>0);//*ѽ  BIN  2
  Data[Len++] = (u8)(sTemp>>8);

  //if(pChgLog->MoneyDecFlag)
  //  Temp = 1;
  //else
  //  Temp = 0;
  Data[Len++] = pChgLog->MoneyDecFlag;//Ƿ֧  BIN 1

  for(i=0; i<48; i++)
  {
    Temp = pChgLog->ChgEnergySeg[i];
    Data[Len++] = (u8)(Temp>>0);
    Data[Len++] = (u8)(Temp>>8);//ʱ1 2 [00:00:00~00:30:00]
  }

  if(pChgLog->CardValidFlag)
    Temp = 0;
  else
    Temp = 1;
  Data[Len++] = (u8)(Temp>>0);//ʽ    0ˢ  1̨  2عԱ

  sTemp = pChgLog->EmployMoney;
  Data[Len++] = (u8)(sTemp>>0);//׮ռ÷	BIN	4
  Data[Len++] = (u8)(sTemp>>8);
  Data[Len++] = (u8)(sTemp>>16);
  Data[Len++] = (u8)(sTemp>>24);

  Data[Len++] = pChgLog->ChgStopType;

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//ϴ翪ʼ
int SendStartTransaction(u8 ChgNum)
{
  StructChgRecd *pChgRecd;
  s32 sTemp;

  u8 Data[128] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendStartTransaction, 0, ChgNum, Data);

#if 1
//  if((2 == ChgNum) && (0 == UserParam.ChgFun.Value.Num_B))
//    return -3;
  if(2 == ChgNum)
  {
    pChgRecd = &CurChgRecd_B;

    Data[Len++] = ChgNum;//ں  BIN  1
    Data[Len++] = 4;//  BIN  1
    Data[Len++] = 0;//*  BIN  4
    Data[Len++] = 0;
    Data[Len++] = 0;
    Data[Len++] = 0;

    Data[Len++] = 0;//ʱ  BCD  4
    Data[Len++] = 0;
    Data[Len++] = 0;
    Data[Len++] = 0;

    memcpy(&Data[Len], pChgRecd->CardNum, 10);//û  BCD  10
    Len += 10;

    sTemp = pChgRecd->StartCardMoney;
    Data[Len++] = (u8)(sTemp>>0);//*ǰ  BIN  4
    Data[Len++] = (u8)(sTemp>>8);
    Data[Len++] = (u8)(sTemp>>16);
    Data[Len++] = (u8)(sTemp>>24);

    if(((eChgPro_B_ChgRun == ChargeCtrl_B.CurProcess) ||(eChgPro_B_WaitVoltChgRun == ChargeCtrl_B.CurProcess))
      && (BrmMsg_B.Valid)
      )
    {
      memcpy(&Data[Len], BrmMsg_B.Vin, 17);//ʶ  BIN  17
      Len += 17;

      Data[Len++] = BrmMsg_B.BatType;//  BIN  1

      Data[Len++] = BrmMsg_B.Manufacturer[0];//  ASCII  4
      Data[Len++] = BrmMsg_B.Manufacturer[1];
      Data[Len++] = BrmMsg_B.Manufacturer[2];
      Data[Len++] = BrmMsg_B.Manufacturer[3];

      Data[Len++] = BrmMsg_B.ProduceNum[0];//  BIN  4
      Data[Len++] = BrmMsg_B.ProduceNum[1];
      Data[Len++] = BrmMsg_B.ProduceNum[2];
      Data[Len++] = BrmMsg_B.ProduceNum[3];

      Data[Len++] = (u8)(BrmMsg_B.BatRateCap>>0);//ض  BIN  2
      Data[Len++] = (u8)(BrmMsg_B.BatRateCap>>8);

      Data[Len++] = (u8)(BrmMsg_B.ChgCount>>0);//س  BIN  3
      Data[Len++] = (u8)(BrmMsg_B.ChgCount>>8);
      Data[Len++] = (u8)(BrmMsg_B.ChgCount>>16);
    }
    else
    {
      memset(&Data[Len], 0xFF, 17);//ʶ  BIN  17
      Len += 17;

      Data[Len++] = 0xFF;//  BIN  1

      Data[Len++] = 0xFF;//  ASCII  4
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;

      Data[Len++] = 0xFF;//  BIN  4
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;

      Data[Len++] = 0xFF;//ض  BIN  2
      Data[Len++] = 0xFF;

      Data[Len++] = 0xFF;//س  BIN  3
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;
    }
    if(((eChgPro_B_ChgRun == ChargeCtrl_B.CurProcess) ||(eChgPro_B_WaitVoltChgRun == ChargeCtrl_B.CurProcess))
      && (BcpMsg_B.Valid))
      Data[Len++] = BcpMsg_B.StartSoc/10;//ʼSOC%  BIN  1
    else
      Data[Len++] = 0xFF;//ʼSOC%  BIN  1

    memset(&Data[Len], 0xFF, 6);//Ԥ  BIN  10
    Len += 6;
    memcpy(&Data[Len], pChgRecd->OrderId, 7);
    Len += 7;
    Len = BuildFrameTail(Data, Len);
  }
  else
#endif
  {
    pChgRecd = &CurChgRecd;

    Data[Len++] = ChgNum;//ں  BIN  1
    Data[Len++] = 4;//  BIN  1
    Data[Len++] = 0;//*  BIN  4
    Data[Len++] = 0;
    Data[Len++] = 0;
    Data[Len++] = 0;

    Data[Len++] = 0;//ʱ  BCD  4
    Data[Len++] = 0;
    Data[Len++] = 0;
    Data[Len++] = 0;

    memcpy(&Data[Len], pChgRecd->CardNum, 10);//û  BCD  10
    Len += 10;

    sTemp = pChgRecd->StartCardMoney;
    Data[Len++] = (u8)(sTemp>>0);//*ǰ  BIN  4
    Data[Len++] = (u8)(sTemp>>8);
    Data[Len++] = (u8)(sTemp>>16);
    Data[Len++] = (u8)(sTemp>>24);

    if(((eChgPro_ChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_WaitVoltChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_AB_ChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_AB_WaitVoltChgRun == ChargeCtrl.CurProcess)
        )
      && (BrmMsg.Valid))
    {
      memcpy(&Data[Len], BrmMsg.Vin, 17);//ʶ  BIN  17
      Len += 17;

      Data[Len++] = BrmMsg.BatType;//  BIN  1

      Data[Len++] = BrmMsg.Manufacturer[0];//  ASCII  4
      Data[Len++] = BrmMsg.Manufacturer[1];
      Data[Len++] = BrmMsg.Manufacturer[2];
      Data[Len++] = BrmMsg.Manufacturer[3];

      Data[Len++] = BrmMsg.ProduceNum[0];//  BIN  4
      Data[Len++] = BrmMsg.ProduceNum[1];
      Data[Len++] = BrmMsg.ProduceNum[2];
      Data[Len++] = BrmMsg.ProduceNum[3];

      Data[Len++] = (u8)(BrmMsg.BatRateCap>>0);//ض  BIN  2
      Data[Len++] = (u8)(BrmMsg.BatRateCap>>8);

      Data[Len++] = (u8)(BrmMsg.ChgCount>>0);//س  BIN  3
      Data[Len++] = (u8)(BrmMsg.ChgCount>>8);
      Data[Len++] = (u8)(BrmMsg.ChgCount>>16);
    }
    else
    {
      memset(&Data[Len], 0xFF, 17);//ʶ  BIN  17
      Len += 17;

      Data[Len++] = 0xFF;//  BIN  1

      Data[Len++] = 0xFF;//  ASCII  4
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;

      Data[Len++] = 0xFF;//  BIN  4
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;

      Data[Len++] = 0xFF;//ض  BIN  2
      Data[Len++] = 0xFF;

      Data[Len++] = 0xFF;//س  BIN  3
      Data[Len++] = 0xFF;
      Data[Len++] = 0xFF;
    }
    if(((eChgPro_ChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_WaitVoltChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_AB_ChgRun == ChargeCtrl.CurProcess)
        || (eChgPro_AB_WaitVoltChgRun == ChargeCtrl.CurProcess)
        )
      && (BcpMsg.Valid))
      Data[Len++] = BcpMsg.StartSoc/10;//ʼSOC%  BIN  1
    else
      Data[Len++] = 0xFF;//ʼSOC%  BIN  1

    memset(&Data[Len], 0xFF, 6);//Ԥ  BIN  10
    Len += 6;
    memcpy(&Data[Len], pChgRecd->OrderId, 7);
    Len += 7;
    Len = BuildFrameTail(Data, Len);
  }

  return InternetFrameSend(Data, Len);
}

//ϴֹͣϢ
int SendStopTransaction(u8 ChgNum)
{
  StructChgRecd *pChgRecd;
  u32 Temp;

  u8 Data[128] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendStopTransaction, 0, ChgNum, Data);
#if 1
//  if((2 == ChgNum) && (0 == UserParam.ChgFun.Value.Num_B))
//    return -3;
  if(2 == ChgNum)
  {
    pChgRecd = &CurChgRecd_B;

    Data[Len++] = ChgNum;//ں  BIN  1
    Data[Len++] = 4;//  BIN  1

    memcpy(&Data[Len], pChgRecd->CardNum, 10);//û  BCD  10
    Len += 10;

    Temp = pChgRecd->ChgTime/60;
    Data[Len++] = (u8)Temp;//ۼƳʱ  BIN  2    ۼƳʱ䣨min
    Data[Len++] = (u8)(Temp>>8);

    if(BsdMsg_B.Valid)
      Data[Len++] = BsdMsg_B.StopSOC;//ֹɵ״̬  SOC(%)  BIN 1 ϵΪ1
    else
      Data[Len++] = 0xFF;//ֹɵ״̬  SOC(%)  BIN 1 ϵΪ1

    memcpy(&Data[Len], pChgRecd->OrderId, 7);
    Len += 7;

    Len = BuildFrameTail(Data, Len);
  }
  else
#endif
  {
    pChgRecd = &CurChgRecd;

    Data[Len++] = ChgNum;//ں  BIN  1
    Data[Len++] = 4;//  BIN  1

    memcpy(&Data[Len], pChgRecd->CardNum, 10);//û  BCD  10
    Len += 10;

    Temp = pChgRecd->ChgTime/60;
    Data[Len++] = (u8)Temp;//ۼƳʱ  BIN  2    ۼƳʱ䣨min
    Data[Len++] = (u8)(Temp>>8);

    if(BsdMsg.Valid)
      Data[Len++] = BsdMsg.StopSOC;//ֹɵ״̬  SOC(%)  BIN 1 ϵΪ1
    else
      Data[Len++] = 0xFF;//ֹɵ״̬  SOC(%)  BIN 1 ϵΪ1

    memcpy(&Data[Len], pChgRecd->OrderId, 7);
    Len += 7;

    Len = BuildFrameTail(Data, Len);
  }

  return InternetFrameSend(Data, Len);
}

int SendCancelReserve(u8 ChgNum)
{
  StructReserveParam *pReserveParam;

  u8 Data[128] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendCancelReserve, 0, ChgNum, Data);
#if 1
//  if((2 == ChgNum) && (0 == UserParam.ChgFun.Value.Num_B))
//    return -3;
  if(2 == ChgNum)
  {
    pReserveParam = &ReserveParam_B;
  }
  else
#endif
  {
    pReserveParam = &ReserveParam;
  }

  Data[Len++] = ChgNum;//ں  BIN  1

  memcpy(&Data[Len], pReserveParam->CardNum, 10);//û  BCD  10
  Len += 10;

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//˳¼
int SendPillarSignOut(void)
{
  u8 Data[128] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendPillarSignOut, 0, 0, Data);

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//ˢϴ֤
int SendCardSure(u8 ChgNum)
{
  u8 Temp;
  StructChgRecd *pChgRecd;

  u8 Data[256] = {0};
  u16 Len = 0;

  Len = BuildFrameHead(eCmd_cSendCardSure, 0, ChgNum, Data);
#if 1
//  if((2 == ChgNum) && (0 == UserParam.ChgFun.Value.Num_B))
//    return -3;
  if(2 == ChgNum)
  {
    pChgRecd = &CurChgRecd_B;
  }
  else
#endif
  {
    pChgRecd = &CurChgRecd;
  }

  Data[Len++] = ChgNum;//ں  BIN  1
  memcpy(&Data[Len], pChgRecd->CardNum, 10);//û  BCD  10
  Len += 10;

  Temp = ((pChgRecd->CardPwd[0] - '0')<<4) + ((pChgRecd->CardPwd[1] - '0')&0x0F);
  Data[Len++] = Temp;//û	ACSII	3
  Temp = ((pChgRecd->CardPwd[2] - '0')<<4) + ((pChgRecd->CardPwd[3] - '0')&0x0F);
  Data[Len++] = Temp;//û	ACSII	3
  Temp = ((pChgRecd->CardPwd[4] - '0')<<4) + ((pChgRecd->CardPwd[5] - '0')&0x0F);
  Data[Len++] = Temp;//û	ACSII	3

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//ظԶ̳翪ʼ
int AckStartTransaction(u8 *pFrame, u32 Resp)
{
  u16 Pos;

  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckStartTransaction, Resp, pFrame, Data);

  Pos = 27;
  Data[Len++] = pFrame[Pos++];//ں  BIN  1
  Data[Len++] = pFrame[Pos++];//  BIN  1
  Data[Len++] = pFrame[Pos++];//*  BIN  4
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//ʱ  BCD  4
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//û  BCD  10
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//û	BIN	4
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  memset(&Data[Len], 0xFF, 17);
  Len += 17;

  Data[Len++] = 0xFF;// BIN 1

  Data[Len++] = 0xFF;// ASCII 4
  Data[Len++] = 0xFF;
  Data[Len++] = 0xFF;
  Data[Len++] = 0xFF;

  Data[Len++] = 0xFF;// BIN 4
  Data[Len++] = 0xFF;
  Data[Len++] = 0xFF;
  Data[Len++] = 0xFF;

  Data[Len++] = 0xFF;//ض BIN 2
  Data[Len++] = 0xFF;

  Data[Len++] = 0xFF;//س BIN 3
  Data[Len++] = 0xFF;
  Data[Len++] = 0xFF;

  Data[Len++] = 0xFF;//ʼSOC% BIN 1

  memset(&Data[Len], 0xFF, 6);//Ԥ BIN 6
  Len += 6;

  memcpy(&Data[Len], &pFrame[51], 7);//	BCD	7
  Len += 7;

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//ظԶֹ̳ͣ
int AckStopTransaction(u8 *pFrame, u32 Resp)
{
  u16 Pos;
  u32 Temp;
  StructChgRecd *pChgRecd;

  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckStopTransaction, Resp, pFrame, Data);
#if 1
//  if((2 == pFrame[26]) && (0 == UserParam.ChgFun.Value.Num_B))
//    return -3;
  if(2 == pFrame[26])
  {
    pChgRecd = &CurChgRecd_B;
  }
  else
#endif
  {
    pChgRecd = &CurChgRecd;
  }
  Pos = 27;
  Data[Len++] = pFrame[Pos++];//ں  BIN  1
  Data[Len++] = pFrame[Pos++];//  BIN  1

  Data[Len++] = pFrame[Pos++];//û  BCD  10
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  if(0 == Resp)
    Temp = pChgRecd->ChgTime/60;
  else
    Temp = 0;
  Data[Len++] = (u8)Temp;//ۼƳʱ  BIN  2    ۼƳʱ䣨min
  Data[Len++] = (u8)(Temp>>8);


  Data[Len++] = 0xFF;//ֹɵ״̬  SOC(%)  BIN 1 ϵΪ1

  memcpy(&Data[Len], &pFrame[39], 7);//	BCD	7
  Len += 7;

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//ظԤԼ
int AckReserveNow(u8 *pFrame, u32 Resp)
{
  u16 Pos;

  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckReserveNow, Resp, pFrame, Data);

  Pos = 27;
  Data[Len++] = pFrame[Pos++];//ں  BIN  1

  Data[Len++] = pFrame[Pos++];//û  BCD  10
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//ԤԼʱ	BIN

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

int AckCancelReserve(u8 *pFrame, u32 Resp)
{
  u16 Pos;

  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckCancelReserve, Resp, pFrame, Data);

  Pos = 27;
  Data[Len++] = pFrame[Pos++];//ں  BIN  1

  Data[Len++] = pFrame[Pos++];//û  BCD  10
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//(0x42) ׮նʱͬ
int AckPillarTimeSet(u8 *pFrame, u32 Resp)
{
  u16 Pos;

  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckTimeSyn, Resp, pFrame, Data);

  Pos = 27;
  Data[Len++] = pFrame[Pos++];//ʱ  BCD   7
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//(0x42) ׮նʱͬ
int AckSetQrcode(u8 *pFrame)
{
  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckSetQrcode, 0, pFrame, Data);

  Data[Len++] = UserParam.PillarNum[0];
  Data[Len++] = UserParam.PillarNum[1];
  Data[Len++] = UserParam.PillarNum[2];
  Data[Len++] = UserParam.PillarNum[3];
  Data[Len++] = UserParam.PillarNum[4];
  Data[Len++] = UserParam.PillarNum[5];
  Data[Len++] = UserParam.PillarNum[6];
  Data[Len++] = UserParam.PillarNum[7];

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//ظλ
int AckPillarReset(u8 *pFrame)
{
  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckPillarReset, 0, pFrame, Data);

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

//(0x42) ׮նʱͬ
int AckGetServerIp(u8 *pFrame)
{
  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckGetServerIp, 0, pFrame, Data);

  Data[Len++] = UserParam.ServerAddr.Ip[0];
  Data[Len++] = UserParam.ServerAddr.Ip[1];
  Data[Len++] = UserParam.ServerAddr.Ip[2];
  Data[Len++] = UserParam.ServerAddr.Ip[3];
  Data[Len++] = (u8)UserParam.ServerAddr.Port;
  Data[Len++] = (u8)(UserParam.ServerAddr.Port>>8);

#if 0
  Data[Len++] = 0;
  Data[Len++] = 0;
  Data[Len++] = 0;
  Data[Len++] = 0;
  Data[Len++] = 0;
  Data[Len++] = 0;
#endif

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

int AckSetServerIp(u8 *pFrame, u32 Resp)
{
  u16 Pos;

  u8 Data[128];
  u16 Len;

  Len = BuildFrameHeadAck(eCmd_cAckSetServerIp, Resp, pFrame, Data);

  Pos = 27;
  Data[Len++] = pFrame[Pos++];//Ч  BIN  1

  Data[Len++] = pFrame[Pos++];//  Чʱ  BCD   7
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//1űIPַ  BIN  4
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//1űIP˿ں  BIN  2
  Data[Len++] = pFrame[Pos++];

#if 0
  Data[Len++] = pFrame[Pos++];//2űIPַ  BIN  4
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//2űIP˿ں  BIN  2
  Data[Len++] = pFrame[Pos++];
#endif

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

int AckGetRate(u8 *pFrame)
{
  u8 Data[128];
  u16 Len;
  u32 Temp1;
    Temp1 = RtcGetTime()%(24*3600);//Сʱ
    Temp1 = Temp1/1800;//30
	
	if((UserParam.EnergyTimeRate[Temp1] > 0) && (UserParam.EnergyTimeRate[Temp1] < 5))
     Temp1 = UserParam.EnergyTimeRate[Temp1] - 1;
    else
     Temp1 = 0;
  Len = BuildFrameHeadAck(eCmd_cAckGetRate, 0, pFrame, Data);

  Data[Len++] = (u8)UserParam.EnergyRate[0];//1ŷ  BIN  2
  Data[Len++] = (u8)(UserParam.EnergyRate[0] >> 8);

  Data[Len++] = (u8)UserParam.EnergyRate[1];//2ŷ  BIN  2
  Data[Len++] = (u8)(UserParam.EnergyRate[1] >> 8);

  Data[Len++] = (u8)UserParam.EnergyRate[2];//3ŷ  BIN  2
  Data[Len++] = (u8)(UserParam.EnergyRate[2]>> 8);

  Data[Len++] = (u8)UserParam.EnergyRate[3];//4ŷ  BIN  2
  Data[Len++] = (u8)(UserParam.EnergyRate[3]>> 8);

  Data[Len++] = (u8)UserParam.ServerRate2[Temp1];//2  BIN  2
  Data[Len++] = (u8)(UserParam.ServerRate2[Temp1] >> 8);

  memcpy(&Data[Len], UserParam.EnergyTimeRate, sizeof(UserParam.EnergyTimeRate));//ʱִзʺ  BIN  48
  Len += sizeof(UserParam.EnergyTimeRate);

  Data[Len++] = (u8)UserParam.FreeTime;//ʱ BIN  2
  Data[Len++] = (u8)(UserParam.FreeTime>> 8);

  Data[Len++] = (u8)UserParam.EmployRate;//ռ÷ѷ BIN  2
  Data[Len++] = (u8)(UserParam.EmployRate >> 8);

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

int AckSetRate(u8 *pFrame, u32 Resp)
{
  u8 Data[128];
  u16 Len;
  u16 Pos;

  Len = BuildFrameHeadAck(eCmd_cAckSetRate, Resp, pFrame, Data);

  Pos = 27;
  Data[Len++] = pFrame[Pos++];//1ŷ  BIN  2
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];//2ŷ  BIN  2
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];//3ŷ  BIN  2
  Data[Len++] = pFrame[Pos++];
  Data[Len++] = pFrame[Pos++];//4ŷ  BIN  2
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//2 BIN 2
  Data[Len++] = pFrame[Pos++];

  memcpy(&Data[Len], &pFrame[Pos], sizeof(UserParam.EnergyTimeRate));//ʱִзʺ  BIN  48
  Len += sizeof(UserParam.EnergyTimeRate);
  Pos += sizeof(UserParam.EnergyTimeRate);

  Data[Len++] = pFrame[Pos++];//ʱ BIN  2
  Data[Len++] = pFrame[Pos++];

  Data[Len++] = pFrame[Pos++];//ռ÷ѷ BIN  2
  Data[Len++] = pFrame[Pos++];

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

int AckSetMoneyKey(u8 *pFrame, u32 Resp)
{
  u8 Data[128];
  u16 Len;
  u16 Pos;

  Len = BuildFrameHeadAck(eCmd_cAckSetMoneyKey, Resp, pFrame, Data);

  Pos = 27;
  memcpy(&Data[Len], &pFrame[Pos], 6);
  Len +=6;

  Len = BuildFrameTail(Data, Len);

  return InternetFrameSend(Data, Len);
}

int SendBatInfor(u8 ChgNum)
{
  u8 Data[700] = {0};
  u16 Len = 0;
  if(2 == ChgNum)
  {
    Len = BuildFrameHead(eCmd_cSendBatInfor, 0, ChgNum, Data);

    Data[Len++] = (u8)(BcpMsg_B.ChgMaxVolt>>0);//ѹ	BIN	2
    Data[Len++] = (u8)(BcpMsg_B.ChgMaxVolt>>8);

    Data[Len++] = (u8)(BcpMsg_B.ChgMaxCurrt>>0);//	BIN	2
    Data[Len++] = (u8)(BcpMsg_B.ChgMaxCurrt>>8);

    Data[Len++] = (u8)(BcpMsg_B.PerBatMaxVolt>>0);//ѹ	BIN	2
    Data[Len++] = (u8)(BcpMsg_B.PerBatMaxVolt>>8);

    Data[Len++] = (u8)(BcpMsg_B.MaxTemp>>0);//¶	BIN	1

    Data[Len++] = (u8)(BclMsg_B.NeedVolt>>0);//ѹ	BIN	2
    Data[Len++] = (u8)(BclMsg_B.NeedVolt>>8);

    Data[Len++] = (u8)(BclMsg_B.NeedCurrt>>0);//	BIN	2
    Data[Len++] = (u8)(BclMsg_B.NeedCurrt>>8);

    Data[Len++] = (u8)(BcsMsg_B.ChgVolt>>0);//ѹֵ	BIN	2	0.1V/λ
    Data[Len++] = (u8)(BcsMsg_B.ChgVolt>>8);

    Data[Len++] = (u8)(BcsMsg_B.ChgCurrt>>0);//ֵ	BIN	2
    Data[Len++] = (u8)(BcsMsg_B.ChgCurrt>>8);

    Data[Len++] = (u8)(BcsMsg_B.BatVoltAndGroup.Mult>>0);//ߵؼ	BIN	1
    Data[Len++] = (u8)(BcsMsg_B.BatVoltAndGroup.Mult>>8);

    Data[Len++] = (u8)(BcsMsg_B.CurSoc>>0);//ǰɵ״̬	BIN	1

    Data[Len++] = (u8)(BcsMsg_B.RemainMin>>0);//ߵؼ	BIN	1
    Data[Len++] = (u8)(BcsMsg_B.RemainMin>>8);

    Data[Len++] = (u8)(BsmMsg_B.HighTempBatNum>>0);//ߵڱ  BIN 1 ϵΪ1    ΧΪ1-256

    Data[Len++] = (u8)(BsmMsg_B.HighTemp>>0);//߶¶	BIN	1

    Data[Len++] = (u8)(BsmMsg_B.HighTempPointNum>>0);//ߵؼ		1

    Data[Len++] = (u8)(BsmMsg_B.LowTemp>>0);//Ͷ¶	BIN	1

    Data[Len++] = (u8)(BsmMsg_B.LowTemp>>0);//͵ؼ	BIN	1

    if(BmvMsg_B.Valid)
      memcpy(&Data[Len], BmvMsg_B.BatVoltAndGroup, sizeof(BmvMsg_B.BatVoltAndGroup));
    else
      memset(&Data[Len], 0xFF, sizeof(BmvMsg_B.BatVoltAndGroup));
    Len += sizeof(BmvMsg_B.BatVoltAndGroup);

    if(BmtMsg_B.Valid)
      memcpy(&Data[Len], BmtMsg_B.Temp, sizeof(BmtMsg_B.Temp));
    else
      memset(&Data[Len], 0xFF, sizeof(BmtMsg_B.Temp));
    Len += sizeof(BmtMsg_B.Temp);

    Len = BuildFrameTail(Data, Len);
  }
  else
  {
    Len = BuildFrameHead(eCmd_cSendBatInfor, 0, ChgNum, Data);

    Data[Len++] = (u8)(BcpMsg.ChgMaxVolt>>0);//ѹ	BIN	2
    Data[Len++] = (u8)(BcpMsg.ChgMaxVolt>>8);

    Data[Len++] = (u8)(BcpMsg.ChgMaxCurrt>>0);//	BIN	2
    Data[Len++] = (u8)(BcpMsg.ChgMaxCurrt>>8);

    Data[Len++] = (u8)(BcpMsg.PerBatMaxVolt>>0);//ѹ	BIN	2
    Data[Len++] = (u8)(BcpMsg.PerBatMaxVolt>>8);

    Data[Len++] = (u8)(BcpMsg.MaxTemp>>0);//¶	BIN	1

    Data[Len++] = (u8)(BclMsg.NeedVolt>>0);//ѹ	BIN	2
    Data[Len++] = (u8)(BclMsg.NeedVolt>>8);

    Data[Len++] = (u8)(BclMsg.NeedCurrt>>0);//	BIN	2
    Data[Len++] = (u8)(BclMsg.NeedCurrt>>8);

    Data[Len++] = (u8)(BcsMsg.ChgVolt>>0);//ѹֵ	BIN	2	0.1V/λ
    Data[Len++] = (u8)(BcsMsg.ChgVolt>>8);

    Data[Len++] = (u8)(BcsMsg.ChgCurrt>>0);//ֵ	BIN	2
    Data[Len++] = (u8)(BcsMsg.ChgCurrt>>8);

    Data[Len++] = (u8)(BcsMsg.BatVoltAndGroup.Mult>>0);//ߵؼ	BIN	1
    Data[Len++] = (u8)(BcsMsg.BatVoltAndGroup.Mult>>8);

    Data[Len++] = (u8)(BcsMsg.CurSoc>>0);//ǰɵ״̬	BIN	1

    Data[Len++] = (u8)(BcsMsg.RemainMin>>0);//ߵؼ	BIN	1
    Data[Len++] = (u8)(BcsMsg.RemainMin>>8);

    Data[Len++] = (u8)(BsmMsg.HighTempBatNum>>0);//ߵڱ  BIN 1 ϵΪ1    ΧΪ1-256

    Data[Len++] = (u8)(BsmMsg.HighTemp>>0);//߶¶	BIN	1

    Data[Len++] = (u8)(BsmMsg.HighTempPointNum>>0);//ߵؼ		1

    Data[Len++] = (u8)(BsmMsg.LowTemp>>0);//Ͷ¶	BIN	1

    Data[Len++] = (u8)(BsmMsg.LowTemp>>0);//͵ؼ	BIN	1

    if(BmvMsg.Valid)
      memcpy(&Data[Len], BmvMsg.BatVoltAndGroup, sizeof(BmvMsg.BatVoltAndGroup));
    else
      memset(&Data[Len], 0xFF, sizeof(BmvMsg.BatVoltAndGroup));
    Len += sizeof(BmvMsg.BatVoltAndGroup);

    if(BmtMsg.Valid)
      memcpy(&Data[Len], BmtMsg.Temp, sizeof(BmtMsg.Temp));
    else
      memset(&Data[Len], 0xFF, sizeof(BmtMsg.Temp));
    Len += sizeof(BmtMsg.Temp);

    Len = BuildFrameTail(Data, Len);

  }

  return InternetFrameSend(Data, Len);
}

//豸ķϢӦ
void FtpUpgradeAck(u8 *pFrame, u8 state)
{
  u8 Data[40];
  u8 Len;
  u32 Temp = 0;
  Len = BuildFrameHeadAck(eCmd_FtpUpgradeAck, Temp, pFrame, Data);
  //TODO
  Data[Len++] = state;//1:ʼ  0:쳣
  InternetFrameSend(Data, Len);
}

