
/******************************************************************************
ļ  : Drv_LcdDwin.c
  : ʿƼ 800x480
  :
޸  : 2014-09-04      

******************************************************************************/

#include "Drv_LcdDwin.h"

osMessageQId LcdDataRecvMsg = NULL;
osMessageQId LcdDataSendMsg = NULL;


osMutexId LcdMutex = NULL;
/******************************************************************************
  : LcdInit
  : ͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 LcdInit(void)
{
  USART_InitTypeDef USART_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable GPIO clock */
  /* Configure USART Tx and Rx as alternate function push-pull */

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = LCD_USARTx_TX_PIN;
  RCC_AHB1PeriphClockCmd(LCD_USARTx_TX_GPIO_CLK, ENABLE);
  GPIO_Init(LCD_USARTx_TX_GPIO_PORT, &GPIO_InitStructure);


  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = LCD_USARTx_RX_PIN;
  RCC_APB2PeriphClockCmd(LCD_USARTx_RX_GPIO_CLK, ENABLE);
  GPIO_Init(LCD_USARTx_RX_GPIO_PORT, &GPIO_InitStructure);

  /* Enable USART clock */
  LCD_USARTx_CLK_INIT(LCD_USARTx_CLK, ENABLE);

  /* Connect USART pins to AF7 */
  GPIO_PinAFConfig(LCD_USARTx_TX_GPIO_PORT, LCD_USARTx_TX_SOURCE, LCD_USARTx_TX_AF);
  GPIO_PinAFConfig(LCD_USARTx_RX_GPIO_PORT, LCD_USARTx_RX_SOURCE, LCD_USARTx_RX_AF);

  /* Enable the USART OverSampling by 8 */
  USART_OverSampling8Cmd(LCD_USARTx, ENABLE);

  /* USARTx configuration ----------------------------------------------------*/
  USART_InitStructure.USART_BaudRate = LCD_USARTx_BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(LCD_USARTx, &USART_InitStructure);

  /* Enable the USARTx Interrupt */
  NVIC_InitStructure.NVIC_IRQChannel = LCD_USARTx_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  /* Create Storage Message Queue */
  LcdDataRecvMsg = NULL;
  osMessageQDef(LcdDataRecvMsg, 128, u8);
  LcdDataRecvMsg = osMessageCreate(osMessageQ(LcdDataRecvMsg), NULL);

  LcdDataSendMsg = NULL;
  osMessageQDef(LcdDataSendMsg, 128, u8);
  LcdDataSendMsg = osMessageCreate(osMessageQ(LcdDataSendMsg), NULL);

//  if(NULL == LcdDataRecvMsg)
//    return FALSE;

  /* Enable USART */
  USART_Cmd(LCD_USARTx, ENABLE);

  /* Enable the Tx buffer empty interrupt */
  USART_ITConfig(LCD_USARTx, USART_IT_RXNE, ENABLE);

  LcdMutex = NULL;
  osMutexDef(LcdMutex);
  LcdMutex = osMutexCreate(osMutex(LcdMutex));

  return TRUE;
}

/******************************************************************************
  : LCD_USARTx_IRQHandler
  : ڽж
  : 
  : 
******************************************************************************/
void LCD_USARTx_IRQHandler(void)
{
  u16 CR1,SR;
  u8 Data;
  osEvent SendDataMsg;

  SR = LCD_USARTx->SR;
  CR1 = LCD_USARTx->CR1;
  if((CR1 & USART_CR1_RXNEIE) && (SR & USART_SR_RXNE))
  {

    Data = (u8)LCD_USARTx->DR;
    osMessagePut(LcdDataRecvMsg, Data, 0);
  }

  if((CR1 & USART_CR1_TXEIE) && (SR & USART_SR_TXE))
  {
    SendDataMsg = osMessageGet(LcdDataSendMsg, 0);
    if(osEventMessage == SendDataMsg.status)
      LCD_USARTx->DR = SendDataMsg.value.v;
    else
      LCD_USARTx->CR1 &= ~USART_CR1_TXEIE;
  }
}

/******************************************************************************
  : LcdSendData
  : ֽ
  : Data - յֽ
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
u8 LcdSendData(u8 Data)
{
  osStatus EvenStatus;

  EvenStatus = osMessagePut(LcdDataSendMsg, Data, portMAX_DELAY);
  if(osOK == EvenStatus)
  {
    LCD_USARTx->CR1 |= USART_CR1_TXEIE;
    return TRUE;
  }

  return FALSE;
}

u16 LcdCheckSum(u8 Cmd, u8 *pData, u8 Len)
{
  const u8 CrcTabH[256] =
  {
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
    0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
    0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
    0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
    0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
    0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
    0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
    0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
    0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
    0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
    0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
    0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
    0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40
  };

  const u8 CrcTabL[256] =
  {
    0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06,
    0x07, 0xC7, 0x05, 0xC5, 0xC4, 0x04, 0xCC, 0x0C, 0x0D, 0xCD,
    0x0F, 0xCF, 0xCE, 0x0E, 0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09,
    0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9, 0x1B, 0xDB, 0xDA, 0x1A,
    0x1E, 0xDE, 0xDF, 0x1F, 0xDD, 0x1D, 0x1C, 0xDC, 0x14, 0xD4,
    0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3,
    0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3,
    0xF2, 0x32, 0x36, 0xF6, 0xF7, 0x37, 0xF5, 0x35, 0x34, 0xF4,
    0x3C, 0xFC, 0xFD, 0x3D, 0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A,
    0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38, 0x28, 0xE8, 0xE9, 0x29,
    0xEB, 0x2B, 0x2A, 0xEA, 0xEE, 0x2E, 0x2F, 0xEF, 0x2D, 0xED,
    0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26,
    0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60,
    0x61, 0xA1, 0x63, 0xA3, 0xA2, 0x62, 0x66, 0xA6, 0xA7, 0x67,
    0xA5, 0x65, 0x64, 0xA4, 0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F,
    0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB, 0x69, 0xA9, 0xA8, 0x68,
    0x78, 0xB8, 0xB9, 0x79, 0xBB, 0x7B, 0x7A, 0xBA, 0xBE, 0x7E,
    0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5,
    0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71,
    0x70, 0xB0, 0x50, 0x90, 0x91, 0x51, 0x93, 0x53, 0x52, 0x92,
    0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C,
    0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E, 0x5A, 0x9A, 0x9B, 0x5B,
    0x99, 0x59, 0x58, 0x98, 0x88, 0x48, 0x49, 0x89, 0x4B, 0x8B,
    0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C,
    0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42,
    0x43, 0x83, 0x41, 0x81, 0x80, 0x40
  };

  u8 CrcH;
  u8 CrcL;
  u8 Index;
  u8 i;

  CrcH = 0xFF;
  CrcL = 0xFF;

  Index = CrcH ^ Cmd;
  CrcH = CrcL ^ CrcTabH[Index];
  CrcL = CrcTabL[Index];

  for(i=0; i<Len; i++)
  {
    Index = CrcH ^ pData[i];
    CrcH = CrcL ^ CrcTabH[Index];
    CrcL = CrcTabL[Index];
  }

  return (((u16)CrcH<<8) | CrcL);
}

/******************************************************************
*    ƣ LcdFrameRecv
*       ȡڽն(FIFO)һ֡
            һ֡EEͷFF FC FF FF βһ֡
*ڲ 
*ڲ 
********************************************************************/
u8 LcdFrameRecv(StructLcdDwinFrame *pFrame)
{
  static u8 Buffer[sizeof(StructLcdDwinFrame)];
  static u16 BufPos = 0;
  static u32 LastRecvTick = 0;

  osEvent RecvDataMsg;

  RecvDataMsg = osMessageGet(LcdDataRecvMsg, 0);
  while((osEventMessage == RecvDataMsg.status) && (BufPos < sizeof(Buffer)))
  {
    LastRecvTick = GetSystemTick();
    Buffer[BufPos] = RecvDataMsg.value.v;
    BufPos++;
    if(BufPos > sizeof(StructLcdDwinFrame))
      break;
    RecvDataMsg = osMessageGet(LcdDataRecvMsg, 5);
  }

  while(BufPos > 3)
  {
    if((LcdFrameHeadH == Buffer[0]) && (LcdFrameHeadL == Buffer[1])       //Head
        && (Buffer[2] > 3) && (Buffer[2] < 64)          //Len
        && ((0x83 == Buffer[3]) || (0x81 == Buffer[3])) //Cmd
      )
    {//֡
      if(BufPos > (Buffer[2] + 2))
      {//֡ѽ꣬У֡
          memcpy(pFrame, Buffer, Buffer[2] + 3);
          BufPos -= (Buffer[2] + 3);
          memmove(&Buffer[0], &Buffer[Buffer[2] + 3], BufPos);
          return TRUE;
       }
      else
        break;
    }
    BufPos--;
    memmove(&Buffer[0], &Buffer[1], BufPos);
  }

  if((GetSystemTick() - LastRecvTick) > 500)
  {
    LastRecvTick = GetSystemTick();
    BufPos = 0;
  }

  return FALSE;
}

/******************************************************************************
  : LcdWriteReg
  : LcdдĴ
  : Addr - дַ
        pData - ͵ָ
        Len - ͵ݳ
  : 
******************************************************************************/
void LcdWriteReg(u8 Addr, u8 *pData, u8 Len)
{
  u8 i;
  //u16 CheckSum;

  if(osOK != osMutexWait(LcdMutex, 5000))//5
    return;

  LcdSendData(LcdFrameHeadH);
  LcdSendData(LcdFrameHeadL);
  LcdSendData(Len+2);
  LcdSendData(0x80);
  LcdSendData(Addr);
  for(i=0; i<Len; i++)
    LcdSendData(pData[i]);

  //CheckSum = LcdCheckSum(0x80, pData, Len);

  //LcdSendData(CheckSum>>8);
  //LcdSendData((u8)CheckSum);

  osMutexRelease(LcdMutex);
}

/******************************************************************************
  : LcdReadReg
  : LcdĴ,Ȳܳ64,ͷļ֡ṹ
  : Addr - ַ
        Len - ݳ
  : 
******************************************************************************/
void LcdReadReg(u8 Addr, u8 Len)
{
  //u16 CheckSum;
  //u8 Data[2];

  if(osOK != osMutexWait(LcdMutex, 5000))//5
    return;

  LcdSendData(LcdFrameHeadH);
  LcdSendData(LcdFrameHeadL);
  LcdSendData(0x03);
  LcdSendData(0x81);
  LcdSendData(Addr);
  LcdSendData(Len);

  //Data[0] = Addr;
  //Data[1] = Len;

  //CheckSum = LcdCheckSum(0x81, Data, sizeof(Data));

  //LcdSendData(CheckSum>>8);
  //LcdSendData((u8)CheckSum);

  osMutexRelease(LcdMutex);
}

/******************************************************************************
  : LcdWriteReg
  : LcdдĴ
  : Addr - дַ
        pData - ͵ָ
        Len - ͵ݳ
  : 
******************************************************************************/
void LcdWriteVar(u16 Addr, u8 *pData, u8 Len)
{
  u8 i;
  //u16 CheckSum;

  if(osOK != osMutexWait(LcdMutex, 5000))//5
    return;

  LcdSendData(LcdFrameHeadH);
  LcdSendData(LcdFrameHeadL);
  LcdSendData(Len + 3);
  LcdSendData(0x82);
  LcdSendData((u8)(Addr>>8));
  LcdSendData((u8)Addr);
  for(i=0; i<Len; i++)
    LcdSendData((u8)pData[i]);

  //CheckSum = LcdCheckSum(0x82, pData, Len);

  //LcdSendData(CheckSum>>8);
  //LcdSendData((u8)CheckSum);

  osMutexRelease(LcdMutex);
}

/******************************************************************************
  : LcdReadVar
  : LcdȲܳ32,ͷļ֡ṹ
  : Addr - ַ
        Len - ݳ(Len,ǰWord)
  : 
******************************************************************************/
void LcdReadVar(u16 Addr, u8 Len)
{
  //u16 CheckSum;
  //u8 Data[3];

  if(osOK != osMutexWait(LcdMutex, 5000))//5
    return;

  LcdSendData(LcdFrameHeadH);
  LcdSendData(LcdFrameHeadL);
  LcdSendData(0x03);
  LcdSendData(0x83);
  LcdSendData((u8)(Addr>>8));
  LcdSendData((u8)Addr);
  LcdSendData(Len);

  //Data[0] = (u8)(Addr>>8);
  //Data[1] = (u8)Addr;
  //Data[2] = Len;

  //CheckSum = LcdCheckSum(0x83, Data, sizeof(Data));

  //LcdSendData(CheckSum>>8);
  //LcdSendData((u8)CheckSum);

  osMutexRelease(LcdMutex);
}

/******************************************************************************
  : LcdShowPage
  : Lcdʾĳҳ
  : Page - ҳ
  : 
******************************************************************************/
void LcdShowPage(u16 Page)
{
  u8 Data[8];
  u8 Len;

  Len = 0;
  Data[Len++] = (u8)(Page>>8);
  Data[Len++] = (u8)Page;
  LcdWriteReg(eLcdRegAddr_Page, Data, Len);
}

/******************************************************************************
  : LcdGetPage
  : Lcdʾĳҳ
  : Page - ҳ
  : 
******************************************************************************/
void LcdGetPage(void)
{
  LcdReadReg(eLcdRegAddr_Page, 2);
}

/******************************************************************************
  : LcdShowNum
  : Lcdʾֵ
  : Addr - ʾλ
        Page - ҳ
  : 
******************************************************************************/
void LcdShowNum(u16 Addr, u16 Num)
{
  u8 Data[8];
  u8 Len;

  Len = 0;
  Data[Len++] = (u8)(Num>>8);
  Data[Len++] = (u8)Num;
  LcdWriteVar(Addr, Data, Len);
}

/******************************************************************************
  : LcdShowStr
  : Lcdʾֵ
  : Addr - ʾλ
        pStr - ʾַ
        Len - ַ
  : 
******************************************************************************/
void LcdShowStr(u16 Addr, u8 *pStr, u8 Len)
{
  u8 i;
  //u16 CheckSum;

  if(osOK != osMutexWait(LcdMutex, 5000))//5
    return;

  LcdSendData(LcdFrameHeadH);
  LcdSendData(LcdFrameHeadL);
  LcdSendData(Len + 3);
  LcdSendData(0x82);
  LcdSendData((u8)(Addr>>8));
  LcdSendData((u8)Addr);
  for(i=0; i<Len; i++)
    LcdSendData((u8)pStr[i]);

  //CheckSum = LcdCheckSum(0x82, pStr, Len);

  //LcdSendData(CheckSum>>8);
  //LcdSendData((u8)CheckSum);

  osMutexRelease(LcdMutex);
}

//*ƣ HexToBcd
//*ܣ  16תBCD
//*  hex_data  Ҫת16(0-100)
//*أ  תBCD
static u8 HexToBcd(u8 Hex)
{
  u8 Temp;
  u8 Bcd;

  Temp = Hex%100;
  Bcd = (Temp/10<<4) | (Temp%10);

  return Bcd;
}

/******************************************************************************
  : LcdSetRtc
  : Lcdʾֵ
  : pTime - ʱ
  : 
******************************************************************************/
void LcdSetRtc(StructTime *pTime)
{
  u8 Data[16];
  u8 Len;

  Len = 0;
  Data[Len++] = 0x5A;
  Data[Len++] = HexToBcd(pTime->Year%100);
  Data[Len++] = HexToBcd(pTime->Mon);
  Data[Len++] = HexToBcd(pTime->Day);
  Data[Len++] = 0x00;
  Data[Len++] = HexToBcd(pTime->Hour);
  Data[Len++] = HexToBcd(pTime->Min);
  Data[Len++] = HexToBcd(pTime->Sec);

  LcdWriteReg(0x1F, Data, Len);
}

/******************************************************************************
  : LcdGetPage
  : Lcdʾĳҳ
  : Page - ҳ
  : 
******************************************************************************/
void LcdGetRtc(void)
{
  LcdReadReg(eLcdRegAddr_Rtc, 7);
}

/******************************************************************************
  : LcdSetBackLight
  : Lcdʾֵ
  : Addr - ʾλ
        pStr - ʾַ
        Len - ַ
  : 
******************************************************************************/
void LcdSetBackLight(u8 Level)
{
  u8 Data[16];
  u8 Len;

  Len = 0;
  Data[Len++] = Level;

  LcdWriteReg(eLcdRegAddr_Backlight, Data, Len);
}

/******************************************************************************
  : LcdBuzzer
  : Lcd
  : Ms - ʱ 10*Ms
  : 
******************************************************************************/
void LcdBuzzer(u8 Ms)
{
  u8 Data[16];
  u8 Len;

  Len = 0;
  Data[Len++] = Ms;

  LcdWriteReg(eLcdRegAddr_Buzzer, Data, Len);
}

/******************************************************************************
  : LcdTouchCorrect
  : LcdУ
  : 
  : 
******************************************************************************/
void LcdTouchCorrect(void)
{
  u8 Data[16];
  u8 Len;

  Len = 0;
  Data[Len++] = 0x5A;

  LcdWriteReg(eLcdRegAddr_TouchCor, Data, Len);
}

/******************************************************************************
  : LcdReset
  : Lcdλ
  : 
  : 
******************************************************************************/
void LcdReset(void)
{
  u8 Data[16];
  u8 Len;

  Len = 0;
  Data[Len++] = 0x5A;
  Data[Len++] = 0xA5;

  LcdWriteReg(eLcdRegAddr_Reset, Data, Len);
}

/******************************************************************************
  : LcdShowData16
  : Lcdʾֵ
  : Addr - ʾλ
        Page - ҳ
  : 
******************************************************************************/
void LcdShowData16(u16 Addr, u16 Data16)
{
  u8 Data[8];
  u8 Len;

  Len = 0;
  Data[Len++] = (u8)(Data16>>8);
  Data[Len++] = (u8)Data16;
  LcdWriteVar(Addr, Data, Len);
}

/******************************************************************************
  : LcdShowData32
  : Lcdʾֵ
  : Addr - ʾλ
        Page - ҳ
  : 
******************************************************************************/
void LcdShowData32(u16 Addr, u32 Data32)
{
  u8 Data[8];
  u8 Len;

  Len = 0;
  Data[Len++] = (u8)(Data32>>24);
  Data[Len++] = (u8)(Data32>>16);
  Data[Len++] = (u8)(Data32>>8);
  Data[Len++] = (u8)Data32;
  LcdWriteVar(Addr, Data, Len);
}


