
/******************************************************************************
ļ  : Drv_ReaderActR1.c
  : гۿ޹˾ACT-R1
  :
޸  : 2014-08-26      

******************************************************************************/

#include "Drv_ReaderActR1.h"

#define ReaderActR1_RecvAckTimeOut  (500)
#define ReaderActR1_RecvAckErrCnt   (1)

osMessageQId ReaderActR1_RecvMsg = NULL;
osMessageQId ReaderActR1_SendMsg = NULL;

static pReaderActR1SendByte ReaderActR1SendByte;

u8 ReaderActR1_Init(osMessageQId RecvOsMsgQId, pReaderActR1SendByte pSendByte)//,osMessageQId SendOsMsgQId)
{

  USART_InitTypeDef USART_InitStructure;

  /* USARTx configuration ----------------------------------------------------*/
  USART_InitStructure.USART_BaudRate = ReaderActR1_USARTx_BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(ReaderActR1_USARTx, &USART_InitStructure);

  ReaderActR1_RecvMsg = RecvOsMsgQId;
  ReaderActR1SendByte = pSendByte;
  //ReaderActR1_SendMsg = SendOsMsgQId;
  /* Enable USART */
  USART_Cmd(ReaderActR1_USARTx, ENABLE);

  /* Enable the Tx buffer empty interrupt */
  USART_ITConfig(ReaderActR1_USARTx, USART_IT_RXNE, ENABLE);
  return TRUE;
}

static u8 ReaderActR1_SendByte(u8 Data)
{
  return ReaderActR1SendByte(Data);
}
/******************************************************************************
  : M1_Reader_FrameRecieve
  : Ӧ֡
  : pData - ͵ָ
        Len - ͵ݳ
  : 
******************************************************************************/
void ReaderActR1_FrameSend(u8 *pData, u16 Len)
{
  u8 CS;
  u16 i;

  CS = 0x00;
  ReaderActR1_SendByte(0x02);
  CS ^= 0x02;
  ReaderActR1_SendByte((u8)(Len >> 8));
  CS ^= (u8)(Len >> 8);
  ReaderActR1_SendByte((u8)Len);
  CS ^= (u8)Len;

  for(i=0; i<Len; i++)
  {
    CS ^= pData[i];
    ReaderActR1_SendByte(pData[i]);
  }

  ReaderActR1_SendByte(0x03);
  CS ^= 0x03;

  ReaderActR1_SendByte(CS);
}

/******************************************************************************
  : ReaderActR1_AckRecv
  : Ӧ֡
  : pData - ָ
        Len - ȡݳ
        TimeOut - ȴظʱ
  : 0 - ʧ
        other - ճɹؽյֽ
******************************************************************************/
int ReaderActR1_AckRecv(u32 TimeOut)
{
  osEvent RecvDataMsg;
  u32 Time;
  u8 Data;

  Time = GetSystemTick();

  while((GetSystemTick() - Time) < TimeOut)
  {
    RecvDataMsg = osMessageGet(ReaderActR1_RecvMsg, 10);
    if(osEventMessage == RecvDataMsg.status)
    {
      Data = RecvDataMsg.value.v;
      if(0x06 == Data)
        return 0;
      else if(0x15 == Data)
        return -2;
      else
        Data = 0;
    }
  }

  return -1;
}

/******************************************************************************
  : ReaderActR1_RespRecv
  : Ӧ֡
  : pData - ָ
        Len - ȡݳ
        TimeOut - ȴظʱ
  : 0 - ʧ
        other - ճɹؽյֽ
******************************************************************************/
int ReaderActR1_RespRecv(u8 *pData, u16 Len, u32 TimeOut)
{
  osEvent RecvDataMsg;
  u32 Time;
  u8 Data;
  u16 FrameLen;
  u8 CheckSum;
  u16 i;
  typedef enum
  {
    eAckStatus_Start = 0x00,
    eAckStatus_FrameLenHi,
    eAckStatus_FrameLenLo,
    eAckStatus_Data,
    eAckStatus_End,
    eAckStatus_CheckSum
  }EnumAckStatus;
  EnumAckStatus AckStatus;


  Time = GetSystemTick();
  AckStatus = eAckStatus_Start;
  FrameLen = 0x00;

  while((GetSystemTick() - Time) < TimeOut)
  {
    RecvDataMsg = osMessageGet(ReaderActR1_RecvMsg, 10);
    if(osEventMessage == RecvDataMsg.status)
    {
      Data = RecvDataMsg.value.v;
      switch(AckStatus)
      {
        case eAckStatus_Start:
          if(0x02 == Data)
          {
            CheckSum = Data;
            AckStatus = eAckStatus_FrameLenHi;
          }
          break;

        case eAckStatus_FrameLenHi:
          if(0x00 == Data)//ĿǰЭݳȲᳬ18;
          {
            CheckSum ^= Data;
            AckStatus = eAckStatus_FrameLenLo;
          }
          else if(0x02 == Data)
          {
            CheckSum = Data;
            AckStatus = eAckStatus_FrameLenHi;
          }
          else
            AckStatus = eAckStatus_Start;
          break;

        case eAckStatus_FrameLenLo:
          if((0x01 < Data) && (Data < 251))//ĿǰЭݳȲᳬ250
          {
            CheckSum ^= Data;
            FrameLen = Data;
            i = 0;
            AckStatus = eAckStatus_Data;
          }
          else
            AckStatus = eAckStatus_Start;
          break;

        case eAckStatus_Data:
          FrameLen--;
          CheckSum ^= Data;
          if((i < Len) && (pData != NULL))
          {
            pData[i] = Data;
            i++;
          }
          if(FrameLen == 0x00)
            AckStatus = eAckStatus_End;
          break;

        case eAckStatus_End:
          if(0x03 == Data)
          {
            CheckSum ^= Data;
            AckStatus = eAckStatus_CheckSum;
          }
          else if(0x02 == Data)
          {
            CheckSum = 0x02;
            AckStatus = eAckStatus_FrameLenHi;
          }
          else
            AckStatus = eAckStatus_Start;
          break;

        case eAckStatus_CheckSum:
          if(CheckSum == Data)
          {
            AckStatus = eAckStatus_Start;
            return i;
          }
          if(0x02 == Data)
          {
            CheckSum = 0x02;
            AckStatus = eAckStatus_FrameLenHi;
          }
          else
            AckStatus = eAckStatus_Start;
          break;

        default:
          AckStatus = eAckStatus_Start;
          break;
      }
    }
  }

  return 0;
}

/******************************************************************************
  : ReaderActR1_CardFind
  : Ѱ
  : pUID - ѰUID
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
u8 ReaderActR1_Test(void)
{
  const u8 Command[] = {0x35,0x30};
  int Retn;
  osEvent RecvDataMsg;
  u8 err;

  ReaderActR1_SendByte(0x04);//ȡ

  do
  {/*սջ*/
    RecvDataMsg = osMessageGet(ReaderActR1_RecvMsg, 2);
  }while(osEventMessage == RecvDataMsg.status);

  err = 3;
  while(err)
  {
    ReaderActR1_FrameSend((u8*)Command, sizeof(Command));
    Retn = ReaderActR1_AckRecv(500);//Ӧ
    if(0 != Retn)
    {
      ReaderActR1_SendByte(0x04);//ȡ
      return FALSE;
    }
    err--;
  }

  return TRUE;
}

/******************************************************************************
  : ReaderActR1_CardFind
  : Ѱ
  : pUID - ѰUID
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ReaderActR1_CardFind(u8 *pUID)
{
  const u8 Command[] = {0x35,0x30};
  u8 Resp[32];
  int RespLen;
  int Retn;
  osEvent RecvDataMsg;

  ReaderActR1_SendByte(0x04);//ȡ

  do
  {/*սջ*/
    RecvDataMsg = osMessageGet(ReaderActR1_RecvMsg, 2);
  }while(osEventMessage == RecvDataMsg.status);

  ReaderActR1_FrameSend((u8*)Command, sizeof(Command));
  Retn = ReaderActR1_AckRecv(ReaderActR1_RecvAckTimeOut);//Ӧ
  if(0 != Retn)
  {
    ReaderActR1_SendByte(0x04);//ȡ
    return -1;
  }

  ReaderActR1_SendByte(0x05);//ִ

  RespLen = ReaderActR1_RespRecv(Resp, sizeof(Resp), ReaderActR1_RecvAckTimeOut);//ִлظ
  if(0 == RespLen)
  {
    ReaderActR1_SendByte(0x04);//ȡ
    return -2;
  }
  if(RespLen < 3)
    return -3;
  if(Command[0] != Resp[0])
    return -4;
  if('Y' != Resp[2])
    return -5;

  return 0;
}

/******************************************************************************
  : ReaderActR1_IdCheck
  : ֤
  : pID - 뻺ָ
        Section - Ҫ֤ Χ0-15
        Key - 'A''a'A, 'B''b'B
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ReaderActR1_IdCheck(u8* pID, u8 Section, u8 Key, u8 *pUid)
{
  u8 Command[9] = {0x35,0x32};
  u8 Resp[32];
  int RespLen;
  int Retn;

  if(NULL == pID)
    return 1;
  if(Section > 15)
    return 2;
  if(('A' != Key) && ('B' != Key) && ('a' != Key) && ('b' != Key))
    return 3;

  if(('A' == Key) || ('a' != Key))
    Command[1] = 0x32;
  else
    Command[1] = 0x39;

  Command[2] = Section;
  memcpy(&Command[3], pID, 6);

  osEvent RecvDataMsg;

  ReaderActR1_SendByte(0x04);//ȡ

  do
  {/*սջ*/
    RecvDataMsg = osMessageGet(ReaderActR1_RecvMsg, 2);
  }while(osEventMessage == RecvDataMsg.status);

  ReaderActR1_FrameSend((u8*)Command, sizeof(Command));
  Retn = ReaderActR1_AckRecv(ReaderActR1_RecvAckTimeOut);//Ӧ
  if(0 != Retn)
  {
    ReaderActR1_SendByte(0x04);//ȡ
    return -1;
  }

  ReaderActR1_SendByte(0x05);//ִ

  RespLen = ReaderActR1_RespRecv(Resp, sizeof(Resp), ReaderActR1_RecvAckTimeOut);//ִлظ
  if(0 == RespLen)
  {
    ReaderActR1_SendByte(0x04);//ȡ
    return -2;
  }
  if(RespLen < 4)
    return -3;
  if(Command[0] != Resp[0])
    return -4;
  if('Y' != Resp[3])
    return -5;

  return 0;
}


/******************************************************************************
  : ReaderActR1_BlockRead
  : 
  : pData - ݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ReaderActR1_BlockRead(u8 *pData, u8 Block)
{
  u8 Command[4] = {0x35,0x33};
  u8 Resp[32];
  int RespLen;
  int Retn;


  if(NULL == pData)
    return 1;
  if(Block > 63)
    return 2;

  Command[2] = Block/4;
  Command[3] = Block%4;

  osEvent RecvDataMsg;

  ReaderActR1_SendByte(0x04);//ȡ

  do
  {/*սջ*/
    RecvDataMsg = osMessageGet(ReaderActR1_RecvMsg, 2);
  }while(osEventMessage == RecvDataMsg.status);

  ReaderActR1_FrameSend((u8*)Command, sizeof(Command));
  Retn = ReaderActR1_AckRecv(ReaderActR1_RecvAckTimeOut);//Ӧ
  if(0 != Retn)
  {
    ReaderActR1_SendByte(0x04);//ȡ
    return -1;
  }

  ReaderActR1_SendByte(0x05);//ִ

  RespLen = ReaderActR1_RespRecv(Resp, sizeof(Resp), ReaderActR1_RecvAckTimeOut);//ִлظ
  if(0 == RespLen)
  {
    ReaderActR1_SendByte(0x04);//ȡ
    return -2;
  }
  if(RespLen < 0x15)
    return -3;
  if(Command[0] != Resp[0])
    return -4;
  if('Y' != Resp[4])
    return -5;

  memcpy(pData, &Resp[5], 16);

  return 0;
}

/******************************************************************************
  : ReaderActR1_BlockWrite
  : д
  : pData - дݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ReaderActR1_BlockWrite(u8 *pData, u8 Block)
{
  u8 Command[20] = {0x35,0x34};
  u8 Resp[32];
  int RespLen;
  int Retn;


  if(NULL == pData)
    return 1;
  if(Block > 63)
    return 2;

  Command[2] = Block/4;
  Command[3] = Block%4;
  memcpy(&Command[4], pData, 16);

  osEvent RecvDataMsg;

  ReaderActR1_SendByte(0x04);//ȡ

  do
  {/*սջ*/
    RecvDataMsg = osMessageGet(ReaderActR1_RecvMsg, 2);
  }while(osEventMessage == RecvDataMsg.status);

  ReaderActR1_FrameSend((u8*)Command, sizeof(Command));
  Retn = ReaderActR1_AckRecv(ReaderActR1_RecvAckTimeOut);//Ӧ
  if(0 != Retn)
  {
    ReaderActR1_SendByte(0x04);//ȡ
    return -1;
  }

  ReaderActR1_SendByte(0x05);//ִ

  RespLen = ReaderActR1_RespRecv(Resp, sizeof(Resp), ReaderActR1_RecvAckTimeOut);//ִлظ
  if(0 == RespLen)
  {
    ReaderActR1_SendByte(0x04);//ȡ
    return -2;
  }
  if(RespLen < 5)
    return -3;
  if(Command[0] != Resp[0])
    return -4;
  if('Y' != Resp[4])
    return -5;

  return 0;
}

