
#ifndef __DRV_READERACTR1_H__
#define __DRV_READERACTR1_H__

#include "Global.h"

#define ReaderActR1_USARTx_BaudRate      (9600)

#define ReaderActR1_USARTx                           USART3
#define ReaderActR1_USARTx_CLK                       RCC_APB1Periph_USART3
#define ReaderActR1_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define ReaderActR1_USARTx_IRQn                      USART3_IRQn
#define ReaderActR1_USARTx_IRQHandler                USART3_IRQHandler

#define ReaderActR1_USARTx_TX_PIN                    GPIO_Pin_8
#define ReaderActR1_USARTx_TX_GPIO_PORT              GPIOD
#define ReaderActR1_USARTx_TX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define ReaderActR1_USARTx_TX_SOURCE                 GPIO_PinSource8
#define ReaderActR1_USARTx_TX_AF                     GPIO_AF_USART3

#define ReaderActR1_USARTx_RX_PIN                    GPIO_Pin_9
#define ReaderActR1_USARTx_RX_GPIO_PORT              GPIOD
#define ReaderActR1_USARTx_RX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define ReaderActR1_USARTx_RX_SOURCE                 GPIO_PinSource9
#define ReaderActR1_USARTx_RX_AF                     GPIO_AF_USART3

typedef u8 (*pReaderActR1SendByte)(u8 Data);

extern u8 ReaderActR1_Init(osMessageQId RecvOsMsgQId, pReaderActR1SendByte pSendByte );

extern u8 ReaderActR1_Test(void);

extern int ReaderActR1_CardFind(u8 *pUID);
extern int ReaderActR1_IdCheck(u8* pID, u8 Section, u8 Key, u8 *pUid);
extern int ReaderActR1_BlockRead(u8 *pData, u8 Block);
extern int ReaderActR1_BlockWrite(u8 *pData, u8 Block);

#endif

