
/******************************************************************************
ļ  : Drv_Reader.c
  : ¿ƼD8TS
  :
޸  : 2014-08-26      

******************************************************************************/

#include "Drv_ReaderZLG600A.h"

osMessageQId ReaderZLG600A_RecvMsg = NULL;
osMessageQId ReaderZLG600A_SendMsg = NULL;

#define ReaderZLG600A_RecvAckTimeOut  (300)
#define ReaderZLG600A_RecvAckErrCnt   (1)


static pReaderZLG600ASendByte ReaderZLG600ASendByte;

u8 ReaderZLG600A_Init(osMessageQId RecvOsMsgQId, pReaderZLG600ASendByte pSendByte)//,osMessageQId SendOsMsgQId)
{

  USART_InitTypeDef USART_InitStructure;

  /* USARTx configuration ----------------------------------------------------*/
  USART_InitStructure.USART_BaudRate = ReaderZLG600A_USARTx_BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(ReaderZLG600A_USARTx, &USART_InitStructure);

  ReaderZLG600A_RecvMsg = RecvOsMsgQId;
  ReaderZLG600ASendByte = pSendByte;
  //ReaderActR1_SendMsg = SendOsMsgQId;
  /* Enable USART */
  USART_Cmd(ReaderZLG600A_USARTx, ENABLE);

  /* Enable the Tx buffer empty interrupt */
  USART_ITConfig(ReaderZLG600A_USARTx, USART_IT_RXNE, ENABLE);
  return TRUE;
}


static u8 ReaderZLG600A_SendByte(u8 Data)
{
  return ReaderZLG600ASendByte(Data);
}


/******************************************************************************
  : M1_Reader_FrameRecieve
  : Ӧ֡
  : pData - ͵ָ
        Len - ͵ݳ
  : 
******************************************************************************/
void ReaderZLG600A_FrameSend(u8 *pData, u16 Len)
{
  u8 CS;
  u16 i;

  ReaderZLG600A_SendByte(0x02);

  ReaderZLG600A_SendByte((u8)(Len >> 8));
  ReaderZLG600A_SendByte((u8)Len);

  CS = 0x00;
  for(i=0; i<Len; i++)
  {
    CS ^= pData[i];
    ReaderZLG600A_SendByte(pData[i]);
  }

  ReaderZLG600A_SendByte(CS);

  ReaderZLG600A_SendByte(0x03);
}

/******************************************************************************
  : ReaderZLG600A_AckRecieve
  : Ӧ֡
  : pData - ָ
        Len - ȡݳ
        TimeOut - ȴظʱ
  : 0 - ɹ
        -1 - ʱ
        other - 
******************************************************************************/
u16 ReaderZLG600A_AckRecieve(u8 *pData, u16 Len, u32 TimeOut)
{
  osEvent RecvDataMsg;
  u32 Time;
  u8 Data;
  u16 FrameLen;
  u16 AckCode;
  u8 CheckSum;
  u16 i;
  typedef enum
  {
    eAckStatus_Start = 0x00,
    eAckStatus_FrameLenHi,
    eAckStatus_FrameLenLo,
    eAckStatus_AckCodeHi,
    eAckStatus_AckCodeLo,
    eAckStatus_Data,
    eAckStatus_CheckSum,
    eAckStatus_End
  }EnumAckStatus;
  EnumAckStatus AckStatus;


 // u8 Buf[256] = {0};
//  u16 BufLen = 0;


  Time = GetSystemTick();
  AckStatus = eAckStatus_Start;
  FrameLen = 0x00;

  while((GetSystemTick() - Time) < TimeOut)
  {
    RecvDataMsg = osMessageGet(ReaderZLG600A_RecvMsg, 5);
    if(osEventMessage == RecvDataMsg.status)
    {
      Data = RecvDataMsg.value.v;

 //     Buf[BufLen++] = Data;

      switch(AckStatus)
      {
        case eAckStatus_Start:
          if(0x02 == Data)
            AckStatus = eAckStatus_FrameLenHi;
          break;

        case eAckStatus_FrameLenHi:
          if(0x00 == Data)//ĿǰЭݳȲᳬ18;
            AckStatus = eAckStatus_FrameLenLo;
          else if(0x02 == Data)
            AckStatus = eAckStatus_FrameLenHi;
          else
            AckStatus = eAckStatus_Start;
          break;

        case eAckStatus_FrameLenLo:
          if((0x01 < Data) && (Data < 251))//ĿǰЭݳȲᳬ250
          {
            FrameLen = Data;
            CheckSum = 0x00;
            AckStatus = eAckStatus_AckCodeHi;
          }
          else
            AckStatus = eAckStatus_Start;
          break;

        case eAckStatus_AckCodeHi:
          FrameLen--;
          CheckSum ^= Data;
          AckCode = Data * 256;
          AckStatus = eAckStatus_AckCodeLo;
          break;

        case eAckStatus_AckCodeLo:
          FrameLen--;
          CheckSum ^= Data;
          AckCode += Data;
          if(FrameLen > 0x00)
          {
            i = 0x00;
            AckStatus = eAckStatus_Data;
          }
          else
            AckStatus = eAckStatus_CheckSum;
          break;

        case eAckStatus_Data:
          FrameLen--;
          CheckSum ^= Data;
          if((i < Len) && (pData != NULL))
          {
            pData[i] = Data;
            i++;
          }
          if(FrameLen == 0x00)
            AckStatus = eAckStatus_CheckSum;
          break;

        case eAckStatus_CheckSum:
          if(CheckSum == Data)
          {
            AckStatus = eAckStatus_End;
          }
          else if(0x02 == Data)
            AckStatus = eAckStatus_FrameLenHi;
          else
            AckStatus = eAckStatus_Start;
          break;

        case eAckStatus_End:
          if(0x03 == Data)
          {
            AckStatus = eAckStatus_End;
            return AckCode;
          }
          else if(0x02 == Data)
            AckStatus = eAckStatus_FrameLenHi;
          else
            AckStatus = eAckStatus_Start;
          break;

        default:
          AckStatus = eAckStatus_Start;
          break;
      }
    }
  }

  return -1;
}


/******************************************************************************
  : ReaderZLG600A_CardFind
  : Ѱ
  : pUID - ѰUID
  : TRUE - ɹ
        FALSE - ʧ
***************************************************************************
u8 ReaderZLG600A_Test(void)
{
  const u8 Command[] = {0x32,0x24,0x00,0x00};
  u16 AckCode;
  u8 err;

  osEvent RecvDataMsg;
  u8 UID[6];
  do
  {//սջ
    RecvDataMsg = osMessageGet(ReaderZLG600A_RecvMsg, 5);
  }while(osEventMessage == RecvDataMsg.status);

  err = 6;
  while(err)
  {
    ReaderZLG600A_FrameSend((u8*)Command, sizeof(Command));
    AckCode = ReaderZLG600A_AckRecieve(UID, 6, 300);
    if((0x00 == AckCode) || (0x3005 == AckCode))
      return TRUE;
    err--;
  }
  return FALSE;
}***/
/******************************************************************************
  : ReaderZLG600A_CardInf
  : Ѱ
  : pUID - ѰUID
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
u8 ReaderZLG600A_Test(void)
{
  const u8 Command[] = {0x31,0x11};
  const u8 CUP_Interface[] = {0x01, 0x00, 0x6C, 0x00, 0x00, 0x00, 0x00, 0x20};
  u16 AckCode;
  u8 err;
  u8 ReaderInf[36];

  err = ReaderZLG600A_RecvAckErrCnt;
  while(err)
  {
    ReaderZLG600A_FrameSend((u8*)Command, sizeof(Command));
    AckCode = ReaderZLG600A_AckRecieve(ReaderInf, 6, ReaderZLG600A_RecvAckTimeOut);
    if((0x00 == AckCode) && (0 == memcmp(CUP_Interface, ReaderInf, 3)))
      return TRUE;
    err--;
  }

  return FALSE;
}

/******************************************************************************
  : ReaderZLG600A_CardFind
  : Ѱ
  : pUID - ѰUID
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ReaderZLG600A_CardFind(u8 *pUID)
{
  const u8 Command[] = {0x32,0x24,0x00,0x00};
  u16 AckCode;
  u8 err;

  err = ReaderZLG600A_RecvAckErrCnt;
  while(err)
  {
    ReaderZLG600A_FrameSend((u8*)Command, sizeof(Command));
    AckCode = ReaderZLG600A_AckRecieve(pUID, 6, ReaderZLG600A_RecvAckTimeOut);
    if(0x00 == AckCode)
      return 0;
    err--;
  }

  //if(0xFFFF == AckCode)
  //  return 0xFF;
  //if(0x3005 == AckCode)//޿ͨѶ
  //  return 0x3005;

  return -1;
}

/******************************************************************************
  : ReaderZLG600A_IdCheck
  : ֤
  : pID - 뻺ָ
        Section - Ҫ֤ Χ0-15
        Key - 'A''a'A, 'B''b'B
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ReaderZLG600A_IdCheck(u8* pID, u8 Section, u8 Key, u8 *pUid)
{
  u8 Command[] = {0x02,0x46,0x60,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
  u16 AckCode;
  u8 err;

  if(NULL == pID)
    return -1;
  if(Section > 15)
    return -1;
  if(('A' != Key) && ('B' != Key) && ('a' != Key) && ('b' != Key))
    return -1;

  if(('A' == Key) || ('a' != Key))
    Command[2] = 0x60;
  else
    Command[2] = 0x61;

  memcpy(&Command[3], pUid+2, 4);

  memcpy(&Command[7], pID, 6);

  Command[13] = (Section * 4) + 3;

  err = ReaderZLG600A_RecvAckErrCnt;
  while(err)
  {
    ReaderZLG600A_FrameSend((u8*)Command, sizeof(Command));
    AckCode = ReaderZLG600A_AckRecieve(NULL, 0, ReaderZLG600A_RecvAckTimeOut);
    if(0x00 == AckCode)
      return 0;
    err--;
  }
  return -1;
}

/******************************************************************************
  : ReaderZLG600A_BlockRead
  : 
  : pData - ݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ReaderZLG600A_BlockRead(u8 *pData, u8 Block)
{
  u8 Command[] = {0x02,0x47,0x00};
  u16 AckCode;
  u8 err;

  if(NULL == pData)
    return -1;
  if(Block > 63)
    return -1;

  Command[2] = Block;
  err = ReaderZLG600A_RecvAckErrCnt;
  while(err)
  {
    ReaderZLG600A_FrameSend((u8*)Command, sizeof(Command));
    AckCode = ReaderZLG600A_AckRecieve(pData, 16, ReaderZLG600A_RecvAckTimeOut);
    if(0x00 == AckCode)
      return 0;
    err--;
  }
  return -1;
}

/******************************************************************************
  : Cmd_ReadBlock
  : д
  : pData - дݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ReaderZLG600A_BlockWrite(u8 *pData, u8 Block)
{
  u8 Command[] = {0x02,0x48,0x00,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  u16 AckCode;
  u8 err;

  if(NULL == pData)
    return -1;
  if(Block > 63)
    return -1;

  Command[2] = Block;
  memcpy(&Command[3], pData, 16);
  err = ReaderZLG600A_RecvAckErrCnt;
  while(err)
  {
    ReaderZLG600A_FrameSend((u8*)Command, sizeof(Command));
    AckCode = ReaderZLG600A_AckRecieve(NULL, 0, ReaderZLG600A_RecvAckTimeOut);
    if(0x00 == AckCode)
      return 0;
    err--;
  }
  return -1;
}

