
/******************************************************************************
ļ  : Drv_Rtc.c
  : STM32F4RTC
  :
޸  : 2014-08-26      

******************************************************************************/

#include "Drv_Rtc.h"

/******************************************************************************
  : RtcUpdateTime
  : RTCǷиʱ
  : pStr - ʱʽpStrȱڵ16
  : 
******************************************************************************/
void RtcGetTime(u8 *pStr)
{
  RTC_TimeTypeDef RTC_TimeStructure ;
  RTC_DateTypeDef RTC_DateStructure ;

  /* Get the current Time and Date */
  RTC_GetTime(RTC_Format_BCD,&RTC_TimeStructure);
  RTC_GetDate(RTC_Format_BCD,&RTC_DateStructure);

  /* Fill the table2 fields with the current Time*/
  pStr[0]='2' ;
  pStr[1]='0' ;
  pStr[2]=(((u8)(RTC_DateStructure.RTC_Year&0xF0)>>0x04)+0x30);
  pStr[3]=(((u8)(RTC_DateStructure.RTC_Year&0x0F))+0x30);
  pStr[4]='-' ;
  pStr[5]=(((u8)(RTC_DateStructure.RTC_Month&0xF0)>>0x04)+0x30);
  pStr[6]=(((u8)(RTC_DateStructure.RTC_Month&0x0F))+0x30);
  pStr[7]='-' ;
  pStr[8]=(((u8)(RTC_DateStructure.RTC_Date&0xF0)>>0x04)+0x30);
  pStr[9]=(((u8)(RTC_DateStructure.RTC_Date&0x0F))+0x30);
  pStr[10]=' ' ;
  pStr[11]=(((u8)(RTC_TimeStructure.RTC_Hours&0xF0)>>0x04)+0x30);
  pStr[12]=(((u8)(RTC_TimeStructure.RTC_Hours&0x0F))+0x30);
  pStr[13]=':' ;
  pStr[14]=(((u8)(RTC_TimeStructure.RTC_Minutes&0xF0)>>0x04)+0x30);
  pStr[15]=(((u8)(RTC_TimeStructure.RTC_Minutes&0x0F))+0x30);
  pStr[16]='\0' ;
}

/******************************************************************************
  : RtcUpdateTime
  : RTCǷиʱ
  : pStr - ʱʽpStrȱڵ16
  : TRUE - и
        FALSE - ޸
******************************************************************************/
u8 RtcUpdateTime(u8 *pStr)
{
  static u32 LastTime=0 ;
  static u32 LastDate=0 ;
  u32 CurTime=0 ;
  u32 CurDate=0 ;
  RTC_TimeTypeDef RTC_TimeStructure ;
  RTC_DateTypeDef RTC_DateStructure ;
#if 0
  /* Get the TimeStamp time and date registers values */
  CurTime = (u32)(RTC->TR & 0x007F7F00);
  //ȥ
  CurDate = (u32)(RTC->DR & 0x00FFFF3F);
#endif
  if((LastTime == CurTime) && (LastDate == CurDate))
    return FALSE ;

  /* Get the current Time and Date */
  RTC_GetTime(RTC_Format_BCD, &RTC_TimeStructure);
  RTC_GetDate(RTC_Format_BCD, &RTC_DateStructure);

  /* Fill the table2 fields with the current Time*/
  pStr[0] = '2' ;
  pStr[1] = '0' ;
  pStr[2] = (((u8)(RTC_DateStructure.RTC_Year&0xF0)>>0x04)+0x30);
  pStr[3] = (((u8)(RTC_DateStructure.RTC_Year&0x0F))+0x30);
  pStr[4] = '-' ;
  pStr[5] = (((u8)(RTC_DateStructure.RTC_Month&0xF0)>>0x04)+0x30);
  pStr[6] = (((u8)(RTC_DateStructure.RTC_Month&0x0F))+0x30);
  pStr[7] = '-' ;
  pStr[8] = (((u8)(RTC_DateStructure.RTC_Date&0xF0)>>0x04)+0x30);
  pStr[9] = (((u8)(RTC_DateStructure.RTC_Date&0x0F))+0x30);
  pStr[10] = ' ' ;
  pStr[11] = (((u8)(RTC_TimeStructure.RTC_Hours&0xF0)>>0x04)+0x30);
  pStr[12] = (((u8)(RTC_TimeStructure.RTC_Hours&0x0F))+0x30);
  pStr[13] = ':' ;
  pStr[14] = (((u8)(RTC_TimeStructure.RTC_Minutes&0xF0)>>0x04)+0x30);
  pStr[15] = (((u8)(RTC_TimeStructure.RTC_Minutes&0x0F))+0x30);
  pStr[16] = '\0' ;

  LastTime=CurTime ;
  LastDate=CurDate ;

  return TRUE ;
}

/******************************************************************************
  : DateTimeInit
  : ʱڳʼ
  : 
  : 
******************************************************************************/
void DateTimeInit(void)
{
#if 0
  RTC_TimeTypeDef RTC_TimeStructure;
  RTC_DateTypeDef RTC_DateStructure;
  u32 Temp;

  Temp = RTC_ReadBackupRegister(RTC_BKP_DR1);
  if(0x32F2 == Temp)
    return;
  /* Set Time hh:mm:ss */
  RTC_TimeStructure.RTC_H12 = RTC_H12_AM;
  RTC_TimeStructure.RTC_Hours = 0x08;
  RTC_TimeStructure.RTC_Minutes = 0x10;
  RTC_TimeStructure.RTC_Seconds = 0x00;
  RTC_SetTime(RTC_Format_BCD, &RTC_TimeStructure);

  /* Set Date Week/Date/Month/Year */
  RTC_DateStructure.RTC_WeekDay = 03;
  RTC_DateStructure.RTC_Date = 0x01;
  RTC_DateStructure.RTC_Month = 0x10;
  RTC_DateStructure.RTC_Year = 0x14;
  RTC_SetDate(RTC_Format_BCD, &RTC_DateStructure);

  RTC_WriteBackupRegister(RTC_BKP_DR1, 0x32F2);/* Write BkUp DR0 */
  #endif
}

/******************************************************************************
  : RtcInit
  : RTCʼ
  : 
  : TRUE - ʼ
    FALSE - ʼ
******************************************************************************/
u8 RtcInit(void)
{
#if 0
  RTC_InitTypeDef RTC_InitStructure;
  u32 uwAsynchPrediv = 0;
  u32 uwSynchPrediv = 0;
  u32 Temp;
  u32 ErrorTime;

  RCC_BackupResetCmd(DISABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);/* Enable the PWR clock */
  PWR_BackupAccessCmd(ENABLE);/* Allow access to RTC */

  Temp = RTC_ReadBackupRegister(RTC_BKP_DR0);
  if(0x1111 == Temp)
  {
    RCC_RTCCLKCmd(ENABLE);/* Enable the RTC Clock */
    RTC_WaitForSynchro();/* Wait for RTC APB registers synchronisation */
    DateTimeInit();
    return TRUE;
  }

  ErrorTime = 0x00800000;
  RCC_LSEConfig(RCC_LSE_ON);
  while(RESET == RCC_GetFlagStatus(RCC_FLAG_LSERDY) && ErrorTime)
  {/* Wait till LSE is ready */
    ErrorTime--;
  }
  if(ErrorTime > 0)
  {
    RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);
    uwSynchPrediv = 0xFF;
    uwAsynchPrediv = 0x7F;

    RCC_RTCCLKCmd(ENABLE);/* ʹRTCʱ */

    RTC_WaitForSynchro();/* ȴRTC APBĴͬ */
    /* RTCݼĴͷƵ */
    RTC_InitStructure.RTC_AsynchPrediv = uwAsynchPrediv ;
    RTC_InitStructure.RTC_SynchPrediv = uwSynchPrediv ;
    RTC_InitStructure.RTC_HourFormat = RTC_HourFormat_24 ;

    /* Check on RTC init */
    ErrorTime = 3;
    while(ERROR == RTC_Init(&RTC_InitStructure) && ErrorTime)
    {
    }

    if(ErrorTime > 0)
    {
      RTC_WriteBackupRegister(RTC_BKP_DR0, 0x1111);
      DateTimeInit();
      return TRUE;
    }
  }

  if(0x2222 == Temp)
  {
    RCC_LSICmd(ENABLE);
    RCC_RTCCLKCmd(ENABLE);/* Enable the RTC Clock */
    RTC_WaitForSynchro();/* Wait for RTC APB registers synchronisation */
    DateTimeInit();
    return TRUE;
  }

  RCC_LSICmd(ENABLE);
  while(RESET == RCC_GetFlagStatus(RCC_FLAG_LSIRDY))
  {/* Wait till LSI is ready */
  }
  RCC_RTCCLKConfig(RCC_RTCCLKSource_LSI);/* Select the RTC Clock Source */

  /* ck_spre(1Hz) = RTCCLK(LSI) /(uwAsynchPrediv + 1)*(uwSynchPrediv + 1)*/
  uwSynchPrediv = 0xF9;
  uwAsynchPrediv = 0x7F;
  RCC_RTCCLKCmd(ENABLE);/* ʹRTCʱ */
  RTC_WaitForSynchro();/* ȴRTC APBĴͬ */
  /* RTCݼĴͷƵ */
  RTC_InitStructure.RTC_AsynchPrediv = uwAsynchPrediv ;
  RTC_InitStructure.RTC_SynchPrediv = uwSynchPrediv ;
  RTC_InitStructure.RTC_HourFormat = RTC_HourFormat_24 ;

  ErrorTime = 3;
  while(ERROR == RTC_Init(&RTC_InitStructure) && ErrorTime)
  {/* Check on RTC init */
  }

  if(ErrorTime > 0)
  {
    RTC_WriteBackupRegister(RTC_BKP_DR0, 0x2222);
    DateTimeInit();
    return TRUE;
  }

  return FALSE;
#endif
}


