
#include "Drv_WifiC322.h"
#include "Memory.h"

StructWifiSta Wifi;

/******************************************************************************
  : WifiModSendByte
  : ֽ
  : Data - յֽ
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
u8 WifiModSendByte(u8 Data)
{
  osStatus EvenStatus;

  EvenStatus = osMessagePut(Wifi.Uart.SendQ, Data, portMAX_DELAY);
  if(osOK == EvenStatus)
  {
    Wifi_USARTx->CR1 |= USART_CR1_TXEIE;
    return TRUE;
  }

  return FALSE;
}

int WifiModPrintf(char *Fmt, ...)
{
  char Buf[256];
  char *pData;
  int Count;
  va_list Args;

  va_start(Args, Fmt);
  Count = vsnprintf(Buf, sizeof(Buf), Fmt, Args);
  pData = Buf;
  while(Count)
  {
    WifiModSendByte(*(u8*)pData);
    pData++;
    Count--;
  }
  va_end(Args);

  return (int)(pData-Buf);
}



/******************************************************************
*    ƣ InternetFrameRecv
*       ȡڽն(FIFO)һ֡
            һ֡EEͷFF FC FF FF βһ֡
*ڲ 
*ڲ 
********************************************************************/
u8 WifiModGetFrame(char *pFrame, u16 MaxLen)
{
  typedef enum
  {
    eWifiRespSta_0D = 0,
    eWifiRespSta_0A,
  }EnumWifiResp;

  osEvent RecvDataMsg;
  u8 DataTemp;
  u8 FrameLen = 0;
  EnumWifiResp RecvSta = eWifiRespSta_0D;

  RecvDataMsg = osMessageGet(Wifi.Uart.RecvQ, 23);
  while((osEventMessage == RecvDataMsg.status) && (FrameLen < (MaxLen-1)))
  {
    DataTemp = RecvDataMsg.value.v;
    pFrame[FrameLen] = DataTemp;
    FrameLen++;
    pFrame[FrameLen] = 0;
    switch(RecvSta)
    {
      case eWifiRespSta_0D:
        if(0x0D == DataTemp)//յ0x0D
          RecvSta = eWifiRespSta_0A;
        else
          RecvSta = eWifiRespSta_0D;
        break;
      case eWifiRespSta_0A:
        if(0x0A == DataTemp)
        {//յ0x0A,
          pFrame[FrameLen] = 0;
          if(FrameLen > 2)//ݷ
            return FrameLen;
          else
          {//ݣ㣬
            RecvSta = eWifiRespSta_0D;
            FrameLen = 0;
          }
        }
        else if(0x0D == DataTemp)
          RecvSta = eWifiRespSta_0A;
        else
          RecvSta = eWifiRespSta_0D;
        break;

      default:
        if(0x0D == DataTemp)//յ0x0D
          RecvSta = eWifiRespSta_0A;
        else
          RecvSta = eWifiRespSta_0D;
        FrameLen = 0;
        pFrame[FrameLen] = DataTemp;
        FrameLen++;
        pFrame[FrameLen] = 0;
        break;
    }
    RecvDataMsg = osMessageGet(Wifi.Uart.RecvQ, 5);
  }

  pFrame[FrameLen]= 0;
  return FrameLen;
}

void CleanRecvBuff(void)
{
  osEvent RecvMsg;

  do
  {/*սջ*/
    RecvMsg = osMessageGet(Wifi.Uart.RecvQ, 1);
  }while(osEventMessage == RecvMsg.status);
}
int WifiModWaitAck(u32 Ms)
{
  u32 StartTick = GetSystemTick();
  char *pStr;
  do
  {
    if(WifiModGetFrame(Wifi.Resp, sizeof(Wifi.Resp)))
    {
      pStr = strstr(Wifi.Resp, "+OK");
      if(NULL != pStr)
        return 0;
      pStr = strstr(Wifi.Resp, "+ERR");
      if(NULL != pStr)
        return 1;
    }
  }while((GetSystemTick() - StartTick) < Ms);

  return -1;//ʱ
}

static u8 AcsiiToHex(u8 Data)
{
	if (Data >= '0' && Data <= '9')
		return Data - '0';
	if (Data >= 'a' && Data <= 'f')
		return 10 + Data -'a';
	if (Data >= 'A' && Data <= 'F')
		return 10 + Data -'A';

	return Data;
}

int StrToHex3(char *pStr, u8 *pData)
{
  u8 Data;

  Data = 0;
  if((pStr[0] >= '0') && (pStr[0] <= '9'))
  {
    Data = pStr[0] - '0';
    if((pStr[1] >= '0') && (pStr[1] <= '9'))
    {
      Data = Data*10 + (pStr[1] - '0');
      if((pStr[2] >= '0') && (pStr[2] <= '9'))
        Data = Data*10 + (pStr[2] - '0');
    }
  }
  else
    return -1;

  *pData = Data;
  return 0;
}

int StrToIp(char *pStr, u8 *pIp)
{
  char *pTemp = pStr;

  if(0 != StrToHex3(pTemp, &pIp[0]))
    return -1;

  pTemp = strstr(pTemp, ".");
  if(NULL == pTemp)
    return -1;
  pTemp++;
  if(0 != StrToHex3(pTemp, &pIp[1]))
    return -1;

  pTemp = strstr(pTemp, ".");
  if(NULL == pTemp)
    return -1;
  pTemp++;
  if(0 != StrToHex3(pTemp, &pIp[2]))
    return -1;

  pTemp = strstr(pTemp, ".");
  if(NULL == pTemp)
    return -1;
  pTemp++;
  if(0 != StrToHex3(pTemp, &pIp[3]))
    return -1;

  return 0;
}

EnumSwitchStatus WifiGetLinkSta(void)
{
  if(Bit_SET == GPIO_ReadInputDataBit(Wifi_Link_PORT, Wifi_Link_PIN))
    return eSwSta_On;
  else
    return eSwSta_Off;
}

typedef enum
{
  eWifiProc_Start = 0,//0
  eWifiProc_Mac = 1,  //1
  eWifiProc_Set,      //2
  eWifiProc_WaitReBoot,
  eWifiProc_WaitLink,
  eWifiProc_NetParam,
  eWifiProc_WaitConnect,
  eWifiProc_SwitchTrans,
  eWifiProc_SoftReset,
  eWifiProc_Error,
  eWifiProc_Idle,
}EnumWifiProc;

void WifiProcStart(void)
{
  int Ack;

  if(0 == Wifi.Proc.StatusTick)
    Wifi.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Wifi.Proc.StatusTick) > 60000)//60s
  {
    Wifi.Proc.StatusTick = 0;
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
    return;
  }

  WifiModPrintf("\r\n");
  osDelay(100);
  WifiModPrintf("+++");
  osDelay(300);
  WifiModPrintf("a");
  osDelay(300);

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+E=OFF\r\n");
  Ack = WifiModWaitAck(200);
  if(0 == Ack)
  {
    Wifi.Err.Bit.NoMod = 0;
    Wifi.Proc.StatusTick = 0;
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Mac;
  }
  else
    Wifi.Err.Bit.NoMod = 1;
}

void WifiProcMac(void)
{
  u8 Ack = 0;
  char *pStr;
  u8 i;

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+MAC\r\n");
  Ack = WifiModWaitAck(300);
  if(0 == Ack)
  {
    pStr = strstr(Wifi.Resp, "+OK=") + strlen("+OK=");
    for(i=0; i<6; i++)
    {
      Wifi.Mac[i] = (AcsiiToHex(pStr[i*2])<<4) + AcsiiToHex(pStr[i*2+1]);
    }
    memcpy(MacAddr, Wifi.Mac, sizeof(MacAddr));

    Wifi.Err.Bit.NoMod = 0;
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Set;
  }
  else
    Wifi.Proc.ErrCnt++;

  if(Wifi.Proc.ErrCnt > 3)
  {
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
  }
}

void WifiProcSet(void)
{
  u8 Ack = 0;
  u8 ErrCnt;
  char Ssid[sizeof(WifiParam.Ssid)+1] = {0};
  char Key[sizeof(WifiParam.Key)+1] = {0};

  ErrCnt = 0;

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+WMODE=STA\r\n");
  //WifiModPrintf("AT+WMODE=AP\r\n");
  Ack = WifiModWaitAck(300);
  if(0 != Ack)
    ErrCnt++;

  memcpy(Ssid, WifiParam.Ssid, sizeof(WifiParam.Ssid));
  Ssid[sizeof(WifiParam.Ssid)] = 0;
  memcpy(Key, WifiParam.Key, sizeof(WifiParam.Key));
  Key[sizeof(WifiParam.Key)] = 0;
  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  if(0 == strlen(Key))
    WifiModPrintf("AT+WSTA=%s,NONE\r\n", Ssid);
  else
    WifiModPrintf("AT+WSTA=%s,%s\r\n", Ssid, Key);
  Ack = WifiModWaitAck(300);
  if(0 != Ack)
    ErrCnt++;

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+WANN=DHCP\r\n");
  Ack = WifiModWaitAck(300);
  if(0 != Ack)
    ErrCnt++;

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+SOCKA=TCPC,%d.%d.%d.%d,%d\r\n", ServerAddr.Ip[0], ServerAddr.Ip[1],
               ServerAddr.Ip[2], ServerAddr.Ip[3], ServerAddr.Port);
  Ack = WifiModWaitAck(300);
  if(0 != Ack)
    ErrCnt++;

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+SOCKDISA=ON\r\n");
  Ack = WifiModWaitAck(300);
  if(0 != Ack)
    ErrCnt++;

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+REGENA=OFF\r\n");
  Ack = WifiModWaitAck(300);
  if(0 != Ack)
    ErrCnt++;

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+Z\r\n");
  Ack = WifiModWaitAck(300);
  if(0 != Ack)
    ErrCnt++;

  if(0 == ErrCnt)
  {
    osDelay(2000);
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_WaitReBoot;
  }
  else
    Wifi.Proc.ErrCnt++;

  if(Wifi.Proc.ErrCnt > 3)
  {
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
  }
}

void WifiProcWaitReBoot(void)
{
  int Ack;

  if(0 == Wifi.Proc.StatusTick)
    Wifi.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Wifi.Proc.StatusTick) > 60000)//60s
  {
    Wifi.Proc.StatusTick = 0;
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
    return;
  }

  WifiModPrintf("\r\n");
  osDelay(100);
  WifiModPrintf("+++");
  osDelay(300);
  WifiModPrintf("a");
  osDelay(300);

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+E=OFF\r\n");
  Ack = WifiModWaitAck(200);
  if(0 == Ack)
  {
    Wifi.Err.Bit.NoMod = 0;
    Wifi.Proc.StatusTick = 0;
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_WaitLink;
  }
  else
    Wifi.Err.Bit.NoMod = 1;
}

void WifiProcWaitLink(void)
{
  u8 Ack = 0;
  char *pStr;

  if(0 == Wifi.Proc.StatusTick)
    Wifi.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Wifi.Proc.StatusTick) > 120000)//120s
  {
    Wifi.Proc.StatusTick = 0;
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
    return;
  }

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+WSLK\r\n");
  Ack = WifiModWaitAck(2000);
  if(0 == Ack)
  {
    pStr = strstr(Wifi.Resp, "+OK");
    if(NULL != strstr(pStr, "DISCONNECTED"))
    {
      Wifi.Err.Bit.NoAp = 1;
    }
    else
    {
      pStr = strstr(Wifi.Resp, "+OK=");
      pStr = strstr(pStr, ",");
      if(NULL != pStr)
      {
        pStr++;
        StrToHex3(pStr, &Wifi.Csq);
      }
      Wifi.Err.Bit.NoAp = 0;
      Wifi.Proc.StatusTick = 0;
      Wifi.Proc.ErrCnt = 0;
      Wifi.Proc.Status = eWifiProc_NetParam;
      //Wifi.Proc.Status = eWifiProc_WaitLink;
    }
  }
  else
    Wifi.Proc.ErrCnt++;

  if(Wifi.Proc.ErrCnt > 3)
  {
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
  }
}

void WifiProcNetParam(void)
{
  u8 Ack = 0;
  char *pStr;
  u8 ErrFlag = 0;
  u8 _LocalIp[4];
  u8 _SubIp[4];
  u8 _GwIp[4];
  u8 _DnsIp[4];

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+WANN\r\n");
  Ack = WifiModWaitAck(500);
  if(0 == Ack)
  {
    ErrFlag = 0;
    pStr = strstr(Wifi.Resp, "+OK=");
    if(NULL == pStr)
    {
      ErrFlag = 1;
      goto __Return__;
    }

    pStr = strstr(pStr, ",");
    if(NULL == pStr)
    {
      ErrFlag = 1;
      goto __Return__;
    }
    pStr++;
    if(0 != StrToIp(pStr, _LocalIp))
    {
      ErrFlag = 1;
      goto __Return__;
    }

    pStr = strstr(pStr, ",");
    if(NULL == pStr)
    {
      ErrFlag = 1;
      goto __Return__;
    }
    pStr++;
    if(0 != StrToIp(pStr, _SubIp))
    {
      ErrFlag = 1;
      goto __Return__;
    }

    pStr = strstr(pStr, ",");
    if(NULL == pStr)
    {
      ErrFlag = 1;
      goto __Return__;
    }
    pStr++;
    if(0 != StrToIp(pStr, _GwIp))
    {
      ErrFlag = 1;
      goto __Return__;
    }

    pStr = strstr(pStr, ",");
    if(NULL == pStr)
    {
      ErrFlag = 1;
      goto __Return__;
    }
    pStr++;
    if(0 != StrToIp(pStr, _DnsIp))
    {
      ErrFlag = 1;
      goto __Return__;
    }
  }
  else
    ErrFlag = 1;

__Return__ :
  if(0 == ErrFlag)
  {
    memcpy(LocalIp, _LocalIp, sizeof(LocalIp));
    memcpy(SubIp, _SubIp, sizeof(SubIp));
    memcpy(GwIp, _GwIp, sizeof(GwIp));
    memcpy(DnsIp, _DnsIp, sizeof(DnsIp));
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_WaitConnect;
  }
  else
    Wifi.Proc.ErrCnt++;

  if(Wifi.Proc.ErrCnt > 3)
  {
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
  }
}

void WifiProcWaitConnect(void)
{
  u8 Ack = 0;
  char *pStr;

  if(0 == Wifi.Proc.StatusTick)
    Wifi.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Wifi.Proc.StatusTick) > 300000)//300s
  {
    Wifi.Proc.StatusTick = 0;
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
    return;
  }

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+SOCKLKA\r\n");
  Ack = WifiModWaitAck(300);
  if(0 == Ack)
  {
    pStr = strstr(Wifi.Resp, "+OK");
    if(NULL != strstr(pStr, "=CONNECTED"))
    {
      Wifi.Err.Bit.NoCon = 0;
      Wifi.Proc.StatusTick = 0;
      Wifi.Proc.ErrCnt = 0;
      Wifi.Proc.Status = eWifiProc_SwitchTrans;
    }
    else if(NULL != strstr(pStr, "=DISCONNECTED"))
    {
      Wifi.Err.Bit.NoCon = 1;
      Wifi.Proc.ErrCnt = 0;
    }
  }
  else
    Wifi.Proc.ErrCnt++;

  if((Wifi.Proc.ErrCnt > 3) || (eSwSta_Off == WifiGetLinkSta()))
  {
    Wifi.Proc.StatusTick = 0;
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
  }
}

void WifiProcSwitchTrans(void)
{
  u8 Ack = 0;

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+ENTM\r\n");
  Ack = WifiModWaitAck(300);
  if(0 == Ack)
  {
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Idle;
    Wifi.LastRecvTime = GetSystemTick();
  }
  else
    Wifi.Proc.ErrCnt++;

  if(Wifi.Proc.ErrCnt > 3)
  {
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
  }
}

void WifiProcSoftReset(void)
{
  u8 Ack = 0;

  WifiModPrintf("\r\n");
  osDelay(100);
  WifiModPrintf("+++");
  osDelay(300);
  WifiModPrintf("a");
  osDelay(300);

  WifiModPrintf("\r\n");
  osDelay(100);
  CleanRecvBuff();
  WifiModPrintf("AT+Z\r\n");
  Ack = WifiModWaitAck(300);
  if(0 == Ack)
  {
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Start;
    osDelay(800);
  }
  else
    Wifi.Proc.ErrCnt++;

  if(Wifi.Proc.ErrCnt > 3)
  {
    Wifi.Proc.ErrCnt = 0;
    Wifi.Proc.Status = eWifiProc_Error;
  }
}

void WifiProcError(void)
{
  GPIO_ResetBits(Wifi_ResetCtrl_PORT, Wifi_ResetCtrl_PIN);
  osDelay(500);
  GPIO_SetBits(Wifi_ResetCtrl_PORT, Wifi_ResetCtrl_PIN);
  osDelay(3000);

  Wifi.Proc.StatusTick = 0;
  Wifi.Proc.ErrCnt = 0;
  Wifi.Proc.Status = eWifiProc_Start;
}

void WifiProcIdle(void)
{
  if((GetSystemTick() - Wifi.LastRecvTime) > (5*60*1000))
    Wifi.Proc.Status = eWifiProc_SoftReset;

  if(eWifiSelfCtrl_CloseSckt == Wifi.SelCtrl)
  {
    Wifi.SelCtrl = eWifiSelfCtrl_None;
    Wifi.Proc.Status = eWifiProc_SoftReset;
  }
  if(eSwSta_Off == WifiGetLinkSta())
    Wifi.Proc.Status = eWifiProc_WaitReBoot;
}

pWifiProcHandle WifiProcHandle[] =
{
  WifiProcStart,
  WifiProcMac,
  WifiProcSet,
  WifiProcWaitReBoot,
  WifiProcWaitLink,
  WifiProcNetParam,
  WifiProcWaitConnect,
  WifiProcSwitchTrans,
  WifiProcSoftReset,
  WifiProcError,
  WifiProcIdle
};

void Thd_WifiProcess(void const *argument)
{
  Wifi.Proc.Status = 0;

  while(1)
  {
    if(Wifi.Proc.Status < (sizeof(WifiProcHandle)/sizeof(pWifiProcHandle)))
      WifiProcHandle[Wifi.Proc.Status]();
    else
      Wifi.Proc.Status = 0;

    osDelay(37);
  }
}

/******************************************************************************
  : Module_USARTx_IRQHandler
  : ڽж
  : 
  : 
******************************************************************************/
void Wifi_USARTx_IRQHandler(void)
{
  u16 CR1,SR;
  u8 Data;
  osEvent SendDataMsg;

  SR = Wifi_USARTx->SR;
  CR1 = Wifi_USARTx->CR1;
  if((CR1 & USART_CR1_RXNEIE) && (SR & USART_SR_RXNE))
  {
    Data = (u8)Wifi_USARTx->DR;
    if(eWifiProc_Idle == Wifi.Proc.Status)
    {
      if(NULL != Wifi.AppRecvQ)
        osMessagePut(Wifi.AppRecvQ, Data, 0);
      Wifi.LastRecvTime = GetSystemTick();
    }
    else
      osMessagePut(Wifi.Uart.RecvQ, Data, 0);
  }

  if((CR1 & USART_CR1_TXEIE) && (SR & USART_SR_TXE))
  {
    SendDataMsg = osMessageGet(Wifi.Uart.SendQ, 0);
    if(osEventMessage == SendDataMsg.status)
      Wifi_USARTx->DR = SendDataMsg.value.v;
    else
      Wifi_USARTx->CR1 &= ~USART_CR1_TXEIE;
  }
}

/******************************************************************************
  : InternetInit
  : ͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 WifiInit(osMessageQId AppRecvQ)
{
  USART_InitTypeDef USART_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  Wifi.AppRecvQ = AppRecvQ;
  CommuUartIrqSet(Wifi_USARTx_IRQHandler);

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);
  GPIO_PinRemapConfig(GPIO_FullRemap_USART3, ENABLE);

  /* Enable GPIO clock */
  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Pin = Wifi_USARTx_TX_PIN;
  RCC_APB2PeriphClockCmd(Wifi_USARTx_TX_GPIO_CLK, ENABLE);
  GPIO_Init(Wifi_USARTx_TX_GPIO_PORT, &GPIO_InitStructure);


  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Pin = Wifi_USARTx_RX_PIN;
  RCC_APB2PeriphClockCmd(Wifi_USARTx_RX_GPIO_CLK, ENABLE);
  GPIO_Init(Wifi_USARTx_RX_GPIO_PORT, &GPIO_InitStructure);

  /* Enable USART clock */
  Wifi_USARTx_CLK_INIT(Wifi_USARTx_CLK, ENABLE);

  /* Enable the USART OverSampling by 8 */
  USART_OverSampling8Cmd(Wifi_USARTx, ENABLE);

  /* USARTx configuration ----------------------------------------------------*/
  USART_InitStructure.USART_BaudRate = Wifi_USARTx_BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(Wifi_USARTx, &USART_InitStructure);

  /* Enable the USARTx Interrupt */
  NVIC_InitStructure.NVIC_IRQChannel = Wifi_USARTx_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  /* Create Storage Message Queue */
  Wifi.Uart.RecvQ = NULL;
  osMessageQDef(RecvQ, 128, u8);
  Wifi.Uart.RecvQ = osMessageCreate(osMessageQ(RecvQ), NULL);

  Wifi.Uart.SendQ = NULL;
  osMessageQDef(SendQ, 512, u8);
  Wifi.Uart.SendQ = osMessageCreate(osMessageQ(SendQ), NULL);

//  if(NULL == ModuleRecvMsg)
//    return FALSE;

  /* Enable USART */
  USART_Cmd(Wifi_USARTx, ENABLE);

  /* Enable the Tx buffer empty interrupt */
  USART_ITConfig(Wifi_USARTx, USART_IT_RXNE, ENABLE);

  osThreadDef(Thd_WifiProcess, Thd_WifiProcess, osPriorityHigh, 0, 2*configMINIMAL_STACK_SIZE);
  osThreadCreate(osThread(Thd_WifiProcess), NULL);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Pin = Wifi_ResetCtrl_PIN;
  RCC_APB2PeriphClockCmd(Wifi_ResetCtrl_RCC, ENABLE);
  GPIO_Init(Wifi_ResetCtrl_PORT, &GPIO_InitStructure);
  GPIO_SetBits(Wifi_ResetCtrl_PORT, Wifi_ResetCtrl_PIN);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Pin = Wifi_Link_PIN;
  RCC_APB2PeriphClockCmd(Wifi_Link_RCC, ENABLE);
  GPIO_Init(Wifi_Link_PORT, &GPIO_InitStructure);

  osMutexDef(Mutex);
  Wifi.SendMutex = osMutexCreate(osMutex(Mutex));

  return TRUE;
}

u8 WifiNetAvail(void)
{
  if(eWifiProc_Idle != Wifi.Proc.Status)
    return FALSE;

  return TRUE;
}

int WifiTcpSend(u8 *pData, u16 Len)
{
  u16 i;

  if(FALSE == WifiNetAvail())
    return -1;

  if(osOK != osMutexWait(Wifi.SendMutex, 5000))//5
    return -2;

  if(FALSE == WifiNetAvail())
  {
    osMutexRelease(Wifi.SendMutex);
    return -3;
  }

  for(i=0; i<Len; i++)
    WifiModSendByte(pData[i]);

  osMutexRelease(Wifi.SendMutex);

  osDelay(200);
  return 0;
}

void WifiTcpClose(void)
{
  Wifi.SelCtrl = eWifiSelfCtrl_CloseSckt;
}


