
#ifndef __DRV_WIFIC322_H__
#define __DRV_WIFIC322_H__

#include "Global.h"
#include "Drv_CommuUart.h"

#define Wifi_USARTx_BaudRate                (115200)

#define Wifi_USARTx                           CommuUart_USARTx
#define Wifi_USARTx_CLK                       CommuUart_USARTx_CLK
#define Wifi_USARTx_CLK_INIT                  CommuUart_USARTx_CLK_INIT
#define Wifi_USARTx_IRQn                      CommuUart_USARTx_IRQn
//#define Wifi_USARTx_IRQHandler                USART3_IRQHandler

#define Wifi_USARTx_TX_PIN                    CommuUart_USARTx_TX_PIN
#define Wifi_USARTx_TX_GPIO_PORT              CommuUart_USARTx_TX_GPIO_PORT
#define Wifi_USARTx_TX_GPIO_CLK               CommuUart_USARTx_TX_GPIO_CLK

#define Wifi_USARTx_RX_PIN                    CommuUart_USARTx_RX_PIN
#define Wifi_USARTx_RX_GPIO_PORT              CommuUart_USARTx_RX_GPIO_PORT
#define Wifi_USARTx_RX_GPIO_CLK               CommuUart_USARTx_RX_GPIO_CLK

#define Wifi_ResetCtrl_PIN            GPIO_Pin_1
#define Wifi_ResetCtrl_PORT           GPIOE
#define Wifi_ResetCtrl_RCC            RCC_APB2Periph_GPIOE

#define Wifi_Link_PIN            GPIO_Pin_5
#define Wifi_Link_PORT           GPIOE
#define Wifi_Link_RCC            RCC_APB2Periph_GPIOE

typedef enum
{
  eWifiSelfCtrl_None = 0,
  eWifiSelfCtrl_CloseSckt,
  eWifiSelfCtrl_Error,
}EnumWifiSelfCtrl;

typedef union
{
  u32 Mux;
  struct
  {
    u32 NoMod : 1;
    u32 NoAp  : 1;
    u32 NoCon : 1;
  }Bit;
}StructWifiError;

typedef struct
{
  osMessageQId RecvQ;
  osMessageQId SendQ;
}StructUartCommu;

typedef struct
{
  u8 ErrCnt;
  u8 Status;
  u32 StatusTick;
}StructWifiProc;

typedef struct
{
  EnumWifiSelfCtrl SelCtrl;
  u8 Csq;
  char Mac[6];
  char Resp[128];
  StructWifiError Err;
  StructUartCommu Uart;
  StructWifiProc Proc;
  osMessageQId AppRecvQ;
  osMutexId SendMutex;
}StructWifiSta;

typedef void(*pWifiProcHandle)(void);

extern StructWifiSta Wifi;
extern EnumSwitchStatus WifiGetLinkSta(void);

extern u8 WifiInit(osMessageQId AppRecvQ);
extern u8 WifiNetAvail(void);
extern int WifiTcpSend(u8 *pData, u16 Len);
extern void WifiTcpClose(void);

#endif


