
#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdarg.h>

#include "Stm32f4xx.h"
#include "cmsis_os.h"

#define BakStartAddr        ((u32)0x08041800)
#define AppCodeSize         ((u32)250*1024)
#define McnRomSectionSize   ((u32)2*1024)
#define UpdateFlagAddr      ((u32)0x08002800)
typedef union
{
  u8 Mult;
  struct
  {
   u32 Idle       : 1;//
   u32 startCompAck :1;//
   u32 stopCompAck: 1;//
   u32 DCTCUInfor : 1;//
   u32 DCTCUMeasu : 1;//
   u32 Param     : 1;//ͣ
   u32 verificationAck : 1;// 
  }Value;
}UnionConEM;

#ifndef NULL
#define NULL    ((void *)0)
#endif

#ifndef TRUE
#define TRUE  (1)
#endif
#ifndef FALSE
#define FALSE (0)
#endif

#ifndef UNKNOWN
#define UNKNOWN (0xFF)
#endif

typedef union
{
  u16 Mult16;
  struct
  {
    u8 L16 : 8;
    u8 H16 : 8;
  }Disp16;
}UnionLittleEnd16;

typedef union
{
  u32 Mult32;
  struct
  {
    u32 LL32 : 8;
    u32 ML32 : 8;
    u32 MH32 : 8;
    u32 HH32 : 8;
  }Disp32;
}UnionLittleEnd32;

typedef struct
{
  u16 Year;
  u8  Mon;
  u8  Day;
  u8  Hour;
  u8  Min;
  u8  Sec;
}StructTime;

typedef enum
{
  eChgType_Auto         = 0x00,
  eChgType_Time         = 0x01,
  eChgType_Energy       = 0x02,
  eChgType_Money        = 0x03,
  eChgType_Delay        = 0x04,
}EnumChargeType;

typedef struct
{
  u32 Energy;
  u32 Serve;
  u32 All;
}StructChgCost;

typedef struct
{
  u8  RecordValid;      //Ϣ־      0 ϢЧ 1ϢЧ
  u8  CardValidFlag;    //Ϣ־      0 ϢЧ(APP˺) 1ϢЧ
  u8  CardSureCtrl;     //˻֤״̬  0Ҫ 1ȴ 2ѷ 3ѻظ 4ظʱ  5쳣 6ۿط
  u8  ChgServerUpCtrl;  //״̬  0Ҫ 1ȴ 2ѷ 3ѻظ
  u8  ChgRecUpCtrl;    //¼Ϣϴ״̬ 0Ҫ 1ȴ 2ѷ 3ѻظ 4Ҫ 5ѱ
  u8  ChgStartNoteCtrl;   //翪ʼ״̬ϴ  0Ҫ 1ȴ 2ѷ 3ѻظ
  u8  ChgStopNotetrl;   //翪ʼ״̬ϴ  0Ҫ 1ȴ 2ѷ 3ѻظ

  u8  CardNum[16];      //
  u8  OrderId[8];       //
  u8  CardPwd[6];       //
  u8  CardResp;         //֤
  s32 CardRespMoney;     //֤
  u8  CardRespCtrl;         //֤

  u16 ChgEnergySeg[48];         //ʱε 0.001kwh/bit

  u8  MoneyDecFlag;   //0xFFδۿ 0x00¿ۿ 0x5Fοۿ   //ӦFlashԿԿ۷Ѻ󸲸
  u8 ChgStopType;      //ֹͣ   //1= 2=쳣 μ¼붨塷

  u8  ChgType;       // 0=Ȼ  1=Զʱ  2=Զ  3=Զ磻
  u32 ChgTypeParam; //Բ0=Ȼ磨01=Զʱ䣨1s/bit2=Զ0.001Kwh/bit3=Զ1/bit

  u32 ChgEnergy;     //ۻ 0.001kWh/bit
  u32 ChgTime;       //ۻʱ 1s/bit

  u32 RespMaxChgEnergy; //֤ɳ 0.001kWh/bit
  u32 RespMaxChgTime;   //֤ɳʱ 1s/bit

  u32 WipeStartTime;    //ˢʼʱ 0δˢ 0 ˢʱ׼ʱ
  u32 WipeStopTime;     //ˢʱ 0δˢ 0 ˢʱ׼ʱ
  u32 ChgStartTime;     //翪ʼʱ 0δʼ 0翪ʼʱʱ
  u32 ChgStopTime;      //ʱ 0δʼ 0ʱʱ

  u32 StartMeterEnergy; //ʼܱ 0.001kWh/bit
  u32 StopMeterEnergy;  //ܱ 0.001kWh/bit

  s32 StartCardMoney;    //ʼ翨  (1/bit
  s32 StopCardMoney;    //翨  (1/bit
  s32 EnergyMoney;  //ѽ
  s32 ServeMoney;   //ѽ
  s32 EmployMoney;   //׮ռý
  s32 TotalMoney;   //ѽ
}StructChgRecd;

/*
//
//ChgStopType ֹͣͱ
//

ֹͣ״̬	ֹͣԭ	ֽڱ
ûֹͣ	ûͨˢֶֹͣѡֹͣ	1
Զֹͣ	ͨƽ̨ϵͳ´ָͣֹͣ	2
ֹͣ	ճԣֹͣ	3
ǹֹͣ	"׮CC/CPźŶϿֱ׮CC1ȷ϶Ͽ"	4
ֹͣ	ôﵽ˻ֹͣ	5
ֹͣ	ֹͣ	6
Զֹͣ	Զ׮ֹͣ	7
ֹͣ	У׮ϵ	8
Աֹͣ	Աֹͣ磬	9

ϵͳֹͣ	ϵͳ޷磬ֹͣ	20
ֹͣͣ	ͣť£ֹͣ	21
ֹͣ	ͨѶϣֹͣ	22
ֹͣ	ͨѶϣֹͣ	23
ʾֹͣ	ʾͨѶϣֹͣ	24
ԵͨѶֹͣ	ԵͨѶϣֹͣ	25
Ӵֹͣ	Ӵϣֹͣ	26

ѹֹͣ	ѹڶѹֹͣ	40
Ƿѹֹͣ	ѹСڶѹֹͣ	41
ȱֹͣ	ѹȱֹ࣬ͣ	42
ֹͣ	ڱֹͣ	43
·ֹͣ	ڶ·ֹͣ	44
ѹֹͣ	ѹڱѹֹͣ	45
Ƿѹֹͣ	ѹСڱѹֹͣ	46

BMSֹͣ	BMS磬ֹͣ	80
׮Եֹͣ	׮Եϣֹͣ	81
BMSͨѶ쳣ֹͣ	BMSͨѶ󣬳ֹͣ	82
صѹֹͣ	صѹߣֹͣ	83
¶ȹֹͣ	¶ȹߣֹͣ	84
سֹͣ	س쳣ֹͣ	85
SOCֹͣ	SOC߻߹ߣֹͣ	86
ؾԵֹͣ	ؾԵ״̬ϣֹͣ	87

쳣ֹͣ	ͨѶ쳣ֹͣ	120
ʼSOCֹͣ	ʼBMSṩSOC98ֹͣ	121
صѹ쳣ֹͣ	ʼBMSصѹѹֹͣ	122
׮ѹֹͣ	ʼBMSصѹڳ׮ѹֹͣ	123
ʵѹ쳣ֹͣ	ʼʵѹڳ׮ѹֹͣ	124
SOCֹͣ	SOC10ӣֹͣ	125
쳣ֹͣ	½쳣ֹͣ	126
*/


typedef enum
{
  eChgStop_None = 0,
  eChgStop_Shake_UserCancel = 1,
  eChgStop_Imd_UserCancel = 2,
  eChgStop_Reco_UserCancle = 3,
  eChgStop_Conf_UserCancel = 4,
  eChgStop_BmsReady_UserCancel = 5,
  eChgStop_PillarReady_UserCancel = 6,
  eChgStop_Start_UserCancel = 7,
  eChgStop_Run_UserCancel = 8,
  eChgStop_ComBreak_UserCancel = 9,
  eChgStop_Shake_CcOpen = 10,
  eChgStop_Imd_CcOpen = 11,
  eChgStop_Reco_CcOpen = 12,
  eChgStop_Conf_CcOpen = 13,
  eChgStop_BmsReady_CcOpen = 14,
  eChgStop_PillarReady_CcOpen = 15,
  eChgStop_Start_CcOpen = 16,
  eChgStop_Run_CcOpen = 17,
  eChgStop_ComBreak_CcOpen = 18,
  eChgStop_Shake_EmerClose = 19,
  eChgStop_Imd_EmerClose = 20,
  eChgStop_Reco_EmerClose = 21,
  eChgStop_Conf_EmerClose = 22,
  eChgStop_BmsReady_EmerClose = 23,
  eChgStop_PillarReady_EmerClose = 24,
  eChgStop_Start_EmerClose = 25,
  eChgStop_Run_EmerClose = 26,
  eChgStop_ComBreak_EmerClose = 27,
  eChgStop_Imd_BhmTimeOut = 28,
  eChgStop_Conf_StartSoc98 = 29,
  eChgStop_Conf_BatVoltOverPermitMax = 30,
  eChgStop_Conf_StartVoltOverPillarMax = 31,
  eChgStop_PillarReady_BatVoltOverPillarMax = 32,
  eChgStop_ComBreak_CurtError = 33,
  eChgStop_ComBreak_BmsStop = 34,
  eChgStop_ComBreak_CommError = 35,
  eChgStop_Start_BmsStop = 36,
  eChgStop_Run_BmsStop = 37,
  eChgStop_Imd_IsolateError = 38,
  eChgStop_Run_Soc98 = 39,
  eChgStop_Run_SinglBatVolt = 40,
  eChgStop_Run_SocOver = 41,
  eChgStop_Run_CurrtOver = 42,
  eChgStop_Run_BatTempOver = 43,
  eChgStop_Run_BatIsolate = 44,
  eChgStop_Run_Cc2Error = 45,
  eChgStop_Run_BmsPause = 46,
  eChgStop_Conf_ChgMaxVoltLessPillarMinVolt = 47,
  eChgStop_PillarReady_BatVoltError = 48,
  eChgStop_PillarReady_BatVoltMismatchBcpVolt = 49,
  eChgStop_Run_VoltOutHighErr = 50,
  eChgStop_Run_CurrtOutHighErr = 51,
  eChgStop_Conf_DoorOpen = 52,
  eChgStop_Reco_DoorOpen = 53,
  eChgStop_Run_DoorOpen = 54,
  eChgStop_Start_DoorOpen = 55,
  eChgStop_ComBreak_DoorOpen = 56,
  eChgStop_Imd_DoorOpen = 57,
  eChgStop_Shake_DoorOpen = 58,
  eChgStop_BmsReady_DoorOpen = 59,
  eChgStop_PillarReady_DoorOpen = 60,
  eChgStop_Run_SinglBatVoltOverPermitMax = 61,
  eChgStop_Conf_Contactor = 62,
  eChgStop_Reco_Contactor = 63,
  eChgStop_Run_Contactor = 64,
  eChgStop_Start_Contactor = 65,
  eChgStop_ComBreak_Contactor = 66,
  eChgStop_Imd_Contactor = 67,
  eChgStop_Shake_Contactor = 68,
  eChgStop_BmsReady_Contactor = 69,
  eChgStop_PillarReady_Contactor = 70,
  eChgStop_Conf_InVolt = 71,
  eChgStop_Reco_InVolt = 72,
  eChgStop_Run_InVolt = 73,
  eChgStop_Start_InVolt = 74,
  eChgStop_ComBreak_InVolt = 75,
  eChgStop_Imd_InVolt = 76,
  eChgStop_Shake_InVolt = 77,
  eChgStop_BmsReady_InVolt = 78,
  eChgStop_PillarReady_InVolt = 79,
  eChgStop_Conf_NoDcmod = 80,
  eChgStop_Reco_NoDcmod = 81,
  eChgStop_Run_NoDcmod = 82,
  eChgStop_Start_NoDcmod = 83,
  eChgStop_ComBreak_NoDcmod = 84,
  eChgStop_Imd_NoDcmod = 85,
  eChgStop_Shake_NoDcmod = 86,
  eChgStop_BmsReady_NoDcmod = 87,
  eChgStop_PillarReady_NoDcmod = 88,
  eChgStop_Conf_Meter = 89,
  eChgStop_Reco_Meter = 90,
  eChgStop_Run_Meter = 91,
  eChgStop_Start_Meter = 92,
  eChgStop_ComBreak_Meter = 93,
  eChgStop_Imd_Meter = 94,
  eChgStop_Shake_Meter = 95,
  eChgStop_BmsReady_Meter = 96,
  eChgStop_PillarReady_Meter = 97,
  eChgStop_Imd_Short = 98,

}EnumChgStopType;

typedef struct
{
  u8  ValidFlag; //0Ч 1Ч
  u8  ReserveNoteCtrl;
  u8  CardNum[16];//ԤԼ 16
  u32 StartTime;//ԤԼʼʱ
  u32 StopTime;//ԤԼʱ
}StructReserveParam;

typedef struct
{
  u8  ConnectFlag;//0 δ 
  u8  SignInFlag; //0 δע ע
  u8  FrameSendNum;
  u8  FrameRecvNum;
  u8  HeartBeatErrCnt;
  u8  HeartBeatErrCnt_B;
  u16 HeartBeatNumCnt;
  u16 HeartBeatLoseCnt;
  u32 HeartBeatSendTime;
  u32 HeartBeatSendTime_B;
  u32 HeartBeatRecvTime;
  u32 HeartBeatRecvTime_B;
  u32 SignInSendTime;
  u32 SignInRecvTime;
  u32 StatusSendTime;
  u32 StatusRecvTime;
}StructCommuStatus;

typedef enum
{
  eSwSta_Off = 0,
  eSwSta_On,
}EnumSwitchStatus;

typedef union
{
  u32 Mult;
  struct
  {
    u32 Emergency   : 1;
    u32 NoDcmod     : 1;
    u32 Insulation  : 1;
    u32 ImdDev      : 1;
    u32 DrainResist : 1;
    u32 Reader      : 1;
    u32 Meter       : 1;
    u32 Memory      : 1;
	
    u32 Lcd         : 1;
    u32 Net         : 1;
    u32 Door        : 1;
    u32 SPD         : 1;
    u32 Humiture    : 1;
    u32 ACMeter     : 1;
    u32 Contactor   : 1;
    u32 BMS         : 1;
	
    u32 InVolt      : 1;
    u32 EleLock     : 1;
    u32 OutVolt     : 1;
    u32 OutCurrt    : 1;
    u32 UniContactor: 1;
	u32 ACContactor : 1;
    u32 DCmodError  : 1;
    u32 PutBack     : 1;

    u32 OutShort    : 1;
	
  }Value;
}UnionPillarError;

typedef union
{
  u32 Mult;
  struct
  {
    u32 DrainResist   : 1;
    u32 IsolateWarn   : 1;
    u32 IsolateError  : 1;
    u32 VoltOutError  : 1;
    u32 CurrtOutError : 1;
  }Value;
}UnionChgError;

/*
typedef enum
{
  eChgErr_NoneError = 0,
  eChgErr_StopErr   = (1<<0),
  eChgErr_RelayErr  = (1<<1),
  eChgErr_CpErr     = (1<<2),
  eChgErr_ConnectErr= (1<<3),
  eChgErr_CurrtLeak = (1<<4),
  eChgErr_CurrtOver = (1<<5),
  eChgErr_CurrtProt = (1<<6),
  eChgErr_VoltHigh  = (1<<7),
  eChgErr_VoltLow   = (1<<8),
  eChgErr_TempOver  = (1<<9),
  eChgErr_NoneGnd   = (1<<10),
  eChgErr_PhaseErr  = (1<<11),
  eChgErr_Reader    = (1<<12),
  eChgErr_Meter     = (1<<13),
  eChgErr_Memory    = (1<<14),
  eChgErr_Display   = (1<<15),
  eChgErr_NetConnect= (1<<16),
  eChgErr_Max,
}EnumChargeError;//й
*/

extern UnionPillarError PillarError;
extern UnionChgError ChargeError;

extern UnionPillarError PillarError_B;
extern UnionChgError ChargeError_B;

extern u32 GetSystemTick(void);
extern u8 BcdToHex(u8 Bcd);
extern u8 HexToBcd(u8 Hex);

extern int CopyCode(u32 Des, u32 Scr, u32 Len);
extern int UpdateFlagSet(u32 Status);

#define __SoftVer__ (0x0320)  //BCD :V1.02   SoftVer = 0x0102

#endif

