
#ifndef __MEMORY_H__
#define __MEMORY_H__

#include "Global.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_CommuUSART3.h"
typedef union
{
  u32 Mult;
  struct
  {
    u8 Num_A        : 1;
    u8 Num_B        : 1;
    u8 Num_AB       : 1;
    u8 IdleLed      : 1;
    u8 Dehumi       : 1;
    u8 Door         : 1;
    u8 BatCellJud   : 1;
    u8 TopFan       : 1;
    u8 ACMeter      : 1;
    u8 NegContactor : 1;
    u8 EleLock      : 1;
    u8 SigUniChg    : 1;
  }Value;
}UnionChgFunctional;

typedef struct
{
  u8  Ip[4];
  u16 Port;
}StructServerAddr;

typedef struct
{
  u16 Sharp;
  u16 Peak;
  u16 Flat;
  u16 Valley;
}StructEnergyRate;

typedef struct
{
  u16 Num;
  u32 StartAddr;
  u32 StopAddr;
}StructFlashRecdParam;

typedef struct
{
  u8 ReaderType;
  u8 Auto_ID;
}StructReader;
typedef struct
{
  u8 DCModType;
  u8 Auto_ID;
}StructModul;
typedef enum
{
  eDCModType_No            = 0x00,
  eDCModType_Incre         = 0x01,
  eDCModType_ZhongXin      = 0x02,
  eDCModType_YouYou        = 0x03,
  eDCModType_YouYouNormal  = 0x04,
  eDCModType_Max           = eDCModType_YouYouNormal,
}EnumDCModType;


typedef struct
{
  u8  Head;
  u8  RecordType;

  u8  SendFlag;           //ϴ־  0xFFδϴ0x00ϴ

  u8  ChgNum;         //ǹ롣
  u8  CardValidFlag;        //ʽ
  u8  CardNum[16];    //
  u8  MoneyDecFlag;   //0δۿ 1¿ۿ
  u8  ChgType;       // 0=Ȼ  1=Զʱ  2=Զ  3=Զ磻
  u16 ChgEnergySeg[48];         //ʱε
  u32 ChgTypeParam; //Բ0=Ȼ磨01=Զʱ䣨1s/bit2=Զ0.001Kwh/bit3=Զ1/bit
  u32 ChgStopType;    //Ƿ
  u32 ChgTime;        //
  u32 ChgStartTime;   //׼ʱ
  u32 ChgStopTime;    //׼ʱ
  u32 StartMeterEnergy;// 0.001kwh/bit
  u32 StopMeterEnergy;// 0.001kwh/bit
  s32 StartCardMoney;    //翨
  s32 StopCardMoney;    //翨
  s32 EnergyMoney;  //ѽ
  s32 ServeMoney;   //ѽ
  s32 EmployMoney;   //׮ռý

  s32 NewStartCardMoney;    //翨
  s32 NewStopCardMoney;    //翨

  u8  End;
}StructAwaitChgRecdLog;

typedef struct
{
  u8  Head;
  u8  RecordType;

  u8  ChgNum;         //ǹ롣
  u8  CardValidFlag;        //ʽ
  u8  CardNum[16];    //
  u8  MoneyDecFlag;   //0δۿ 1¿ۿ
  u8  ChgType;       // 0=Ȼ  1=Զʱ  2=Զ  3=Զ磻
  u16 ChgEnergySeg[48];         //ʱε
  u32 ChgTypeParam; //Բ0=Ȼ磨01=Զʱ䣨1s/bit2=Զ0.001Kwh/bit3=Զ1/bit
  u32 ChgStopType;    //Ƿ
  u32 ChgTime;        //
  u32 ChgStartTime;   //׼ʱ
  u32 ChgStopTime;    //׼ʱ
  u32 StartMeterEnergy;// 0.001kwh/bit
  u32 StopMeterEnergy;// 0.001kwh/bit
  s32 StartCardMoney;    //翨
  s32 StopCardMoney;    //翨
  s32 EnergyMoney;  //ѽ
  s32 ServeMoney;   //ѽ
  s32 EmployMoney;   //׮ռý

  u8  End;
}StructChgRecdLog;

typedef struct
{
  u8  Head;
  u8  RecordType;
  u8  ChgNum;//ǹ롣
  u8  CardNum[16];//
  u32 ChgEnergy;//ۼƳ λ:ǧʱ 0.001kah/bit
  u32 ChgTime;  //ۼƳʱ  1s/bit
  u32 ChgVolt;//ѹѹ 0.001V/bit
  u32 ChgCurrt;//ѹ 0.001A/bit
  u32 MeterEnergy;//ǰ
  u32 RecordTime; //¼ʱ
  u8  End;
}StructChgProcLog;

typedef struct
{
  u8  Head;
  u8  RecordType;
  u8  AlarmType;
  u32 AlarmCode;
  u32 RecordTime;
  u8  End;
}StructAlarmLog;

typedef struct
{
  u8  Head;
  u8  RecordType;
  u32 EventType;
  u32 RecordTime;
  u8  End;
}StructEventLog;

typedef struct
{
  u8  Head;
  u8  RecordType;

  u8  RecordValid;      //Ϣ־      0 ϢЧ 1ϢЧ
  u8  ChgNum;         //ǹ롣
  u8  CardValidFlag;    //Ϣ־      0 ϢЧ(APP˺) 1ϢЧ
  u8  CardNum[16];    //
  u8  MoneyDecFlag;   //0xFFδۿ 0x00¿ۿ 0x5Fοۿ   //ӦFlashԿԿ۷Ѻ󸲸
  u8  ChgType;       // 0=Ȼ  1=Զʱ  2=Զ  3=Զ磻
  u16 ChgEnergySeg[48];         //ʱε
  u32 ChgTypeParam; //Բ0=Ȼ磨01=Զʱ䣨1s/bit2=Զ0.001Kwh/bit3=Զ1/bit
  u32 ChgStopType;    //Ƿ
  u32 ChgTime;        //
  u32 ChgStartTime;   //׼ʱ
  u32 ChgStopTime;    //׼ʱ
  u32 StartMeterEnergy;// 0.001kwh/bit
  u32 StopMeterEnergy;// 0.001kwh/bit
  s32 StartCardMoney;    //翨
  s32 StopCardMoney;    //翨
  s32 EnergyMoney;  //ѽ
  s32 ServeMoney;   //ѽ
  s32 EmployMoney;   //׮ռý

  u8  End;
}StructTempChgRecd;

typedef struct
{
  u8 SetFlag;
  StructServerAddr IpAddr;
  u32 SetTime;
}StructIpSetDelay;

typedef struct
{
  u8 SysPwd[6];  //ϵͳ
  u8 MoneyKey[6];//7C8D461F887E
  u8 PillarNum[8];  //׮
  u8 TelNum_1[16];//ߵ绰1
  u8 TelNum_2[16];//ߵ绰2
  u8 AssetNum[16];//ʲ
  u8 DealQrcode[52];//׶ά
  u8 EnergyTimeRate[48];
  StructServerAddr ServerAddr;////׮IP
  u16 ServerRate;//
  u16 HadSigned;//ע־
  u16 LockCard;//
  u16 EnergyRate[4];
  u8 LocalIp[4];//IP
  u8 SubIp[4];//
  u8 GwIp[4];//
  u8 DnsIp[4];//Dns
  u8 MacAddr[6];//Macַ
  u16 StaticIp;//̬Ip
  u16 NetType;//ģʽ
  u16 EmployRate;//X.xxԪ/
  u16 FreeTime;//X.xxСʱ
  u16 DcMaxVolt;//ģѹ XXX.xV
  u16 DcMinVolt;//ģСѹ XXX.xV
  u16 DcMaxCurrt;//ģ XX.xA
  u16 DcMinCurrt;//ģС XX.xA
  u8  DcMaxPower;//ģ XX KW
  u8  ChgVer;
  UnionChgFunctional ChgFun;
  u16 TempDiff;
  u16 SuitTempDiff;
  u32 AlarmTemp;
  u16 FaultTemp;
  u8 MeterAddr[6];
  u8 MeterAddr_B[6];
  u8 MeterAddr_AC[6];
  u16 VoltHigh;
  u16 VoltLow;
  StructReader Reader;
  u16 EnergyRatio;//0.001
  u16 VoltRatio;//0.001
  u16 CurrtRatio;//0.001
  u16 BalanceMoney;//0.01Ԫ
  u16 FtpDataChn;
  u16 ServerRate2[4];
  u8 ServerTimeRate[48];
  StructModul Module;
  u16 SingleMaxCurrt;
  u16 SOCMAX;
}StructMemory;

extern StructMemory UserParam;

extern StructMemory UserParamDef;

extern u16 WaitUpChgRecdNum;//ϴ¼

extern StructFlashRecdParam LogChgRecdParam;

extern void UserParamInit(void);
extern void UserParamReset(void);
extern u8 SaveUserParam(u8* pData, u16 Len);
extern u8 GetUserParam(u8* pData, u16 Len);

extern void ChgRecdSaveToAwaitLog(StructChgRecd *pRecord, u8 ChgNum);
extern u8 AwaitChgRecdRead(u16 Num, StructAwaitChgRecdLog *pChgRecd);
extern u8 AwaitChgRecdWrite(u16 Num, StructAwaitChgRecdLog *pAwaitChgRecd);

extern void MemoryInit(void);

extern void LogParamReset(void);//¼

extern void ChgRecdSaveToLog(StructChgRecd *pChgRecd, u8 ChgNum);
extern u8 ChgRecdReadInLog(u16 Num, StructChgRecdLog *pChgRecd);
extern void TempChgRecdSaveToLog(StructChgRecd *pChgRecd, u8 ChgNum, u8 Vaild);

#define SpiFlashSectionSize         (0x1000)

#define FlashInitAddr               (0)//0Kַʼ ܹ4K

#define UserParamAddr               (FlashInitAddr+SpiFlashSectionSize)//4Kַʼ ܹ4K
#define UserParamBakAddr            (UserParamAddr+SpiFlashSectionSize)//8Kַʼ ܹ4K

#define ChgRecdSize                 (256)
#define WaitUpChgRecdBaseAddr       (UserParamBakAddr+SpiFlashSectionSize)//12Kַʼ ܹ40K
#define WaitUpChgRecdNumMax         (160)
#define WaitUpChgRecdIsolateAddr    (WaitUpChgRecdBaseAddr+WaitUpChgRecdNumMax*ChgRecdSize)//52Kַʼ ܹ4K

#define LogChgRecdBaseAddr          ((u32)WaitUpChgRecdIsolateAddr+SpiFlashSectionSize)//56Kַʼ ܹ48K
#define LogChgRecdNumMax            (192)
#define LogChgRecdIsolateAddr       ((u32)LogChgRecdBaseAddr+LogChgRecdNumMax*ChgRecdSize)//104Kַʼ ܹ4K

#define TempChgRecdBaseAddr         ((u32)LogChgRecdIsolateAddr+SpiFlashSectionSize)//108Kַʼ ܹ124K
#define TempChgRecdNumMax           (496)
#define TempChgRecdIsolateAddr      ((u32)LogChgRecdBaseAddr+TempChgRecdNumMax*ChgRecdSize)//252Kַʼ ܹ4K

/*************************************E2ROM***************************************************/
#define __TEMPCHGSAVEINE2ROM__

#define mBackupBaseAddr     ((u16)0x8000)
#define mWrChkSumSize       (1)

#define eeAddr_TempChgRecdBase        (0)//ԤAǹBǹ洢λ
#define eeAddr_TempChgRecdBase_B      (eeAddr_TempChgRecdBase + sizeof(StructTempChgRecd) + mWrChkSumSize)

#endif


