

#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Memory.h"


void ChgProChgStart_AB(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CRO_SendTick = 0;
  u8  CroStarus = 0x00;
  u32 CcStatusChkTick = 0;

  BemMsg.Valid = 0;
  BclMsg.Valid = 0;
  BcsMsg.Valid = 0;
  BstMsg.Valid = 0;
  BmsCanInit();
  osDelay(20);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet_AB(eSwSta_On);
  LockSet_AB(eSwSta_On);
  FanSet_AB(eSwSta_On);
  ImdWorkSet_AB(eSwSta_Off);
  DrainResistSet_AB(eSwSta_Off);
  if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer))//ȫ¹պϼ̵
    DcOutSet_AB(eSwSta_On);
  else
    DcOutSet_AB(eSwSta_Off);

  CroStarus = 0xAA;
  CRO_Send(CroStarus);
  CRO_SendTick = GetSystemTick();

  BclMsg.RecvTick = GetSystemTick();
  BcsMsg.RecvTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CRO_SendTick) > 250)
    {
      CRO_Send(CroStarus);
      CRO_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);

    if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer))
    {
      if((GetSystemTick() - BclMsg.RecvTick) > MsgTimeout_1S)
      {
        CemMsg.Cem.Value.Bcl = 1;
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
        pChargeCtrl->Param = 0;
      }

      if((GetSystemTick() - BcsMsg.RecvTick) > MsgTimeout_5S)
      {
        CemMsg.Cem.Value.Bcs = 1;
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
        pChargeCtrl->Param = 0;
      }
    }
    else
    {
      if((GetSystemTick() - BclMsg.RecvTick) > (MsgTimeout_5S*3/2))
      {
        CemMsg.Cem.Value.Bcl = 1;
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
        pChargeCtrl->Param = 0;
      }

      if((GetSystemTick() - BcsMsg.RecvTick) > (MsgTimeout_5S*3/2))
      {
        CemMsg.Cem.Value.Bcs = 1;
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
        pChargeCtrl->Param = 0;
      }
    }

    if((0 != BclMsg.Valid) && (0 != BcsMsg.Valid))
    {//յBrm
      if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer))
      {
        pChargeCtrl->CurProcess = eChgPro_AB_ChgRun;
        pChargeCtrl->Param = 0;
      }
      else
      {
        pChargeCtrl->CurProcess = eChgPro_AB_WaitVoltChgRun;
        pChargeCtrl->Param = 0;
      }
    }

    if(0 != BemMsg.Valid)
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 != BstMsg.Valid)
    {
      CstMsg.StopReason.Value.BmsStop = 1;
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      ChargeStopType = eChgStop_Start_BmsStop;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(0 == ChargeEnable_AB)
    {//ⲿƽ
      CstMsg.StopReason.Value.Manual = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      ChargeStopType = eChgStop_Start_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick))
    {
      CstMsg.StopReason.Value.Truble = 1;
      CstMsg.StopTruble.Value.ChgGun = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_Start_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Emergency) || (0 != PillarError_B.Value.Emergency))
    {
      CstMsg.StopReason.Value.Truble = 1;
      CstMsg.StopTruble.Value.Emergency = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Start_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Door) || (0 != PillarError_B.Value.Door))
    {
      CstMsg.StopReason.Value.Truble = 1;
      CstMsg.StopTruble.Value.Other = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Start_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Contactor) || (0 != PillarError_B.Value.Contactor))
    {
      CstMsg.StopReason.Value.Truble = 1;
      CstMsg.StopTruble.Value.Other = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Start_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.UniContactor) || (0 != PillarError_B.Value.UniContactor))
    {
      CstMsg.StopReason.Value.Truble = 1;
      CstMsg.StopTruble.Value.Other = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Start_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.InVolt) || (0 != PillarError_B.Value.InVolt))
    {
      CstMsg.StopReason.Value.Truble = 1;
      CstMsg.StopTruble.Value.Other = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Start_InVolt;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.NoDcmod) || (0 != PillarError_B.Value.NoDcmod))
    {
      CstMsg.StopReason.Value.Truble = 1;
      CstMsg.StopTruble.Value.Other = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Start_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Meter) || (0 != PillarError_B.Value.Meter))
    {
      CstMsg.StopReason.Value.Truble = 1;
      CstMsg.StopTruble.Value.Other = 1;
      CST_Send(&CstMsg);
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Start_Meter;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_AB_ChgStart != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}



