

#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"


void ChgProWaitBmsReady_AB(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CML_SendTick = 0;
  u32 CTS_SendTick = 0;
  u32 CcStatusChkTick = 0;
  u32 BRO_AA_RecvTick = 0;

  BemMsg.Valid = 0;
  BroMsg.Valid = 0;
  BmsCanInit();
  osDelay(20);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet_AB(eSwSta_On);
  LockSet_AB(eSwSta_On);
  FanSet_AB(eSwSta_On);
  ImdWorkSet_AB(eSwSta_Off);
  DrainResistSet_AB(eSwSta_Off);
  DcOutSet_AB(eSwSta_Off);
  DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));

  CTS_Send();
  CTS_SendTick = GetSystemTick();
  CML_Send(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)), 4000 - DcModuleAbility.MinCurrt);
  CML_SendTick = GetSystemTick();

  BroMsg.RecvTick = GetSystemTick();
  BRO_AA_RecvTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CML_SendTick) > 250)
    {
      CML_Send(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)), 4000 - DcModuleAbility.MinCurrt);
      CML_SendTick = GetSystemTick();
    }
    if((GetSystemTick() - CTS_SendTick) > 500)
    {
      CTS_Send();
      CTS_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);

    if((GetSystemTick() - BroMsg.RecvTick) > MsgTimeout_5S)
    {
      CemMsg.Cem.Value.Bro = 1;
      pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg.Cem.Value.Bro = 0;

    if((0 != BRO_AA_RecvTick) && ((GetSystemTick() - BRO_AA_RecvTick) > MsgTimeout_60S))
    {
      CemMsg.Cem.Value.Bro = 1;
      pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if((0 != BroMsg.Valid) && (0xAA == BroMsg.Status))
    {//յBrm
      BRO_AA_RecvTick = 0;
      pChargeCtrl->CurProcess = eChgPro_AB_WaitPillarReady;
      pChargeCtrl->Param = 0;
    }

    if(0 != BemMsg.Valid)
    {
      pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 == ChargeEnable_AB)
    {//ⲿƽ
      ChargeStopType = eChgStop_BmsReady_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_ChgIdle;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick * 2))
    {
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_BmsReady_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Emergency) || (0 != PillarError_B.Value.Emergency))
    {
      ChargeStopType = eChgStop_BmsReady_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Door) || (0 != PillarError_B.Value.Door))
    {
      ChargeStopType = eChgStop_BmsReady_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Contactor) || (0 != PillarError_B.Value.Contactor))
    {
      ChargeStopType = eChgStop_BmsReady_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.UniContactor) || (0 != PillarError_B.Value.UniContactor))
    {
      ChargeStopType = eChgStop_BmsReady_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.InVolt) || (0 != PillarError_B.Value.InVolt))
    {
      ChargeStopType = eChgStop_BmsReady_InVolt;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.NoDcmod) || (0 != PillarError_B.Value.NoDcmod))
    {
      ChargeStopType = eChgStop_BmsReady_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Meter) || (0 != PillarError_B.Value.Meter))
    {
      ChargeStopType = eChgStop_BmsReady_Meter;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_AB_WaitBmsReady != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}


