

#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Memory.h"


void ChgProWaitBmsReady(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CML_SendTick = 0;
  u32 CTS_SendTick = 0;
  u32 CcStatusChkTick = 0;
  u32 BRO_AA_RecvTick = 0;

  BemMsg.Valid = 0;
  BroMsg.Valid = 0;
  BmsCanInit();
  osDelay(20);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet(eSwSta_On);
  LockSet(eSwSta_On);
  FanSet(eSwSta_On);
  ImdWorkSet(eSwSta_Off);
  DrainResistSet(eSwSta_Off);
  DcOutSet(eSwSta_Off);
  DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);

  CTS_Send();
  CTS_SendTick = GetSystemTick();
  if(0 != UserParam.ChgFun.Value.SigUniChg)
    CML_Send(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)), 4000 - DcModuleAbility.MinCurrt);
  else
    CML_Send(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*DcModuleManage.ValidNum), 4000 - DcModuleAbility.MinCurrt);
  CML_SendTick = GetSystemTick();

  BroMsg.RecvTick = GetSystemTick();
  BRO_AA_RecvTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CML_SendTick) > 250)
    {
      if(0 != UserParam.ChgFun.Value.SigUniChg)
        CML_Send(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)), 4000 - DcModuleAbility.MinCurrt);
      else
        CML_Send(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*DcModuleManage.ValidNum), 4000 - DcModuleAbility.MinCurrt);
      CML_SendTick = GetSystemTick();
    }
    if((GetSystemTick() - CTS_SendTick) > 500)
    {
      CTS_Send();
      CTS_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);

    if((GetSystemTick() - BroMsg.RecvTick) > MsgTimeout_5S)
    {
      CemMsg.Cem.Value.Bro = 1;
      pChargeCtrl->CurProcess = eChgPro_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg.Cem.Value.Bro = 0;

    if((0 != BRO_AA_RecvTick) && ((GetSystemTick() - BRO_AA_RecvTick) > MsgTimeout_60S))
    {
      CemMsg.Cem.Value.Bro = 1;
      pChargeCtrl->CurProcess = eChgPro_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if((0 != BroMsg.Valid) && (0xAA == BroMsg.Status))
    {//յBrm
      BRO_AA_RecvTick = 0;
      pChargeCtrl->CurProcess = eChgPro_WaitPillarReady;
      pChargeCtrl->Param = 0;
    }

    if(0 != BemMsg.Valid)
    {
      pChargeCtrl->CurProcess = eChgPro_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd.TCUChargeEnable)
    {//ⲿƽ
      ChargeStopType = eChgStop_BmsReady_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_ChgIdle;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick * 2))
    {
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_BmsReady_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Emergency)
    {
      ChargeStopType = eChgStop_BmsReady_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Door)
    {
      ChargeStopType = eChgStop_BmsReady_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Contactor)
    {
      ChargeStopType = eChgStop_BmsReady_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.UniContactor)
    {
      ChargeStopType = eChgStop_BmsReady_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.InVolt)
    {
      ChargeStopType = eChgStop_BmsReady_InVolt;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.NoDcmod)
    {
      ChargeStopType = eChgStop_BmsReady_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Meter)
    {
      ChargeStopType = eChgStop_BmsReady_Meter;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_WaitBmsReady != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}


