

#include "Thd_Charge.h"
#include "Thd_Charge_B.h"
#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_ImdJyc.h"
#include "Drv_Meter.h"
#include "Memory.h"

s32 GetChgVoltChgRun_B(void)
{
  if(ImdValue_B.Vaild)
    return ImdValue_B.PnVolt;
  if(eMeterSta_Unavail != MeterComm.Status_B)
    return MeterValue_B.Voltage;
  if(BcsMsg_B.Valid)
    return BcsMsg_B.ChgVolt;
  return -1;
}

s32 GetChgCurrtChgRun_B(void)
{
  if(eMeterSta_Unavail != MeterComm.Status_B)
    return MeterValue_B.Current/100;
  if(BcsMsg_B.Valid)
    return abs((s32)BcsMsg_B.ChgCurrt - 4000);
  return -1;
}

void ChgProChgRun_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CCS_SendTick = 0;
  u32 CcStatusChkTick = 0;
  u32 SocStopTick = 0;

  u16 MaxCurrt = 0;
  u16 NeedCurrt = 0;

  u16 MaxVolt = 0;
  u16 NeedVolt = 0;

  u16 CcsChgEnable = 0;

  u32 BmsPauseTick = 0;

  s32 Temp = 0;
  u32 CurrtOutChkTick = 0;

  u32 UniChgTick = 0;

  memset(&BemMsg_B, 0, sizeof(BemMsg_B));
  memset(&CemMsg_B, 0, sizeof(CemMsg_B));
  memset(&BstMsg_B, 0, sizeof(BstMsg_B));
  memset(&CstMsg_B, 0, sizeof(CstMsg_B));
  memset(&BsdMsg_B, 0, sizeof(BsdMsg_B));
  memset(&CsdMsg_B, 0, sizeof(CsdMsg_B));

  memset(&BmvMsg_B, 0xFF, sizeof(BmvMsg_B));
  memset(&BmtMsg_B, 0xFF, sizeof(BmtMsg_B));
  BmvMsg_B.Valid = 0;
  BmtMsg_B.Valid = 0;

  BemMsg_B.Valid = 0;
  BstMsg_B.Valid = 0;
  BmsCanInit_B();
  osDelay(20);

  ChargeTimerSet_B(eSwSta_On);
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  DcOutSet_B(eSwSta_On);

  CcsChgEnable = 1;
  CCS_Send_B(GetDcModuleVolt_B(), (4000-GetDcModuleCurrt_B()), GetChgMin_B(), CcsChgEnable);
  CCS_SendTick = GetSystemTick();
  BclMsg_B.RecvTick = GetSystemTick();
  BcsMsg_B.RecvTick = GetSystemTick();

  BmsPauseTick = 0;

  CurrtOutChkTick = 0;

  UniChgEnable = FALSE;
  UniChgTick = 0;

  while(1)
  {
    if((GetSystemTick() - CCS_SendTick) > 50)
    {
      if(FALSE == UniChgEnable)
       // CCS_Send_B(GetDcModuleVolt_B(), (4000-GetDcModuleCurrt_B()), GetChgMin_B(), CcsChgEnable);
        CCS_Send_B( MeterValue_B.Voltage, (4000- MeterValue_B.Current/100), GetChgMin(), CcsChgEnable);
      else
       // CCS_Send_B(GetDcModuleVolt_AB(), (4000-GetDcModuleCurrt_AB()), GetChgMin_B(), CcsChgEnable);
	  CCS_Send_B( MeterValue_B.Voltage, (4000- MeterValue_B.Current/100), GetChgMin(), CcsChgEnable);
      CCS_SendTick = GetSystemTick();
    }

    ChgPgnRecv_B(&PgnRecv);
    /*ģʽ*/
    if(FALSE == UniChgEnable)
    {
      if((0 != ChargePauseFlag_B) || (0 != BmsPauseTick))
      {
        CcsChgEnable = 0;
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        ChargeTimerSet_B(eSwSta_Off);
      }
      else if(0 != BclMsg_B.Valid)
      {
        if(eChgVer_2011 != UserParam.ChgVer)
          MaxCurrt = abs((s32)BcpMsg_B.ChgMaxCurrt - 4000);
        else
          MaxCurrt = abs((s32)BclMsg_B.NeedCurrt - 4000);

        NeedCurrt = abs((s32)BclMsg_B.NeedCurrt - 4000);
        /*жϿ*/
        if((0 != UserParam.ChgFun.Value.SigUniChg)
          //&& (MaxCurrt > (DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum))
          //&& (NeedCurrt > (u16)((u32)DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum*11/10))//ڵ׮ٷֶʮ
          //&& (NeedCurrt > (u16)((u32)GetDcModuleCurrt_B()*11/10))
          &&(NeedCurrt > (u16)((u32)(MeterValue_B.Current/100)*11/10))
          && (eChgPro_ChgIdle == ChargeCtrl.CurProcess)//Aǹ
          && (eSwSta_Off == DcOutPosGetSet()) //aǹ̵պ
          && (eSwSta_Off == DcOutGet()) //aǹ̵ûպ
          && (0 == (PillarError.Mult&~0x20200)) //a޴
          )
        {
          if(0 == UniChgTick)
            UniChgTick = GetSystemTick();
          else if((GetSystemTick() - UniChgTick) > (30 * 1000))// պ̵
          {
            UniChgEnable = TRUE;
            UniChgTick = 0;
            CcsChgEnable = 0;
            DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
            DcOutSet_Uni(eSwSta_On);
            ChargeTimerSet_B(eSwSta_Off);
          }
          else if((GetSystemTick() - UniChgTick) > (25 * 1000))//Ӻرģ ģʽ
          {
            //UniChgEnable = 1;
            CcsChgEnable = 0;
            DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
            ChargeTimerSet_B(eSwSta_Off);
          }
          else//
          {
            if(NeedCurrt > MaxCurrt)
              NeedCurrt = MaxCurrt;
            if(NeedCurrt > (DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum))
              NeedCurrt = DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum;

            MaxVolt = BcpMsg_B.ChgMaxVolt;
            NeedVolt = BclMsg_B.NeedVolt;
            if(NeedVolt > MaxVolt)
              NeedVolt = MaxVolt;
            if(NeedVolt > DcModuleAbility.MaxVolt)
              NeedVolt = DcModuleAbility.MaxVolt;

            CcsChgEnable = 1;
            DcModuleSet_B(eSwSta_On, NeedVolt, NeedCurrt);
            ChargeTimerSet_B(eSwSta_On);
          }
        }
        else
        {
          if(NeedCurrt > MaxCurrt)
            NeedCurrt = MaxCurrt;
          if(NeedCurrt > (DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum))
            NeedCurrt = DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum;

          MaxVolt = BcpMsg_B.ChgMaxVolt;
          NeedVolt = BclMsg_B.NeedVolt;
          if(NeedVolt > MaxVolt)
            NeedVolt = MaxVolt;
          if(NeedVolt > DcModuleAbility.MaxVolt)
            NeedVolt = DcModuleAbility.MaxVolt;

          UniChgTick = 0;
          CcsChgEnable = 1;
          DcModuleSet_B(eSwSta_On, NeedVolt, NeedCurrt);
          ChargeTimerSet_B(eSwSta_On);
        }
      }

      if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer_B))
      {
        Temp = GetChgVoltChgRun_B();
        if((0 != CcsChgEnable) && (Temp >= DcModuleAbility.MinVolt) && (Temp > GetDcModuleVoltSet_B()))
        {
          if((Temp - GetDcModuleVoltSet_B()) > (GetDcModuleVoltSet_B()*5/100))
          {
            CstMsg_B.StopReason.Value.Truble = 1;
            CstMsg_B.StopTruble.Value.Other = 1;
            CstMsg_B.StopFault.Value.Volt = 1;
            ChargeError_B.Value.VoltOutError = 1;
            DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
            DcOutSet_B(eSwSta_Off);
            DcOutSet_Uni(eSwSta_Off);
            ChargeStopType_B = eChgStop_Run_VoltOutHighErr;
            pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
            //pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
            pChargeCtrl->Param = 0;
          }
        }
      }

      if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer_B))
      {
        Temp = GetChgCurrtChgRun_B();
        if((0 != CcsChgEnable) && (Temp > (DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum)) && (Temp > GetDcModuleCurrtSet_B()))
        {
          if((Temp - GetDcModuleCurrtSet_B()) > (GetDcModuleCurrtSet_B()*10/100))
          {
            if(0 == CurrtOutChkTick)
              CurrtOutChkTick = GetSystemTick();
          }
          else
            CurrtOutChkTick = 0;
        }
        else
          CurrtOutChkTick = 0;
        if((0 != CurrtOutChkTick) && ((GetSystemTick() - CurrtOutChkTick) > 10000))
        {
          CurrtOutChkTick = 0;
          CstMsg_B.StopReason.Value.Truble = 1;
          CstMsg_B.StopTruble.Value.Other = 1;
          CstMsg_B.StopFault.Value.Currt = 1;
          ChargeError_B.Value.CurrtOutError = 1;
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
          DcOutSet_B(eSwSta_Off);
          DcOutSet_Uni(eSwSta_Off);
          ChargeStopType_B = eChgStop_Run_CurrtOutHighErr;
          pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
          pChargeCtrl->Param = 0;
        }
      }
    }
    else
    {
      if((0 != ChargePauseFlag_B) || (0 != BmsPauseTick))
      {
        CcsChgEnable = 0;
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        ChargeTimerSet_B(eSwSta_Off);
      }
      else if(0 != BclMsg_B.Valid)
      {
        if(eChgVer_2011 != UserParam.ChgVer)
          MaxCurrt = abs((s32)BcpMsg_B.ChgMaxCurrt - 4000);
        else
          MaxCurrt = abs((s32)BclMsg_B.NeedCurrt - 4000);

        NeedCurrt = abs((s32)BclMsg_B.NeedCurrt - 4000);
        /*жϹر*/
        if((0 == UserParam.ChgFun.Value.SigUniChg)
          || (eChgPro_ChgIdle != ChargeCtrl.CurProcess)//ǿ
          || (eSwSta_Off != DcOutPosGetSet()) //Bǹ̵պ
          || (eSwSta_Off != DcOutGet()) //Bǹ̵պ
          || ((0 != PillarError.Mult)&&(1 != PillarError.Value.Net)) //д
          )
        {/*Ͽ*/
          UniChgEnable = FALSE;
          UniChgTick = 0;
          CcsChgEnable = 0;
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
          DcOutSet_Uni(eSwSta_Off);
          ChargeTimerSet_B(eSwSta_Off);
        }
        else if(NeedCurrt < (u16)((u32)DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum))//Сڵ׮
        {/*ʱٶϿ*/
          if(0 == UniChgTick)
            UniChgTick = GetSystemTick();
          else if((GetSystemTick() - UniChgTick) > (30 * 1000))//ر Ͽ̵
          {
            UniChgEnable = FALSE;
            UniChgTick = 0;
            CcsChgEnable = 0;
            DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
            DcOutSet_Uni(eSwSta_Off);
            ChargeTimerSet_B(eSwSta_Off);
          }
          else if((GetSystemTick() - UniChgTick) > (25 * 1000))//Ӻرģ ģʽ
          {
            //UniChgEnable = 1;
            CcsChgEnable = 0;
            DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
            ChargeTimerSet_B(eSwSta_Off);
          }
          else//...
          {
            if(NeedCurrt > MaxCurrt)
              NeedCurrt = MaxCurrt;
            if(NeedCurrt > (DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)))
              NeedCurrt = DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum);

            MaxVolt = BcpMsg_B.ChgMaxVolt;
            NeedVolt = BclMsg_B.NeedVolt;
            if(NeedVolt > MaxVolt)
              NeedVolt = MaxVolt;
            if(NeedVolt > DcModuleAbility.MaxVolt)
              NeedVolt = DcModuleAbility.MaxVolt;

            UniChgTick = 0;
            CcsChgEnable = 1;
            DcModuleSet_AB(eSwSta_On, NeedVolt, NeedCurrt);
            ChargeTimerSet_B(eSwSta_On);
          }
        }
        else
        {
          if(NeedCurrt > MaxCurrt)
            NeedCurrt = MaxCurrt;
          if(NeedCurrt > (DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)))
            NeedCurrt = DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum);

          MaxVolt = BcpMsg_B.ChgMaxVolt;
          NeedVolt = BclMsg_B.NeedVolt;
          if(NeedVolt > MaxVolt)
            NeedVolt = MaxVolt;
          if(NeedVolt > DcModuleAbility.MaxVolt)
            NeedVolt = DcModuleAbility.MaxVolt;

          CcsChgEnable = 1;
          DcModuleSet_AB(eSwSta_On, NeedVolt, NeedCurrt);
          ChargeTimerSet_B(eSwSta_On);
        }
      }

      if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer_B))
      {
        Temp = GetChgVoltChgRun_B();
        if((0 != CcsChgEnable) && (Temp >= DcModuleAbility.MinVolt) && (Temp > GetDcModuleVoltSet_AB()))
        {
          if((Temp - GetDcModuleVoltSet_AB()) > (GetDcModuleVoltSet_AB()*5/100))
          {
            CstMsg_B.StopReason.Value.Truble = 1;
            CstMsg_B.StopTruble.Value.Other = 1;
            CstMsg_B.StopFault.Value.Volt = 1;
            ChargeError_B.Value.VoltOutError = 1;
            DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
            DcOutSet_B(eSwSta_Off);
            DcOutSet_Uni(eSwSta_Off);
            UniChgEnable = FALSE;
            ChargeStopType_B = eChgStop_Run_VoltOutHighErr;
            pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
            //pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
            pChargeCtrl->Param = 0;
          }
        }
      }

      if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer_B))
      {
        Temp = GetChgCurrtChgRun_B();
        if((0 != CcsChgEnable) && (Temp > (DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum))) && (Temp > GetDcModuleCurrtSet_AB()))
        {
          if((Temp - GetDcModuleCurrtSet_AB()) > (GetDcModuleCurrtSet_AB()*10/100))
          {
            if(0 == CurrtOutChkTick)
              CurrtOutChkTick = GetSystemTick();
          }
          else
            CurrtOutChkTick = 0;
        }
        else
          CurrtOutChkTick = 0;
        if((0 != CurrtOutChkTick) && ((GetSystemTick() - CurrtOutChkTick) > 10000))
        {
          CurrtOutChkTick = 0;
          CstMsg_B.StopReason.Value.Truble = 1;
          CstMsg_B.StopTruble.Value.Other = 1;
          CstMsg_B.StopFault.Value.Currt = 1;
          ChargeError_B.Value.CurrtOutError = 1;
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
          DcOutSet_B(eSwSta_Off);
          DcOutSet_Uni(eSwSta_Off);
          UniChgEnable = FALSE;
          ChargeStopType_B = eChgStop_Run_CurrtOutHighErr;
          pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
          pChargeCtrl->Param = 0;
        }
      }
    }

    if(0 != BsmMsg_B.Valid)
    {
      if(0x00 != BsmMsg_B.BatSta.Value.Volt)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopFault.Value.Volt = 1;
        CST_Send_B(&CstMsg_B);
        if(FALSE == UniChgEnable)
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        else
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        DcOutSet_Uni(eSwSta_Off);
        UniChgEnable = FALSE;
        ChargeTimerSet_B(eSwSta_Off);
        ChargeStopType_B = eChgStop_Run_SinglBatVolt;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(0x00 != BsmMsg_B.BatSta.Value.Soc)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopTruble.Value.Other = 1;
        CST_Send_B(&CstMsg_B);
        if(FALSE == UniChgEnable)
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        else
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        DcOutSet_Uni(eSwSta_Off);
        UniChgEnable = FALSE;
        ChargeTimerSet_B(eSwSta_Off);
        ChargeStopType_B = eChgStop_Run_SocOver;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(0x01 == BsmMsg_B.BatSta.Value.Currt)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopFault.Value.Currt = 1;
        CST_Send_B(&CstMsg_B);
        if(FALSE == UniChgEnable)
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        else
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        DcOutSet_Uni(eSwSta_Off);
        UniChgEnable = FALSE;
        ChargeTimerSet_B(eSwSta_Off);
        ChargeStopType_B = eChgStop_Run_CurrtOver;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(0x01 == BsmMsg_B.BatSta.Value.Temp)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopTruble.Value.Other = 1;
        CST_Send_B(&CstMsg);
        if(FALSE == UniChgEnable)
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        else
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        DcOutSet_Uni(eSwSta_Off);
        UniChgEnable = FALSE;
        ChargeTimerSet_B(eSwSta_Off);
        ChargeStopType_B = eChgStop_Run_BatTempOver;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      if(0x01 == BsmMsg_B.ChgSta.Value.Imd)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopTruble.Value.Other = 1;
        CST_Send_B(&CstMsg_B);
        if(FALSE == UniChgEnable)
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        else
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        DcOutSet_Uni(eSwSta_Off);
        UniChgEnable = FALSE;
        ChargeTimerSet_B(eSwSta_Off);
        ChargeStopType_B = eChgStop_Run_BatIsolate;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      if(0x01 == BsmMsg_B.ChgSta.Value.Connect)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopTruble.Value.Other = 1;
        CST_Send_B(&CstMsg_B);
        if(FALSE == UniChgEnable)
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        else
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        DcOutSet_Uni(eSwSta_Off);
        UniChgEnable = FALSE;
        ChargeTimerSet_B(eSwSta_Off);
        ChargeStopType_B = eChgStop_Run_Cc2Error;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(0x00 == BsmMsg_B.ChgSta.Value.ChgEnable)
      {
        if(FALSE == UniChgEnable)
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        else
          DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
        DcOutSet_Uni(eSwSta_Off);
        UniChgEnable = FALSE;
        ChargeTimerSet_B(eSwSta_Off);
        if(0 == BmsPauseTick)
          BmsPauseTick = GetSystemTick();
        if((0 != BmsPauseTick) && ((GetSystemTick() - BmsPauseTick) > MsgTimeout_B_10M))
        {
          CstMsg_B.StopReason.Value.Truble = 1;
          CstMsg_B.StopTruble.Value.Other = 1;
          CST_Send_B(&CstMsg_B);
          if(FALSE == UniChgEnable)
            DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
          else
            DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
          DcOutSet_Uni(eSwSta_Off);
          UniChgEnable = FALSE;
          ChargeTimerSet_B(eSwSta_Off);
          ChargeStopType_B = eChgStop_Run_BmsPause;
          pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
          pChargeCtrl->Param = 0;
        }
      }
      else if(0x01 == BsmMsg_B.ChgSta.Value.ChgEnable)
        BmsPauseTick = 0;
    }

    if((GetSystemTick() - BclMsg_B.RecvTick) > MsgTimeout_B_1S)
    {
      CemMsg_B.Cem.Value.Bcl = 1;
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      ChargeTimerSet_B(eSwSta_Off);
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg_B.Cem.Value.Bcl = 0;
    
	 if(((GetSystemTick() - BcsMsg_B.RecvTick) >1000+500)&&(eChgVer_2011 == UserParam.ChgVer))
		{
			StructChargeSend FrameSend;
	
			FrameSend.Id.Mult = 0;
			FrameSend.Id.Disp.Prio = 7;
			FrameSend.Id.Disp.PF = TPCM>>8;
			FrameSend.Id.Disp.DA_PS = Card1939Addr;
			FrameSend.Id.Disp.SA = Charger1939Addr;
			FrameSend.Data[0] = 0x13;
			FrameSend.Data[1] = 0x09;
			FrameSend.Data[2] = 0x00;
			FrameSend.Data[3] = 0x02;
			FrameSend.Data[4] = 0xFe;
			FrameSend.Data[5] = 0x00;
			FrameSend.Data[6] = 0x11;
			FrameSend.Data[7] = 0x00;
			FrameSend.Len = 8;
	        BcsMsg_B.RecvTick =GetSystemTick();
			BmsCommSendMsg_B(&FrameSend);
		}
		else
		 CemMsg_B.Cem.Value.Bcs = 0;//ֲ
    if((GetSystemTick() - BcsMsg_B.RecvTick) > MsgTimeout_B_5S)
    {
      CemMsg_B.Cem.Value.Bcs = 1;
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      ChargeTimerSet_B(eSwSta_Off);
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg_B.Cem.Value.Bcs = 0;

    if(0 != BemMsg_B.Valid)
    {
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      ChargeTimerSet_B(eSwSta_Off);
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 != BstMsg_B.Valid)
    {
      CstMsg_B.StopReason.Value.BmsStop = 1;
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      ChargeTimerSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_BmsStop;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd_B.TCUChargeEnable)
    {//ⲿƽ
      CstMsg_B.StopReason.Value.Manual = 1;
      CST_Send_B(&CstMsg_B);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      ChargeTimerSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if((BcsMsg_B.Valid) && (BcsMsg_B.CurSoc >= 100))
    {
      if(0 == SocStopTick)
        SocStopTick = GetSystemTick();
    }
    else
      SocStopTick = 0;
    if((0 != SocStopTick) && ((GetSystemTick() - SocStopTick) > (MsgTimeout_B_60S*2)))
    {//ⲿƽ
      CstMsg_B.StopReason.Value.AutoSet = 1;
      CST_Send_B(&CstMsg_B);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      ChargeTimerSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_Soc98;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if((BcsMsg_B.Valid) && (BcsMsg_B.BatVoltAndGroup.Value.Volt > BcpMsg_B.PerBatMaxVolt) && (1 == UserParam.ChgFun.Value.BatCellJud))
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopFault.Value.Volt = 1;
      CST_Send_B(&CstMsg_B);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      ChargeTimerSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_SinglBatVoltOverPermitMax;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

  // if((eSwSta_On != CcStatusRead_B())&&( ChargeStopType_B!= eChgStop_None))
    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B))
    {
      //CstMsg_B.StopReason.Value.Truble = 1;
      //CstMsg_B.StopTruble.Value.ChgGun = 1;
      CstMsg_B.StopReason.Value.Manual = 1;
      CST_Send_B(&CstMsg_B);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      DcOutSet_B(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType_B = eChgStop_Run_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Emergency)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Emergency = 1;
      CST_Send_B(&CstMsg_B);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Door)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Contactor)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.UniContactor)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.InVolt)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_InVolt;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.NoDcmod)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Meter)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg);
      if(FALSE == UniChgEnable)
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      else
        DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_Uni(eSwSta_Off);
      UniChgEnable = FALSE;
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Run_Meter;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_ChgRun != pChargeCtrl->CurProcess)
      return;
    osDelay(5);
  }
}




