

#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Memory.h"


void ChgProWaitBmsReady_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CML_SendTick = 0;
  u32 CTS_SendTick = 0;
  u32 CcStatusChkTick = 0;
  u32 BRO_AA_RecvTick = 0;

  BemMsg_B.Valid = 0;
  BroMsg_B.Valid = 0;
  BmsCanInit_B();
  osDelay(20);

  ChargeTimerSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  DcOutSet_B(eSwSta_Off);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  CTS_Send_B();
  CTS_SendTick = GetSystemTick();
  if(0 != UserParam.ChgFun.Value.SigUniChg)
    CML_Send_B(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)), 4000 - DcModuleAbility.MinCurrt);
  else
    CML_Send_B(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum), 4000 - DcModuleAbility.MinCurrt);
  CML_SendTick = GetSystemTick();

  BroMsg_B.RecvTick = GetSystemTick();
  BRO_AA_RecvTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CML_SendTick) > 250)
    {
      if(0 != UserParam.ChgFun.Value.SigUniChg)
        CML_Send_B(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)), 4000 - DcModuleAbility.MinCurrt);
      else
        CML_Send_B(DcModuleAbility.MaxVolt, DcModuleAbility.MinVolt, 4000 - (DcModuleAbility.MaxCurrt*DcModuleManage_B.ValidNum), 4000 - DcModuleAbility.MinCurrt);
      CML_SendTick = GetSystemTick();
    }
    if((GetSystemTick() - CTS_SendTick) > 500)
    {
      CTS_Send_B();
      CTS_SendTick = GetSystemTick();
    }

    ChgPgnRecv_B(&PgnRecv);

    if((GetSystemTick() - BroMsg_B.RecvTick) > MsgTimeout_B_5S)
    {
      CemMsg_B.Cem.Value.Bro = 1;
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg_B.Cem.Value.Bro = 0;

    if((0 != BRO_AA_RecvTick) && ((GetSystemTick() - BRO_AA_RecvTick) > MsgTimeout_B_60S))
    {
      CemMsg_B.Cem.Value.Bro = 1;
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if((0 != BroMsg_B.Valid) && (0xAA == BroMsg_B.Status))
    {//յBrm
      BRO_AA_RecvTick = 0;
      pChargeCtrl->CurProcess = eChgPro_B_WaitPillarReady;
      pChargeCtrl->Param = 0;
    }

    if(0 != BemMsg_B.Valid)
    {
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd_B.TCUChargeEnable)
    {//ⲿƽ
      ChargeStopType_B = eChgStop_BmsReady_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_B_ChgIdle;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B * 2))
    {
      CcStatusChkTick = 0;
      ChargeStopType_B = eChgStop_BmsReady_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Emergency)
    {
      ChargeStopType_B = eChgStop_BmsReady_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Door)
    {
      ChargeStopType_B = eChgStop_BmsReady_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Contactor)
    {
      ChargeStopType_B = eChgStop_BmsReady_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.UniContactor)
    {
      ChargeStopType_B = eChgStop_BmsReady_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.InVolt)
    {
      ChargeStopType_B = eChgStop_BmsReady_InVolt;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.NoDcmod)
    {
      ChargeStopType_B = eChgStop_BmsReady_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Meter)
    {
      ChargeStopType_B = eChgStop_BmsReady_Meter;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_WaitBmsReady != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}


