
#include "Thd_Lcd.h"

#define ScrnBmsInfor_AB  ((u16)16)
#define BtnBmsInfor_AB_Cancel      ((u16)0x1601)
#define BtnBmsInfor_AB_Next        ((u16)0x000B)
#define BtnBmsInfor_AB_Last        ((u16)0x000A)

#define DataBmsInfor_AB_MaxtVolt               ((u16)0x0025)
#define DataBmsInfor_AB_MaxCurrt               ((u16)0x0026)
#define DataBmsInfor_AB_NeedVolt               ((u16)0x0027)
#define DataBmsInfor_AB_CurSoc                 ((u16)0x0028)
#define DataBmsInfor_AB_MaxTemp                ((u16)0x0029)
#define DataBmsInfor_AB_BatEnergy              ((u16)0x002A)
#define DataBmsInfor_AB_NeedCurrt              ((u16)0x002B)
#define DataBmsInfor_AB_BatTemp                ((u16)0x002C)

#define DataBmsInfor_AB_PerBatVoltHi           ((u16)0x0034)
#define DataBmsInfor_AB_PerBatVoltLo           ((u16)0x0035)
#define DataBmsInfor_AB_BatType                ((u16)0x4000)

#define VarBmsInfor_AB_Position                 ((u16)0x003C)
void BmsInforPaint_AB(void)
{
  char Str[64];

  LcdShowData16(VarBmsInfor_AB_Position, 3);

  if(BcpMsg.Valid)
  {
    LcdShowData16(DataBmsInfor_AB_MaxtVolt, BcpMsg.ChgMaxVolt);
    LcdShowData16(DataBmsInfor_AB_MaxCurrt, (s16)(4000 - BcpMsg.ChgMaxCurrt));
    LcdShowData16(DataBmsInfor_AB_MaxTemp, (s16)BcpMsg.MaxTemp - 50);
    LcdShowData16(DataBmsInfor_AB_BatEnergy, BcpMsg.BatEnergy);
  }
  else
  {
    LcdShowData16(DataBmsInfor_AB_MaxtVolt, 0);
    LcdShowData16(DataBmsInfor_AB_MaxCurrt, 0);
    LcdShowData16(DataBmsInfor_AB_MaxTemp, 0);
    LcdShowData16(DataBmsInfor_AB_BatEnergy, 0);
  }

  if(BclMsg.Valid)
  {
    LcdShowData16(DataBmsInfor_AB_NeedVolt, BclMsg.NeedVolt);
    LcdShowData16(DataBmsInfor_AB_NeedCurrt, (s16)(4000 - BclMsg.NeedCurrt));
  }
  else
  {
    LcdShowData16(DataBmsInfor_AB_NeedVolt, 0);
    LcdShowData16(DataBmsInfor_AB_NeedCurrt, 0);
  }

  if(BcsMsg.Valid)
    LcdShowData16(DataBmsInfor_AB_CurSoc, BcsMsg.CurSoc);
  else
    LcdShowData16(DataBmsInfor_AB_CurSoc, 0);

  if(BsmMsg.Valid)
    LcdShowData16(DataBmsInfor_AB_BatTemp, (s16)BsmMsg.HighTemp - 50);
  else
    LcdShowData16(DataBmsInfor_AB_BatTemp, 0);

  if(BsdMsg.Valid)
  {
    LcdShowData16(DataBmsInfor_AB_PerBatVoltLo, BsdMsg.PerMinVolt);
    LcdShowData16(DataBmsInfor_AB_PerBatVoltHi, BsdMsg.PerMaxVolt);
  }
  else
  {
    LcdShowData16(DataBmsInfor_AB_PerBatVoltLo, 0);
    if(BcsMsg.Valid)
      LcdShowData16(DataBmsInfor_AB_PerBatVoltHi, BcsMsg.BatVoltAndGroup.Value.Volt);
  }

  if(eChgPro_AB_CommError== ChargeCtrl.CurProcess)
  {
    snprintf(Str, sizeof(Str), "%08X %06X %08X %06X", CommErrFrame[0], CommErrFrame[1], CommErrFrame[2], CommErrFrame[3]);
    LcdShowStr(DataBmsInfor_AB_BatType, (u8*)Str, (strlen(Str)+1));
  }
  else if(BrmMsg.Valid)
  {
    switch(BrmMsg.BatType)
    {
      case 0x01:
        snprintf(Str, sizeof(Str), "Ǧ");
        break;
      case 0x02:
        snprintf(Str, sizeof(Str), "");
        break;
      case 0x03:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x04:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x05:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x06:
        snprintf(Str, sizeof(Str), "Ԫϵ");
        break;
      case 0x07:
        snprintf(Str, sizeof(Str), "ۺӵ");
        break;
      case 0x08:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0xFF:
        snprintf(Str, sizeof(Str), "");
        break;
      default:
        snprintf(Str, sizeof(Str), "δ֪");
        break;
    }
    LcdShowStr(DataBmsInfor_AB_BatType, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), "ͨѶ");
    LcdShowStr(DataBmsInfor_AB_BatType, (u8*)Str, (strlen(Str)+1));
  }

  LcdShowPage(ScrnBmsInfor_AB);
}

typedef struct
{
  u32 RePainTick;
}StructBmsInforUpdate;

void BmsInforUpdate_AB(StructBmsInforUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    BmsInforPaint_AB();
  }
}

#define TimeOutTime   (30*1000)

void LcdProBmsInfor_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructBmsInforUpdate Update;
  u32 TimeOutTick;

  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  pCurChgRecd_AB = &CurChgRecd;

  ScreenChkTick = GetSystemTick();

  BmsInforPaint_AB();
  Update.RePainTick = GetSystemTick();

  TimeOutTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnBmsInfor_AB != Temp)
              LcdShowPage(ScrnBmsInfor_AB);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnBmsInfor_AB_Cancel:
                pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
                //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              case BtnBmsInfor_AB_Next:
                pLcdCtrl->CurScreen = eLcdPro_AB_CommuInfor;
                //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
                pLcdCtrl->Param = 0;
              case BtnBmsInfor_AB_Last:
                pLcdCtrl->CurScreen = eLcdPro_AB_CommuInfor;
                //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnBmsInfor_AB);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_AB_BmsInfor != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
      //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
      pLcdCtrl->Param = 0;
    }

    BmsInforUpdate_AB(&Update);

    osDelay(100);
  }
}





