
#include "Thd_Lcd.h"

#define ScrnChargeStop_AB  ((u16)15)
#define BtnChargeStop_AB_Enter      ((u16)0x0015)
#define BtnChargeStop_AB_Cancel        ((u16)0x0016)
#define VarChargeStop_AB_Position       ((u16)0x003C)

void ChargeStopPaint_AB(void)
{
  LcdShowData16(VarChargeStop_AB_Position, 3);
  LcdShowPage(ScrnChargeStop_AB);
}

typedef struct
{
  u32 RePainTick;
}StructChargeStopUpdate;

void ChargeStopUpdate_AB(void)
{

}

#define TimeOutTime   (30*1000)

void LcdProChargeStop_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  u32 TimeOutTick;

  ChargePauseFlag = 1;

  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  ChargeStopPaint_AB();

  TimeOutTick = GetSystemTick();


  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnChargeStop_AB != Temp)
              LcdShowPage(ScrnChargeStop_AB);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnChargeStop_AB_Enter:
                ChargeEnable_AB = 0;
                pLcdCtrl->CurScreen = eLcdPro_AB_SwipeCard;
                pLcdCtrl->Param = 0;
                break;
              case BtnChargeStop_AB_Cancel:
                pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnChargeStop_AB);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_AB_ChargeStop != pLcdCtrl->CurScreen)
    {
      ChargePauseFlag = 0;
      return;
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    ChargeStopUpdate_AB();

    osDelay(100);
  }
}





