
#include "Thd_Lcd.h"

#define ScrnChargeSummary_AB  ((u16)111)

#define BtnChargeSummary_Cancel      ((u16)0x1112)
#define BtnChargeSummary_Infor        ((u16)0x1111)

#define VarChargeSummary_AB_TotalMoney     ((u16)0x0007)
#define DataChargeSummary_AB_Volt               ((u16)0x0021)
#define DataChargeSummary_AB_Currt              ((u16)0x0022)
#define DataChargeSummary_AB_Soc                ((u16)0x0023)
#define TextChargeSummary_AB_ChgStatus             ((u16)0x4120)
#define AnimChargeSummary_AB_Charge             ((u16)0x001A)

#define BtnChargeSummary_B_Cancel      ((u16)0x1114)
#define BtnChargeSummary_B_Infor        ((u16)0x1113)

#define VarChargeSummary_AB_B_TotalMoney     ((u16)0x0039)
#define DataChargeSummary_AB_B_Volt               ((u16)0x0038)
#define DataChargeSummary_AB_B_Currt              ((u16)0x0037)
#define DataChargeSummary_AB_B_Soc                ((u16)0x0036)
#define TextChargeSummary_AB_B_ChgStatus             ((u16)0x41C0)
#define AnimChargeSummary_AB_B_Charge             ((u16)0x001C)


void ChargeSummaryPaint_AB(void)
{
  char Str[64];
  u16 TempU16;
  LcdShowData16(VarChargeSummary_AB_TotalMoney, CurChgRecd.TotalMoney);

  TempU16 = BcsMsg.CurSoc;
  LcdShowData16(DataChargeSummary_AB_Soc, TempU16);

  if(TRUE == UniChgEnable)
  {
    if((eChgPro_ChgRun == ChargeCtrl.CurProcess)
      || (eChgPro_WaitVoltChgRun == ChargeCtrl.CurProcess)
      )
    {
      TempU16 = GetDcModuleVolt_AB();
      LcdShowData16(DataChargeSummary_AB_Volt, TempU16);
      TempU16 = GetDcModuleCurrt_AB();
      LcdShowData16(DataChargeSummary_AB_Currt, TempU16);
    }
    else if(eMeterSta_Unavail != MeterComm.Status)
    {
      LcdShowData16(DataChargeSummary_AB_Volt, MeterValue.Voltage);
      LcdShowData16(DataChargeSummary_AB_Currt, MeterValue.Current/100);
    }
    else
    {
      LcdShowData16(DataChargeSummary_AB_Volt, 0);
      LcdShowData16(DataChargeSummary_AB_Currt, 0);
    }
  }
  else
  {
    TempU16 = GetDcModuleVolt();
    LcdShowData16(DataChargeSummary_AB_Volt, TempU16);
    TempU16 = GetDcModuleCurrt();
    LcdShowData16(DataChargeSummary_AB_Currt, TempU16);
  }
  //TempU16 = GetDcModuleVolt();
  //LcdShowData16(DataChargeSummary_AB_Volt, TempU16);
  //TempU16 = GetDcModuleCurrt();
  //LcdShowData16(DataChargeSummary_AB_Currt, TempU16);

  if((eChgPro_ChgIdle == ChargeCtrl.CurProcess)
      || (eChgPro_ChgStop == ChargeCtrl.CurProcess)
      || (eChgPro_ChgBreak == ChargeCtrl.CurProcess)
      || (eChgPro_CommError == ChargeCtrl.CurProcess))
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(AnimChargeSummary_AB_Charge, TempU16);

  if(eChgPro_ChgIdle == ChargeCtrl.CurProcess)
    snprintf(Str, sizeof(Str), "ֹͣ");
  else if (eChgPro_ChgStop == ChargeCtrl.CurProcess)
    snprintf(Str, sizeof(Str), "");
  else if(eChgPro_ChgBreak == ChargeCtrl.CurProcess)
    snprintf(Str, sizeof(Str), "ֹ");
  else if(eChgPro_CommError== ChargeCtrl.CurProcess)
    snprintf(Str, sizeof(Str), "ֹ");
  else
    snprintf(Str, sizeof(Str), "ڳ");
  LcdShowStr(TextChargeSummary_AB_ChgStatus, (u8*)Str, (strlen(Str)+1));


  LcdShowData16(VarChargeSummary_AB_B_TotalMoney, CurChgRecd_B.TotalMoney);
  TempU16 = BcsMsg_B.CurSoc;
  LcdShowData16(DataChargeSummary_AB_B_Soc, TempU16);

  if(TRUE == UniChgEnable)
  {
    if((eChgPro_B_ChgRun == ChargeCtrl_B.CurProcess)
      || (eChgPro_B_WaitVoltChgRun == ChargeCtrl_B.CurProcess)
      )
    {
      TempU16 = GetDcModuleVolt_AB();
      LcdShowData16(DataChargeSummary_AB_B_Volt, TempU16);
      TempU16 = GetDcModuleCurrt_AB();
      LcdShowData16(DataChargeSummary_AB_B_Currt, TempU16);
    }
    else if(eMeterSta_Unavail != MeterComm.Status_B)
    {
      LcdShowData16(DataChargeSummary_AB_B_Volt, MeterValue_B.Voltage);
      LcdShowData16(DataChargeSummary_AB_B_Currt, MeterValue_B.Current/100);
    }
    else
    {
      LcdShowData16(DataChargeSummary_AB_B_Volt, 0);
      LcdShowData16(DataChargeSummary_AB_B_Currt, 0);
    }
  }
  else
  {
    TempU16 = GetDcModuleVolt_B();
    LcdShowData16(DataChargeSummary_AB_B_Volt, TempU16);
    TempU16 = GetDcModuleCurrt_B();
    LcdShowData16(DataChargeSummary_AB_B_Currt, TempU16);
  }

  //TempU16 = GetDcModuleVolt_B();
  //LcdShowData16(DataChargeSummary_AB_B_Volt, TempU16);
  //TempU16 = GetDcModuleCurrt_B();
  //LcdShowData16(DataChargeSummary_AB_B_Currt, TempU16);

  if((eChgPro_B_ChgIdle == ChargeCtrl_B.CurProcess)
      || (eChgPro_B_ChgStop == ChargeCtrl_B.CurProcess)
      || (eChgPro_B_ChgBreak == ChargeCtrl_B.CurProcess)
      || (eChgPro_B_CommError == ChargeCtrl_B.CurProcess))
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(AnimChargeSummary_AB_B_Charge, TempU16);
  if(eChgPro_B_ChgIdle == ChargeCtrl_B.CurProcess)
    snprintf(Str, sizeof(Str), "ֹͣ");
  else if (eChgPro_B_ChgStop == ChargeCtrl_B.CurProcess)
    snprintf(Str, sizeof(Str), "");
  else if(eChgPro_B_ChgBreak == ChargeCtrl_B.CurProcess)
    snprintf(Str, sizeof(Str), "ֹ");
  else if(eChgPro_B_CommError== ChargeCtrl_B.CurProcess)
    snprintf(Str, sizeof(Str), "ֹ");
  else
    snprintf(Str, sizeof(Str), "ڳ");
  LcdShowStr(TextChargeSummary_AB_B_ChgStatus, (u8*)Str, (strlen(Str)+1));
  LcdShowPage(ScrnChargeSummary_AB);
}

typedef struct
{
  u32 RePainTick;
}StructChargeSummaryUpdate;


void ChargeSummaryUpdate_AB(StructChargeSummaryUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    ChargeSummaryPaint_AB();
  }
}

static u32 UnconnectTick;
static u32 UnconnectTick_B;
#define UnconnectTime   (3500)//20S   //ⲻCC/CP Ͽֹͣ 
u32 ChgEnergyCheckValue = 0;
u32 EnergyCheckTick = 0;



void EnergyCheckpPer30S(void)
{
  

  if(GetDcModuleCurrt() > 100)
    {
      if(GetSystemTick()-EnergyCheckTick > 60*1000)//30S
      {
        EnergyCheckTick = GetSystemTick();
        if(CurChgRecd.ChgEnergy > ChgEnergyCheckValue )
        ChgEnergyCheckValue = CurChgRecd.ChgEnergy;
        else
        {
          ChargeEnable = 0;
          CurChgRecd.ChgStopType = 23;//
        }
      }
    }
  else
  {
    EnergyCheckTick = GetSystemTick();
    ChgEnergyCheckValue = CurChgRecd.ChgEnergy;
  }
}
u32 ChgEnergyCheckValue_B = 0;
u32 EnergyCheckTick_B = 0;

void EnergyCheckpPer30S_B(void)
{
  

  if(GetDcModuleCurrt_B() > 100)
    {
      if(GetSystemTick()-EnergyCheckTick_B> 60*1000)//30S
      {
        EnergyCheckTick_B = GetSystemTick();
        if(CurChgRecd_B.ChgEnergy > ChgEnergyCheckValue_B)
          ChgEnergyCheckValue_B = CurChgRecd_B.ChgEnergy;
        else
        {
          ChargeEnable_B = 0;
          CurChgRecd_B.ChgStopType = 23;//
        }
      }
    }
  else
  {
  	EnergyCheckTick_B = GetSystemTick();
  	ChgEnergyCheckValue_B = CurChgRecd_B.ChgEnergy;
  }
}


void LcdProChargeSummary_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 SummaryChkTick;
  u32 Temp;
  StructChargeSummaryUpdate Update;


  StructTime Time;
  u32 TimeSynTick;
  u32 TempRecdTick;

  TempChgRecdSaveToLog(&CurChgRecd, 1, 1);
  TempChgRecdSaveToLog(&CurChgRecd_B, 2, 1);

  TempRecdTick = GetSystemTick();

  SummaryChkTick = GetSystemTick();

  ChargeSummaryPaint_AB();
  Update.RePainTick = GetSystemTick();

  TimeSynTick = GetSystemTick();

  LcdGetRtc();
  ChgEnergyCheckValue =  CurChgRecd.ChgEnergy;;
  EnergyCheckTick = GetSystemTick();
  ChgEnergyCheckValue_B = CurChgRecd_B.ChgEnergy;
  EnergyCheckTick_B = GetSystemTick();
  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnChargeSummary_AB != Temp)
              LcdShowPage(ScrnChargeSummary_AB);
          }
          else if(eLcdRegAddr_Rtc == Frame.Ctrl.RdReg.Addr)
          {
            Time.Year = 2000 + BcdToHex(Frame.Ctrl.RdReg.Data[0]);          //  
            Time.Mon = BcdToHex(Frame.Ctrl.RdReg.Data[1] & 0x1F);      //  
            Time.Day = BcdToHex(Frame.Ctrl.RdReg.Data[2] & 0x3F);      //  
                    //Frame.Ctrl.RdReg.Data[3]
            Time.Hour = BcdToHex(Frame.Ctrl.RdReg.Data[4] & 0x3F);      //  Сʱ
            Time.Min = BcdToHex(Frame.Ctrl.RdReg.Data[5] & 0x7F);      //  
            Time.Sec = BcdToHex(Frame.Ctrl.RdReg.Data[6] &0x7F);      //  

            RtcSetTime(GetExtOrLcdStamp(&Time));
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnChargeSummary_Cancel:
          //      if(CurChgRecd.CardValidFlag != 0)
                  {
                pLcdCtrl->CurScreen = eLcdPro_SwipeCard;
                //pLcdCtrl->CurScreen = eLcdPro_PutBack;
                pLcdCtrl->Param = 0;
                  }
                break;
              case BtnChargeSummary_Infor:
                pLcdCtrl->CurScreen = eLcdPro_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;
              case BtnChargeSummary_B_Cancel:
                pLcdCtrl->CurScreen = eLcdPro_B_SwipeCard;
                //pLcdCtrl->CurScreen = eLcdPro_B_PutBack;
                pLcdCtrl->Param = 0;
                break;
              case BtnChargeSummary_B_Infor:
                pLcdCtrl->CurScreen = eLcdPro_B_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnChargeSummary_AB);
                break;
            }
          }
          break;

        default:
          break;
      }
    }
	if((eSwSta_On != CcStatusRead())&&( ChargeStopType != eChgStop_None))

    {
      if(0 == UnconnectTick)
        UnconnectTick = GetSystemTick();
    }
    else
      UnconnectTick = 0;
    if((0 != UnconnectTick) && (GetSystemTick() - UnconnectTick) > UnconnectTime)
    {
      CurChgRecd.ChgStopType = 4;//ǹֹͣ  "׮CC/CPźŶϿֱ׮CC1ȷ϶Ͽ"  4

      //pLcdCtrl->CurScreen = eLcdPro_PutBack;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_PutBack);
      pLcdCtrl->Param = 0;
    }


	if((eSwSta_On != CcStatusRead_B())&&( ChargeStopType_B!= eChgStop_None))

    {
      if(0 == UnconnectTick_B)
        UnconnectTick_B = GetSystemTick();
    }
    else
      UnconnectTick_B = 0;
    if((0 != UnconnectTick_B) && (GetSystemTick() - UnconnectTick_B) > UnconnectTime)
    {
      CurChgRecd_B.ChgStopType = 4;//ǹֹͣ  "׮CC/CPźŶϿֱ׮CC1ȷ϶Ͽ"  4

      //pLcdCtrl->CurScreen = eLcdPro_B_PutBack;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_PutBack);
      pLcdCtrl->Param = 0;
    }

    //if((1 == CurChgRecd.CardValidFlag) && (CurChgRecd.TotalMoney >= CurChgRecd.CardRespMoney))
    if(CurChgRecd.TotalMoney >= (CurChgRecd.CardRespMoney - UserParam.BalanceMoney))
    {
      ChargeEnable = 0;
      CurChgRecd.ChgStopType = 5;//ֹͣ  ôﵽ˻ֹͣ  5
    }
    //if((1 == CurChgRecd_B.CardValidFlag) && (CurChgRecd_B.TotalMoney >= CurChgRecd_B.CardRespMoney))
    if(CurChgRecd_B.TotalMoney >= (CurChgRecd_B.CardRespMoney - UserParam.BalanceMoney))
    {
      ChargeEnable_B = 0;
      CurChgRecd_B.ChgStopType = 5;//ֹͣ  ôﵽ˻ֹͣ  5
    }
    if((BcsMsg.CurSoc >= UserParam.SOCMAX)&&(BclMsg.Valid ==1))
    {
      ChargeEnable = 0;
      CurChgRecd.ChgStopType = 3;//ﵽsoc趨ֵ
     }
     if((BcsMsg_B.CurSoc >= UserParam.SOCMAX)&&(BclMsg_B.Valid ==1))
     {
      ChargeEnable_B= 0;
      CurChgRecd_B.ChgStopType = 3;//ﵽsoc趨ֵ
     }
    if(eLcdPro_AB_ChargeSummary != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - SummaryChkTick) >= CheckSreenTime)
    {
      SummaryChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeSynTick) >= RtcSynTime)
    {
      TimeSynTick = GetSystemTick();
      LcdGetRtc();
    }

    if((GetSystemTick() - TempRecdTick) > 60*1000)
    {
      TempChgRecdSaveToLog(&CurChgRecd, 1, 1);
	  osDelay(1000);
      TempChgRecdSaveToLog(&CurChgRecd_B, 2, 1);
      TempRecdTick = GetSystemTick();
    }

    ChargeSummaryUpdate_AB(&Update);
    EnergyCheckpPer30S_B();
    EnergyCheckpPer30S();

    osDelay(100);
  }
}




