
#include "Thd_Lcd.h"

#define ScrnCommuInfor_AB  ((u16)20)
#define BtnCommuInfor_AB_Cancel      ((u16)0x2001)
#define BtnCommuInfor_AB_Next        ((u16)0x000B)
#define BtnCommuInfor_AB_Last        ((u16)0x000A)

#define DataCommuInfor_AB_BSE_E             ((u16)0x41E0)
#define DataCommuInfor_AB_BST               ((u16)0x41F0)
#define DataCommuInfor_AB_CST               ((u16)0x4200)
#define DataCommuInfor_AB_BEM               ((u16)0x4210)
#define DataCommuInfor_AB_CEM               ((u16)0x4220)
#define DataCommuInfor_AB_PillError         ((u16)0x4230)

#define VarCommuInfor_AB_Position                 ((u16)0x003C)


void CommuInforPaint_AB(void)
{
  char Str[64];

  LcdShowData16(VarCommuInfor_AB_Position, 3);

  if(BsmMsg.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %02X ", BsmMsg.BatSta.Mult,BsmMsg.ChgSta.Mult);
    LcdShowStr(DataCommuInfor_AB_BSE_E, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_AB_BSE_E, (u8*)Str, (strlen(Str)+1));
  }

  if(BstMsg.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %04X %02X", BstMsg.StopReason.Mult,BstMsg.StopTruble.Mult,BstMsg.StopFault.Mult);
    LcdShowStr(DataCommuInfor_AB_BST, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_AB_BST, (u8*)Str, (strlen(Str)+1));
  }

  //if(CstMsg.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %04X %02X", CstMsg.StopReason.Mult,CstMsg.StopTruble.Mult,CstMsg.StopFault.Mult);
    LcdShowStr(DataCommuInfor_AB_CST, (u8*)Str, (strlen(Str)+1));
  }
  //else
  //{
  //  snprintf(Str, sizeof(Str), " ");
  //  LcdShowStr(DataCommuInfor_AB_CST, (u8*)Str, (strlen(Str)+1));
  //}

  if(BemMsg.Valid)
  {
    snprintf(Str, sizeof(Str), "%08X ", BemMsg.Bem.Mult);
    LcdShowStr(DataCommuInfor_AB_BEM, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_AB_BEM, (u8*)Str, (strlen(Str)+1));
  }

  //if(CemMsg.Cem.Mult)
  {
    snprintf(Str, sizeof(Str), "%08X ", CemMsg.Cem.Mult);
    LcdShowStr(DataCommuInfor_AB_CEM, (u8*)Str, (strlen(Str)+1));
  }
  //else
  //{
  //  snprintf(Str, sizeof(Str), " ");
  //  LcdShowStr(DataCommuInfor_AB_CEM, (u8*)Str, (strlen(Str)+1));
  //}

  snprintf(Str, sizeof(Str), "%08X ", (PillarError.Mult|PillarError_B.Mult));
  LcdShowStr(DataCommuInfor_AB_PillError, (u8*)Str, (strlen(Str)+1));

  LcdShowPage(ScrnCommuInfor_AB);
}

typedef struct
{
  u32 RePainTick;
}StructCommuInforUpdate_AB;

void CommuInforUpdate_AB(StructCommuInforUpdate_AB *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    CommuInforPaint_AB();
  }
}

#define TimeOutTime   (30*1000)

void LcdProCommuInfor_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructCommuInforUpdate_AB Update;
  u32 TimeOutTick;
  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  CommuInforPaint_AB();
  Update.RePainTick = GetSystemTick();

  TimeOutTick = GetSystemTick();
  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnCommuInfor_AB != Temp)
              LcdShowPage(ScrnCommuInfor_AB);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCommuInfor_AB_Cancel:
                pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;
              case BtnCommuInfor_AB_Next:
                pLcdCtrl->CurScreen = eLcdPro_AB_BmsInfor;
                pLcdCtrl->Param = 0;
              case BtnCommuInfor_AB_Last:
                pLcdCtrl->CurScreen = eLcdPro_AB_BmsInfor;
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnCommuInfor_AB);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_AB_CommuInfor != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
      pLcdCtrl->Param = 0;
    }

    CommuInforUpdate_AB(&Update);

    osDelay(100);
  }
}



