
#include "Thd_Lcd.h"

#define ScrnElectLock_AB            ((u16)119)//((u16)18)
#define BtnElectLock_AB_Cancel      ((u16)0x1192)//((u16)0x1801)
#define BtnElectLock_AB_Enter        ((u16)0x1191)

#define BtnElectLock_AB_LockOn         ((u16)0x1802)
#define BtnElectLock_AB_LockOff       ((u16)0x1803)

#define VarElectLock_AB_Position           ((u16)0x003C)

void ElectLockPaint_AB(void)
{
  LcdShowData16(VarElectLock_AB_Position, 3);
  LcdShowPage(ScrnElectLock_AB);
}

void ElectLockIdle_AB(void)
{

}

#define TimeOutTime   (60*1000)

void LcdProElectLock_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  TimeOutTick = GetSystemTick();
  ElectLockPaint_AB();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnElectLock_AB_Cancel:  //A ǹ"" 
                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->Param = 0;
                break;

              case BtnElectLock_AB_Enter:  //A ǹ"" 
                pLcdCtrl->CurScreen = eLcdPro_AB_CnctDetect;
                break;

              default:
                LcdShowPage(ScrnElectLock_AB);
                break;
            }
          }
          else
            LcdShowPage(ScrnElectLock_AB);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_AB_ElectLock != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      LockSet_AB(eSwSta_Off);
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }
/*
    if(eSwSta_Off == LockGet_AB())
    {
      LockSet_AB(eSwSta_Off);
      //pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    if(eSwSta_Off == CcStatusRead_AB())
    {
      LockSet_AB(eSwSta_Off);
      //pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }
*/
    ElectLockIdle_AB();

    osDelay(100);
  }
}

