
#include "Thd_Lcd.h"

#define ScrnBmsInfor_B  ((u16)16)
#define BtnBmsInfor_B_Cancel      ((u16)0x1601)
#define BtnBmsInfor_B_Commu      ((u16)0x1602)
#define BtnBmsInfor_B_Next        ((u16)0x000B)
#define BtnBmsInfor_B_Last        ((u16)0x000A)

#define DataBmsInfor_B_MaxtVolt               ((u16)0x0025)
#define DataBmsInfor_B_MaxCurrt               ((u16)0x0026)
#define DataBmsInfor_B_NeedVolt               ((u16)0x0027)
#define DataBmsInfor_B_CurSoc                 ((u16)0x0028)
#define DataBmsInfor_B_MaxTemp                ((u16)0x0029)
#define DataBmsInfor_B_BatEnergy              ((u16)0x002A)
#define DataBmsInfor_B_NeedCurrt              ((u16)0x002B)
#define DataBmsInfor_B_BatTemp                ((u16)0x002C)

#define DataBmsInfor_B_PerBatVoltHi           ((u16)0x0034)
#define DataBmsInfor_B_PerBatVoltLo           ((u16)0x0035)
#define DataBmsInfor_B_PerBatPerVoltHi        ((u16)0x0165)
#define DataBmsInfor_B_BatType                ((u16)0x4000)

#define VarBmsInfor_B_Position                 ((u16)0x003C)
void BmsInforPaint_B(void)
{
  char Str[64];

  LcdShowData16(VarBmsInfor_B_Position, 2);
  LcdShowStr((u16)0x00E1, (u8*)"¶ȣ", (strlen("¶ȣ")+1));
  LcdShowData16((u16)0x0053, Dht12_GetTemp()/100);
  LcdShowStr((u16)0x00E9, (u8*)"", (strlen("")+1));
  LcdShowData16((u16)0x0051, Adc_Get_B_PTemp());
  LcdShowStr((u16)0x00F4, (u8*)"", (strlen("")+1));
  LcdShowData16((u16)0x0052, Adc_Get_B_NTemp());

  if(BcpMsg_B.Valid)
  {
    LcdShowData16(DataBmsInfor_B_MaxtVolt, BcpMsg_B.ChgMaxVolt);
    LcdShowData16(DataBmsInfor_B_MaxCurrt, (s16)(4000 - BcpMsg_B.ChgMaxCurrt));
    LcdShowData16(DataBmsInfor_B_MaxTemp, (s16)BcpMsg_B.MaxTemp - 50);
    LcdShowData16(DataBmsInfor_B_BatEnergy, BcpMsg_B.BatEnergy);
    LcdShowData16(DataBmsInfor_B_PerBatPerVoltHi,BcpMsg_B.PerBatMaxVolt);
  }
  else
  {
    LcdShowData16(DataBmsInfor_B_MaxtVolt, 0);
    LcdShowData16(DataBmsInfor_B_MaxCurrt, 0);
    LcdShowData16(DataBmsInfor_B_MaxTemp, 0);
    LcdShowData16(DataBmsInfor_B_BatEnergy, 0);
    LcdShowData16(DataBmsInfor_B_PerBatPerVoltHi,0);
  }

  if(BclMsg_B.Valid)
  {
    LcdShowData16(DataBmsInfor_B_NeedVolt, BclMsg_B.NeedVolt);
    LcdShowData16(DataBmsInfor_B_NeedCurrt, (s16)(4000 - BclMsg_B.NeedCurrt));
  }
  else
  {
    LcdShowData16(DataBmsInfor_B_NeedVolt, 0);
    LcdShowData16(DataBmsInfor_B_NeedCurrt, 0);
  }

  if(BcsMsg_B.Valid)
    LcdShowData16(DataBmsInfor_B_CurSoc, BcsMsg_B.CurSoc);
  else
    LcdShowData16(DataBmsInfor_B_CurSoc, 0);

  if(BsmMsg_B.Valid)
    LcdShowData16(DataBmsInfor_B_BatTemp, (s16)BsmMsg_B.HighTemp - 50);
  else
    LcdShowData16(DataBmsInfor_B_BatTemp, 0);

  if(BsdMsg_B.Valid)
  {
    LcdShowData16(DataBmsInfor_B_PerBatVoltLo, BsdMsg_B.PerMinVolt);
    LcdShowData16(DataBmsInfor_B_PerBatVoltHi, BsdMsg_B.PerMaxVolt);
  }
  else
  {
    LcdShowData16(DataBmsInfor_B_PerBatVoltLo, 0);
    if(BcsMsg_B.Valid)
      LcdShowData16(DataBmsInfor_B_PerBatVoltHi, BcsMsg_B.BatVoltAndGroup.Value.Volt);
  }

  if(eChgPro_B_CommError== ChargeCtrl_B.CurProcess)
  {
    snprintf(Str, sizeof(Str), "%08X %06X %08X %06X", CommErrFrame_B[0], CommErrFrame_B[1], CommErrFrame_B[2], CommErrFrame_B[3]);
    LcdShowStr(DataBmsInfor_B_BatType, (u8*)Str, (strlen(Str)+1));
  }
  else if(BrmMsg_B.Valid)
  {
    switch(BrmMsg_B.BatType)
    {
      case 0x01:
        snprintf(Str, sizeof(Str), "Ǧ");
        break;
      case 0x02:
        snprintf(Str, sizeof(Str), "");
        break;
      case 0x03:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x04:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x05:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x06:
        snprintf(Str, sizeof(Str), "Ԫϵ");
        break;
      case 0x07:
        snprintf(Str, sizeof(Str), "ۺӵ");
        break;
      case 0x08:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0xFF:
        snprintf(Str, sizeof(Str), "");
        break;
      default:
        snprintf(Str, sizeof(Str), "δ֪");
        break;
    }
    LcdShowStr(DataBmsInfor_B_BatType, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), "ͨѶ");
    LcdShowStr(DataBmsInfor_B_BatType, (u8*)Str, (strlen(Str)+1));
  }

  LcdShowPage(ScrnBmsInfor_B);
}

typedef struct
{
  u32 RePainTick;
}StructBmsInforUpdate;

void BmsInforUpdate_B(StructBmsInforUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    BmsInforPaint_B();
  }
}

#define TimeOutTime   (30*1000)

void LcdProBmsInfor_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructBmsInforUpdate Update;
  u32 TimeOutTick;

  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  BmsInforPaint_B();
  Update.RePainTick = GetSystemTick();

  TimeOutTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnBmsInfor_B != Temp)
              LcdShowPage(ScrnBmsInfor_B);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnBmsInfor_B_Cancel:
                //pLcdCtrl->CurScreen = eLcdPro_B_ChargeSummary;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              case BtnBmsInfor_B_Next:
                //pLcdCtrl->CurScreen = eLcdPro_B_CommuInfor;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_CommuInfor);
                pLcdCtrl->Param = 0;
              case BtnBmsInfor_B_Last:
                //pLcdCtrl->CurScreen = eLcdPro_B_CommuInfor;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_CommuInfor);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnBmsInfor_B);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_B_BmsInfor != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      //pLcdCtrl->CurScreen = eLcdPro_B_ChargeSummary;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
      pLcdCtrl->Param = 0;
    }

    BmsInforUpdate_B(&Update);

    osDelay(100);
  }
}





