
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnPillarError_B  ((u16)15)

#define BtnPillarError_B_Sure      ((u16)0x1501)
#define TextPillarErrorAddr_B      ((u16)0x4000)
#define VarPillarError_B_Position  ((u16)0x003C)

void PillarErrorPaint_B(void)
{
  char Str[64];
  LcdShowData16(VarPillarError_B_Position, 2);

  if(0 == UserParam.ChgFun.Value.Num_B)
    snprintf(Str, sizeof(Str), "λֹ");

  else if(PillarError_B.Value.Emergency)
    snprintf(Str, sizeof(Str), "ͣ");
  else if(PillarError_B.Value.Door)
    snprintf(Str, sizeof(Str), "׮Ŵ");
  else if(PillarError_B.Value.InVolt)
    snprintf(Str, sizeof(Str), "ѹ쳣");
  else if(PillarError_B.Value.NoDcmod)
    snprintf(Str, sizeof(Str), "޳ģ");
  else if(PillarError_B.Value.Insulation)
    snprintf(Str, sizeof(Str), "Ե쳣");
  else if(PillarError_B.Value.ImdDev)
    snprintf(Str, sizeof(Str), "Ե쳣");
  else if(PillarError_B.Value.DrainResist)
    snprintf(Str, sizeof(Str), "йŵ·쳣");
  else if(PillarError_B.Value.Reader)
    snprintf(Str, sizeof(Str), "쳣");
  else if(PillarError_B.Value.Meter)
    snprintf(Str, sizeof(Str), "쳣");
  else if(PillarError_B.Value.ACMeter)
    snprintf(Str, sizeof(Str), "쳣");
  else if(PillarError_B.Value.SPD)
    snprintf(Str, sizeof(Str), "쳣");
  else if(PillarError_B.Value.Memory)
    snprintf(Str, sizeof(Str), "洢");
  else if(PillarError_B.Value.Lcd)
    snprintf(Str, sizeof(Str), "ʾ");
  else if(PillarError_B.Value.Contactor)
    snprintf(Str, sizeof(Str), "ֱӴ쳣");
  else if(PillarError_B.Value.UniContactor)
    snprintf(Str, sizeof(Str), "Ӵ쳣");
  else if(PillarError_B.Value.EleLock)
    snprintf(Str, sizeof(Str), "쳣");
  else if(PillarError_B.Value.Humiture)
    snprintf(Str, sizeof(Str), "ʪ쳣");
  else if(PillarError_B.Value.BMS)
    snprintf(Str, sizeof(Str), "BMSͨѶ쳣");
  else if(PillarError_B.Value.OutVolt)
    snprintf(Str, sizeof(Str), "ѹ쳣");
  else if(PillarError_B.Value.OutCurrt)
    snprintf(Str, sizeof(Str), "쳣");
  else if(PillarError_B.Value.Net)
    snprintf(Str, sizeof(Str), "쳣");
  else
    snprintf(Str, sizeof(Str), "  ");

  LcdShowStr(TextPillarErrorAddr_B, (u8*)Str, (strlen(Str)+1));
  LcdShowPage(ScrnPillarError_B);
}

void PillarErrorIdle_B(void)
{

}

#define GetCardTime   (2*1000)     //ȴˢʱ

#define TimeOutTime   (10*1000)    //10S  ˢ

void LcdProPillarError_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  u32 TimeOutTick;

  char Str[32] = {0};
  EnumCardError CardRtn;
  u32 GetCardTick;
  GetCardTick = GetSystemTick();

  //IdleLedSet(eSwSta_Off);

  //ChgLedSet(eSwSta_Off);
  ScreenChkTick = GetSystemTick();
  PillarErrorPaint_B();

  TimeOutTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnPillarError_B != Temp)
              LcdShowPage(ScrnPillarError_B);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnPillarError_B_Sure:
//                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnPillarError_B);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if(
        (0 == PillarError_B.Value.Emergency)
        && (0 == PillarError_B.Value.Door)
        && (0 == PillarError_B.Value.InVolt)
        && (0 == PillarError_B.Value.NoDcmod)
        && (0 == PillarError_B.Value.Insulation)
        && (0 == PillarError_B.Value.ImdDev)// && ((eChgVer_2011 != UserParam.ChgVer))) || (eChgVer_2011 == UserParam.ChgVer))
        && (0 == PillarError_B.Value.DrainResist)
        && (0 == PillarError_B.Value.Reader)
        && (0 == PillarError_B.Value.Meter)
        && (0 == PillarError_B.Value.ACMeter)
        && (0 == PillarError_B.Value.SPD)
        && (0 == PillarError_B.Value.Memory)
        && (0 == PillarError_B.Value.Lcd)
        && (0 == PillarError_B.Value.Contactor)
        && (0 == PillarError_B.Value.UniContactor)
        && (0 == PillarError_B.Value.OutVolt)
        && (0 == PillarError_B.Value.OutCurrt)
        && (0 == PillarError_B.Value.Humiture)
        && (1 == PillarError_B.Value.Net)
      )
    {
      if((GetSystemTick() - GetCardTick) > GetCardTime)
      {
        CardRtn = ReaderGetCard(&CardData);
        switch(CardRtn)
        {
          case eCardErr_TimeOut:
          case eCardErr_Error:
            memset(&CardData, 0, sizeof(CardData));
            break;
          case eCardErr_Ok:
            TimeOutTick = GetSystemTick();
            GetCardTick = GetSystemTick();
            if(TRUE == CarNumVerify(CardData.CardNum))
            {
              if((0x88 == CardData.CardNum[0]) && (0x80 == (CardData.CardNum[1] & 0x80)))
              {
                if((0xAA == CardData.CardStatus) && (0 != UserParam.LockCard))
                {
                  snprintf(Str, sizeof(Str), "");
                  LcdShowStr(TextPillarErrorAddr_B, (u8*)Str, strlen(Str)+1);
                  BuzzerRun(2, 80, 80);
                }
                else if(CardData.CardMoney <= 0)
                {
                  snprintf(Str, sizeof(Str), "˻%.2fԪ,㡣", ((float)CardData.CardMoney/100));
                  LcdShowStr(TextPillarErrorAddr_B, (u8*)Str, strlen(Str)+1);
                  BuzzerRun(2, 80, 80);
                }
                else
                {
                  BuzzerRun(1, 80, 80);
                  pLcdCtrl->CurScreen = eLcdPro_B_CardPwd;
                  pLcdCtrl->Param = 0;
                }
              }
              else
                BuzzerRun(3, 80, 80);
            }
            else
            {
              snprintf(Str, sizeof(Str), "ˢʧܣԡ");
              LcdShowStr(TextPillarErrorAddr_B, (u8*)Str, strlen(Str)+1);
              BuzzerRun(2, 80, 80);
            }
            break;

          default:
            memset(&CardData, 0, sizeof(CardData));
            TimeOutTick = GetSystemTick();
            GetCardTick = GetSystemTick();
            BuzzerRun(2, 80, 80);
            break;
        }
      }
    }


    if(eLcdPro_B_PillarError != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeOutTick) > (TimeOutTime))
    {
//      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    PillarErrorIdle_B();

    osDelay(100);
  }
}

