
#include "Thd_Lcd.h"

#define ScrnChargeStop  ((u16)15)
#define BtnChargeStop_Enter      ((u16)0x0015)
#define BtnChargeStop_Cancel        ((u16)0x0016)
#define VarChargeStop_Position       ((u16)0x003C)

void ChargeStopPaint(void)
{
  LcdShowData16(VarChargeStop_Position, UserParam.ChgFun.Value.Num_B);
  LcdShowPage(ScrnChargeStop);
}

typedef struct
{
  u32 RePainTick;
}StructChargeStopUpdate;

void ChargeStopUpdate(void)
{

}

#define TimeOutTime   (30*1000)

void LcdProChargeStop(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  u32 TimeOutTick;

  ChargePauseFlag = 1;

  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  ChargeStopPaint();

  TimeOutTick = GetSystemTick();


  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnChargeStop != Temp)
              LcdShowPage(ScrnChargeStop);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnChargeStop_Enter:
                ChargeEnable = 0;
                pLcdCtrl->CurScreen = eLcdPro_SwipeCard;
                pLcdCtrl->Param = 0;
                break;
              case BtnChargeStop_Cancel:
                pLcdCtrl->CurScreen = eLcdPro_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnChargeStop);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_ChargeStop != pLcdCtrl->CurScreen)
    {
      ChargePauseFlag = 0;
      return;
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
//      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    ChargeStopUpdate();

    osDelay(100);
  }
}





