
#include "Thd_Lcd.h"

#define ScrnChargeSummary  ((u16)107)
#define BtnChargeSummary_Cancel      ((u16)0x1112)
#define BtnChargeSummary_Infor        ((u16)0x1111)

#define VarChargeSummary_TotalMoney     ((u16)0x0007)
#define DataChargeSummary_Volt               ((u16)0x0021)
#define DataChargeSummary_Currt              ((u16)0x0022)
#define DataChargeSummary_Soc                ((u16)0x0023)
#define TextChargeSummary_ChgStatus             ((u16)0x4120)
#define AnimChargeSummary_Charge             ((u16)0x001A)


#define BtnChargeSummary_Start_B        ((u16)0x1030)
#define BtnElock_B_Off      ((u16)0x1116)
#define Elock_Key_Show_B    ((u16)0x003E)


void ChargeSummaryPaint(void)
{
  char Str[64];
  u16 TempU16;

  LcdShowData16(VarChargeSummary_TotalMoney, CurChgRecd.TotalMoney);

  TempU16 = BcsMsg.CurSoc;
  LcdShowData16(DataChargeSummary_Soc, TempU16);
  if(TRUE == UniChgEnable)
  {
    TempU16 = GetDcModuleVolt_AB();
    LcdShowData16(DataChargeSummary_Volt, TempU16);
    TempU16 = GetDcModuleCurrt_AB();
    LcdShowData16(DataChargeSummary_Currt, TempU16);
  }
  else
  {
    TempU16 = GetDcModuleVolt();
    LcdShowData16(DataChargeSummary_Volt, TempU16);
    TempU16 = GetDcModuleCurrt();
    LcdShowData16(DataChargeSummary_Currt, TempU16);
  }

  if((eChgPro_ChgIdle == ChargeCtrl.CurProcess)
      || (eChgPro_ChgStop == ChargeCtrl.CurProcess)
      || (eChgPro_ChgBreak == ChargeCtrl.CurProcess)
      || (eChgPro_CommError == ChargeCtrl.CurProcess))
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(AnimChargeSummary_Charge, TempU16);

  if(eChgPro_ChgIdle == ChargeCtrl.CurProcess)
    snprintf(Str, sizeof(Str), "ֹͣ");
  else if (eChgPro_ChgStop == ChargeCtrl.CurProcess)
    snprintf(Str, sizeof(Str), "");
  else if(eChgPro_ChgBreak == ChargeCtrl.CurProcess)
    snprintf(Str, sizeof(Str), "ֹ");
  else if(eChgPro_CommError== ChargeCtrl.CurProcess)
    snprintf(Str, sizeof(Str), "ֹ");
  else
    snprintf(Str, sizeof(Str), "ڳ");
  LcdShowStr(TextChargeSummary_ChgStatus, (u8*)Str, (strlen(Str)+1));

  LcdShowPage(ScrnChargeSummary);
}

typedef struct
{
  u32 RePainTick;
}StructChargeSummaryUpdate;

void ChargeSummaryUpdate(StructChargeSummaryUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    ChargeSummaryPaint();
  }
}

static u32 UnconnectTick;
#define UnconnectTime   (3500)//20S   //ⲻCC/CP Ͽֹͣ 
extern u32 ChgEnergyCheckValue;
extern u32 EnergyCheckTick;

extern void EnergyCheckpPer30S(void);

void LcdProChargeSummary(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 SummaryChkTick;
  u32 Temp;
  StructChargeSummaryUpdate Update;


  StructTime Time;
  u32 TimeSynTick;
  u32 TempRecdTick;
  u8 Cmd[1],i,j;

  //TempChgRecdSaveToLog(&CurChgRecd, 1, 1);
  //TempRecdTick = GetSystemTick();

  SummaryChkTick = GetSystemTick();

  ChargeSummaryPaint();
  Update.RePainTick = GetSystemTick();
  TimeSynTick = GetSystemTick();
  LcdGetRtc();
  ChgEnergyCheckValue =  CurChgRecd.ChgEnergy;;
  EnergyCheckTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnChargeSummary != Temp)
              LcdShowPage(ScrnChargeSummary);
          }
          else if(eLcdRegAddr_Rtc == Frame.Ctrl.RdReg.Addr)
          {
            Time.Year = 2000 + BcdToHex(Frame.Ctrl.RdReg.Data[0]);          //  
            Time.Mon = BcdToHex(Frame.Ctrl.RdReg.Data[1] & 0x1F);      //  
            Time.Day = BcdToHex(Frame.Ctrl.RdReg.Data[2] & 0x3F);      //  
                    //Frame.Ctrl.RdReg.Data[3]
            Time.Hour = BcdToHex(Frame.Ctrl.RdReg.Data[4] & 0x3F);      //  Сʱ
            Time.Min = BcdToHex(Frame.Ctrl.RdReg.Data[5] & 0x7F);      //  
            Time.Sec = BcdToHex(Frame.Ctrl.RdReg.Data[6] &0x7F);      //  

            RtcSetTime(GetExtOrLcdStamp(&Time));
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnChargeSummary_Cancel:
            //    if(CurChgRecd.CardValidFlag != 0)
                {
                  pLcdCtrl->CurScreen = eLcdPro_SwipeCard;
                  pLcdCtrl->Param = 0;
                }
                break;
              case BtnChargeSummary_Infor:
                pLcdCtrl->CurScreen = eLcdPro_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;
              case BtnChargeSummary_Start_B:
                if(
                    (0 != PillarError_B.Value.Emergency)
                    || (0 != PillarError_B.Value.NoDcmod)
                    || (0 != PillarError_B.Value.Insulation)
                    || (0 != PillarError_B.Value.ImdDev)// && (eChgVer_2011 != UserParam.ChgVer))
                    || (0 != PillarError_B.Value.DrainResist)
                    || (0 != PillarError_B.Value.Reader)
                    || (0 != PillarError_B.Value.Meter)
                    || (0 != PillarError_B.Value.ACMeter)
                    || (0 != PillarError_B.Value.Memory)
                    || (0 != PillarError_B.Value.Lcd)
                    || (0 != PillarError_B.Value.Contactor)
                    || (0 != PillarError_B.Value.UniContactor)
                    || (0 != PillarError_B.Value.Door)
                    || (0 != PillarError_B.Value.SPD)
                    || (0 != PillarError_B.Value.InVolt)
                    || (0 != PillarError_B.Value.OutVolt)
                    || (0 != PillarError_B.Value.OutCurrt)
                    || (0 != PillarError_B.Value.EleLock)
                    || (0 != PillarError_B.Value.Humiture)
                    || (UserParam.HadSigned && (0 != PillarError_B.Value.Net))
                    || (0 == UserParam.ChgFun.Value.Num_B)
                  )
                {
                  pLcdCtrl->CurScreen = eLcdPro_B_PillarError;
                  pLcdCtrl->Param = 0;
                }
                else
                {
                  pLcdCtrl->CurScreen = eLcdPro_B_GetCard;
                  //pLcdCtrl->CurScreen = eLcdPro_CnctDetect;
                  pLcdCtrl->Param = 0;
                }
                break;
              case BtnElock_B_Off:
               if(LockGet_B()!=eSwSta_Off)
                {
                  Cmd[0]=0x08;
                  LcdWriteReg(0x4F, Cmd, sizeof(Cmd));
                  for(i=0;i<8;i++)
                  {
                    LockSet_B(eSwSta_On);
                    osDelay(500);
                    LockSet_B(eSwSta_Off);
                    osDelay(500);
                    for(j=0;j<10;j++)
                    {
                      if(LockGet_B()!=eSwSta_Off) break;
                      osDelay(10);
                    }
                    if(j>=10) break;
                    osDelay(1000);
                  }
                  CloseKeyBoard();
                }

              default:
                LcdShowPage(ScrnChargeSummary);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

  	if((eSwSta_On != CcStatusRead())&&( ChargeStopType != eChgStop_None))
  //  if(0)
    {
      if(0 == UnconnectTick)
        UnconnectTick = GetSystemTick();
    }
    else
      UnconnectTick = 0;
	if((BcsMsg.CurSoc >= UserParam.SOCMAX)&&(BclMsg.Valid ==1))
    {
      ChargeEnable = 0;
      CurChgRecd.ChgStopType = 3;//ﵽsoc趨ֵ
     }
    if((0 != UnconnectTick) && (GetSystemTick() - UnconnectTick) > UnconnectTime)
    {
      CurChgRecd.ChgStopType = 4;//ǹֹͣ  "׮CC/CPźŶϿֱ׮CC1ȷ϶Ͽ"  4

      //pLcdCtrl->CurScreen = eLcdPro_PutBack;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_PutBack);
      pLcdCtrl->Param = 0;
    }

    //if((1 == CurChgRecd.CardValidFlag) && (CurChgRecd.TotalMoney >= CurChgRecd.CardRespMoney))
    if(CurChgRecd.TotalMoney >= (CurChgRecd.CardRespMoney - UserParam.BalanceMoney))
    {
      ChargeEnable = 0;
      CurChgRecd.ChgStopType = 5;//ֹͣ  ôﵽ˻ֹͣ  5
    }

    if(eLcdPro_ChargeSummary != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - SummaryChkTick) >= CheckSreenTime)
    {
      SummaryChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeSynTick) >= RtcSynTime)
    {
      TimeSynTick = GetSystemTick();
      LcdGetRtc();
    }

    if((GetSystemTick() - TempRecdTick) > 60*1000)
    {
      TempChgRecdSaveToLog(&CurChgRecd, 1, 1);
      TempRecdTick = GetSystemTick();
    }

    ChargeSummaryUpdate(&Update);
    EnergyCheckpPer30S();

    LcdShowData16(Elock_Key_Show_B, !LockGet_B());

    osDelay(100);
  }
}


