
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnCommError         ((u16)122)//((u16)9)

#define BtnCommError_Sure     ((u16)0x1221)//((u16)0x0901)

#define VarCommError_Position    ((u16)0x003C)
/*
#define TextCommErrorAddr  ((u16)0x4000)

const u8 ConnectErrStr[] = "δӳǹ";
const u8 CommErrStr[] = "ͨŹ";

void CommErrorPaint(void)
{
  const u8 *pStr;
  u8 Len;

  if(eSwSta_On != CcStatusRead())
  {
    pStr = ConnectErrStr;
    Len = sizeof(ConnectErrStr);
  }
  else
  {
    pStr = CommErrStr;
    Len = sizeof(CommErrStr);
  }

  LcdShowStr(TextCommErrorAddr, (u8*)pStr, Len);

  LcdShowPage(ScrnCommError);
}

void CommErrorIdle(void)
{
}

void LcdProCommError(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;

  //ChgLedSet(eSwSta_Off);
  //IdleLedSet(eSwSta_Off);
  ScreenChkTick = GetSystemTick();
  CommErrorPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnCommError != Temp)
              LcdShowPage(ScrnCommError);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp += Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCommError_Sure:
                ChargeEnable = 0;
                pLcdCtrl->CurScreen = eLcdPro_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnCommError);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_CommError != pLcdCtrl->CurScreen)
      return;

    CommErrorIdle();

    osDelay(100);
  }
}
*/

#define TimeOutTime   (60*1000)

void LcdProCommError(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  TimeOutTick = GetSystemTick();

  LcdShowData16(VarCommError_Position, pLcdCtrl->Param);
  LcdShowPage(ScrnCommError);

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCommError_Sure:  //"" 
                if(pLcdCtrl->Param == 1)
                  pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
                else if(pLcdCtrl->Param == 2)
                  pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
                else if(pLcdCtrl->Param == 3)
                  pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnCommError);
                break;
            }
          }
          else
            LcdShowPage(ScrnCommError);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_CommError != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      if(pLcdCtrl->Param == 1)
        pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
      else if(pLcdCtrl->Param == 2)
        pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
      else if(pLcdCtrl->Param == 3)
        pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
      pLcdCtrl->Param = 0;
    }

    osDelay(100);
  }
}



