
#include "Thd_Lcd.h"

#define ScrnCommuInfor  ((u16)20)
#define BtnCommuInfor_Cancel      ((u16)0x2001)
#define BtnCommuInfor_Next        ((u16)0x000B)
#define BtnCommuInfor_Last        ((u16)0x000A)

#define DataCommuInfor_BSE_E             ((u16)0x41E0)
#define DataCommuInfor_BST               ((u16)0x41F0)
#define DataCommuInfor_CST               ((u16)0x4200)
#define DataCommuInfor_BEM               ((u16)0x4210)
#define DataCommuInfor_CEM               ((u16)0x4220)
#define DataCommuInfor_PillError         ((u16)0x4230)

#define VarCommuInfor_Position                 ((u16)0x003C)


void CommuInforPaint(void)
{
  char Str[64];

  LcdShowData16(VarCommuInfor_Position, UserParam.ChgFun.Value.Num_B);

  if(BsmMsg.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %02X ", BsmMsg.BatSta.Mult,BsmMsg.ChgSta.Mult);
    LcdShowStr(DataCommuInfor_BSE_E, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_BSE_E, (u8*)Str, (strlen(Str)+1));
  }

  if(BstMsg.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %04X %02X", BstMsg.StopReason.Mult,BstMsg.StopTruble.Mult,BstMsg.StopFault.Mult);
    LcdShowStr(DataCommuInfor_BST, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_BST, (u8*)Str, (strlen(Str)+1));
  }

  //if(CstMsg.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %04X %02X", CstMsg.StopReason.Mult,CstMsg.StopTruble.Mult,CstMsg.StopFault.Mult);
    LcdShowStr(DataCommuInfor_CST, (u8*)Str, (strlen(Str)+1));
  }
  //else
  //{
  //  snprintf(Str, sizeof(Str), " ");
  //  LcdShowStr(DataCommuInfor_CST, (u8*)Str, (strlen(Str)+1));
  //}

  if(BemMsg.Valid)
  {
    snprintf(Str, sizeof(Str), "%08X ", BemMsg.Bem.Mult);
    LcdShowStr(DataCommuInfor_BEM, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_BEM, (u8*)Str, (strlen(Str)+1));
  }

  //if(CemMsg.Cem.Mult)
  {
    snprintf(Str, sizeof(Str), "%08X ", CemMsg.Cem.Mult);
    LcdShowStr(DataCommuInfor_CEM, (u8*)Str, (strlen(Str)+1));
  }
  //else
  //{
  //  snprintf(Str, sizeof(Str), " ");
  //  LcdShowStr(DataCommuInfor_CEM, (u8*)Str, (strlen(Str)+1));
  //}

  snprintf(Str, sizeof(Str), "%08X ", PillarError.Mult);
  LcdShowStr(DataCommuInfor_PillError, (u8*)Str, (strlen(Str)+1));

  LcdShowPage(ScrnCommuInfor);
}

typedef struct
{
  u32 RePainTick;
}StructCommuInforUpdate;

void CommuInforUpdate(StructCommuInforUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    CommuInforPaint();
  }
}

#define TimeOutTime   (30*1000)

void LcdProCommuInfor(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructCommuInforUpdate Update;
  u32 TimeOutTick;
  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  CommuInforPaint();
  Update.RePainTick = GetSystemTick();

  TimeOutTick = GetSystemTick();
  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnCommuInfor != Temp)
              LcdShowPage(ScrnCommuInfor);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCommuInfor_Cancel:
                //pLcdCtrl->CurScreen = eLcdPro_ChargeScreen;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              case BtnCommuInfor_Next:
                //pLcdCtrl->CurScreen = eLcdPro_BmsInfor;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_BmsInfor);
                pLcdCtrl->Param = 0;
              case BtnCommuInfor_Last:
                //pLcdCtrl->CurScreen = eLcdPro_BmsInfor;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_BmsInfor);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnCommuInfor);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_CommuInfor != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      //pLcdCtrl->CurScreen = eLcdPro_ChargeScreen;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
      pLcdCtrl->Param = 0;
    }

    CommuInforUpdate(&Update);

    osDelay(100);
  }
}





