
#include "Thd_Lcd.h"

#define ScrnElectLock            ((u16)119)//((u16)18)
#define BtnElectLock_Cancel      ((u16)0x1192)//((u16)0x1801)
#define BtnElectLock_Enter       ((u16)0x1191)

#define BtnElectLock_LockOn      ((u16)0x1802)
#define BtnElectLock_LockOff     ((u16)0x1803)

#define VarElectLock_Position    ((u16)0x003C)

void ElectLockPaint(void)
{
  LcdShowData16(VarElectLock_Position, UserParam.ChgFun.Value.Num_B);
  LcdShowPage(ScrnElectLock);
}

void ElectLockIdle(void)
{

}

#define TimeOutTime   (60*1000)

void LcdProElectLock(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  TimeOutTick = GetSystemTick();
  ElectLockPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnElectLock_Cancel:  //A ǹ"" 
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;

              case BtnElectLock_Enter:  //A ǹ"" 
                pLcdCtrl->CurScreen = eLcdPro_CnctDetect;
                break;

              default:
                LcdShowPage(ScrnElectLock);
                break;
            }
          }
          else
            LcdShowPage(ScrnElectLock);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_ElectLock != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      LockSet(eSwSta_Off);
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

   /* if(eSwSta_Off == LockGet())
    {
      LockSet(eSwSta_Off);
      //pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    if(eSwSta_Off == CcStatusRead())
    {
      LockSet(eSwSta_Off);
      //pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }
*/
    ElectLockIdle();

    osDelay(100);
  }
}



