
#include "Thd_Lcd.h"

#define ScrnFactoryChgInfor  ((u16)45)
#define BtnFactoryChgInfor_Stop      ((u16)0x4501)
#define BtnFactoryChgInfor_Next        ((u16)0x000B)
#define BtnFactoryChgInfor_Last        ((u16)0x000A)

#define DataFactoryChgInfor_ChgVolt               ((u16)0x0021)
#define DataFactoryChgInfor_ChgCurrt              ((u16)0x0022)

#define DataFactoryChgInfor_PosReg               ((u16)0x0180)
#define DataFactoryChgInfor_NegReg              ((u16)0x0181)

#define VarFactoryChgInfor_Position           ((u16)0x003C)

void FactoryChgInforPaint(void)
{
  LcdShowData16(VarFactoryChgInfor_Position, UserParam.ChgFun.Value.Num_B);

  LcdShowData16(DataFactoryChgInfor_ChgVolt, GetDcModuleVolt());
  LcdShowData16(DataFactoryChgInfor_ChgCurrt, GetDcModuleCurrt());

  if(ImdValue.Vaild)
  {
    LcdShowData16(DataFactoryChgInfor_PosReg, ImdValue.PositResist);
    LcdShowData16(DataFactoryChgInfor_NegReg, ImdValue.NegatResist);
  }

  LcdShowPage(ScrnFactoryChgInfor);
}

typedef struct
{
  u32 RePainTick;
}StructFactoryChgInforUpdate;

void FactoryChgInforUpdate(StructFactoryChgInforUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    FactoryChgInforPaint();
  }
}

void LcdProFactoryChgInfor(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructFactoryChgInforUpdate Update;

  IdleLedSet(eSwSta_Off);
  ChgLedSet(eSwSta_On);

  BmsPowerSet(eSwSta_On);
  LockSet(eSwSta_On);
  FanSet(eSwSta_On);
  ImdWorkSet(eSwSta_On);
  DrainResistSet(eSwSta_Off);
  DcOutSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  FactoryChgInforPaint();
  Update.RePainTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnFactoryChgInfor != Temp)
              LcdShowPage(ScrnFactoryChgInfor);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnFactoryChgInfor_Stop:
                pLcdCtrl->CurScreen = eLcdPro_FactoryChgSet;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnFactoryChgInfor);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_FactoryChgInfor != pLcdCtrl->CurScreen)
    {
      ChgLedSet(eSwSta_Off);

      IdleLedSet(eSwSta_On);

      BmsPowerSet(eSwSta_Off);
      LockSet(eSwSta_Off);
      FanSet(eSwSta_Off);
      ImdWorkSet(eSwSta_Off);
      DrainResistSet(eSwSta_Off);
      DcOutSet(eSwSta_Off);
      DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
      return;
    }

    FactoryChgInforUpdate(&Update);

    osDelay(100);
  }
}






