
#include "Thd_Lcd.h"

#define ScrnFactoryChgSet            ((u16)44)
#define BtnFactoryChgSet_Start       ((u16)0x4401)

#define BtnFactoryChgSet_Next        ((u16)0x000B)
#define BtnFactoryChgSet_Last        ((u16)0x000A)

#define VarFactoryChgSet_SetVolt     ((u16)0x0027)
#define VarFactoryChgSet_SetCurrt    ((u16)0x002B)
#define VarFactoryChgSet_ChgVolt     ((u16)0x0021)
#define VarFactoryChgSet_ChgCurrt    ((u16)0x0022)

#define VarFactoryChgSet_Position           ((u16)0x003C)

void FactoryChgSetPaint(void)
{
  LcdShowData16(VarFactoryChgSet_Position, UserParam.ChgFun.Value.Num_B);

  LcdShowData16(VarFactoryChgSet_SetVolt, DcModuleAbility.MinVolt);
  LcdShowData16(VarFactoryChgSet_SetCurrt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);
  LcdShowData16(VarFactoryChgSet_ChgVolt, 0);
  LcdShowData16(VarFactoryChgSet_ChgCurrt, 0);

  LcdShowPage(ScrnFactoryChgSet);
}

void FactoryChgSetIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProFactoryChgSet(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u16 NeedVolt;
  u16 NeedCurrt;

//  ChgLedSet(eSwSta_Off);
//  IdleLedSet(eSwSta_Off);

  BmsPowerSet(eSwSta_Off);
  LockSet(eSwSta_Off);
  FanSet(eSwSta_Off);
  ImdWorkSet(eSwSta_Off);
  DrainResistSet(eSwSta_On);
  DcOutSet(eSwSta_Off);
  DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);

  NeedVolt = DcModuleAbility.MinVolt;
  NeedCurrt = DcModuleAbility.MinCurrt*DcModuleManage.ValidNum;

  TimeOutTick = GetSystemTick();

  FactoryChgSetPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnFactoryChgSet_Start:
                TimeOutTick = GetSystemTick();
                DrainResistSet(eSwSta_Off);
                ImdWorkSet(eSwSta_On);
                osDelay(200);
                DcModuleSet(eSwSta_On, NeedVolt, NeedCurrt);
                LcdShowData16(VarFactoryChgSet_SetVolt, NeedVolt);
                LcdShowData16(VarFactoryChgSet_SetCurrt, NeedCurrt);
                pLcdCtrl->CurScreen = eLcdPro_FactoryChgInfor;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryChgSet_Next:
                TimeOutTick = GetSystemTick();
				DrainResistSet(eSwSta_Off);
                pLcdCtrl->CurScreen = eLcdPro_B_FactoryTest;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryChgSet_Last:
                TimeOutTick = GetSystemTick();
				DrainResistSet(eSwSta_Off);
                pLcdCtrl->CurScreen = eLcdPro_FactoryTestTwo;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnFactoryChgSet);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnFactoryChgSet);
            if(VarFactoryChgSet_SetVolt == Temp)
              NeedVolt = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarFactoryChgSet_SetCurrt == Temp)
              NeedCurrt = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_FactoryChgSet != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      DrainResistSet(eSwSta_Off);
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    FactoryChgSetIdle();

    osDelay(100);
  }
}


