
#include "Thd_Lcd.h"

#define ScrnFactoryDcModSet            ((u16)49)
#define BtnFactoryDcModSet_Enter       ((u16)0x4901)
#define BtnFactoryDcModSet_Cancel      ((u16)0x4902)
#define BtnMainMenu_Manage     ((u16)0x0102)


#define BtnFactoryDcModSet_Next        ((u16)0x000B)
#define BtnFactoryDcModSet_Last        ((u16)0x000A)

#define VarFactoryDcModSet_MaxVolt     ((u16)0x0030)
#define VarFactoryDcModSet_MinVolt     ((u16)0x0031)
#define VarFactoryDcModSet_MaxCurrt    ((u16)0x0032)
#define VarFactoryDcModSet_MinCurrt    ((u16)0x0033)
#define VarFactoryDcModSet_SingMaxCurrt    ((u16)0x0034)
#define VarFactoryDcModSet_MaxPower    ((u16)0x0035)

#define TextFactoryDcModSet_Tip        ((u16)0x4000)


void FactoryDcModSetPaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str)," ");
  LcdShowStr(TextFactoryDcModSet_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowData16(VarFactoryDcModSet_MaxVolt, UserParam.DcMaxVolt);
  LcdShowData16(VarFactoryDcModSet_MinVolt, UserParam.DcMinVolt);

  LcdShowData16(VarFactoryDcModSet_MaxCurrt, UserParam.DcMaxCurrt);
  LcdShowData16(VarFactoryDcModSet_MinCurrt, UserParam.DcMinCurrt);
  LcdShowData16(VarFactoryDcModSet_SingMaxCurrt, UserParam.SingleMaxCurrt);
  LcdShowData16(VarFactoryDcModSet_MaxPower, UserParam.DcMaxPower);

  LcdShowPage(ScrnFactoryDcModSet);
}

void FactoryDcModSetIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProFactoryDcModSet(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u16 MaxVoltTemp;
  u16 MinVoltTemp;
  u16 MaxCurrtTemp;
  u16 MinCurrtTemp;
  u16 SingManCurrtTemp;
  u8  MaxPowerTemp;
  u32 BtnManageTick;
  u8  BtnManageCounter;

  MaxVoltTemp = UserParam.DcMaxVolt;
  MinVoltTemp = UserParam.DcMinVolt;
  MaxCurrtTemp = UserParam.DcMaxCurrt;
  MinCurrtTemp = UserParam.DcMinCurrt;
  SingManCurrtTemp = UserParam.SingleMaxCurrt;
  MaxPowerTemp = UserParam.DcMaxPower;
  TimeOutTick = GetSystemTick();

  FactoryDcModSetPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnFactoryDcModSet_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryDcModSet_Enter:
                TimeOutTick = GetSystemTick();
                UserParam.DcMaxVolt = MaxVoltTemp;
                UserParam.DcMinVolt = MinVoltTemp;

                UserParam.DcMaxCurrt = MaxCurrtTemp;
                UserParam.DcMinCurrt = MinCurrtTemp;
                UserParam.SingleMaxCurrt = SingManCurrtTemp;
                UserParam.DcMaxPower = MaxPowerTemp;

                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                DcModuleAbility.MaxVolt = UserParam.DcMaxVolt;
                DcModuleAbility.MinVolt = UserParam.DcMinVolt;
                DcModuleAbility.MaxCurrt = UserParam.DcMaxCurrt;
                DcModuleAbility.MinCurrt = UserParam.DcMinCurrt;
                DcModuleAbility.SingleMaxCurrt= UserParam.SingleMaxCurrt;

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryDcModSet_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_FactoryPillarInputSet;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryDcModSet_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_B_FactoryChgSet;
                pLcdCtrl->Param = 0;
                break;
              case BtnMainMenu_Manage:
              if((GetSystemTick() - BtnManageTick) >= 1000)
                BtnManageCounter = 0;
              else
              {
                BtnManageCounter++;
                if(BtnManageCounter > 2)
                {
                  pLcdCtrl->CurScreen =  eLcdPro_FactoryDcModSelect;
                //  pLcdCtrl->CurScreen =  eLcdPro_ManageSelect;
                  pLcdCtrl->Param = 0;
                }
              }
              BtnManageTick = GetSystemTick();
              break;

              default:
                LcdShowPage(ScrnFactoryDcModSet);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnFactoryDcModSet);
            if(VarFactoryDcModSet_MaxVolt == Temp)
              MaxVoltTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarFactoryDcModSet_MinVolt == Temp)
              MinVoltTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            if(VarFactoryDcModSet_MaxCurrt == Temp)
              MaxCurrtTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarFactoryDcModSet_MinCurrt == Temp)
              MinCurrtTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarFactoryDcModSet_SingMaxCurrt == Temp)
              SingManCurrtTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarFactoryDcModSet_MaxPower== Temp)
              MaxPowerTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_FactoryDcModSet != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    FactoryDcModSetIdle();

    osDelay(100);
  }
}



