
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnFactoryFunctionSet  ((u16)60)
#define BtnFactoryFunSet_Enter        ((u16)0x6001)
#define BtnFactoryFunSet_Cancel        ((u16)0x6002)

#define BtnFactoryFunSet_Next        ((u16)0x000B)
#define BtnFactoryFunSet_Last        ((u16)0x000A)

#define BtnFactoryFunSetAddr_A_Num  ((u16)0x014B)
#define BtnFactoryFunSetValue_A_NumOff ((u16)0x0000)
#define BtnFactoryFunSet_A_NumOff      ((u32)BtnFactoryFunSetAddr_A_Num*65536+BtnFactoryFunSetValue_A_NumOff)
#define BtnFactoryFunSetValue_A_NumOn  ((u16)0x0001)
#define BtnFactoryFunSet_A_NumOn       ((u32)BtnFactoryFunSetAddr_A_Num*65536+BtnFactoryFunSetValue_A_NumOn)

#define BtnFactoryFunSetAddr_B_Num  ((u16)0x014D)
#define BtnFactoryFunSetValue_B_NumOff ((u16)0x0000)
#define BtnFactoryFunSet_B_NumOff      ((u32)BtnFactoryFunSetAddr_B_Num*65536+BtnFactoryFunSetValue_B_NumOff)
#define BtnFactoryFunSetValue_B_NumOn  ((u16)0x0001)
#define BtnFactoryFunSet_B_NumOn       ((u32)BtnFactoryFunSetAddr_B_Num*65536+BtnFactoryFunSetValue_B_NumOn)

#define BtnFactoryFunSetAddr_AB_Num  ((u16)0x014F)
#define BtnFactoryFunSetValue_AB_NumOff ((u16)0x0000)
#define BtnFactoryFunSet_AB_NumOff      ((u32)BtnFactoryFunSetAddr_AB_Num*65536+BtnFactoryFunSetValue_AB_NumOff)
#define BtnFactoryFunSetValue_AB_NumOn  ((u16)0x0001)
#define BtnFactoryFunSet_AB_NumOn       ((u32)BtnFactoryFunSetAddr_AB_Num*65536+BtnFactoryFunSetValue_AB_NumOn)

#define BtnFactoryFunSetAddr_IdleLed  ((u16)0x014C)
#define BtnFactoryFunSetValue_IdleLedOff ((u16)0x0000)
#define BtnFactoryFunSet_IdleLedOff      ((u32)BtnFactoryFunSetAddr_IdleLed*65536+BtnFactoryFunSetValue_IdleLedOff)
#define BtnFactoryFunSetValue_IdleLedOn  ((u16)0x0001)
#define BtnFactoryFunSet_IdleLedOn       ((u32)BtnFactoryFunSetAddr_IdleLed*65536+BtnFactoryFunSetValue_IdleLedOn)

#define BtnFactoryFunSetAddr_Dehumi  ((u16)0x014E)
#define BtnFactoryFunSetValue_DehumiOff ((u16)0x0000)
#define BtnFactoryFunSet_DehumiOff      ((u32)BtnFactoryFunSetAddr_Dehumi*65536+BtnFactoryFunSetValue_DehumiOff)
#define BtnFactoryFunSetValue_DehumiOn  ((u16)0x0001)
#define BtnFactoryFunSet_DehumiOn       ((u32)BtnFactoryFunSetAddr_Dehumi*65536+BtnFactoryFunSetValue_DehumiOn)

#define BtnFactoryFunSetAddr_Door  ((u16)0x0150)
#define BtnFactoryFunSetValue_DoorOff ((u16)0x0000)
#define BtnFactoryFunSet_DoorOff      ((u32)BtnFactoryFunSetAddr_Door*65536+BtnFactoryFunSetValue_DoorOff)
#define BtnFactoryFunSetValue_DoorOn  ((u16)0x0001)
#define BtnFactoryFunSet_DoorOn       ((u32)BtnFactoryFunSetAddr_Door*65536+BtnFactoryFunSetValue_DoorOn)

#define BtnFactoryFunSetAddr_BatCellJud  ((u16)0x0151)
#define BtnFactoryFunSetValue_BatCellJudOff ((u16)0x0000)
#define BtnFactoryFunSet_BatCellJudOff      ((u32)BtnFactoryFunSetAddr_BatCellJud*65536+BtnFactoryFunSetValue_BatCellJudOff)
#define BtnFactoryFunSetValue_BatCellJudOn  ((u16)0x0001)
#define BtnFactoryFunSet_BatCellJudOn       ((u32)BtnFactoryFunSetAddr_BatCellJud*65536+BtnFactoryFunSetValue_BatCellJudOn)

#define BtnFactoryFunSetAddr_TopFan  ((u16)0x0152)
#define BtnFactoryFunSetValue_TopFanOff ((u16)0x0000)
#define BtnFactoryFunSet_TopFanOff      ((u32)BtnFactoryFunSetAddr_TopFan*65536+BtnFactoryFunSetValue_TopFanOff)
#define BtnFactoryFunSetValue_TopFanOn  ((u16)0x0001)
#define BtnFactoryFunSet_TopFanOn       ((u32)BtnFactoryFunSetAddr_TopFan*65536+BtnFactoryFunSetValue_TopFanOn)

#define BtnFactoryFunSetAddr_EleLock  ((u16)0x0153)
#define BtnFactoryFunSetValue_EleLockOff ((u16)0x0000)
#define BtnFactoryFunSet_EleLockOff      ((u32)BtnFactoryFunSetAddr_EleLock*65536+BtnFactoryFunSetValue_EleLockOff)
#define BtnFactoryFunSetValue_EleLockOn  ((u16)0x0001)
#define BtnFactoryFunSet_EleLockOn       ((u32)BtnFactoryFunSetAddr_EleLock*65536+BtnFactoryFunSetValue_EleLockOn)

#define BtnFactoryFunSetAddr_ACMeter  ((u16)0x0154)
#define BtnFactoryFunSetValue_ACMeterOff ((u16)0x0000)
#define BtnFactoryFunSet_ACMeterOff      ((u32)BtnFactoryFunSetAddr_ACMeter*65536+BtnFactoryFunSetValue_ACMeterOff)
#define BtnFactoryFunSetValue_ACMeterOn  ((u16)0x0001)
#define BtnFactoryFunSet_ACMeterOn       ((u32)BtnFactoryFunSetAddr_ACMeter*65536+BtnFactoryFunSetValue_ACMeterOn)

#define BtnFactoryFunSetAddr_SigUniChg  ((u16)0x0155)
#define BtnFactoryFunSetValue_SigUniChgOff ((u16)0x0000)
#define BtnFactoryFunSet_SigUniChgOff      ((u32)BtnFactoryFunSetAddr_SigUniChg*65536+BtnFactoryFunSetValue_SigUniChgOff)
#define BtnFactoryFunSetValue_SigUniChgOn  ((u16)0x0001)
#define BtnFactoryFunSet_SigUniChgOn       ((u32)BtnFactoryFunSetAddr_SigUniChg*65536+BtnFactoryFunSetValue_SigUniChgOn)

#define BtnFactoryFunSetAddr_NegContactor  ((u16)0x0156)
#define BtnFactoryFunSetValue_NegContactorOff ((u16)0x0000)
#define BtnFactoryFunSet_NegContactorOff      ((u32)BtnFactoryFunSetAddr_NegContactor*65536+BtnFactoryFunSetValue_NegContactorOff)
#define BtnFactoryFunSetValue_NegContactorOn  ((u16)0x0001)
#define BtnFactoryFunSet_NegContactorOn       ((u32)BtnFactoryFunSetAddr_NegContactor*65536+BtnFactoryFunSetValue_NegContactorOn)

void FactoryFunSetPaint(void)
{
  u16 TempU16;

  if(0 != UserParam.ChgFun.Value.Num_A)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_A_Num, TempU16);

  if(0 != UserParam.ChgFun.Value.Num_B)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_B_Num, TempU16);

    if(0 != UserParam.ChgFun.Value.Num_AB)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_AB_Num, TempU16);

  if(0 != UserParam.ChgFun.Value.IdleLed)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_IdleLed, TempU16);

  if(0 != UserParam.ChgFun.Value.Dehumi)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_Dehumi, TempU16);

  if(0 != UserParam.ChgFun.Value.Door)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_Door, TempU16);

  if(0 != UserParam.ChgFun.Value.BatCellJud)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_BatCellJud, TempU16);

  if(0 != UserParam.ChgFun.Value.TopFan)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_TopFan, TempU16);

  if(0 != UserParam.ChgFun.Value.EleLock)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_EleLock, TempU16);

  if(0 != UserParam.ChgFun.Value.ACMeter)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_ACMeter, TempU16);

  if(0 != UserParam.ChgFun.Value.SigUniChg)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_SigUniChg, TempU16);

  if(0 != UserParam.ChgFun.Value.NegContactor)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnFactoryFunSetAddr_NegContactor, TempU16);

  LcdShowPage(ScrnFactoryFunctionSet);
}

#define TimeOutTime   (40*1000)

void LcdProFactoryFunSet(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 TimeOutTick;
  u32 KeyValue;
  UnionChgFunctional ChgFunVal;


  ChgFunVal.Mult = UserParam.ChgFun.Mult;
  TimeOutTick = GetSystemTick();

  FactoryFunSetPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            KeyValue = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnFactoryFunctionSet != KeyValue)
              LcdShowPage(ScrnFactoryFunctionSet);
          }
          break;
        case eLcdCmd_RdVar:
          KeyValue  = Frame.Ctrl.RdVar.AddrH << 24;
          KeyValue += Frame.Ctrl.RdVar.AddrL << 16;
          KeyValue += Frame.Ctrl.RdVar.Data[0] << 8;
          KeyValue += Frame.Ctrl.RdVar.Data[1];
          switch(KeyValue)
          {
            case BtnFactoryFunSet_Cancel:  //A ǹ"" 
              TimeOutTick = GetSystemTick();
              pLcdCtrl->CurScreen = eLcdPro_FactoryProtSet;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryFunSet_Enter:
              TimeOutTick = GetSystemTick();

              UserParam.ChgFun.Mult = ChgFunVal.Mult;

              SaveUserParam((u8*)&UserParam, sizeof(UserParam));
              UserParamInit();

              pLcdCtrl->CurScreen = eLcdPro_FactoryProtSet;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryFunSet_Next:
              TimeOutTick = GetSystemTick();

              break;
            case BtnFactoryFunSet_Last:
              TimeOutTick = GetSystemTick();

              break;

            case BtnFactoryFunSet_A_NumOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Num_A = 0;
              break;
            case BtnFactoryFunSet_A_NumOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Num_A = 1;
              break;

            case BtnFactoryFunSet_B_NumOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Num_B = 0;
              break;
            case BtnFactoryFunSet_B_NumOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Num_B = 1;
              break;

            case BtnFactoryFunSet_AB_NumOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Num_AB = 0;
              break;
            case BtnFactoryFunSet_AB_NumOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Num_AB = 1;
              break;

            case BtnFactoryFunSet_IdleLedOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.IdleLed = 0;
              break;
            case BtnFactoryFunSet_IdleLedOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.IdleLed = 1;
              break;
            //ʪBǹ ¶Ƚӿ
            case BtnFactoryFunSet_DehumiOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Dehumi = 0;
              break;
            case BtnFactoryFunSet_DehumiOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Dehumi = 1;
              break;

            case BtnFactoryFunSet_DoorOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Door = 0;
              break;
            case BtnFactoryFunSet_DoorOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.Door = 1;
              break;

            case BtnFactoryFunSet_BatCellJudOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.BatCellJud = 0;
              break;
            case BtnFactoryFunSet_BatCellJudOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.BatCellJud = 1;
              break;

            case BtnFactoryFunSet_TopFanOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.TopFan = 0;
              break;
            case BtnFactoryFunSet_TopFanOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.TopFan = 1;
              break;

            case BtnFactoryFunSet_ACMeterOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.ACMeter = 0;
              break;
            case BtnFactoryFunSet_ACMeterOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.ACMeter = 1;
              break;

            case BtnFactoryFunSet_EleLockOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.EleLock = 0;
              break;
            case BtnFactoryFunSet_EleLockOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.EleLock = 1;
              break;
            //ǹ˫ǹ以 
            case BtnFactoryFunSet_SigUniChgOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.SigUniChg = 0;
              break;
            case BtnFactoryFunSet_SigUniChgOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.SigUniChg = 1;
              break;

            case BtnFactoryFunSet_NegContactorOff:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.NegContactor = 0;
              break;
            case BtnFactoryFunSet_NegContactorOn:
              TimeOutTick = GetSystemTick();
              ChgFunVal.Value.NegContactor = 1;
              break;

            default:
              LcdShowPage(ScrnFactoryFunctionSet);
              break;
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    if(eLcdPro_FactoryFunctionSet != pLcdCtrl->CurScreen)
      return;

    osDelay(100);
  }
}



