
#include "Thd_Lcd.h"

#define ScrnFactoryPillarInputSet            ((u16)61)
#define BtnFactoryPillarInputSet_Enter       ((u16)0x6101)
#define BtnFactoryPillarInputSet_Cancel      ((u16)0x6102)

#define BtnFactoryPillarInputSet_Next        ((u16)0x000B)
#define BtnFactoryPillarInputSet_Last        ((u16)0x000A)

#define VarFactoryPillarInputSet_VoltHigh     ((u16)0x003A)
#define VarFactoryPillarInputSet_VoltLow     ((u16)0x003B)

#define TextFactoryPillarInputSet_Tip        ((u16)0x4000)


void FactoryPillarInputSetPaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str)," ");
  LcdShowStr(TextFactoryPillarInputSet_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowData16(VarFactoryPillarInputSet_VoltHigh, UserParam.VoltHigh);
  LcdShowData16(VarFactoryPillarInputSet_VoltLow, UserParam.VoltLow);

  LcdShowPage(ScrnFactoryPillarInputSet);
}

void FactoryPillarInputSetIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProFactoryPillarInputSet(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u16 VoltHighTemp;
  u16 VoltLowTemp;

  VoltHighTemp = UserParam.VoltHigh;
  VoltLowTemp = UserParam.VoltLow;

  TimeOutTick = GetSystemTick();

  FactoryPillarInputSetPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnFactoryPillarInputSet_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryPillarInputSet_Enter:
                TimeOutTick = GetSystemTick();
                UserParam.VoltHigh = VoltHighTemp;
                UserParam.VoltLow = VoltLowTemp;

                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryPillarInputSet_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_FactoryProtSet;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryPillarInputSet_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_FactoryDcModSet;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnFactoryPillarInputSet);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnFactoryPillarInputSet);
            if(VarFactoryPillarInputSet_VoltHigh == Temp)
              VoltHighTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarFactoryPillarInputSet_VoltLow == Temp)
              VoltLowTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_FactoryPillarInputSet != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    FactoryPillarInputSetIdle();

    osDelay(100);
  }
}

