
#include "Thd_Lcd.h"

#define ScrnMainMenuSingle     ((u16)1)
#define ScrnMainMenuDouble     ((u16)103)

#define BtnMainMenu_Start      ((u16)0x0101)
#define BtnMainMenu_Manage     ((u16)0x0102)

#define BtnMainMenu_Start_B      ((u16)0x1030)
#define BtnMainMenu_Start_AB      ((u16)0x1031)
#define BtnElock_A_Off      ((u16)0x1115)
#define BtnElock_B_Off      ((u16)0x1116)
#define Elock_Key_Show      ((u16)0x003D)
#define Elock_Key_Show_B    ((u16)0x003E)

#define TextMainMenu_PillarNum ((u16)0x40E0)
#define TextMainMenu_TelNum    ((u16)0x4100)
#define QrMainMenu_PillarNum        ((u16)0x6B00)
#define VarMainMenu_NetWork         ((u16)0x0019)

#define __pQrStr__  "%02X%02X%02X%02X%02X%02X%02X%02X"

u16 ScrnMainMenu;

void PaintQr(void)
{
  char Str[128];

  memset(Str, 0xFF, sizeof(Str));
  snprintf((char*)Str, sizeof(Str),"%s"__pQrStr__, UserParam.DealQrcode, UserParam.PillarNum[0], UserParam.PillarNum[1], UserParam.PillarNum[2], UserParam.PillarNum[3],
                                             UserParam.PillarNum[4], UserParam.PillarNum[5], UserParam.PillarNum[6], UserParam.PillarNum[7]);

  LcdShowStr(QrMainMenu_PillarNum, (u8*)Str, strlen(Str)+2);
}

void NetLedOn(void)
{
  LcdShowData16(VarMainMenu_NetWork, 1);
}

void NetLedOff(void)
{
  LcdShowData16(VarMainMenu_NetWork, 0);
}

void PaintPillarInfor(void)
{
  char Str[64];

  PaintQr();

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X", UserParam.PillarNum[0],UserParam.PillarNum[1],
            UserParam.PillarNum[2], UserParam.PillarNum[3], UserParam.PillarNum[4], UserParam.PillarNum[5], UserParam.PillarNum[6], UserParam.PillarNum[7]);
  LcdShowStr(TextMainMenu_PillarNum, (u8 *)Str, (strlen(Str)+1));

  LcdShowStr(TextMainMenu_TelNum, (u8 *)UserParam.TelNum_1, sizeof(UserParam.TelNum_1));
}

void CloseKeyBoard(void)
{
  u8 Cmd[1] = {0x5A};

  LcdWriteReg(0x4F, Cmd, sizeof(Cmd));
}

void MainMenuPaint(void)
{
  PaintQr();
  PaintPillarInfor();

  LcdShowPage(ScrnMainMenu);
}

void MainMenuIdle(void)
{
  PaintQr();
  PaintPillarInfor();
}

void LcdProMainMenu(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructTime Time;
  u32 TimeSynTick;

  u32 PaintTick;

  u32 BtnManageTick;
  u8  BtnManageCounter;

  u8 Qr[8];
  u8 PaintCount = 0;

  u8 Cmd[1],i,j;

  memcpy(Qr, UserParam.PillarNum, sizeof(Qr));

  ChargeEnable = 0;
  ChargePauseFlag = 0;
  ChargeEnable_B = 0;
  ChargePauseFlag_B = 0;
  pCurChgRecd_AB = NULL;
  LockSet(eSwSta_Off);
  LockSet_B(eSwSta_Off);
  ChargeEnable_AB = 0;

  //IdleLedSet(eSwSta_On);

  //ChgLedSet(eSwSta_Off);
  if(0 != UserParam.ChgFun.Value.Num_B)
    ScrnMainMenu = ScrnMainMenuDouble;
  else
    ScrnMainMenu = ScrnMainMenuSingle;

  ScreenChkTick = GetSystemTick();
  MainMenuPaint();

  PaintTick = GetSystemTick();

  TimeSynTick = GetSystemTick();
  LcdGetRtc();

  BtnManageTick = GetSystemTick();
  BtnManageCounter = 0;

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnMainMenu != Temp)
              LcdShowPage(ScrnMainMenu);
          }
          else if(eLcdRegAddr_Rtc == Frame.Ctrl.RdReg.Addr)
          {
            Time.Year = 2000 + BcdToHex(Frame.Ctrl.RdReg.Data[0]);          //  
            Time.Mon = BcdToHex(Frame.Ctrl.RdReg.Data[1] & 0x1F);      //  
            Time.Day = BcdToHex(Frame.Ctrl.RdReg.Data[2] & 0x3F);      //  
                    //Frame.Ctrl.RdReg.Data[3]
            Time.Hour = BcdToHex(Frame.Ctrl.RdReg.Data[4] & 0x3F);      //  Сʱ
            Time.Min = BcdToHex(Frame.Ctrl.RdReg.Data[5] & 0x7F);      //  
            Time.Sec = BcdToHex(Frame.Ctrl.RdReg.Data[6] &0x7F);      //  

            RtcSetTime(GetExtOrLcdStamp(&Time));
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnMainMenu_Start:
                if(
                    (0 != PillarError.Value.Emergency)
                    || (0 != PillarError.Value.NoDcmod)
                    || (0 != PillarError.Value.Insulation)
                    || (0 != PillarError.Value.ImdDev)// && (eChgVer_2011 != UserParam.ChgVer))
                    || (0 != PillarError.Value.DrainResist)
                    || (0 != PillarError.Value.Reader)
                    || (0 != PillarError.Value.Meter)
                    || (0 != PillarError.Value.ACMeter)
                    || (0 != PillarError.Value.Memory)
                    || (0 != PillarError.Value.Lcd)
                    || (0 != PillarError.Value.Contactor)
                    || (0 != PillarError.Value.UniContactor)
                    || (0 != PillarError.Value.Door)
                    || (0 != PillarError.Value.SPD)
                    || (0 != PillarError.Value.InVolt)
                    || (0 != PillarError.Value.OutVolt)
                    || (0 != PillarError.Value.OutCurrt)
                    || (0 != PillarError.Value.EleLock)
                    || (0 != PillarError.Value.Humiture)
                    || (UserParam.HadSigned && (0 != PillarError.Value.Net))
                    || (0 == UserParam.ChgFun.Value.Num_A)
                  )
                {
                  pLcdCtrl->CurScreen = eLcdPro_PillarError;
                  pLcdCtrl->Param = 0;
                }
                else
                {
                  pLcdCtrl->CurScreen = eLcdPro_GetCard;
                  //pLcdCtrl->CurScreen = eLcdPro_CnctDetect;
                  pLcdCtrl->Param = 0;
                }
                break;
              case BtnMainMenu_Start_B:
                if(
                    (0 != PillarError_B.Value.Emergency)
                    || (0 != PillarError_B.Value.NoDcmod)
                    || (0 != PillarError_B.Value.Insulation)
                    || (0 != PillarError_B.Value.ImdDev)// && (eChgVer_2011 != UserParam.ChgVer))
                    || (0 != PillarError_B.Value.DrainResist)
                    || (0 != PillarError_B.Value.Reader)
                    || (0 != PillarError_B.Value.Meter)
                    || (0 != PillarError_B.Value.ACMeter)
                    || (0 != PillarError_B.Value.Memory)
                    || (0 != PillarError_B.Value.Lcd)
                    || (0 != PillarError_B.Value.Contactor)
                    || (0 != PillarError_B.Value.UniContactor)
                    || (0 != PillarError_B.Value.Door)
                    || (0 != PillarError_B.Value.SPD)
                    || (0 != PillarError_B.Value.InVolt)
                    || (0 != PillarError_B.Value.OutVolt)
                    || (0 != PillarError_B.Value.OutCurrt)
                    || (0 != PillarError_B.Value.EleLock)
                    || (0 != PillarError_B.Value.Humiture)
                    || (UserParam.HadSigned && (0 != PillarError_B.Value.Net))
                    || (0 == UserParam.ChgFun.Value.Num_B)
                  )
                {
                  pLcdCtrl->CurScreen = eLcdPro_B_PillarError;
                  pLcdCtrl->Param = 0;
                }
                else
                {
                  pLcdCtrl->CurScreen = eLcdPro_B_GetCard;
                  //pLcdCtrl->CurScreen = eLcdPro_CnctDetect;
                  pLcdCtrl->Param = 0;
                }
                break;
              case BtnMainMenu_Start_AB:
                if(
                    (0 != PillarError_B.Value.Emergency)
                    || (0 != PillarError_B.Value.NoDcmod)
                    || (0 != PillarError_B.Value.Insulation)
                    || (0 != PillarError_B.Value.ImdDev)// && (eChgVer_2011 != UserParam.ChgVer))
                    || (0 != PillarError_B.Value.DrainResist)
                    || (0 != PillarError_B.Value.Reader)
                    || (0 != PillarError_B.Value.Meter)
                    || (0 != PillarError_B.Value.ACMeter)
                    || (0 != PillarError_B.Value.Memory)
                    || (0 != PillarError_B.Value.Lcd)
                    || (0 != PillarError_B.Value.Contactor)
                    || (0 != PillarError_B.Value.UniContactor)
                    || (0 != PillarError_B.Value.Door)
                    || (0 != PillarError_B.Value.SPD)
                    || (0 != PillarError_B.Value.InVolt)
                    || (0 != PillarError_B.Value.OutVolt)
                    || (0 != PillarError_B.Value.OutCurrt)
                    || (0 != PillarError_B.Value.EleLock)
                    || (0 != PillarError_B.Value.Humiture)
                    || (UserParam.HadSigned && (0 != PillarError_B.Value.Net))
                    || (0 != PillarError.Value.Emergency)
                    || (0 != PillarError.Value.NoDcmod)
                    || (0 != PillarError.Value.Insulation)
                    || (0 != PillarError.Value.ImdDev)// && (eChgVer_2011 != UserParam.ChgVer))
                    || (0 != PillarError.Value.DrainResist)
                    || (0 != PillarError.Value.Reader)
                    || (0 != PillarError.Value.Meter)
                    || (0 != PillarError.Value.ACMeter)
                    || (0 != PillarError.Value.Memory)
                    || (0 != PillarError.Value.Lcd)
                    || (0 != PillarError.Value.Contactor)
                    || (0 != PillarError.Value.UniContactor)
                    || (0 != PillarError.Value.Door)
                    || (0 != PillarError.Value.SPD)
                    || (0 != PillarError.Value.InVolt)
                    || (0 != PillarError.Value.OutVolt)
                    || (0 != PillarError.Value.OutCurrt)
                    || (0 != PillarError.Value.EleLock)
                    || (0 != PillarError.Value.Humiture)
                    || (UserParam.HadSigned && (0 != PillarError.Value.Net))
                    || (0 == UserParam.ChgFun.Value.Num_A)
                    || (0 == UserParam.ChgFun.Value.Num_B)
                    || (0 == UserParam.ChgFun.Value.Num_AB)
                  )
                {
                  pLcdCtrl->CurScreen = eLcdPro_AB_PillarError;
                  pLcdCtrl->Param = 0;
                }
                else
                {
                  pLcdCtrl->CurScreen = eLcdPro_AB_GetCard;
                  //pLcdCtrl->CurScreen = eLcdPro_CnctDetect;
                  pLcdCtrl->Param = 0;
                }
                break;
              case BtnMainMenu_Manage:
                if((GetSystemTick() - BtnManageTick) >= 1000)
                  BtnManageCounter = 0;
                else
                {
                  BtnManageCounter++;
                  if(BtnManageCounter > 2)
                  {
                    pLcdCtrl->CurScreen = eLcdPro_ManagePwd;
                  //  pLcdCtrl->CurScreen =  eLcdPro_ManageSelect;
                    pLcdCtrl->Param = 0;
                  }
                }
                BtnManageTick = GetSystemTick();
                break;
              case BtnElock_A_Off:
                if(LockGet()!=eSwSta_Off)
                {
                  Cmd[0]=0x06;
                  LcdWriteReg(0x4F, Cmd, sizeof(Cmd));
                  for(i=0;i<8;i++)
                  {
                    LockSet(eSwSta_On);
                    osDelay(500);
                    LockSet(eSwSta_Off);
                    osDelay(500);
                    for(j=0;j<10;j++)
                    {
                      if(LockGet()!=eSwSta_Off) break;
                      osDelay(10);
                    }
                    if(j>=10) break;
                    osDelay(1000);
                  }
                  CloseKeyBoard();
                }
                break;
              case BtnElock_B_Off:
                if(LockGet_B()!=eSwSta_Off)
                {
                  Cmd[0]=0x08;
                  LcdWriteReg(0x4F, Cmd, sizeof(Cmd));
                  for(i=0;i<8;i++)
                  {
                    LockSet_B(eSwSta_On);
                    osDelay(500);
                    LockSet_B(eSwSta_Off);
                    osDelay(500);
                    for(j=0;j<10;j++)
                    {
                      if(LockGet_B()!=eSwSta_Off) break;
                      osDelay(10);
                    }
                    if(j>=10) break;
                    osDelay(1000);
                  }
                  CloseKeyBoard();
                }
                break;
              default:
                LcdShowPage(ScrnMainMenu);
                break;
              }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_MainMenu != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeSynTick) >= RtcSynTime)
    {
      TimeSynTick = GetSystemTick();
      LcdGetRtc();
    }

    if((GetSystemTick() - PaintTick) >= (5000))
    {
      PaintTick = GetSystemTick();
      PaintCount++;
      if((PaintCount > 14) || (0 != memcmp(Qr, UserParam.PillarNum, sizeof(Qr))))
      {
        PaintCount = 0;
        MainMenuIdle();
      }
    }

    LcdShowData16(Elock_Key_Show, !LockGet());
    LcdShowData16(Elock_Key_Show_B, !LockGet_B());

    osDelay(100);
  }
}

