
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnManagePwd  ((u16)27)

#define BtnManagePwd_Cancel     ((u16)0x2701)
#define BtnManagePwd_Log        ((u16)0x2702)

#define TextManagePwd_Pwd       ((u16)0x3000)
#define InputManagePwd_Pwd      ((u16)0x3008)

#define TextManagePwd_Tip       ((u16)0x4000)

#define TextManagePswd_SwVer      ((u16)0x40D0)

static const char *pStrManagePwd[] =
{
  "롣",
  "볤Ȳ㣬䡣",
  "䡣",
  "***",
  "******"
};

void ManagePwdPaint(void)
{
  char Str[64];

  LcdWriteVar(TextManagePwd_Pwd, (u8*)pStrManagePwd[4], strlen(pStrManagePwd[4])+1);
  LcdShowStr(TextManagePwd_Tip, (u8*)pStrManagePwd[0], strlen(pStrManagePwd[0])+1);
  if(0 == UserParam.ChgFun.Value.Num_B)
    snprintf((char*)Str, sizeof(Str),"SW Ver:%dVǹV%X.%02X", DcModuleAbility.MaxVolt/10, (u8)(__SoftVer__>>8),(u8)(__SoftVer__&0xff));
  else
    snprintf((char*)Str, sizeof(Str),"SW Ver:%dV˫ǹV%X.%02X", DcModuleAbility.MaxVolt/10, (u8)(__SoftVer__>>8),(u8)(__SoftVer__&0xff));
  LcdShowStr(TextManagePswd_SwVer, (u8*)Str, strlen(Str)+1);

  LcdShowPage(ScrnManagePwd);
}

void ManagePwdUpdate(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (20*1000)

void LcdProManagePwd(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  u32 TimeOutTick;
  u32 BtnManageTick;
  u8  BtnManageCounter;

  BtnManageTick = GetSystemTick();
  BtnManageCounter = 0;

  //IdleLedSet(eSwSta_Off);

  //ChgLedSet(eSwSta_Off);
  ScreenChkTick = GetSystemTick();
  ManagePwdPaint();
  TimeOutTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnManagePwd != Temp)
              LcdShowPage(ScrnManagePwd);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnManagePwd_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->Param = 0;
                break;
              case BtnManagePwd_Log:  //A ǹ"" 
                if((GetSystemTick() - BtnManageTick) >= 1000)
                  BtnManageCounter = 0;
                else
                {
                  BtnManageCounter++;
                  if(BtnManageCounter > 2)
                  {
                    pLcdCtrl->CurScreen = eLcdPro_InforChgRecdLog;
                    pLcdCtrl->Param = 0;
                  }
                }
                BtnManageTick = GetSystemTick();
                break;
              default:
                LcdShowPage(ScrnManagePwd);
                break;
            }
          }
          else if(InputManagePwd_Pwd == Temp)
          {
            TimeOutTick = GetSystemTick();
            if((Frame.Ctrl.RdVar.Len < 4) || ((4 == Frame.Ctrl.RdVar.Len) &&  (00 == Frame.Ctrl.RdVar.Data[7])))
            {
              LcdWriteVar(TextManagePwd_Pwd, (u8*)pStrManagePwd[3], strlen(pStrManagePwd[3])+1);
              LcdWriteVar(TextManagePwd_Tip, (u8*)pStrManagePwd[1], strlen(pStrManagePwd[1])+1);
            }
            else
            {
              LcdWriteVar(TextManagePwd_Pwd, (u8*)pStrManagePwd[4], strlen(pStrManagePwd[4])+1);
              if(0 == (memcmp(UserParam.SysPwd, Frame.Ctrl.RdVar.Data, 6)))
              {
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
              }
              else
                LcdWriteVar(TextManagePwd_Tip, (u8*)pStrManagePwd[2], strlen(pStrManagePwd[2])+1);
            }
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_ManagePwd != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      TimeOutTick = GetSystemTick();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    ManagePwdUpdate();

    osDelay(100);
  }
}



