
#include "Thd_Lcd.h"

#define ScrnManageSelect            ((u16)29)
#define BtnManageSelect_Cancel      ((u16)0x2901)

#define BtnManageSelect_Set         ((u16)0x2902)
#define BtnManageSelect_Infor       ((u16)0x2903)
#define BtnManageSelect_Debug       ((u16)0x2904)

void ManageSelectPaint(void)
{
  LcdShowPage(ScrnManageSelect);
}

void ManageSelectIdle(void)
{

}

#define TimeOutTime   (20*1000)

void LcdProManageSelect(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  TimeOutTick = GetSystemTick();
  ManageSelectPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnManageSelect_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->Param = 0;
                break;

              case BtnManageSelect_Set:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetRtc;
                pLcdCtrl->Param = 0;
                break;

              case BtnManageSelect_Infor:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_InforLogClean;
                pLcdCtrl->Param = 0;
                break;

              case BtnManageSelect_Debug:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_FactoryTest;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnManageSelect);
                break;
            }
          }
          else
            LcdShowPage(ScrnManageSelect);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_ManageSelect != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    ManageSelectIdle();

    osDelay(100);
  }
}




