
#include "Thd_Lcd.h"

#define ScrnSetHumiture            ((u16)55)
#define BtnSetHumiture_Enter       ((u16)0x5501)
#define BtnSetHumiture_Cancel      ((u16)0x5502)

#define BtnSetHumiture_Next        ((u16)0x000B)
#define BtnSetHumiture_Last        ((u16)0x000A)

#define VarHumiture_EnviTemp    ((u16)0x0052)
#define VarHumiture_Humi        ((u16)0x0053)
#define VarHumiture_Temp        ((u16)0x0054)

#define VarHumiture_EnviTemp1    ((u16)0x0055)
#define VarHumiture_EnviTemp2    ((u16)0x0056)
#define VarHumiture_EnviTemp3    ((u16)0x0057)

#define VarSetHumiture_Alam   ((u16)0x012F)
#define VarSetHumiture_Fault     ((u16)0x0130)

#define TextSetHumiture_Tip        ((u16)0x4000)


void SetHumiturePaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str)," ");
  LcdShowStr(TextSetHumiture_Tip, (u8 *)Str, (strlen(Str)+1));
  LcdShowData16(VarHumiture_EnviTemp,  Adc_Get_a_PTemp());
  LcdShowData16(VarHumiture_EnviTemp1, Adc_Get_a_NTemp());
  LcdShowData16(VarHumiture_EnviTemp2, Adc_Get_B_PTemp());
  LcdShowData16(VarHumiture_EnviTemp3, Adc_Get_B_NTemp());

  LcdShowData16(VarHumiture_Humi, Dht12_GetHumi());
  LcdShowData16(VarHumiture_Temp, Dht12_GetTemp());

  LcdShowData16(VarSetHumiture_Alam, UserParam.AlarmTemp*10);
  LcdShowData16(VarSetHumiture_Fault, UserParam.FaultTemp);


  LcdShowPage(ScrnSetHumiture);
}

void SetHumitureIdle(void)
{

  LcdShowData16(VarHumiture_EnviTemp, (u16)Adc_GetNtcTemp());
  LcdShowData16(VarHumiture_Humi, Dht12_GetHumi());
  LcdShowData16(VarHumiture_Temp, Dht12_GetTemp());
  LcdShowData16(VarHumiture_EnviTemp1, Adc_Get_a_NTemp());
  LcdShowData16(VarHumiture_EnviTemp2, Adc_Get_B_PTemp());
  LcdShowData16(VarHumiture_EnviTemp3, Adc_Get_B_NTemp());
}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetHumiture(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u16 TempDiffTemp;
  u16 SuitTempDiffTemp;
  u32 NTCDivisionValTemp;
  u16 NTCBValTemp;

  TempDiffTemp = UserParam.TempDiff;
  SuitTempDiffTemp = UserParam.SuitTempDiff;
  NTCDivisionValTemp = UserParam.AlarmTemp;
  NTCBValTemp = UserParam.FaultTemp;

  TimeOutTick = GetSystemTick();

  SetHumiturePaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetHumiture_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetHumiture_Enter:
                TimeOutTick = GetSystemTick();
                UserParam.AlarmTemp= NTCDivisionValTemp;
                UserParam.FaultTemp= NTCBValTemp;

                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetHumiture_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetTel;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetHumiture_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetReader;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetHumiture);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetHumiture);
            if(VarSetHumiture_Alam == Temp)
              NTCDivisionValTemp = (Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1])/10;
            else if(VarSetHumiture_Fault== Temp)
              NTCBValTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetHumiture != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetHumitureIdle();

    osDelay(100);
  }
}


