
/******************************************************************************
ļ  : Lcd_SetIp.c
  : Һʾ棬Aǹˢ
  :
޸  : 2015-04-10      

******************************************************************************/

#include "Thd_Lcd.h"


#define PageSetIp            ((u16)38)
#define BtnSetIp_Enter       ((u16)0x3801)
#define BtnSetIp_Cancel      ((u16)0x3802)
#define BtnSetMac_Addr       ((u16)0x3803)

#define BtnSetIp_Next        ((u16)0x000B)
#define BtnSetIp_Last        ((u16)0x000A)

#define VarSetIp_ServeIp0     ((u16)0x003D)
#define VarSetIp_ServeIp1     ((u16)0x003E)
#define VarSetIp_ServeIp2     ((u16)0x003F)
#define VarSetIp_ServeIp3     ((u16)0x0040)
#define VarSetIp_ServePort    ((u16)0x0041)

#define VarSetIp_Register     ((u16)0x0042)

#define VarSetIp_LocalIp0     ((u16)0x0043)
#define VarSetIp_LocalIp1     ((u16)0x0044)
#define VarSetIp_LocalIp2     ((u16)0x0045)
#define VarSetIp_LocalIp3     ((u16)0x0046)

#define VarSetIp_SubIp0       ((u16)0x0047)
#define VarSetIp_SubIp1       ((u16)0x0048)
#define VarSetIp_SubIp2       ((u16)0x0049)
#define VarSetIp_SubIp3       ((u16)0x004A)

#define VarSetIp_GwIp0        ((u16)0x004B)
#define VarSetIp_GwIp1        ((u16)0x004C)
#define VarSetIp_GwIp2        ((u16)0x004D)
#define VarSetIp_GwIp3        ((u16)0x004E)


#define TextSetIp_Tip        ((u16)0x4000)


void SetIpPaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str)," ");
  LcdShowStr(TextSetIp_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowData16(VarSetIp_ServeIp0, UserParam.ServerAddr.Ip[0]);
  LcdShowData16(VarSetIp_ServeIp1, UserParam.ServerAddr.Ip[1]);
  LcdShowData16(VarSetIp_ServeIp2, UserParam.ServerAddr.Ip[2]);
  LcdShowData16(VarSetIp_ServeIp3, UserParam.ServerAddr.Ip[3]);
  LcdShowData16(VarSetIp_ServePort, UserParam.ServerAddr.Port);

  LcdShowData16(VarSetIp_Register, UserParam.HadSigned);

  LcdShowData16(VarSetIp_LocalIp0, UserParam.LocalIp[0]);
  LcdShowData16(VarSetIp_LocalIp1, UserParam.LocalIp[1]);
  LcdShowData16(VarSetIp_LocalIp2, UserParam.LocalIp[2]);
  LcdShowData16(VarSetIp_LocalIp3, UserParam.LocalIp[3]);

  LcdShowData16(VarSetIp_SubIp0, UserParam.SubIp[0]);
  LcdShowData16(VarSetIp_SubIp1, UserParam.SubIp[1]);
  LcdShowData16(VarSetIp_SubIp2, UserParam.SubIp[2]);
  LcdShowData16(VarSetIp_SubIp3, UserParam.SubIp[3]);

  LcdShowData16(VarSetIp_GwIp0, UserParam.GwIp[0]);
  LcdShowData16(VarSetIp_GwIp1, UserParam.GwIp[1]);
  LcdShowData16(VarSetIp_GwIp2, UserParam.GwIp[2]);
  LcdShowData16(VarSetIp_GwIp3, UserParam.GwIp[3]);


  LcdShowPage(PageSetIp);
}

void SetIpIdle(void)
{

}

extern void CloseKeyBoard(void);
extern void SetServerIp(void);

#define TimeOutTime   (60*1000)

void LcdProSetIp(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u32 TimeBtnMACAddrTick;
  u16 ServeIp[4];
  u16 ServePort;
  u16 HadSignedTemp;
  u16 LocalIpTemp[4];
  u16 SubIpTemp[4];
  u16 GwIpTemp[4];
  u8  BtnMACAddrCounter;

  ServeIp[0] = UserParam.ServerAddr.Ip[0];
  ServeIp[1] = UserParam.ServerAddr.Ip[1];
  ServeIp[2] = UserParam.ServerAddr.Ip[2];
  ServeIp[3] = UserParam.ServerAddr.Ip[3];
  ServePort  = UserParam.ServerAddr.Port;

  HadSignedTemp = UserParam.HadSigned;

  LocalIpTemp[0] = UserParam.LocalIp[0];
  LocalIpTemp[1] = UserParam.LocalIp[1];
  LocalIpTemp[2] = UserParam.LocalIp[2];
  LocalIpTemp[3] = UserParam.LocalIp[3];

  SubIpTemp[0] = UserParam.SubIp[0];
  SubIpTemp[1] = UserParam.SubIp[1];
  SubIpTemp[2] = UserParam.SubIp[2];
  SubIpTemp[3] = UserParam.SubIp[3];

  GwIpTemp[0] = UserParam.GwIp[0];
  GwIpTemp[1] = UserParam.GwIp[1];
  GwIpTemp[2] = UserParam.GwIp[2];
  GwIpTemp[3] = UserParam.GwIp[3];

  TimeOutTick = GetSystemTick();
  TimeBtnMACAddrTick = GetSystemTick();
  BtnMACAddrCounter = 0;

  SetIpPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetMac_Addr:
                if((GetSystemTick() - TimeBtnMACAddrTick) >= 1000)
                  BtnMACAddrCounter = 0;
                else
                {
                  BtnMACAddrCounter++;
                  if(BtnMACAddrCounter > 2)
                  {
                    pLcdCtrl->CurScreen = eLcdPro_SetMAC;
                    pLcdCtrl->Param = 0;
                  }
                }
                TimeBtnMACAddrTick = GetSystemTick();
                break;

              case BtnSetIp_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetIp_Enter:
                TimeOutTick = GetSystemTick();
                UserParam.ServerAddr.Ip[0] = ServeIp[0];
                UserParam.ServerAddr.Ip[1] = ServeIp[1];
                UserParam.ServerAddr.Ip[2] = ServeIp[2];
                UserParam.ServerAddr.Ip[3] = ServeIp[3];
                UserParam.ServerAddr.Port = ServePort;

                UserParam.HadSigned = HadSignedTemp;

                UserParam.LocalIp[0] = LocalIpTemp[0];
                UserParam.LocalIp[1] = LocalIpTemp[1];
                UserParam.LocalIp[2] = LocalIpTemp[2];
                UserParam.LocalIp[3] = LocalIpTemp[3];

                UserParam.SubIp[0] = SubIpTemp[0];
                UserParam.SubIp[1] = SubIpTemp[1];
                UserParam.SubIp[2] = SubIpTemp[2];
                UserParam.SubIp[3] = SubIpTemp[3];

                UserParam.GwIp[0] = GwIpTemp[0];
                UserParam.GwIp[1] = GwIpTemp[1];
                UserParam.GwIp[2] = GwIpTemp[2];
                UserParam.GwIp[3] = GwIpTemp[3];
///////////////////////////////////////////////////////////////////////////////////////
                SetServerIp();
///////////////////////////////////////////////////////////////////////////////////////
                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetIp_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetCard;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetIp_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetEmployRate;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(PageSetIp);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(PageSetIp);
            if(VarSetIp_ServeIp0 == Temp)
              ServeIp[0] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_ServeIp1 == Temp)
              ServeIp[1] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_ServeIp2 == Temp)
              ServeIp[2] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_ServeIp3 == Temp)
              ServeIp[3] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_ServePort == Temp)
              ServePort = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_Register == Temp)
              HadSignedTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_LocalIp0 == Temp)
              LocalIpTemp[0] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_LocalIp1 == Temp)
              LocalIpTemp[1] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_LocalIp2 == Temp)
              LocalIpTemp[2] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_LocalIp3 == Temp)
              LocalIpTemp[3] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_SubIp0 == Temp)
              SubIpTemp[0] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_SubIp1 == Temp)
              SubIpTemp[1] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_SubIp2 == Temp)
              SubIpTemp[2] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_SubIp3 == Temp)
              SubIpTemp[3] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_GwIp0 == Temp)
              GwIpTemp[0] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_GwIp1 == Temp)
              GwIpTemp[1] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_GwIp2 == Temp)
              GwIpTemp[2] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetIp_GwIp3 == Temp)
              GwIpTemp[3] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetIp != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetIpIdle();

    osDelay(100);
  }
}









