
#include "Thd_Lcd.h"

#define ScrnSetMAC            ((u16)62)
#define BtnSetMAC_Enter       ((u16)0x6201)
#define BtnSetMAC_Cancel      ((u16)0x6202)

#define BtnSetMAC_Next        ((u16)0x000B)
#define BtnSetMAC_Last        ((u16)0x000A)

#define TextSetMAC_Addr        ((u16)0x30F0)

#define TextSetMAC_Tip        ((u16)0x4000)

void SetMACPaint(void)
{
  char Str[64];

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X", UserParam.MacAddr[0],UserParam.MacAddr[1],
          UserParam.MacAddr[2], UserParam.MacAddr[3], UserParam.MacAddr[4], UserParam.MacAddr[5]);
  LcdShowStr(TextSetMAC_Addr, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str, sizeof(Str), "  ");
  LcdShowStr(TextSetMAC_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowPage(ScrnSetMAC);
}

void SetMACIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetMAC(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  char MacAddr[16];
  u8 MacAddrLen;

  char Str[64];
  u8 i;

  MacAddrLen = 12;
  snprintf(MacAddr, sizeof(MacAddr), "%02X%02X%02X%02X%02X%02X", UserParam.MacAddr[0], UserParam.MacAddr[1],
          UserParam.MacAddr[2], UserParam.MacAddr[3], UserParam.MacAddr[4], UserParam.MacAddr[5]);

  TimeOutTick = GetSystemTick();

  SetMACPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetMAC_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetMAC_Enter:
                TimeOutTick = GetSystemTick();
                if(0 == MacAddrLen)
                {
                  snprintf(Str,sizeof(Str),"Ȳ㣬޷档");
                  LcdWriteVar(TextSetMAC_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else
                {
                  for(i=0; i<12; i++)
                  {
                    Temp = MacAddr[i] - '0';
                    if(Temp > 9)
                      Temp -= 7;
                    MacAddr[i] = Temp;
                  }
                  for(i=0; i<6; i++)
                    UserParam.MacAddr[i] = (MacAddr[2*i] << 4) | (MacAddr[2*i + 1] & 0x0F);

                  SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                  UserParamInit();

                  pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                  pLcdCtrl->Param = 0;
                }
                break;

              case BtnSetMAC_Next:
                TimeOutTick = GetSystemTick();
                //pLcdCtrl->CurScreen = eLcdPro_SetHumiture;
                //pLcdCtrl->Param = 0;
                break;

              case BtnSetMAC_Last:
                TimeOutTick = GetSystemTick();
                //pLcdCtrl->CurScreen = eLcdPro_SetIp;
                //pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetMAC);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetMAC);

            if(TextSetMAC_Addr == Temp)
            {
              MacAddrLen = 0;
              if((Frame.Ctrl.RdVar.Len < 7) || ((7 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[11])))
              {
                snprintf(Str,sizeof(Str),"Ȳ㣬䡣");
                LcdWriteVar(TextSetMAC_Tip, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetMAC_Tip, (u8 *)Str, (strlen(Str)+1));
                MacAddrLen = 12;
                memcpy(MacAddr, Frame.Ctrl.RdVar.Data, 12);
              }
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetMAC != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetMACIdle();

    osDelay(100);
  }
}






