
#include "Thd_Lcd.h"

#define ScrnSetNum            ((u16)34)
#define BtnSetNum_Enter       ((u16)0x3401)
#define BtnSetNum_Cancel      ((u16)0x3402)

#define BtnSetNum_Next        ((u16)0x000B)
#define BtnSetNum_Last        ((u16)0x000A)

#define TextSetNum_SysNum     ((u16)0x3020)
#define TextSetNum_AssetNum   ((u16)0x3040)
#define TextSetNum_QrNum      ((u16)0x41A0)

#define TextSetNum_Tip        ((u16)0x4000)

#define TextSetNum_PillarNum  ((u16)0x40E0)


void SetNumPaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str),"  ");
  LcdShowStr(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X", UserParam.PillarNum[0],UserParam.PillarNum[1],
            UserParam.PillarNum[2], UserParam.PillarNum[3], UserParam.PillarNum[4], UserParam.PillarNum[5], UserParam.PillarNum[6], UserParam.PillarNum[7]);
  LcdShowStr(TextSetNum_SysNum, (u8 *)Str, (strlen(Str)+1));

  LcdShowStr(TextSetNum_AssetNum, (u8 *)UserParam.AssetNum, 16);

  LcdShowStr(TextSetNum_QrNum, (u8 *)UserParam.DealQrcode, 48);

  LcdShowPage(ScrnSetNum);
}

void SetNumIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (60*1000)

void LcdProSetNum(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  char PillarTemp[17] = {0};
  u8 PillarTempLen;
  char AssetTemp[17] = {0};
  u8 AssetTempLen;
  char DealQrcodeTemp[48]= {0};
  u8 DealQrcodeTempLen;

  char Str[64];
  u8 i;

  PillarTempLen = 16;
  snprintf(PillarTemp, sizeof(PillarTemp), "%02X%02X%02X%02X%02X%02X%02X%02X", UserParam.PillarNum[0], UserParam.PillarNum[1],
            UserParam.PillarNum[2], UserParam.PillarNum[3], UserParam.PillarNum[4], UserParam.PillarNum[5], UserParam.PillarNum[6], UserParam.PillarNum[7]);

  AssetTempLen = 16;
  memcpy(AssetTemp, UserParam.AssetNum, 16);

  DealQrcodeTempLen = 48;
  memcpy(DealQrcodeTemp, UserParam.DealQrcode, 48);

  TimeOutTick = GetSystemTick();

  SetNumPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetNum_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetNum_Enter:
                TimeOutTick = GetSystemTick();
                if(0 == PillarTempLen)
                {
                  snprintf(Str,sizeof(Str),"׮볤Ȳ㣬޷档");
                  LcdWriteVar(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else if(0 == AssetTempLen)
                {
                  snprintf(Str,sizeof(Str),"ʲ볤Ȳ㣬޷档");
                  LcdWriteVar(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                //else if(0 == DealQrcodeTempLen)
                //{
                //  snprintf(Str,sizeof(Str),"ά볤Ȳ㣬޷档");
                //  LcdWriteVar(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));
                //}
                else
                {
                  for(i=0; i<8; i++)
                    UserParam.PillarNum[i] = ((PillarTemp[2*i] - '0') << 4) | ((PillarTemp[2*i + 1] - '0') & 0x0F);
                  memcpy(UserParam.AssetNum, AssetTemp, 16);

                  memcpy(UserParam.DealQrcode, DealQrcodeTemp, 48);

                  SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                  UserParamInit();

                  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X", UserParam.PillarNum[0],UserParam.PillarNum[1],
                            UserParam.PillarNum[2], UserParam.PillarNum[3], UserParam.PillarNum[4], UserParam.PillarNum[5], UserParam.PillarNum[6], UserParam.PillarNum[7]);
                  LcdShowStr(TextSetNum_PillarNum, (u8 *)Str, (strlen(Str)+1));

                  pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                  pLcdCtrl->Param = 0;
                }
                break;

              case BtnSetNum_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetMeterAddr;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetNum_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetRtc;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetNum);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetNum);
            if(TextSetNum_SysNum == Temp)
            {
              PillarTempLen = 0;
              if((Frame.Ctrl.RdVar.Len < 9) || ((9 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[15])))
              {
                snprintf(Str,sizeof(Str),"׮볤Ȳ㣬䡣");
                LcdWriteVar(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));
                PillarTempLen = 16;
                memcpy(PillarTemp, Frame.Ctrl.RdVar.Data, 16);
              }
            }
            else if(TextSetNum_AssetNum == Temp)
            {
              AssetTempLen = 0;
              if((Frame.Ctrl.RdVar.Len < 9) || ((9 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[15])))
              {
                snprintf(Str,sizeof(Str),"ʲ볤Ȳ㣬䡣");
                LcdWriteVar(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));
                AssetTempLen = 16;
                memcpy(AssetTemp, Frame.Ctrl.RdVar.Data, 16);
              }
            }
            else if(TextSetNum_QrNum == Temp)
            {
              for(DealQrcodeTempLen=0; DealQrcodeTempLen<48; DealQrcodeTempLen++)
              {
                if((0xFF == Frame.Ctrl.RdVar.Data[DealQrcodeTempLen]) || (0 == Frame.Ctrl.RdVar.Data[DealQrcodeTempLen]))
                  break;
              }
              snprintf(Str,sizeof(Str),"  ");
              LcdWriteVar(TextSetNum_Tip, (u8 *)Str, (strlen(Str)+1));

              memset(DealQrcodeTemp, 0, 48);
              memcpy(DealQrcodeTemp, Frame.Ctrl.RdVar.Data, DealQrcodeTempLen);
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetNum != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetNumIdle();

    osDelay(100);
  }
}






