
#include "Thd_Lcd.h"

#define ScrnSetParamDef            ((u16)43)
#define BtnSetParamDef_Enter       ((u16)0x4301)
#define BtnSetParamDef_Cancel      ((u16)0x4302)

#define BtnSetParamDef_Next        ((u16)0x000B)
#define BtnSetParamDef_Last        ((u16)0x000A)

#define TextSetParamDef_PillarNum ((u16)0x3000)
#define TextSetParamDef_TelNum    ((u16)0x3010)


void SetParamDefPaint(void)
{
  LcdShowPage(ScrnSetParamDef);
}

void SetParamDefIdle(void)
{

}

#define TimeOutTime   (40*1000)

void LcdProSetParamDef(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  char Str[64] = {0};

  TimeOutTick = GetSystemTick();
  SetParamDefPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetParamDef_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetParamDef_Enter:  //A ǹ"" 
                TimeOutTick = GetSystemTick();

                UserParamReset();
                UserParamInit();

                snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X", UserParam.PillarNum[0],UserParam.PillarNum[1],
                          UserParam.PillarNum[2], UserParam.PillarNum[3], UserParam.PillarNum[4], UserParam.PillarNum[5], UserParam.PillarNum[6], UserParam.PillarNum[7]);
                LcdShowStr(TextSetParamDef_PillarNum, (u8 *)Str, (strlen(Str)+1));
                LcdShowStr(TextSetParamDef_TelNum, (u8 *)UserParam.TelNum_1, sizeof(UserParam.TelNum_1));

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetParamDef_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetPassword;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetParamDef_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetPassword;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetParamDef);
                break;
            }
          }
          else
            LcdShowPage(ScrnSetParamDef);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetParamDef != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetParamDefIdle();

    osDelay(100);
  }
}







