
#include "Thd_Lcd.h"

#define ScrnSetPswd            ((u16)41)
#define BtnSetPswd_Enter       ((u16)0x4101)
#define BtnSetPswd_Cancel      ((u16)0x4102)

#define BtnSetPswd_Next        ((u16)0x000B)
#define BtnSetPswd_Last        ((u16)0x000A)

#define BtnSetPswd_ParamDef    ((u16)0x4103)

#define TextSetPswd_Pwd       ((u16)0x3000)
#define TextSetPswd_NewPwd    ((u16)0x30B0)
#define TextSetPswd_ConfPwd   ((u16)0x30C0)

#define DataSetPswd_Pwd       ((u16)0x3008)
#define DataSetPswd_NewPwd    ((u16)0x30B8)
#define DataSetPswd_ConfPwd   ((u16)0x30C8)

#define TextSetPswd_Tip       ((u16)0x4000)


void SetPswdPaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str),"  ");
  LcdShowStr(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowStr(TextSetPswd_Pwd, (u8 *)Str, (strlen(Str)+1));
  LcdShowStr(TextSetPswd_NewPwd, (u8 *)Str, (strlen(Str)+1));
  LcdShowStr(TextSetPswd_ConfPwd, (u8 *)Str, (strlen(Str)+1));

  LcdShowPage(ScrnSetPswd);
}

void SetPswdIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetPassword(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u8 Pwd[6];
  u8 PwdLen;
  u8 NewPwd[6];
  u8 NewPwdLen;
  u8 ConfPwd[6];
  u8 ConfPwdLen;

  char Str[64];

  PwdLen = 0;
  NewPwdLen = 0;
  ConfPwdLen = 0;

  TimeOutTick = GetSystemTick();

  SetPswdPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetPswd_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetPswd_Enter:
                TimeOutTick = GetSystemTick();
                if((0 == PwdLen) || (0 != memcmp(UserParam.SysPwd, Pwd, 6)))
                {
                  snprintf(Str,sizeof(Str),"ԭ벻ȷ");
                  LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else if(0 == NewPwdLen)
                {
                  snprintf(Str,sizeof(Str),"볤Ȳ㡣");
                  LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else if(0 == ConfPwdLen)
                {
                  snprintf(Str,sizeof(Str),"ȷ볤Ȳ㡣");
                  LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else if(0 != memcmp(NewPwd, ConfPwd, 6))
                {
                  snprintf(Str,sizeof(Str),"벻һ¡");
                  LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else
                {
                  memcpy(UserParam.SysPwd, ConfPwd, sizeof(UserParam.SysPwd));
                  SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                  UserParamInit();
                  pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                  pLcdCtrl->Param = 0;
                }
                break;

              case BtnSetPswd_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetReboot;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetPswd_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetTel;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetPswd_ParamDef:
                TimeOutTick = GetSystemTick();
                if((0 == PwdLen) || (0 != memcmp(UserParam.SysPwd, Pwd, 6)))
                {
                  snprintf(Str,sizeof(Str),"ԭ벻ȷ");
                  LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else
                {
                  pLcdCtrl->CurScreen = eLcdPro_SetParamDef;
                  pLcdCtrl->Param = 0;
                }
                break;

              default:
                LcdShowPage(ScrnSetPswd);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetPswd);
            if(DataSetPswd_Pwd == Temp)
            {
              PwdLen = 0;
              if((Frame.Ctrl.RdVar.Len < 4) || ((4 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[5])))
              {
                snprintf(Str,sizeof(Str),"ԭ볤Ȳ㣬䡣");
                LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                snprintf(Str,sizeof(Str),"***");
                LcdWriteVar(TextSetPswd_Pwd, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                snprintf(Str,sizeof(Str),"******");
                LcdWriteVar(TextSetPswd_Pwd, (u8 *)Str, (strlen(Str)+1));
                PwdLen = 6;
                memcpy(Pwd, Frame.Ctrl.RdVar.Data, 6);
              }
            }
            else if(DataSetPswd_NewPwd == Temp)
            {
              NewPwdLen = 0;
              if((Frame.Ctrl.RdVar.Len < 4) || ((4 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[5])))
              {
                snprintf(Str,sizeof(Str),"볤Ȳ㣬䡣");
                LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                snprintf(Str,sizeof(Str),"***");
                LcdWriteVar(TextSetPswd_NewPwd, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                snprintf(Str,sizeof(Str),"******");
                LcdWriteVar(TextSetPswd_NewPwd, (u8 *)Str, (strlen(Str)+1));
                NewPwdLen = 6;
                memcpy(NewPwd, Frame.Ctrl.RdVar.Data, 6);
              }
            }
            else if(DataSetPswd_ConfPwd == Temp)
            {
              ConfPwdLen = 0;
              if((Frame.Ctrl.RdVar.Len < 4) || ((4 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[5])))
              {
                snprintf(Str,sizeof(Str),"ȷ볤Ȳ㣬䡣");
                LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                snprintf(Str,sizeof(Str),"***");
                LcdWriteVar(TextSetPswd_ConfPwd, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetPswd_Tip, (u8 *)Str, (strlen(Str)+1));
                snprintf(Str,sizeof(Str),"******");
                LcdWriteVar(TextSetPswd_ConfPwd, (u8 *)Str, (strlen(Str)+1));
                ConfPwdLen = 6;
                memcpy(ConfPwd, Frame.Ctrl.RdVar.Data, 6);
              }
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetPassword != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetPswdIdle();

    osDelay(100);
  }
}







