
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnSetReader  ((u16)64)
#define BtnSetReader_Enter        ((u16)0x6401)
#define BtnSetReader_Cancel        ((u16)0x6402)

#define BtnSetReader_Next        ((u16)0x000B)
#define BtnSetReader_Last        ((u16)0x000A)

#define BtnSetReader_ActR1  ((u16)0x0168)
#define BtnSetReaderValue_RctR1Off ((u16)0x0000)
#define BtnSetReader_RctR1Off      ((u32)BtnSetReader_ActR1*65536+BtnSetReaderValue_RctR1Off)
#define BtnSetReaderValue_RctR1On  ((u16)0x0001)
#define BtnSetReader_RctR1On       ((u32)BtnSetReader_ActR1*65536+BtnSetReaderValue_RctR1On)

#define BtnSetReader_Pcd200  ((u16)0x0169)
#define BtnSetReaderValue_Pcd200Off ((u16)0x0000)
#define BtnSetReader_Pcd200Off      ((u32)BtnSetReader_Pcd200*65536+BtnSetReaderValue_Pcd200Off)
#define BtnSetReaderValue_Pcd200On  ((u16)0x0001)
#define BtnSetReader_Pcd200On       ((u32)BtnSetReader_Pcd200*65536+BtnSetReaderValue_Pcd200On)

#define BtnSetReader_ZLG600A  ((u16)0x016A)
#define BtnSetReaderValue_ZLG600AOff ((u16)0x0000)
#define BtnSetReader_ZLG600AOff      ((u32)BtnSetReader_ZLG600A*65536+BtnSetReaderValue_ZLG600AOff)
#define BtnSetReaderValue_ZLG600AOn  ((u16)0x0001)
#define BtnSetReader_ZLG600AOn       ((u32)BtnSetReader_ZLG600A*65536+BtnSetReaderValue_ZLG600AOn)

#define BtnSetReader_AutoID  ((u16)0x016B)
#define BtnSetReaderValue_AutoIDOff ((u16)0x0000)
#define BtnSetReader_AutoIDOff      ((u32)BtnSetReader_AutoID*65536+BtnSetReaderValue_AutoIDOff)
#define BtnSetReaderValue_AutoIDOn  ((u16)0x0001)
#define BtnSetReader_AutoIDOn       ((u32)BtnSetReader_AutoID*65536+BtnSetReaderValue_AutoIDOn)

void SetReaderPaint(void)
{
  u16 TempU16;

  if(eReaderType_ActR1 == UserParam.Reader.ReaderType)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnSetReader_ActR1, TempU16);

  if(eReaderType_Pcd200 == UserParam.Reader.ReaderType)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnSetReader_Pcd200, TempU16);

  if(eReaderType_ZLG600A == UserParam.Reader.ReaderType)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnSetReader_ZLG600A, TempU16);

  if(0 != UserParam.Reader.Auto_ID)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnSetReader_AutoID, TempU16);

  LcdShowPage(ScrnSetReader);
}

typedef struct
{
  u32 RePaintTick;
  u8 ReaderType;
  u8 Auto_ID;
}StructReaderUpdate;
void ReaderUpdate(StructReaderUpdate *pUpdate)
{
  u16 TempU16;
  if((GetSystemTick() - pUpdate->RePaintTick) >= 1000)
  {
    pUpdate->RePaintTick = GetSystemTick();

    if(eReaderType_ActR1 == pUpdate->ReaderType)
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(BtnSetReader_ActR1, TempU16);

    if(eReaderType_Pcd200 == pUpdate->ReaderType)
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(BtnSetReader_Pcd200, TempU16);

    if(eReaderType_ZLG600A == pUpdate->ReaderType)
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(BtnSetReader_ZLG600A, TempU16);

    if(0 != pUpdate->Auto_ID)
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(BtnSetReader_AutoID, TempU16);
  }
}


#define TimeOutTime   (40*1000)

void LcdProSetReader(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 TimeOutTick;
  u32 KeyValue;
  StructReaderUpdate Update;

  Update.ReaderType = UserParam.Reader.ReaderType;
  Update.Auto_ID = UserParam.Reader.Auto_ID;

  TimeOutTick = GetSystemTick();

  SetReaderPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            KeyValue = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnSetReader != KeyValue)
              LcdShowPage(ScrnSetReader);
          }
          break;
        case eLcdCmd_RdVar:
          KeyValue  = Frame.Ctrl.RdVar.AddrH << 24;
          KeyValue += Frame.Ctrl.RdVar.AddrL << 16;
          KeyValue += Frame.Ctrl.RdVar.Data[0] << 8;
          KeyValue += Frame.Ctrl.RdVar.Data[1];
          switch(KeyValue)
          {
            case BtnSetReader_Cancel:  //A ǹ"" 
              TimeOutTick = GetSystemTick();
              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnSetReader_Enter:
              TimeOutTick = GetSystemTick();

              UserParam.Reader.ReaderType = Update.ReaderType;
              UserParam.Reader.Auto_ID = Update.Auto_ID;

              SaveUserParam((u8*)&UserParam, sizeof(UserParam));
              UserParamInit();
              ReaderDiscern();

              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnSetReader_Next:
              TimeOutTick = GetSystemTick();
              pLcdCtrl->CurScreen = eLcdPro_SetHumiture;
              pLcdCtrl->Param = 0;
              break;
            case BtnSetReader_Last:
              TimeOutTick = GetSystemTick();
              pLcdCtrl->CurScreen = eLcdPro_SetCard;
              pLcdCtrl->Param = 0;
              break;

            case BtnSetReader_RctR1Off:
              TimeOutTick = GetSystemTick();
              Update.ReaderType = eReaderType_No;
              break;
            case BtnSetReader_RctR1On:
              TimeOutTick = GetSystemTick();
              Update.ReaderType = eReaderType_ActR1;
              break;

            case BtnSetReader_Pcd200Off:
              TimeOutTick = GetSystemTick();
              Update.ReaderType = eReaderType_No;
              break;
            case BtnSetReader_Pcd200On:
              TimeOutTick = GetSystemTick();
              Update.ReaderType = eReaderType_Pcd200;
              break;

            case BtnSetReader_ZLG600AOff:
              TimeOutTick = GetSystemTick();
              Update.ReaderType = eReaderType_No;
              break;
            case BtnSetReader_ZLG600AOn:
              TimeOutTick = GetSystemTick();
              Update.ReaderType = eReaderType_ZLG600A;
              break;

            case BtnSetReader_AutoIDOff:
              TimeOutTick = GetSystemTick();
              Update.Auto_ID = 0;
              break;
            case BtnSetReader_AutoIDOn:
              TimeOutTick = GetSystemTick();
              Update.Auto_ID = 1;
              break;

            default:
              LcdShowPage(ScrnSetReader);
              break;
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    if(eLcdPro_SetReader != pLcdCtrl->CurScreen)
      return;

    ReaderUpdate(&Update);

    osDelay(100);
  }
}

