
#include "Thd_Lcd.h"

#define ScrnSetReboot            ((u16)42)
#define BtnSetReboot_Enter       ((u16)0x4201)
#define BtnSetReboot_Cancel      ((u16)0x4202)

#define BtnSetReboot_Next        ((u16)0x000B)
#define BtnSetReboot_Last        ((u16)0x000A)

void SetRebootPaint(void)
{
  LcdShowPage(ScrnSetReboot);
}

void SetRebootIdle(void)
{

}

#define TimeOutTime   (40*1000)

void LcdProSetReboot(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  TimeOutTick = GetSystemTick();
  SetRebootPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetReboot_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetReboot_Enter:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                LcdReset();
                osDelay(200);
                SystemReboot();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetReboot_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetRtc;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetReboot_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetPassword;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetReboot);
                break;
            }
          }
          else
            LcdShowPage(ScrnSetReboot);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetReboot != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetRebootIdle();

    osDelay(100);
  }
}






