
#include "Thd_Lcd.h"

#define ScrnSetRtc            ((u16)32)
#define BtnSetRtc_Enter       ((u16)0x3201)
#define BtnSetRtc_Cancel      ((u16)0x3202)

#define BtnSetRtc_Next        ((u16)0x000B)
#define BtnSetRtc_Last        ((u16)0x000A)

void SetRtcPaint(void)
{
  LcdShowPage(ScrnSetRtc);
}

void SetRtcIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetRtc(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  StructTime Time;

  StampToTime(RtcGetTime(), &Time);
  LcdSetRtc(&Time);

  TimeOutTick = GetSystemTick();
  SetRtcPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Rtc == Frame.Ctrl.RdReg.Addr)
          {
            Time.Year = 2000 + BcdToHex(Frame.Ctrl.RdReg.Data[0]);          //  
            Time.Mon = BcdToHex(Frame.Ctrl.RdReg.Data[1] & 0x1F);      //  
            Time.Day = BcdToHex(Frame.Ctrl.RdReg.Data[2] & 0x3F);      //  
            //Frame.Ctrl.RdReg.Data[3]
            Time.Hour = BcdToHex(Frame.Ctrl.RdReg.Data[4] & 0x3F);      //  Сʱ
            Time.Min = BcdToHex(Frame.Ctrl.RdReg.Data[5] & 0x7F);      //  
            Time.Sec = BcdToHex(Frame.Ctrl.RdReg.Data[6] &0x7F);      //  

            RtcSetTime(TimeToStamp(&Time));
            RtcExtSetTime(&Time);

            pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
            pLcdCtrl->Param = 0;
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetRtc_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();

                StampToTime(RtcGetTime(), &Time);
                LcdSetRtc(&Time);

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetRtc_Enter:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                LcdGetRtc();
                //MenuParam->CurScreen = eScrn_ManageSelect;
                //MenuParam->Param = 0;
                break;

              case BtnSetRtc_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetNum;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetRtc_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetReboot;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetRtc);
                break;
            }
          }
          else
            LcdShowPage(ScrnSetRtc);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetRtc != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      TimeOutTick = GetSystemTick();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetRtcIdle();

    osDelay(100);
  }
}





