
#include "Thd_Lcd.h"

#define ScrnSetTel            ((u16)40)
#define BtnSetTel_Enter       ((u16)0x4001)
#define BtnSetTel_Cancel      ((u16)0x4002)

#define BtnSetTel_Next        ((u16)0x000B)
#define BtnSetTel_Last        ((u16)0x000A)

#define TextSetTel_Tel_1     ((u16)0x3090)
#define TextSetTel_Tel_2   ((u16)0x30A0)

#define TextSetTel_Tip        ((u16)0x4000)

#define TextSetTel_TelNum    ((u16)0x4100)

void SetTelPaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str),"  ");
  LcdShowStr(TextSetTel_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowStr(TextSetTel_Tel_1, (u8 *)UserParam.TelNum_1, sizeof(UserParam.TelNum_1));

  LcdShowStr(TextSetTel_Tel_2, (u8 *)UserParam.TelNum_2, sizeof(UserParam.TelNum_2));

  LcdShowPage(ScrnSetTel);
}

void SetTelIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetTel(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  char Tel_1_Temp[16];
  char Tel_2_Temp[16];
  //u8 i;

  memcpy(Tel_1_Temp, UserParam.TelNum_1, 16);
  memcpy(Tel_2_Temp, UserParam.TelNum_2, 16);

  TimeOutTick = GetSystemTick();

  SetTelPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetTel_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetTel_Enter:
                TimeOutTick = GetSystemTick();
                memcpy(UserParam.TelNum_1, Tel_1_Temp, 16);
                memcpy(UserParam.TelNum_2, Tel_2_Temp, 16);

                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                LcdShowStr(TextSetTel_TelNum, (u8 *)UserParam.TelNum_1, sizeof(UserParam.TelNum_1));
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetTel_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetPassword;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetTel_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetHumiture;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetTel);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetTel);
            if(TextSetTel_Tel_1 == Temp)
            {
              memcpy(Tel_1_Temp, Frame.Ctrl.RdVar.Data, 16);
            }
            else if(TextSetTel_Tel_2 == Temp)
            {
              memcpy(Tel_2_Temp, Frame.Ctrl.RdVar.Data, 16);
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetTel != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetTelIdle();

    osDelay(100);
  }
}







