
#include "Thd_Lcd.h"

#define ScrnSetTimeRate            ((u16)36)
#define BtnSetTimeRate_Enter       ((u16)0x3601)
#define BtnSetTimeRate_Cancel      ((u16)0x3602)

#define BtnSetTimeRate_Next        ((u16)0x000B)
#define BtnSetTimeRate_Last        ((u16)0x000A)

#define DataSetTimeRate_RateBase    ((u16)0x0060)

#define TextSetTimeRate_Rate1        ((u16)0x4080)
#define TextSetTimeRate_Rate2        ((u16)0x4090)
#define TextSetTimeRate_Rate3        ((u16)0x40A0)
#define TextSetTimeRate_Rate4        ((u16)0x40B0)

//#define TextSetTimeRate_Tip        ((u16)0x0260)

void SetTimeRatePaint(void)
{
  char Str[64];
  u8 i;

#if 1
  snprintf(Str,sizeof(Str),"(1) %.2fԪ", (float)UserParam.EnergyRate[0]/100.0);
  LcdShowStr(TextSetTimeRate_Rate1, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str,sizeof(Str),"(2) %.2fԪ", (float)UserParam.EnergyRate[1]/100.0);
  LcdShowStr(TextSetTimeRate_Rate2, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str,sizeof(Str),"(3) %.2fԪ", (float)UserParam.EnergyRate[2]/100.0);
  LcdShowStr(TextSetTimeRate_Rate3, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str,sizeof(Str),"(4) %.2fԪ", (float)UserParam.EnergyRate[3]/100.0);
  LcdShowStr(TextSetTimeRate_Rate4, (u8 *)Str, (strlen(Str)+1));

#else

  snprintf(Str,sizeof(Str),"(1) %1d.%2dԪ", UserParam.EnergyRate[0]/100, UserParam.EnergyRate[0]%100);
  LcdShowStr(TextSetTimeRate_Rate1, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str,sizeof(Str),"(2) %1d.%2dԪ", UserParam.EnergyRate[1]/100, UserParam.EnergyRate[1]%100);
  LcdShowStr(TextSetTimeRate_Rate2, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str,sizeof(Str),"(3) %1d.%2dԪ", UserParam.EnergyRate[2]/100, UserParam.EnergyRate[2]%100);
  LcdShowStr(TextSetTimeRate_Rate3, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str,sizeof(Str),"(4) %1d.%2dԪ", UserParam.EnergyRate[3]/100, UserParam.EnergyRate[3]%100);
  LcdShowStr(TextSetTimeRate_Rate4, (u8 *)Str, (strlen(Str)+1));

#endif
  for(i=0; i<48; i++)
  {
    LcdShowData16(DataSetTimeRate_RateBase+i, UserParam.EnergyTimeRate[i]);
  }

  LcdShowPage(ScrnSetTimeRate);
}

void SetTimeRateIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetTimeRate(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u8 TimeRate[sizeof(UserParam.EnergyTimeRate)];

  memcpy(TimeRate, UserParam.EnergyTimeRate, sizeof(UserParam.EnergyTimeRate));

  TimeOutTick = GetSystemTick();

  SetTimeRatePaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetTimeRate_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetTimeRate_Enter:
                TimeOutTick = GetSystemTick();
                memcpy(UserParam.EnergyTimeRate, TimeRate, sizeof(UserParam.EnergyTimeRate));

                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetTimeRate_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen =eLcdPro_SetServerRate;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetTimeRate_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetRate;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetTimeRate);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetTimeRate);
            if((Temp >= DataSetTimeRate_RateBase) && (Temp < (DataSetTimeRate_RateBase + sizeof(UserParam.EnergyTimeRate))))
              TimeRate[Temp - DataSetTimeRate_RateBase] = Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetTimeRate != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetTimeRateIdle();

    osDelay(100);
  }
}


