
#ifndef __THD_CHARGE_H__
#define __THD_CHARGE_H__

#include "Global.h"
#include "Drv_Adc.h"
#include "Drv_TCUComm.h"
#include "Thd_TcuControl.h"


#define CC_CheckTick    (100)
#define MsgTimeout_1S   (1000+200)
#define MsgTimeout_5S   (5000+500)
#define MsgTimeout_10S  (10*1000+3000)
#define MsgTimeout_60S  (60*1000+3000)
#define MsgTimeout_10M  (10*60*1000+3000)

typedef enum
{
  eChgPro_ChgIdle = 0,
  eChgPro_ShakeHand,

  eChgPro_ImdCheck,
  eChgPro_ChgRecognizeEx,

  eChgPro_ChgRecognize,
  eChgPro_ChgConfigure,
  eChgPro_WaitBmsReady,
  eChgPro_WaitPillarReady,
  eChgPro_ChgStart,
  eChgPro_ChgRun,
  eChgPro_WaitVoltChgRun,
  eChgPro_ChgStop,
  eChgPro_CommBreak,
  eChgPro_CommError,
  eChgPro_ChgBreak,

  eChgPro_AB_ShakeHand,

  eChgPro_AB_ImdCheck,
  eChgPro_AB_ChgRecognizeEx,

  eChgPro_AB_ChgRecognize,
  eChgPro_AB_ChgConfigure,
  eChgPro_AB_WaitBmsReady,
  eChgPro_AB_WaitPillarReady,
  eChgPro_AB_ChgStart,
  eChgPro_AB_ChgRun,
  eChgPro_AB_WaitVoltChgRun,
  eChgPro_AB_ChgStop,
  eChgPro_AB_CommBreak,
  eChgPro_AB_CommError,
  eChgPro_AB_ChgBreak,
  eChgPro_Max,
}EnumChargeProcess;

typedef struct
{
  EnumChargeProcess CurProcess;
  //EnumChargeProcess AimStep;
  void *Param;
}StructChargeCtrl;

typedef void (*pChargeCtrlHandle)(StructChargeCtrl *pChgCtrl);


extern u8 ChargeEnable_B;

extern u8 ChargeEnable;
extern u8 ChargePauseFlag;
extern u8 UniChgEnable;
extern StructChargeCtrl ChargeCtrl;

extern u8 ChargeEnable_AB;

extern s32 StartChgEnergy;
extern s32 StopChgEnergy;

extern EnumChgStopType ChargeStopType;

extern u8 CommErrorCount;
extern u32 CommErrFrame[4];

extern u32 ChargeTimeCount;//
extern void ChargeTimerSet(EnumSwitchStatus OnOff);
u16 GetChgMin(void);
extern u32 GetChgSec(void);
extern void CleanChgTimeCnt(void);


#endif

