
#include "Global.h"
#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_Meter.h"
#include "Thd_Charge.h"
#include "Thd_Charge_B.h"
#include "Thd_InternetBsb.h"
#include "Thd_Lcd.h"
#include "Memory.h"
#include "Drv_ImdJyc.h"
#include "Drv_Dht12.h"

void ImdModeProcess(void)
{
  static EnumChargeProcess ChgCurProcessLast = eChgPro_ChgIdle;
  static EnumChargeProcess_B ChgCurProcessLast_B = eChgPro_B_ChgIdle;

  if(eChgVer_2011 != UserParam.ChgVer)
  {
    if(ChgCurProcessLast != ChargeCtrl.CurProcess)
    {
      if(eChgPro_ChgIdle == ChargeCtrl.CurProcess)
      {
        ImdWrite(0x0017, 0x0002);
        ImdWrite(0x01FE, 0x0001);
      }
      else if(eChgPro_ImdCheck == ChgCurProcessLast)
      {
        if(eChgPro_ChgRecognize == ChargeCtrl.CurProcess || eChgPro_ChgRecognizeEx == ChargeCtrl.CurProcess)
        {
          ImdWrite(0x0017, 0x0003);
          ImdWrite(0x01FE, 0x0001);
        }
      }

      ChgCurProcessLast = ChargeCtrl.CurProcess;
    }
/*********************************Bǹ*************************************/
    if(ChgCurProcessLast_B != ChargeCtrl_B.CurProcess)
    {
      if(eChgPro_B_ChgIdle == ChargeCtrl_B.CurProcess)
      {
        ImdWrite_B(0x0017, 0x0002);
        ImdWrite_B(0x01FE, 0x0001);
      }
      else if(eChgPro_B_ImdCheck == ChgCurProcessLast_B)
      {
        if(eChgPro_B_ChgRecognize == ChargeCtrl_B.CurProcess || eChgPro_B_ChgRecognizeEx == ChargeCtrl_B.CurProcess)
        {
          ImdWrite_B(0x0017, 0x0003);
          ImdWrite_B(0x01FE, 0x0001);
        }
      }

      ChgCurProcessLast_B = ChargeCtrl_B.CurProcess;
    }
  }

}

static EnumSwitchStatus BlinkChgLedSta = eSwSta_Off;

void RunLedProcess(void)
{
  static EnumSwitchStatus RunLedSta = eSwSta_Off;

  RunLedSet(RunLedSta);
  RunLedSta = (EnumSwitchStatus)(!RunLedSta);
}

void LedProcess(void)
{
  if(eLcdPro_FactoryTest == LcdCtrl.CurScreen
    ||eLcdPro_FactoryChgInfor == LcdCtrl.CurScreen
    ||eLcdPro_FactoryTestTwo == LcdCtrl.CurScreen)
    return;
  if(
      (0 != PillarError.Value.Emergency)
      || (0 != PillarError.Value.NoDcmod)
      || (0 != PillarError.Value.Insulation)
      || (0 != PillarError.Value.ImdDev) //&& (eChgVer_2011 != UserParam.ChgVer))
      || (0 != PillarError.Value.DrainResist)
      || (0 != PillarError.Value.Reader)
      || (0 != PillarError.Value.Meter)
      || (0 != PillarError.Value.ACMeter)
      || (0 != PillarError.Value.SPD)
      || (0 != PillarError.Value.Memory)
      || (0 != PillarError.Value.Lcd)
      || (0 != PillarError.Value.Contactor)
      || (0 != PillarError.Value.UniContactor)
      || (0 != PillarError.Value.Humiture)
      || (0 != PillarError.Value.Net)
      || (0 != PillarError.Value.Door)
      || (0 != PillarError.Value.InVolt)
      || (0 != PillarError.Value.EleLock)
      || (0 != PillarError.Value.OutVolt)
      || (0 != PillarError.Value.OutCurrt)
    )
  {
    IdleLedSet(eSwSta_Off);
    ChgLedSet(eSwSta_Off);
    FaultLedSet(eSwSta_On);
  }
  else if((1 == CurChgRecd.RecordValid)
       || (1 == ReserveParam.ValidFlag)
       ||((NULL != pCurChgRecd_AB) && (1 == pCurChgRecd_AB->RecordValid))
       )
  {
    IdleLedSet(eSwSta_Off);
    if((eChgPro_ChgRun == ChargeCtrl.CurProcess)
      || (eChgPro_WaitVoltChgRun == ChargeCtrl.CurProcess)
      || (eChgPro_AB_ChgRun == ChargeCtrl.CurProcess)
      || (eChgPro_AB_WaitVoltChgRun == ChargeCtrl.CurProcess)
      )
    {
      ChgLedSet(BlinkChgLedSta);
    }
    else
    {
      ChgLedSet(eSwSta_On);
    }
    FaultLedSet(eSwSta_Off);
  }
  else
  {
    if(0 != UserParam.ChgFun.Value.IdleLed)
      IdleLedSet(eSwSta_On);
    else
      IdleLedSet(eSwSta_Off);
    ChgLedSet(eSwSta_Off);
    FaultLedSet(eSwSta_Off);
  }
}

void LedProcess_B(void)
{
  if(eLcdPro_B_FactoryTest == LcdCtrl.CurScreen
    ||eLcdPro_B_FactoryChgInfor == LcdCtrl.CurScreen
    ||eLcdPro_B_FactoryTestTwo == LcdCtrl.CurScreen)
    return;
  if(
      (0 != PillarError_B.Value.Emergency)
      || (0 != PillarError_B.Value.NoDcmod)
      || (0 != PillarError_B.Value.Insulation)
      || (0 != PillarError_B.Value.ImdDev) //&& (eChgVer_2011 != UserParam.ChgVer))
      || (0 != PillarError_B.Value.DrainResist)
      || (0 != PillarError_B.Value.Reader)
      || (0 != PillarError_B.Value.Meter)
      || (0 != PillarError_B.Value.ACMeter)
      || (0 != PillarError_B.Value.SPD)
      || (0 != PillarError_B.Value.Memory)
      || (0 != PillarError_B.Value.Lcd)
      || (0 != PillarError_B.Value.Contactor)
      || (0 != PillarError_B.Value.UniContactor)
      || (0 != PillarError_B.Value.Humiture)
      || (0 != PillarError_B.Value.Net)
      || (0 != PillarError_B.Value.Door)
      || (0 != PillarError_B.Value.InVolt)
      || (0 != PillarError_B.Value.EleLock)
      || (0 != PillarError_B.Value.OutVolt)
      || (0 != PillarError_B.Value.OutCurrt)
    )
  {
    IdleLedSet_B(eSwSta_Off);
    ChgLedSet_B(eSwSta_Off);
    if(0 == UserParam.ChgFun.Value.Num_B)
      FaultLedSet_B(eSwSta_Off);
    else
      FaultLedSet_B(eSwSta_On);
  }
  else if((1 == CurChgRecd_B.RecordValid)
        || (1 == ReserveParam_B.ValidFlag)
        ||((NULL != pCurChgRecd_AB) && (1 == pCurChgRecd_AB->RecordValid))
        )
  {
    IdleLedSet_B(eSwSta_Off);
    if((eChgPro_B_ChgRun == ChargeCtrl_B.CurProcess)
      || (eChgPro_B_WaitVoltChgRun == ChargeCtrl_B.CurProcess)
      || (eChgPro_AB_ChgRun == ChargeCtrl.CurProcess)
      || (eChgPro_AB_WaitVoltChgRun == ChargeCtrl.CurProcess)
      )
    {
      ChgLedSet_B(BlinkChgLedSta);
    }
    else
    {
      ChgLedSet_B(eSwSta_On);
    }
    FaultLedSet_B(eSwSta_Off);
  }
  else
  {
    if(0 != UserParam.ChgFun.Value.IdleLed)
      IdleLedSet_B(eSwSta_On);
    else
      IdleLedSet_B(eSwSta_Off);
    ChgLedSet_B(eSwSta_Off);
    FaultLedSet_B(eSwSta_Off);
  }
}

static s8 VoltChkCnt = 0;
void VoltDetect(void)
{
  if(UserParam.VoltHigh < (u16)(MeterValue_AC.Voltage))
  {
    if(VoltChkCnt < 5)
      VoltChkCnt++;
    else
      VoltChkCnt = 5;
  }
  else if(UserParam.VoltLow > (u16)(MeterValue_AC.Voltage))
  {
    if(VoltChkCnt > -5)
      VoltChkCnt--;
    else
      VoltChkCnt = -5;
  }
  else
  {
    if(VoltChkCnt > 0)
      VoltChkCnt--;
    else if(VoltChkCnt < 0)
      VoltChkCnt ++;
    else
      VoltChkCnt = 0;
  }
}
//////////////////////   0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20
u16 DewTable[2][21] = {{87,87,87,87,87,87,87,88,90,90,92,92,94,95,95,96,97,98,98,99,99}
                   ,{1575,1575,1575,1575,1575,1575,1575,1389,1233,1030,921,775,692
                     ,593,473,380,301,220,145,71,71}
                   };
void HumidnessAdjust(void)
{
  u16 PillarTemp;
  s16 EnviTemp;
  s16 DewTemp;
  u8 Humi;
  if((0 == Dht12Data.ValidFlag) || (eLcdPro_FactoryTestTwo == LcdCtrl.CurScreen))
    return;

  Humi = (u8)(Dht12Data.Dht12Humity * 2/1000);//  /100/10
  EnviTemp = Adc_GetNtcTemp();//ⲿ¶
  DewTemp = (s16)(((s32)EnviTemp * DewTable[0][Humi]/100)-DewTable[1][Humi]);//¶¶
  PillarTemp = (s16)(Dht12Data.Dht12Temp - 600);////¶ȵ6϶ ֵС²

  if(PillarTemp - UserParam.TempDiff < DewTemp)//׮ڻ¶Ƚӽ¶¶
  {
    DehumidifierSet(eSwSta_On);
  }
  else if(PillarTemp - UserParam.SuitTempDiff > DewTemp)
  {
    DehumidifierSet(eSwSta_Off);
  }
}
void HumidnessAdjustProcess(void)
{
  //NtcRetToTemp(UserParam.NTC_DivisionVal,UserParam.NTC_BVal);
  HumidnessAdjust();
}
void TempToControlFan(void)
{
 if ((TCUCurChgRecd_B.TCUChargeEnable == 0)&&(TCUCurChgRecd.TCUChargeEnable==0)&&(0 != UserParam.ChgFun.Value.Dehumi))
	 {
	   if(Dht12Data.ValidFlag == 1)
	   {
		if((Dht12_GetTemp() > -40)&&(Dht12_GetTemp()<=150))//¶ȷΧ
		{
		 if(Dht12_GetTemp()>=55)
		  FanSet(eSwSta_On);
		 else if((Dht12_GetTemp()>=0)&&(Dht12_GetTemp()<=45))
		  FanSet(eSwSta_Off);
		}
		else
		  FanSet(eSwSta_Off);//¶ȲڷΧ
	  }
	  else
	   FanSet(eSwSta_Off);//ģ
	 }
}


static u32 ProAlamTemDecreaseCurrentValue = 0;
static u32  AlamTemDecreaseCurrentValue = 0;

static u32 ProAlamTemDecreaseCurrentValueB = 0;
static u32  AlamTemDecreaseCurrentValueB = 0;
static u32  AlamInterTemDecreaseCurrentValue = 0;



void GunTemControl(void)
{
  static u32 TempAlarmCountA = 0 ;
  static s16 alarmTempe = 0 ;
  static  u16 alarmTempeCurrent  = 0;
  if (0 == UserParam.ChgFun.Value.Dehumi)
  	{
  	 AlamTemDecreaseCurrentValue = 0;
  	 return;
  	}
  if((PT1000RetToTemp() == FALSE)&&(PT1000RetToTempN() == FALSE))//ʧЧ
  	{
  	 TempAlarmCountA= 0;
    if(AlamInterTemDecreaseCurrentValue == 0)
	   AlamTemDecreaseCurrentValue = 0;
	   alarmTempeCurrent = 0 ;
  	}
  else if(((Adc_Get_a_PTemp() >= UserParam.AlarmTemp)||(PT1000RetToTemp() == FALSE))
  	&&((Adc_Get_a_NTemp() >= UserParam.AlarmTemp)||(PT1000RetToTempN() == FALSE)))//ʧЧһ
  	{
  	 if((TempAlarmCountA== 0)||(DcModuleManage.SetCurrt >alarmTempeCurrent))
  	 alarmTempeCurrent = DcModuleManage.SetCurrt ;//Record the current when the problem occurs
  	 if(TempAlarmCountA == 0)
     TempAlarmCountA = GetSystemTick();
	 if((Adc_Get_a_PTemp() >= Adc_Get_a_NTemp())&&(PT1000RetToTemp() != FALSE))
	  alarmTempe =  Adc_Get_a_PTemp();
	 else
	  alarmTempe =  Adc_Get_a_NTemp();
  	}
  else
  {
    if(TCUCurChgRecd.TCUChargeEnable == 0)
    {
  	 TempAlarmCountA= 0;
     if(AlamInterTemDecreaseCurrentValue == 0)
	    AlamTemDecreaseCurrentValue = 0;
	   alarmTempeCurrent = 0;//temperature recovery
    }
  }
  if( TempAlarmCountA != 0)//alarm occur
  {
   if(GetSystemTick()-TempAlarmCountA >30000 )//check once every 30s
   	{
   	 if (alarmTempe > UserParam.AlarmTemp)
   	 {
	   ProAlamTemDecreaseCurrentValue = (UserParam.DcMaxCurrt/(UserParam.FaultTemp- UserParam.AlarmTemp)
	   	                              *(alarmTempe - UserParam.AlarmTemp))*100;//1000
	   if(ProAlamTemDecreaseCurrentValue > AlamTemDecreaseCurrentValue )
	   	 AlamTemDecreaseCurrentValue  =  ProAlamTemDecreaseCurrentValue;
	   else if (ProAlamTemDecreaseCurrentValue <=AlamTemDecreaseCurrentValue)
	   	{
	    	AlamTemDecreaseCurrentValue =  	AlamTemDecreaseCurrentValue;
	   	}

   	 }
     if((DcModuleManage.SetCurrt <=(alarmTempeCurrent-AlamTemDecreaseCurrentValue)&&(alarmTempeCurrent>AlamTemDecreaseCurrentValue)) )
           AlamTemDecreaseCurrentValue  = 0 ;
      TempAlarmCountA = GetSystemTick();//¼ʱ
   	}
  }
}

void GunTemControl_B(void)
{
  static u32 TempAlarmCountB = 0 ;
  static s16 alarmTempe = 0 ;
  static  u16 alarmTempeCurrent  = 0;
  if (0 == UserParam.ChgFun.Value.Dehumi)
  	{
  	 AlamTemDecreaseCurrentValueB= 0;
  	 return;
  	}
  if((PT1000RetToTempB_N() == FALSE)&&(PT1000RetToTempB_P() == FALSE))//ʧЧ
  	{
  	 TempAlarmCountB= 0;
     if(AlamInterTemDecreaseCurrentValue == 0)
	   AlamTemDecreaseCurrentValueB= 0;
	   alarmTempeCurrent = 0 ;
  	}
  else if(((Adc_Get_B_PTemp() >= UserParam.AlarmTemp)||(PT1000RetToTempB_P() == FALSE))
  	&&((Adc_Get_B_NTemp() >= UserParam.AlarmTemp)||(PT1000RetToTempB_N() == FALSE)))//ʧЧһ
  	{
  	 if((TempAlarmCountB== 0)||(DcModuleManage_B.SetCurrt >alarmTempeCurrent))
  	 alarmTempeCurrent = DcModuleManage.SetCurrt ;//Record the current when the problem occurs
  	 if(TempAlarmCountB== 0)
     TempAlarmCountB= GetSystemTick();
	 if((Adc_Get_B_PTemp() >= Adc_Get_B_NTemp())&&(PT1000RetToTempB_P() != FALSE))
	  alarmTempe =  Adc_Get_B_PTemp();
	 else
	  alarmTempe =  Adc_Get_B_NTemp();
  	}
  else
  {
    if(TCUCurChgRecd_B.TCUChargeEnable== 0)
    {
  	 TempAlarmCountB= 0;
     if(AlamInterTemDecreaseCurrentValue == 0)
	   AlamTemDecreaseCurrentValueB= 0;
	   alarmTempeCurrent = 0;//temperature recovery
    }
  }
  if( TempAlarmCountB!= 0)//alarm occur
  {
   if(GetSystemTick()-TempAlarmCountB>30000 )//check once every 30s
   	{
   	 if (alarmTempe > UserParam.AlarmTemp)
   	 {
	   ProAlamTemDecreaseCurrentValueB= (UserParam.DcMaxCurrt/(UserParam.FaultTemp- UserParam.AlarmTemp)
	   	                              *(alarmTempe - UserParam.AlarmTemp))*100;//1000
	   if(ProAlamTemDecreaseCurrentValueB> AlamTemDecreaseCurrentValueB)
	   	 AlamTemDecreaseCurrentValueB=  ProAlamTemDecreaseCurrentValueB;
	   else if (ProAlamTemDecreaseCurrentValueB<=AlamTemDecreaseCurrentValueB)
	   	{
	    	AlamTemDecreaseCurrentValueB = AlamTemDecreaseCurrentValueB;
	   	}
   	 }
     if((DcModuleManage_B.SetCurrt <=(alarmTempeCurrent-AlamTemDecreaseCurrentValueB)&&(alarmTempeCurrent > AlamTemDecreaseCurrentValueB)) )
       AlamTemDecreaseCurrentValueB= 0 ;
     TempAlarmCountB= GetSystemTick();//¼ʱ
   	}
  }
}

static u32 ProAlamInterTemDecreaseCurrentValue = 0;
#define AlarmInterTemp 45

void InterTemControl(void)
{
  static u32 InterTempAlarmCountA = 0 ;
  static s16 InteralarmTempe = 0 ;
  static  u16 InteralarmTempeCurrent  = 0;
  if (0 == UserParam.ChgFun.Value.Dehumi)
  {
    AlamInterTemDecreaseCurrentValue = 0;
    return;
  }
  if((Dht12_GetTemp() > -40)&&(Dht12_GetTemp()<=150))//¶ȷΧ//ʧЧһ
  {
    if(Dht12_GetTemp() >=  UserParam.AlarmTemp)
    {
      if((InterTempAlarmCountA == 0)||(DcModuleManage.SetCurrt >InteralarmTempeCurrent)||(DcModuleManage_B.SetCurrt >InteralarmTempeCurrent))
      {
        if((DcModuleManage.SetCurrt >=DcModuleManage_B.SetCurrt))
        InteralarmTempeCurrent = DcModuleManage.SetCurrt ;//Record the current when the problem occurs
        else
        InteralarmTempeCurrent = DcModuleManage_B.SetCurrt ;
      }
       if(InterTempAlarmCountA == 0)
       InterTempAlarmCountA = GetSystemTick();
      InteralarmTempe = Dht12_GetTemp();
      if((TCUCurChgRecd.TCUChargeEnable == 0)&&(TCUCurChgRecd_B.TCUChargeEnable== 0)&&(ChargeEnable_AB== 0))
      {
        InterTempAlarmCountA= 0;
        AlamInterTemDecreaseCurrentValue = 0;
        InteralarmTempeCurrent = 0;//temperature recovery
      }
    }
    else
    {
      if((TCUCurChgRecd.TCUChargeEnable == 0)&&(TCUCurChgRecd_B.TCUChargeEnable== 0)&&(ChargeEnable_AB== 0))
      {
        InterTempAlarmCountA= 0;
        AlamInterTemDecreaseCurrentValue = 0;
        InteralarmTempeCurrent = 0;//temperature recovery
      }
  }
}
else
{
 if((TCUCurChgRecd.TCUChargeEnable == 0)&&(ChargeEnable_B== 0)&&(ChargeEnable_AB== 0))
  {
    InterTempAlarmCountA= 0;
    AlamInterTemDecreaseCurrentValue = 0;
    InteralarmTempeCurrent = 0;//temperature recovery
  }
}

  if( InterTempAlarmCountA != 0)//alarm occur
  {
   if(GetSystemTick()-InterTempAlarmCountA >30000 )//check once every 30s
   	{
   	 if (InteralarmTempe > UserParam.AlarmTemp)
   	 {
	   ProAlamInterTemDecreaseCurrentValue = (UserParam.DcMaxCurrt/(UserParam.FaultTemp- UserParam.AlarmTemp)
	   	                              *(InteralarmTempe - UserParam.AlarmTemp))*100;//1000
	   if(ProAlamInterTemDecreaseCurrentValue > AlamInterTemDecreaseCurrentValue )
	   	 AlamInterTemDecreaseCurrentValue  =  ProAlamInterTemDecreaseCurrentValue;
	   else if (ProAlamInterTemDecreaseCurrentValue <=AlamInterTemDecreaseCurrentValue)
	   	{

	    	AlamInterTemDecreaseCurrentValue = AlamInterTemDecreaseCurrentValue;
	   	}
   	 }
    InterTempAlarmCountA = GetSystemTick();//¼ʱ
    if(TCUCurChgRecd.TCUChargeEnable == 1)
    {
    if((DcModuleManage.SetCurrt <=(InteralarmTempeCurrent-AlamInterTemDecreaseCurrentValue)&&(InteralarmTempeCurrent >AlamInterTemDecreaseCurrentValue)) )
    AlamInterTemDecreaseCurrentValue  = 0 ;
    }
    else if (TCUCurChgRecd_B.TCUChargeEnable ==1)
    {
    if((DcModuleManage_B.SetCurrt <=(InteralarmTempeCurrent-AlamInterTemDecreaseCurrentValue)&&(InteralarmTempeCurrent >AlamInterTemDecreaseCurrentValue)) )
    AlamInterTemDecreaseCurrentValue  = 0 ;
    }
    else if(ChargeEnable_AB == 1)
    {
    if((DcModuleManage.SetCurrt <=(InteralarmTempeCurrent-AlamInterTemDecreaseCurrentValue)&&(InteralarmTempeCurrent >AlamInterTemDecreaseCurrentValue)) )
    AlamInterTemDecreaseCurrentValue  = 0 ;
    else if((DcModuleManage_B.SetCurrt <=(InteralarmTempeCurrent-AlamInterTemDecreaseCurrentValue)&&(InteralarmTempeCurrent>=AlamTemDecreaseCurrentValueB)) )
    AlamInterTemDecreaseCurrentValue  = 0 ;
    }

 	}

 }

}

u32 TemDecreaseCurrentValue(void)
{
 if(AlamInterTemDecreaseCurrentValue > AlamTemDecreaseCurrentValue)
  AlamTemDecreaseCurrentValue =  AlamInterTemDecreaseCurrentValue;
 return  AlamTemDecreaseCurrentValue ;
}

u32 TemDecreaseCurrentValueB(void)
{
 if(AlamInterTemDecreaseCurrentValue > AlamTemDecreaseCurrentValueB)
  AlamTemDecreaseCurrentValueB =  AlamInterTemDecreaseCurrentValue;
 return  AlamTemDecreaseCurrentValueB;
}

void PillarEnvironmentProcess(void const *Param)
{
  static u8 PillarEnviUpdTcik;
  PillarEnviUpdTcik ++;
  BlinkChgLedSta = (EnumSwitchStatus)(!BlinkChgLedSta);

  if(PillarEnviUpdTcik>=5)
  {
    PillarEnviUpdTcik = 0;
    PT1000RetToTemp();
	  PT1000RetToTempN();
	  PT1000RetToTempB_P();
	  PT1000RetToTempB_N();
    Dht12_GetHumiAndTemp();
  }
  TempToControlFan();
  GunTemControl();
  GunTemControl_B();
  InterTemControl();
  RunLedProcess();
  LedProcess();
  LedProcess_B();
  //VoltDetect();
}
u8 Acc_On_3s_flag;

void PillEnviConlTimeInt(void)
{
  osTimerId PillarEnvironmentContlTime;

  /* Create Touch screen Timer */
  osTimerDef(PillarEnvironmentContlTime, PillarEnvironmentProcess);
  PillarEnvironmentContlTime = osTimerCreate(osTimer(PillarEnvironmentContlTime), osTimerPeriodic, (void *)0);
  /* Start the TS Timer */
  osTimerStart(PillarEnvironmentContlTime, 1000);
}

void Thd_Mult(void const *parameter)
{
  u8 MergencyCheckCnt = 0;
  u8 DoorChkCnt = 0;
  u8 SPDChkCnt = 0;
  u8 ContactorChkCnt = 0;
  u8 ContactorChkCnt_B = 0;
  u8 ContactorChkCnt_Uni = 0;
  u8 EleLockChkCnt = 0;
  u8 EleLockChkCnt_B = 0;
  u8 ImdErrorCnt = 0;
  u8 ImdErrorCnt_B = 0;
  u32 ImdCheckTcik,ImdCheckTcik_B;
  u8 ACContactorChkCnt = 0;
  u8 ACContactorOnCnt = 0;
  MergencyCheckCnt = 0;
  DoorChkCnt = 0;
  ImdErrorCnt = 0;

  Dht12Init();

  ImdInit();
  PillEnviConlTimeInt();

  ImdCheckTcik = GetSystemTick();
  ImdCheckTcik_B= GetSystemTick();

  osDelay(1000);
  ImdWrite(0x0017, 0x0003);
  osDelay(300);
  ImdWrite(0x01FE, 0x0001);
  osDelay(300);
  ImdWrite(0x0017, 0x0003);
  osDelay(500);
  ImdWrite(0x01FE, 0x0001);
  osDelay(300);
  ImdWrite(0x0021, 0x003C);
  osDelay(500);
  ImdWrite(0x0021, 0x003C);
  osDelay(300);
  ImdWrite_B(0x0017, 0x0003);
  osDelay(300);
  ImdWrite_B(0x01FE, 0x0001);
  osDelay(300);
  ImdWrite_B(0x0017, 0x0003);
  osDelay(500);
  ImdWrite_B(0x01FE, 0x0001);
  osDelay(300);
  ImdWrite_B(0x0021, 0x003C);
  osDelay(500);
  ImdWrite_B(0x0021, 0x003C);
  osDelay(300);
  /*ImdAddrSet(0x01,0x02);
  osDelay(300);
  ImdAddrSet(0x01,0x02);
  osDelay(300);*/


  while(1)
  {
    //ImdModeProcess();
    /*ͣж*/
    if(eSwSta_Off == EmergenceGet())
    {
      if(MergencyCheckCnt)
        MergencyCheckCnt--;
    }
    else
    {
      if(MergencyCheckCnt < 3)
        MergencyCheckCnt++;
      else
        MergencyCheckCnt = 3;
    }
    if(0 == MergencyCheckCnt)
    {
      PillarError_B.Value.Emergency = 0;
      PillarError.Value.Emergency = 0;
    }
    else if(3 == MergencyCheckCnt)
    {
      PillarError_B.Value.Emergency = 1;
      PillarError.Value.Emergency = 1;
    }
    /*Žж*/
    if(eSwSta_Off == DoorChkGet())
    {
      if(DoorChkCnt)
        DoorChkCnt--;
    }
    else
    {
      if(DoorChkCnt < 3)
        DoorChkCnt++;
      else
        DoorChkCnt = 3;
    }
    if((0 == DoorChkCnt) || (0 == UserParam.ChgFun.Value.Door))
    {
      PillarError_B.Value.Door = 0;
      PillarError.Value.Door = 0;
    }
    else if((3 == DoorChkCnt) && (0 != UserParam.ChgFun.Value.Door))
    {
      PillarError_B.Value.Door = 1;
      PillarError.Value.Door = 1;
    }
    /*ϼ*/
    if(eSwSta_Off == SPDGet())
    {
      if(SPDChkCnt)
        SPDChkCnt--;
    }
    else
    {
      if(SPDChkCnt < 3)
        SPDChkCnt++;
      else
        SPDChkCnt = 3;
    }
    if(0 == SPDChkCnt)
    {
      PillarError_B.Value.SPD = 0;
      PillarError.Value.SPD = 0;
    }
    else if(3 == SPDChkCnt)
    {
      PillarError_B.Value.SPD = 1;
      PillarError.Value.SPD = 1;
    }
    /*ж ɽ*/
    if((0 == CommuStatus.ConnectFlag) && (1 == UserParam.HadSigned))
    {
      PillarError.Value.Net = 1;
      PillarError_B.Value.Net = 1;
    }
    else
    {
      PillarError.Value.Net = 0;
      PillarError_B.Value.Net = 0;
    }
    /*洢ж*/
    if(WaitUpChgRecdNum >= WaitUpChgRecdNumMax)
    {
      PillarError.Value.Memory = 1;
      PillarError_B.Value.Memory = 1;
    }
    else
    {
      PillarError.Value.Memory = 0;
      PillarError_B.Value.Memory = 0;
    }
    /*ʪͨѶж ɽ*/
    if((0 == Dht12Data.ValidFlag) && (0 != UserParam.ChgFun.Value.Dehumi))
    {
      PillarError.Value.Humiture = 1;
      PillarError_B.Value.Humiture = 1;
    }
    else
    {
      PillarError.Value.Humiture = 0;
      PillarError_B.Value.Humiture = 0;
    }
    /*ܱͨѶж ɽ*/
    if((eMeterSta_Unavail == MeterComm.Status_AC) && (0 != UserParam.ChgFun.Value.ACMeter))
    {
      PillarError.Value.ACMeter = 1;
      PillarError_B.Value.ACMeter = 1;
    }
    else
    {
      PillarError.Value.ACMeter = 0;
      PillarError_B.Value.ACMeter = 0;
    }
    /*ѹ쳣*/
    if((5 == VoltChkCnt) || (-5 == VoltChkCnt))
    {
      PillarError.Value.InVolt = 1;
      PillarError_B.Value.InVolt = 1;
    }
    else if(0 == VoltChkCnt)
    {
      PillarError.Value.InVolt = 0;
      PillarError_B.Value.InVolt = 0;
    }
/******************************************************/
    /*BǹλģͨѶж*/
    if(0 == DcModuleManage_B.OnlineFlag)
     ;// PillarError_B.Value.NoDcmod = 1;
    else
      PillarError_B.Value.NoDcmod = 0;
    /*BǹλܱͨѶж*/
    if(eMeterSta_Unavail == MeterComm.Status_B)
      PillarError_B.Value.Meter = 1;
    else
      PillarError_B.Value.Meter = 0;
    /*BǹλԵж*/
    if(0 != ChargeError_B.Value.IsolateError)
      PillarError_B.Value.Insulation = 1;
    else
      PillarError_B.Value.Insulation = 0;
    /*Bǹλѹж*/
    if(0 != ChargeError_B.Value.VoltOutError)
      PillarError_B.Value.OutVolt = 1;
    else
      PillarError_B.Value.OutVolt = 0;
    /*Bǹλж*/
    if(0 != ChargeError_B.Value.CurrtOutError)
      PillarError_B.Value.OutCurrt = 1;
    else
      PillarError_B.Value.OutCurrt = 0;
    /*BǹλBMSͨѶ*/
    if(eChgPro_B_CommError == ChargeCtrl_B.CurProcess)
      PillarError_B.Value.BMS = 1;
    else
      PillarError_B.Value.BMS = 0;
    /*Bǹλж*/
    if(EleLockSta_B == LockGet_B())
    {
      if(EleLockChkCnt_B)
        EleLockChkCnt_B--;
    }
    else
    {
      if(EleLockChkCnt_B < 20)
        EleLockChkCnt_B++;
      else
        EleLockChkCnt_B = 20;
    }
    if((0 == EleLockChkCnt_B) || (0 == UserParam.ChgFun.Value.EleLock))
    {
      PillarError_B.Value.EleLock = 0;
    }
    else if(20 == EleLockChkCnt_B)
    {
      PillarError_B.Value.EleLock = 1;
    }
    /*BǹλӴж*/
    if(((0 == UserParam.ChgFun.Value.NegContactor) && (DcOutPosSta_B == DcOutPosGet_B()))\
      ||((0 != UserParam.ChgFun.Value.NegContactor) && (DcOutPosSta_B == DcOutPosGet_B()) && (DcOutNegSta_B == DcOutNegGet_B())))
    {
      if((ContactorChkCnt_B) && (0 == PillarError_B.Value.Contactor))
        ContactorChkCnt_B--;
#if 1
      else if(0 != PillarError_B.Value.Contactor)
      {
        if(eLcdPro_MainMenu== LcdCtrl.CurScreen)
        {
          if(ContactorChkCnt_B)
            ContactorChkCnt_B--;
        }
      }
#endif
    }
    else
    {
      if(ContactorChkCnt_B < 20)
        ContactorChkCnt_B++;
      else
        ContactorChkCnt_B = 20;
    }
    if(0 == ContactorChkCnt_B)
    {
      PillarError_B.Value.Contactor = 0;
    }
    else if(20 == ContactorChkCnt_B)
    {
      PillarError_B.Value.Contactor = 1;
    }
	if((PillarError.Value.Emergency == 0) && (ACContactorSta != ACContactorGet()))
    {
      if(ACContactorChkCnt < 20)
        ACContactorChkCnt++;
      else
      {
        PillarError.Value.ACContactor = 1;
        PillarError_B.Value.ACContactor = 1;
      }
    }
    else
    {
      if(ACContactorChkCnt)
        ACContactorChkCnt--;
      //else
      {
        //PillarError.Value.ACContactor = 0;
        //PillarError_B.Value.ACContactor = 0;
      }
    }

    if((ACContactorSta==eSwSta_On)&&(ACContactorGet()==eSwSta_On))
    {
      if(ACContactorOnCnt < 250)
        ACContactorOnCnt++;
      else
        Acc_On_3s_flag = 1;
    }
    else
    {
      ACContactorOnCnt=0;
      Acc_On_3s_flag = 0;
    }

/******************************************************/
    /*ģͨѶж*/
    if(0 == DcModuleManage.OnlineFlag)
     ;// PillarError.Value.NoDcmod = 1;
    else
      PillarError.Value.NoDcmod = 0;
    /*ܱͨѶж*/
    if(eMeterSta_Unavail == MeterComm.Status)
      PillarError.Value.Meter = 1;
    else
      PillarError.Value.Meter = 0;
    /*Եж*/
    if(0 != ChargeError.Value.IsolateError)
      PillarError.Value.Insulation = 1;
    else
      PillarError.Value.Insulation = 0;
    /*ѹж*/
    if(0 != ChargeError.Value.VoltOutError)
      PillarError.Value.OutVolt = 1;
    else
      PillarError.Value.OutVolt = 0;
    /*ж*/
    if(0 != ChargeError.Value.CurrtOutError)
      PillarError.Value.OutCurrt = 1;
    else
      PillarError.Value.OutCurrt = 0;
    /*BMSͨѶ*/
    if((eChgPro_AB_CommError == ChargeCtrl.CurProcess) || (eChgPro_CommError == ChargeCtrl.CurProcess))
      PillarError.Value.BMS = 1;
    else
      PillarError.Value.BMS = 0;
    /*ж*/
    if(EleLockSta == LockGet())
    {
      if(EleLockChkCnt)
        EleLockChkCnt--;
    }
    else
    {
      if(EleLockChkCnt < 20)
        EleLockChkCnt++;
      else
        EleLockChkCnt = 20;
    }
    if((0 == EleLockChkCnt) || (0 == UserParam.ChgFun.Value.EleLock))
    {
      PillarError.Value.EleLock = 0;
    }
    else if(20 == EleLockChkCnt)
    {
      PillarError.Value.EleLock = 1;
    }
    /*Ӵж*/
    if(((0 == UserParam.ChgFun.Value.NegContactor) && (DcOutPosSta == DcOutPosGet()))\
      ||((0 != UserParam.ChgFun.Value.NegContactor) && (DcOutPosSta == DcOutPosGet()) && (DcOutNegSta == DcOutNegGet())))//Ӵ
    {
      if((ContactorChkCnt) && (0 == PillarError.Value.Contactor))
        ContactorChkCnt--;
#if 1
      else if(0 != PillarError.Value.Contactor)
      {
        if(eLcdPro_MainMenu== LcdCtrl.CurScreen)
        {
          if(ContactorChkCnt)
            ContactorChkCnt--;
        }
      }
#endif
    }
    else
    {
      if(ContactorChkCnt < 20)
        ContactorChkCnt++;
      else
        ContactorChkCnt = 20;
    }
    if(0 == ContactorChkCnt)
    {
      PillarError.Value.Contactor = 0;
    }
    else if(20 == ContactorChkCnt)
    {
      PillarError.Value.Contactor = 1;
    }

    /*Ӵж*/
    if(((0 == UserParam.ChgFun.Value.SigUniChg))\
      ||((DcOutPosSta_Uni == DcOutPosGet_Uni()) && (DcOutNegSta_Uni == DcOutNegGet_Uni())))//Ӵ
    {
      if((ContactorChkCnt_Uni) && ((0 == PillarError.Value.UniContactor) || (0 == PillarError_B.Value.UniContactor)))
        ContactorChkCnt_Uni--;
#if 1
      else if((0 != PillarError.Value.UniContactor) || (0 != PillarError_B.Value.UniContactor))
      {
        if(eLcdPro_MainMenu== LcdCtrl.CurScreen)
        {
          if(ContactorChkCnt_Uni)
            ContactorChkCnt_Uni--;
        }
      }
#endif
    }
    else
    {
      if(ContactorChkCnt_Uni < 20)
        ContactorChkCnt_Uni++;
      else
        ContactorChkCnt_Uni = 20;
    }
    if(0 == ContactorChkCnt_Uni)
    {
      PillarError.Value.UniContactor = 0;
      PillarError_B.Value.UniContactor = 0;
    }
    else if(20 == ContactorChkCnt_Uni)
    {
    //  PillarError.Value.UniContactor = 1;
    //  PillarError_B.Value.UniContactor = 1;
    }

    /*ԵͨѶж*/
    if((GetSystemTick() - ImdCheckTcik) >= 600)
    {
      //if(eChgVer_2011 != UserParam.ChgVer
      //  || eLcdPro_FactoryTest == LcdCtrl.CurScreen
      //  || eLcdPro_B_FactoryTest == LcdCtrl.CurScreen
      //  )
      {
        if(0 == ImdRead(&ImdValue))
        {
          if(ImdErrorCnt > 2)
            ImdErrorCnt -= 2;
          else if(ImdErrorCnt > 0)
            ImdErrorCnt--;

          ImdValue.Vaild = 1;
        }
        else
        {
          if(ImdErrorCnt < 5)
            ImdErrorCnt++;
          else
          {
            ImdErrorCnt = 5;
            ImdValue.Vaild = 0;
          }
        }


      }
      //else
      //{
      //  ImdErrorCnt = 0;
      //  ImdErrorCnt_B = 0;
      //  ImdValue.Vaild = 0;
      //  ImdValue_B.Vaild = 0;
      //}

      ImdCheckTcik = GetSystemTick();
    }
    if((GetSystemTick() - ImdCheckTcik_B) >= 550)
	{
		if(0 == ImdRead_B(&ImdValue_B))
		{
			if(ImdErrorCnt_B > 2)
			ImdErrorCnt_B -= 2;
			else if(ImdErrorCnt_B > 0)
			ImdErrorCnt_B--;
			ImdValue_B.Vaild = 1;
		}
		else
		{
			if(ImdErrorCnt_B < 5)
			ImdErrorCnt_B++;
			else
			{
			ImdErrorCnt_B = 5;
			ImdValue_B.Vaild = 0;
			}
		}
	  ImdCheckTcik_B= GetSystemTick();
	}
    if(0 == ImdErrorCnt)
      PillarError.Value.ImdDev = 0;
    else if((5 == ImdErrorCnt)&&((TCUCurChgRecd_B.TCUChargeEnable == 0)&&(TCUCurChgRecd.TCUChargeEnable==0)&&(eChgVer_2011 != UserParam.ChgVer)))
      PillarError.Value.ImdDev = 1;

    if(0 == ImdErrorCnt_B)
      PillarError_B.Value.ImdDev = 0;
    else if((5 == ImdErrorCnt_B)&&((TCUCurChgRecd_B.TCUChargeEnable == 0)&&(TCUCurChgRecd.TCUChargeEnable==0)&&(eChgVer_2011 != UserParam.ChgVer)))
      PillarError_B.Value.ImdDev = 1;

    osDelay(25);
  }
}

