
#include "Thd_TCU.h"

#include "Drv_BoardIo.h"

#include "Memory.h"
#include "Thd_Lcd.h"

#include "Thd_Charge.h"
#include "Thd_Charge_B.h"

#include "Drv_Adc.h"

#include "FTP_Upgrade.h"

extern void TCUCanInit(void);

StructTCUCommuStatus TCUCommuStatus =
{
	.ChgNum 			= 0, 
	.CommStage			= HeartStage, 
	.ParamVaild 		= 0, 
	0, 
	0
};


const StructTCUCommuParam TCUCommuParam =
{
	.HeartPeriod		= 1, 
	.HeartErrCntMax 	= 3, 
	.HeartTimeout		= 3, 
	.SignInPeriod		= 60, 
};


//̨ͨŲ
void TCURecvProcess(void)
{
	StructTCUSend	pPgnRecv;

	if (pdTRUE != xQueueReceive(TCUMsg, &pPgnRecv, 0))
		return;

	switch (pPgnRecv.Pgn)
	{
		case eCmd_start: //  ֡
			StartMeg(&pPgnRecv); //
			break;

		case eCmd_stop: //	ֹͣ֡
			StopMeg(&pPgnRecv);
			break;

		case eCmd_time: //		ʱ֡
			TCUtimeSet(&pPgnRecv); //ʱ 
			break;

		case eCmd_versi: //汾У֡
			TCUVersionCheck(&pPgnRecv);
			break;

		case eCmd_param: //  ·Ϣ֡
			TCUParam(&pPgnRecv);
			break;

		case eCmd_SerCon: //	 ͣ֡
			SerConAckAnalysis(&pPgnRecv);
			break;

		case eCmd_Gun: //	ɿ֡
			ElectControlAnalysis(&pPgnRecv);
			break;

		case eCmd_power: //  ʵڿ֡
			PowerControlAnalysis(&pPgnRecv);
			break;

		case eCmd_Query: //  ׮Ϣѯ֡ 
			TCUCommuStatus.ChgNum = pPgnRecv.Data[0];
			TCUCommuStatus.CommStage = ChgInfornQueryStage;
			TCUCommuStatus.ChgInfornQueryRecvTime = GetSystemTick();
			TCUCommuStatus.ChgInfornQuerySentTime = 0;
			break;

		case eCmd_verificationAck: //֤Ӧ֡
			verificationAck(&pPgnRecv);
			break;

		////////////״̬֡///////////////// 
		case eCmd_startCompAck: //	Ӧ֡
			ACkStartCompMeg(&pPgnRecv);
			break;

		case eCmd_stopCompAck: // ֹͣӦ֡
			stopCompAck(&pPgnRecv);
			break;

		///////////֡/ֱ////////////
		case eCmd_DCTCUMeasu: // ƷѵԪң֡
			TCUMeasuRecv(&pPgnRecv);
			
			break;

		///////////֡///////////
		case eCmd_TcuHeart: //	ƷѵԪ
			AckTCUHeartBeat(&pPgnRecv); //
			break;

		case eCmd_TCUErroComm: // ƷѵԪ֡
			TCUErroCommAnalysis(&pPgnRecv);
			break;

		default:
			break;
	}

}


void InformationReporting(void)
{
	if (TCUCommuStatus.DCConInforSendTime == 0)
	{
		InformationReporting_22_A();
		InformationReporting_23_A();
		TCUCommuStatus.DCConInforSendTime = GetSystemTick();
	}
	else if (GetSystemTick() -TCUCommuStatus.DCConInforSendTime >= 500)
	{
		InformationReporting_22_A();
		InformationReporting_23_A();
		TCUCommuStatus.DCConInforSendTime = GetSystemTick();
	}

	if (TCUCommuStatus.DCConInforSendTime_B == 0)
	{
		InformationReporting_22_B();
		InformationReporting_23_B();
		TCUCommuStatus.DCConInforSendTime_B = GetSystemTick();
	}
	else if (GetSystemTick() -TCUCommuStatus.DCConInforSendTime_B >= 500)
	{
		InformationReporting_22_B();
		InformationReporting_23_B();
		TCUCommuStatus.DCConInforSendTime_B = GetSystemTick();
	} //ң
}


void DCMeasuring_A(void)
{
	if (0 == TCUCommuStatus.DCMeasuRecvTime) //ң
	{
		if ((GetSystemTick() -TCUCommuStatus.DCMeasuSendTime) > 2000)
		{
			TCUCommuStatus.DCMeasuErrCnt++;

			if (TCUCommuStatus.DCMeasuErrCnt > 5)
			{
				memset(&TCUCommuStatus, 0x00, sizeof(TCUCommuStatus)); //ͨѶʼ
				TCUCommuStatus.ConnectFlag = 0;
				TCUCommuStatus.HeartBeatErrCnt = 0;
				TCUCommuStatus.HeartBeatVaild = 0;	//ʧЧ
				TCUCanInit();				//canͨѶӿڳʼ
			}
			else 
			{
				measuringReporting20_A();
				TCUCommuStatus.DCMeasuSendTime = GetSystemTick();
				TCUCommuStatus.DCMeasuRecvTime = 0;
			}
		}
	}
	else //ѭ
	{
		if ((GetSystemTick() -TCUCommuStatus.DCMeasuSendTime) > 1000)
		{
			measuringReporting20_A();
			TCUCommuStatus.DCMeasuSendTime = GetSystemTick();
			TCUCommuStatus.DCMeasuRecvTime = 0;
		}
	}
}


void DCMeasuring_B(void)
{
	if (0 == TCUCommuStatus.DCMeasuRecvTime_B) //ң
	{
		if ((GetSystemTick() -TCUCommuStatus.DCMeasuSendTime_B) > 2000)
		{
			TCUCommuStatus.DCMeasuErrCnt_B++;

			if (TCUCommuStatus.DCMeasuErrCnt_B > 5)
			{
				memset(&TCUCommuStatus, 0x00, sizeof(TCUCommuStatus)); //ͨѶʼ
				TCUCommuStatus.ConnectFlag = 0;
				TCUCommuStatus.HeartBeatErrCnt = 0;
				TCUCommuStatus.HeartBeatVaild = 0;	//ʧЧ
				TCUCanInit();
			}
			else 
			{
				measuringReporting20_B();
				TCUCommuStatus.DCMeasuSendTime_B = GetSystemTick();
				TCUCommuStatus.DCMeasuRecvTime_B = 0;
			}
		}
	}
	else //ѭ
	{
		if ((GetSystemTick() -TCUCommuStatus.DCMeasuSendTime_B) > 1000)
		{
			measuringReporting20_B();
			TCUCommuStatus.DCMeasuSendTime_B = GetSystemTick();
			TCUCommuStatus.DCMeasuRecvTime_B = 0;
		}
	}
}


void ConEMSend(void)
{
	static u32		ConEMSendTick = 0;
	static u32		ConEMSendEcount = 0;
	static u32		ConEMSendTick_B = 0;
	static u32		ConEMSendEcount_B = 0;

	if (TCUCommuStatus.ConEMSendFlag == 1)
	{
		TcuEMMsg(TCUCommuStatus.ErrData.Mult);		//֡ʱ
		ConEMSendTick		= GetSystemTick();
		TCUCommuStatus.ConEMSendFlag = 2;
	}
	else if (TCUCommuStatus.ConEMSendFlag == 2)
	{
		if (GetSystemTick() -ConEMSendTick >= 250)
		{
			if (ConEMSendEcount < 20)
			{
				ConEMSendEcount++;
				TcuEMMsg(TCUCommuStatus.ErrData.Mult);
			}
			else 
			{
				ConEMSendTick		= 0;
				TCUCommuStatus.ConEMSendFlag = 0;

				if (TCUCurChgRecd.TCUChargeEnable == 0)
					TCUCommuStatus.ErrData.Mult = 0;

				ConEMSendEcount 	= 0;
			}
		}
		else 
		{
			ConEMSendTick		= 0;
			TCUCommuStatus.ConEMSendFlag = 0;
			TCUCommuStatus.ErrData.Mult = 0;
			ConEMSendEcount 	= 0;
		}
	}

	if (TCUCommuStatus.ConEMSendFlag_B == 1)
	{
		TcuEMMsg_B(TCUCommuStatus.ErrData_B.Mult);	//֡ʱ
		ConEMSendTick_B 	= GetSystemTick();
		TCUCommuStatus.ConEMSendFlag_B = 2;
	}
	else if (TCUCommuStatus.ConEMSendFlag_B == 2)
	{
		if (GetSystemTick() -ConEMSendTick_B >= 250)
		{
			if (ConEMSendEcount_B < 20)
			{
				ConEMSendEcount_B++;
				TcuEMMsg_B(TCUCommuStatus.ErrData_B.Mult);
			}
			else 
			{
				ConEMSendTick_B 	= 0;
				TCUCommuStatus.ConEMSendFlag_B = 0;
				TCUCommuStatus.ErrData_B.Mult = 0;
				ConEMSendEcount_B	= 0;
			}
		}
	}
	else 
	{
		ConEMSendTick_B 	= 0;
		TCUCommuStatus.ConEMSendFlag_B = 0;

		if (TCUCurChgRecd_B.TCUChargeEnable == 0)
			TCUCommuStatus.ErrData_B.Mult = 0; //ͣ֡ɻTCUͣʱ0

		ConEMSendEcount_B	= 0;
	}
}


void CommutionConfigurationStage(void)
{
	if (TCUCommuStatus.CommStage == VersionStage)
	{
		if (GetSystemTick() -TCUCommuStatus.VersionRecvTime <= 2000) //2S
		{
			if (TCUCommuStatus.VersionSentTime == 0)
			{
				TCUVersionCheckSent();
				TCUCommuStatus.VersionSentTime = GetSystemTick();
			}
			else if (GetSystemTick() -TCUCommuStatus.VersionSentTime >= 500)
			{
				TCUVersionCheckSent();
				TCUCommuStatus.VersionSentTime = GetSystemTick();
			}
		}
		else if (GetSystemTick() -TCUCommuStatus.VersionRecvTime >= 5000)
		{
			if (TCUCommuStatus.ChgNum == 2)
			{
				TCUCommuStatus.ErrData.Value.Param = 1;
				TCUCommuStatus.ConEMSendFlag = 1;
			}
			else 
			{
				TCUCommuStatus.ErrData_B.Value.Param = 1;
				TCUCommuStatus.ConEMSendFlag_B = 1;
			}

			TCUCommuStatus.CommStage = HeartStage;
		}
	}

}


void TCUPillarHeartBeat(void)
{
	u32 			SendTick;

	if (TCUCommuStatus.HeartBeatVaild != CONNECT_NORMAL)
		return;

	if (0 == TCUCommuStatus.HeartBeatRecvTime) //ʼ12sһ
	{
		if ((GetSystemTick() -TCUCommuStatus.HeartBeatSendTime) > ((u32) TCUCommuParam.HeartTimeout * 1000))
		{
			TCUCommuStatus.HeartBeatErrCnt++;

			if (TCUCommuStatus.HeartBeatErrCnt > TCUCommuParam.HeartErrCntMax)
			{
				memset(&TCUCommuStatus, 0x00, sizeof(TCUCommuStatus)); //ͨѶʼ
				TCUCommuStatus.ConnectFlag = 0;
				TCUCommuStatus.HeartBeatErrCnt = 0;
				TCUCommuStatus.HeartBeatVaild = 0;	//ʧЧ
				TCUCanInit();
			}
			else 
			{
				TCUHeartBeat_A();
				TCUCommuStatus.HeartBeatSendTime = GetSystemTick();
				TCUCommuStatus.HeartBeatRecvTime = 0;
			}
		}
	}
	else 
	{ //
		SendTick			= ((u32) TCUCommuParam.HeartPeriod * 1000);

		if ((GetSystemTick() -TCUCommuStatus.HeartBeatSendTime) > SendTick)
		{
			TCUHeartBeat_A();
			TCUCommuStatus.HeartBeatSendTime = GetSystemTick();
			TCUCommuStatus.HeartBeatRecvTime = 0;
		}
	}
}


void TCUPillarHeartBeat_B(void)
{
	u32 			SendTick;

	if (TCUCommuStatus.HeartBeatVaild != CONNECT_NORMAL)
		return;

	if (0 == TCUCommuStatus.HeartBeatRecvTime_B) //ʼ12sһ
	{
		if ((GetSystemTick() -TCUCommuStatus.HeartBeatSendTime_B) > ((u32) TCUCommuParam.HeartTimeout * 1000))
		{
			TCUCommuStatus.HeartBeatErrCnt_B++;

			if (TCUCommuStatus.HeartBeatErrCnt_B > TCUCommuParam.HeartErrCntMax)
			{
				TCUCommuStatus.ConnectFlag = 0;
				TCUCommuStatus.HeartBeatErrCnt_B = 0;
				TCUCommuStatus.HeartBeatVaild = 0;	//ʧЧ
				TCUCanInit();
			}
			else 
			{
				TCUHeartBeat_B();
				TCUCommuStatus.HeartBeatSendTime = GetSystemTick();
				TCUCommuStatus.HeartBeatRecvTime = 0;
			}
		}
	}
	else 
	{ //
		SendTick			= ((u32) TCUCommuParam.HeartPeriod * 1000);

		if ((GetSystemTick() -TCUCommuStatus.HeartBeatSendTime_B) > SendTick)
		{
			TCUHeartBeat_B();
			TCUCommuStatus.HeartBeatSendTime_B = GetSystemTick();
			TCUCommuStatus.HeartBeatRecvTime_B = 0;
		}
	}
}


void CommutionRunStage(void)
{
	if ((TCUCommuStatus.CommStage == ChageParamStage))
	{
		if (GetSystemTick() -TCUCommuStatus.ParamRecvTime <= 2000) //2S
		{
			if (TCUCommuStatus.ParamSentTime == 0)
			{
				TCUParamAck();
				TCUCommuStatus.ParamSentTime = GetSystemTick();
			}
			else if (GetSystemTick() -TCUCommuStatus.ParamSentTime >= 500)
			{
				TCUParamAck();
				TCUCommuStatus.ParamSentTime = GetSystemTick();
			}
		}
		else 
		{
			TCUCommuStatus.CommStage = HeartStage;
		}
	}

	if ((TCUCommuStatus.CommStage == TimeStage))
	{
		if (GetSystemTick() -TCUCommuStatus.TimeRecvTime <= 2000) //2Sʱ
		{
			if (TCUCommuStatus.TimeSentTime == 0)
			{
				TCUtimeSetAck();
				TCUCommuStatus.TimeSentTime = GetSystemTick();
			}
			else if (GetSystemTick() -TCUCommuStatus.TimeSentTime >= 500)
			{
				TCUtimeSetAck();
				TCUCommuStatus.TimeSentTime = GetSystemTick();
			}
		}
		else 
		{
			TCUCommuStatus.CommStage = HeartStage;
		}
	}

	if ((TCUCommuStatus.CommStage == ServiceContralStage))
	{
		if (GetSystemTick() -TCUCommuStatus.ServiceContralRecvTime <= 2000) //2S
		{
			if (TCUCommuStatus.ServiceContralSentTime == 0)
			{
				SerConAck();
				TCUCommuStatus.ServiceContralSentTime = GetSystemTick();
			}
			else if (GetSystemTick() -TCUCommuStatus.ServiceContralSentTime >= 500)
			{
				SerConAck();
				TCUCommuStatus.ServiceContralSentTime = GetSystemTick();
			}
		}
		else 
		{
			TCUCommuStatus.CommStage = HeartStage;
		}
	}

	if ((TCUCommuStatus.CommStage == ElectLockStage))
	{
		if (GetSystemTick() -TCUCommuStatus.ElectLockRecvTime <= 2000) //2S
		{
			if (TCUCommuStatus.ElectLockSentTime == 0)
			{
				ElectControlAck();
				TCUCommuStatus.ElectLockSentTime = GetSystemTick();
			}
			else if (GetSystemTick() -TCUCommuStatus.ElectLockSentTime >= 500)
			{
				ElectControlAck();
				TCUCommuStatus.ElectLockSentTime = GetSystemTick();
			}
		}
		else 
		{
			TCUCommuStatus.CommStage = HeartStage;
		}
	}

	if ((TCUCommuStatus.CommStage == PowerControlStage))
	{
		if (GetSystemTick() -TCUCommuStatus.ElectLockRecvTime <= 2000) //2S
		{
			if (TCUCommuStatus.PowerControlSentTime == 0)
			{
				PowerControlAck();
				TCUCommuStatus.PowerControlSentTime = GetSystemTick();
			}
			else if (GetSystemTick() -TCUCommuStatus.PowerControlSentTime >= 500)
			{
				PowerControlAck();
				TCUCommuStatus.PowerControlSentTime = GetSystemTick();
			}
		}
		else 
		{
			TCUCommuStatus.CommStage = HeartStage;
		}
	}

	if ((TCUCommuStatus.CommStage == ChgInfornQueryStage))
	{
		if (GetSystemTick() -TCUCommuStatus.ChgInfornQueryRecvTime <= 2000) //2S
		{
			if (TCUCommuStatus.ChgInfornQuerySentTime == 0)
			{
				ChgInfornQueryAck();
				TCUCommuStatus.ChgInfornQuerySentTime = GetSystemTick();
			}
			else if (GetSystemTick() -TCUCommuStatus.ChgInfornQuerySentTime >= 500)
			{
				ChgInfornQueryAck();
				TCUCommuStatus.ChgInfornQuerySentTime = GetSystemTick();
			}
		}
		else 
		{
			TCUCommuStatus.CommStage = HeartStage;
		}
	}

}


void TCUCurChgRecordInterface_A(void)
{
	static u32		ChgRecordSendTick = 0;
	static u32		ChgRecordSendErr = 0;			//ֹͣ֡
	static u32		ChgStopSendTick = 0;
	static u32		ChgStopSendEcount = 0;			//ֹͣ֡
	static u32		ChgStartSendTick = 0;
	static u32		ChgStartSendEcount = 0; 		//֡
	static u32		ChgStartCompSendTick = 0;
	static u32		ChgStartCompSendEcount = 0; 	//֡

	if (TCUCurChgRecd.TCUChgStartNotetrl == 1) //֡߼
	{
		StartMegAck_A();							//֡
		ChgStartSendTick	= GetSystemTick();
		TCUCurChgRecd.TCUChgStartNotetrl = 2;
	}
	else if (TCUCurChgRecd.TCUChgStartNotetrl == 2)
	{
		if (GetSystemTick() -ChgStartSendTick >= 250)
		{
			if (ChgStartSendEcount < 8) //2S
			{
				ChgStartSendEcount++;
				StartMegAck_A();					//֡
			}
			else 
			{
				ChgStartSendTick	= 0;
				TCUCurChgRecd.TCUChgStartNotetrl = 0; //ֹͣ
				ChgStartSendEcount	= 0;
			}
		}
	}
	else if (TCUCurChgRecd.TCUChgStarCompNotetrl == 1)
	{
		stopCompSend_A();
		ChgStartCompSendTick = GetSystemTick();
		TCUCurChgRecd.TCUChgStarCompNotetrl = 2;
	}
	else if (TCUCurChgRecd.TCUChgStarCompNotetrl == 2)
	{
		if ((GetSystemTick() -ChgStartCompSendTick) > (250))
		{
			ChgStartCompSendEcount++;

			if (ChgRecordSendErr < 20) //ʱ5S
			{ //ʱС20
				startCompSend_B();
				ChgRecordSendTick	= GetSystemTick();
			}
			else 
			{ //ʱڣ
				TCUCommuStatus.ConEMSendFlag_B = 1; //֡
				TCUCommuStatus.ErrData.Value.startCompAck = 1;
				TCUCurChgRecd.TCUChgStarCompNotetrl = 3;

				TCUCurChgRecd.TCUChargeEnable = 0;	//ʱͣ
				ChgStartCompSendEcount = 0;
			}
		}
	}
	else if (TCUCurChgRecd_B.TCUChgStarCompNotetrl == 3)
	{
		TCUCurChgRecd_B.TCUStartCompresult = 0; 	//
		TCUCurChgRecd_B.TCUChargeEnable = 0;		//
		TCUCurChgRecd_B.StarChgType = 0;
		ChgStartCompSendEcount = 0;
	}
	else if (TCUCurChgRecd.TCUChgStopNotetrl == 1) //ֹͣ֡߼
	{
		StopMegAck_A(); 							//ֹͣ֡
		ChgStopSendTick 	= GetSystemTick();
		TCUCurChgRecd.TCUChgStopNotetrl = 2;
	}
	else if (TCUCurChgRecd.TCUChgStopNotetrl == 2)
	{
		if (GetSystemTick() -ChgStopSendTick >= 250)
		{
			if (ChgStopSendEcount < 8)
			{
				ChgStopSendEcount++;
				StopMegAck_A();
			}
			else 
			{
				ChgStopSendTick 	= 0;
				TCUCurChgRecd.TCUChgStopNotetrl = 0; //ֹͣ
				ChgStopSendEcount	= 0;
			}
		}
	}
	else if ((TCUCurChgRecd.TCUChgStopCompNotetrl == 1) //ֹͣ֡߼
	&& (0 != TCUCurChgRecd.TCUChargeEnable))
	{
		stopCompSend_A();
		ChgRecordSendTick	= GetSystemTick();
		TCUCurChgRecd.TCUChgStopCompNotetrl = 2;
	}
	else if ((TCUCurChgRecd.TCUChgStopCompNotetrl == 2) && (0 != TCUCurChgRecd.TCUChargeEnable))
	{
		if ((GetSystemTick() -ChgRecordSendTick) > (250))
		{
			ChgRecordSendErr++;

			if (ChgRecordSendErr < 20) //ʱ5S
			{ //ʱС20
				stopCompSend_A();
				ChgRecordSendTick	= GetSystemTick();
			}
			else 
			{ //ʱڣ
				TCUCommuStatus.ConEMSendFlag = 1;
				TCUCommuStatus.ErrData.Value.stopCompAck = 1;
				TCUCurChgRecd.TCUChgStopCompNotetrl = 3;
				ChgRecordSendErr	= 0;
			}
		}
	}
	else if ((TCUCurChgRecd.TCUChgStopCompNotetrl == 3) && (0 != TCUCurChgRecd.TCUChargeEnable))
	{
		TCUCurChgRecd.TCUChgStopCompNotetrl = 0;	//ʱ
		TCUCurChgRecd.TCUChargeEnable = 0;			//
		TCUCurChgRecd.TCUChgStopType = 0;

		ChgRecordSendErr	= 0;
	}
}


void TCUCurChgRecordInterface_B(void)
{
	static u32		ChgRecordSendTick = 0;
	static u32		ChgRecordSendErr = 0;
	static u32		ChgStopSendTick = 0;
	static u32		ChgStopSendEcount = 0;
	static u32		ChgStartSendTick = 0;
	static u32		ChgStartSendEcount = 0; 		//֡
	static u32		ChgStartCompSendTick = 0;
	static u32		ChgStartCompSendEcount = 0; 	//֡

	if (TCUCurChgRecd_B.TCUChgStartNotetrl == 1) //֡߼
	{
		StartMegAck_B();							//֡
		ChgStartSendTick	= GetSystemTick();
		TCUCurChgRecd_B.TCUChgStartNotetrl = 2;
	}
	else if (TCUCurChgRecd_B.TCUChgStartNotetrl == 2)
	{
		if (GetSystemTick() -ChgStartSendTick >= 250)
		{
			if (ChgStartSendEcount < 8) //2S
			{
				ChgStartSendEcount++;
				StartMegAck_B();					//֡
			}
			else 
			{
				ChgStartSendTick	= 0;
				TCUCurChgRecd_B.TCUChgStartNotetrl = 0; //ֹͣ
				ChgStartSendEcount	= 0;
			}
		}
	}
	else if (TCUCurChgRecd_B.TCUChgStarCompNotetrl == 1)
	{
		stopCompSend_B();
		ChgStartCompSendTick = GetSystemTick();
		TCUCurChgRecd_B.TCUChgStarCompNotetrl = 2;
	}
	else if (TCUCurChgRecd_B.TCUChgStarCompNotetrl == 2)
	{
		if ((GetSystemTick() -ChgStartCompSendTick) > (250))
		{
			ChgStartCompSendEcount++;

			if (ChgRecordSendErr < 20) //ʱ5S
			{ //ʱС20
				startCompSend_B();
				ChgRecordSendTick	= GetSystemTick();
			}
			else 
			{ //ʱڣ
				TCUCommuStatus.ConEMSendFlag_B = 1; //֡
				TCUCommuStatus.ErrData_B.Value.startCompAck = 1;
				TCUCurChgRecd_B.TCUChargeEnable = 0; //ʱͣ
				TCUCurChgRecd_B.TCUChgStarCompNotetrl = 3;
				ChgStartCompSendEcount = 0;
			}
		}
	}
	else if (TCUCurChgRecd_B.TCUChgStarCompNotetrl == 3)
	{
		TCUCurChgRecd_B.TCUStartCompresult = 0; 	//
		TCUCurChgRecd_B.TCUChargeEnable = 0;		//
		TCUCurChgRecd_B.StarChgType = 0;
		ChgStartCompSendEcount = 0;
	}
	else if (TCUCurChgRecd.TCUChgStopNotetrl == 1)
	{
		StopMegAck_B();
		ChgStopSendTick 	= GetSystemTick();
		TCUCurChgRecd_B.TCUChgStopNotetrl = 2;
	}
	else if (TCUCurChgRecd_B.TCUChgStopNotetrl == 2)
	{
		if (GetSystemTick() -ChgStopSendTick >= 250)
		{
			if (ChgStopSendEcount < 8)
			{
				ChgStopSendEcount++;
				StopMegAck_B();
			}
			else 
			{
				ChgStopSendTick 	= 0;
				TCUCurChgRecd_B.TCUChgStopNotetrl = 0; //ֹͣ
				ChgStopSendEcount	= 0;
			}
		}
	}
	else if ((TCUCurChgRecd_B.TCUChgStopCompNotetrl == 1) && (0 != TCUCurChgRecd_B.TCUChargeEnable))
	{
		stopCompSend_B();
		ChgRecordSendTick	= GetSystemTick();
		TCUCurChgRecd_B.TCUChgStopCompNotetrl = 2;
	}
	else if ((TCUCurChgRecd_B.TCUChgStopCompNotetrl == 2) && (0 != TCUCurChgRecd_B.TCUChargeEnable))
	{
		if ((GetSystemTick() -ChgRecordSendTick) > (250))
		{
			ChgRecordSendErr++;

			if (ChgRecordSendErr < 20) //ʱ5S
			{ //ʱС20
				stopCompSend_B();
				ChgRecordSendTick	= GetSystemTick();
			}
			else 
			{ //ʱڣ
				TCUCommuStatus.ConEMSendFlag_B = 1; //֡
				TCUCommuStatus.ErrData_B.Value.stopCompAck = 1;
				TCUCurChgRecd_B.TCUChgStopCompNotetrl = 3;
				ChgRecordSendErr	= 0;
			}
		}
	}
	else if ((TCUCurChgRecd_B.TCUChgStopCompNotetrl == 3) && (0 != TCUCurChgRecd_B.TCUChargeEnable))
	{
		TCUCurChgRecd_B.TCUChgStopCompNotetrl = 0;	//ʱ
		TCUCurChgRecd_B.TCUChargeEnable = 0;		//
		TCUCurChgRecd_B.TCUChgStopType = 0;
		ChgRecordSendErr	= 0;
	}
}


void TCUChgStarStopProcess(void) //ͣ߼
{
	TCUCurChgRecordInterface_A();
	TCUCurChgRecordInterface_B();
}


void TCUWorkProcess(void)
{
	if (TCUCommuStatus.VerChkVaild == 0) //汾δɲ
		return;

	InformationReporting(); 						//ң
	DCMeasuring_A();								//ң
	DCMeasuring_B();								//ң
}


void TCULinkProcess(void) //֡
{
	TCUPillarHeartBeat();							//
	//TCUPillarHeartBeat_B(); 						//
	CommutionConfigurationStage();					//ý׶
	CommutionRunStage();							//н׶
	ConEMSend();									//abʱ߼


}


void TCUComm(void const * argument)
{

	osDelay(6000);
	TCUCommInit();

	for (; ; )
	{

		TCURecvProcess();							//֡
		TCUWorkProcess();							//ңңϢ
		TCULinkProcess();							//Ϣ
		TCUChgStarStopProcess();					//ͣ߼

		// TCUCodeDone();//澯ϴ
		// TCUSaveEventDone();
		osDelay(100);
	}
}


